<?php

require_once("lib-api-action/apiaction.php");

/**
 */
class CancelVendorPackage extends MB_ClientAPIAction {
	/**
	 */
	function CancelVendorPackage() {
		parent::MB_ClientAPIAction();
		$this->stringRep = "CancelVendorPackage";
		$this->params = array();
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->mergeMarketplaceSellerInfo();

		if (!(int)$this->sellerInfo["sellerActive"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid product variant ID.");
		}
		if (!(int)$_REQUEST["packageID"]){
			Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid package ID.");
		}

		$packageInfo = oneByID("packages", (int)$_REQUEST["packageID"], array(
			"clientID" => $this->clientInfo["clientID"],
		));

		if (!(int)$packageInfo["packageID"]){
			Error::api(1003, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid package ID.");
		}

		if ($packageInfo["packageCancellationType"]==getAPITypeID("cancellation", "admin_suspend") || $packageInfo["packageCancellationType"]==getAPITypeID("cancellation", "admin_delete")){
			Error::api(1004, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] You are not allowed to cancel this package.");
		}

		updateForKey("packages", $packageInfo["packageID"], array(
			"packagePendingCancellation" => getAPITypeID("pendingcancellation", "client"),
		));

		$output = array("success" => 1);

		return $this->output($output);

	}
} // CancelVendorPackage
?>