<?php

require_once("action-api/include/lib-action/api/UpdateClientContact.php");

class CreateClientContact extends UpdateClientContact
{
	public function execute()
	{
		MB_AdminAPIAction::execute();

		if ( !is_null($id = bgpc("clientID")) ) {
			$customer = Factory()->Customer($id);
		} else if ( !is_null($guid = bgpc("clientGUID")) ) {
			$customer = Factory()->Customer($guid, "guid");
		} else if ( !is_null($externalId = bgpc("customerExternalID")) ) {
			$customer = Factory()->Customer($externalId, "external_id");
		} else {
			throw new ProductException(ProductException::E_OBJECT_NOT_FOUND, "Missing customer identifier");
		}

		$contact = Factory()->Contact();
		$contact->client_id = $customer->id;
		$this->collectContact($contact);
        $this->validateContact($contact);
        Service()->ContactManager->update($contact);

		return $this->output(array("clientContactGUID" => $contact->guid, "contactExternalID" => $contact->external_id));
	}
}
