<?php

require_once("lib-api-action/apiaction.php");

use Billing\Manager\CryptManager;

class ForgotPassword extends MB_AdminAPIAction
{
    public function execute()
    {
		parent::execute();

		$clientContact = Factory()->Contact(bgpc("email"), "contact_email");
		if (1 != $clientContact->contact_active) {
			throw new Exception("Client is not active");
		}

		$newPassword = getRandomPassword(12);
        if ("msp" == PACKAGE_TYPE) {
            $clientContact->contact_password = Service()->CryptManager->getPasswordHash($newPassword);
            $clientContact->plainPassword = $newPassword;
            $clientContact->contact_password_type = CryptManager::TYPE_CRYPT;
        } else {
            $clientContact->contact_temp_password = Service()->CryptManager->getPasswordHash($newPassword);
        }
        Service()->ContactManager->update($clientContact);

		require_once("lib-mbapi/include/mail/emailTemplates/passwordNotificationEmail.php");
		$email = new PasswordNotificationEmail( $newPassword, $clientContact->id );
		if (!$email->execute()) {
			throw new Exception("Failed to send email");
		}

		return $this->output();
    }
}