<?php

require_once("lib-api-action/apiaction.php");
require_once("lib-action/include/reports/ARAging.php");
require_once("lib-billing/include/accounting/Accounting.php");

use Billing\Object\LedgerAccount;

class GetClientStatus extends MB_AdminAPIAction
{
	public function execute()
    {
		global $CONF;
		parent::execute();

		if ((int)$_REQUEST["packageID"]){
			$packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"packageID" => (int)$_REQUEST["packageID"],
					),
				),
			)));
			$_REQUEST["clientID"] = $packageInfo["clientID"];
		}

		$clientInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetClients",
				"params" => array(
					"clientID" => (int)$_REQUEST["clientID"],
				),
			),
		)));

		if (!(int)$clientInfo["clientID"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid client ID.");
		}

		$vendorId = Factory()->Customer($_REQUEST["clientID"])->vendor_id;

		$this->reportParams = array(
			"detailLevel" => 0,
			"outputType" => 0,
			"clientID" => (int)$clientInfo["clientID"],
			"generalLedgerDateCreatedMax" => time(),
			"ledgerAccountID" => array(getGeneralLedgerAccountID(LedgerAccount::NAME_ACCOUNTS_RECEIVABLE, $vendorId)),
			);
		$this->report = new ARAgingReport($this->reportParams);
		$this->reportdata = $this->report->execute();

		$agingLevel = 0;
		foreach ((array)$this->reportdata["data"][$clientInfo["clientID"]] as $currency=>$data){
			foreach ((array)$data as $level=>$leveldata){
				if ($leveldata["debits"]>0){
					if ($level>=$agingLevel){
						$agingLevel = $level+1;
					}
				}
			}
		}

		$output = array(
			"clientStatus" => $clientInfo["clientStatus"],
			"clientAPIStatus" => $CONF["APIstatuses"]["client"][$clientInfo["clientStatus"]],
			"clientStatusName" => $CONF["statuses"]["client"][$clientInfo["clientStatus"]],
			"agingLevel" => $agingLevel,
		);


		$retArray = array(
			"api" => array(
				"header" => array(
					"app" => "action-api",
					"success" => 1,
					"timestamp" => time(),
				),
				"results" => $output,
			)
		);

   		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n\n";
		echo toXML($retArray);

		return true;
	}
}
