<?php
require_once ("lib-api-action/apiaction.php");

class GetReportCustomerPaymentsByDate extends MB_AdminAPIAction
{
	public function __construct()
    {
		parent::__construct();
		$this->params = array();

		$this->beginMonth = (int)$_REQUEST["cpBeginMonth"];
		$this->beginDay = (int)$_REQUEST["cpBeginDay"];
		$this->beginYear = (int)$_REQUEST["cpBeginYear"];

		$this->endMonth = (int)$_REQUEST["cpEndMonth"];
		$this->endDay = (int)$_REQUEST["cpEndDay"];
		$this->endYear = (int)$_REQUEST["cpEndYear"];

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;
	}

	public function execute()
    {
		parent::execute();
		$this->addTemplate("", $output = array("reportData" => $this->getReportData()));
		return (!$_REQUEST["__JS"] && !$_REQUEST["__JSON"] && !$_REQUEST["__XML"])?$this->output($output):array();
	}

	public function getReportData()
    {
		dbg("RUNNING IN API REPORT!!!");
		$ret = $params = array(
			"startDate" => $this->startTime,
			"endDate" => $this->endTime,
		);
        if (!is_null($vendorId = getCurrentSession()->getVendorId())) {
            $params["vendorID"] = $vendorId;
        }
		$ret["transactions"] = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetCustomerTransactions",
				"params" => $params,
			),
		));
		return $ret;
	}
}