<?php
require_once ("lib-api-action/apiaction.php");

class GetReportDailyInvoices extends MB_AdminAPIAction
{
	public function __construct()
    {
		parent::__construct();
		$this->params = array();
		list($m, $d, $y) = explode("/", $_REQUEST["dateRange"]);
		dbg("report day: $m $d $y");
		$this->startTime = mktime(0,0,0,$m,$d,$y);
		$this->endTime = $this->startTime + (24*60*60) - 1;
		unset($_REQUEST["dateRange"]);
	}

	public function execute()
    {
		parent::execute();
		$this->addTemplate("", $output = array("reportData" => $this->getReportData()));
		return (!$_REQUEST["__JS"] && !$_REQUEST["__JSON"] && !$_REQUEST["__XML"])?$this->output($output):array();
	}
	
	public function getReportData()
    {
		dbg("RUNNING IN API REPORT!!!");
		$ret = array();
		$ret["startDate"] = $this->startTime;

		$ret["invoices"] = arrayFor(":invoices", array(
            "vendorID" => is_null($vendorId = getCurrentSession()->getVendorId()) ? "NULL" : $vendorId,
			"invoiceDateEnteredGreaterThan" => $this->startTime-1,
			"invoiceDateEnteredLessThan" => $this->endTime+1,
			"sortDir" => "ASC",
			"sortColumn" => "invoiceID",
		));
		$contactIDs = array();
		$clientIDs = array();
		foreach ($ret["invoices"] as $row){
			if ($row["clientContactID"]){
				$contactIDs[] = $row["clientContactID"];
			} else {
				$clientIDs[] = $row["clientID"];
			}
		}
		$contacts = arrayFor(":contacts", array(
			"clientContactID" => $contactIDs,
		)) + arrayFor(":contacts", array(
			"clientID" => $clientIDs,
			"contactPrimary" => 1,
		));
		$keyedContacts = array();
		foreach ($contacts as $x=>$c){
			$keyedContacts[$c["clientID"]] =& $contacts[$x];
		}
		
		
		$ret["numInvoices"] = count($ret["invoices"]);
		$ret["numClients"] = array();
		$clientIDs = array();
		foreach ((array)$ret["invoices"] as $x=>$inv){
			$inv = (array)$inv + (array)$keyedContacts[$inv["clientID"]];
			$ret["invoices"][$x] = (array)$ret["invoices"][$x] + (array)$keyedContacts[$inv["clientID"]];
			$ret["numClients"][$inv["clientID"]] = 1;
			$ret["currencies"][$inv["currencyID"]]["numInvoices"]++;
			$ret["currencies"][$inv["currencyID"]]["numClients"][$inv["clientID"]] = 1;
			$ret["currencies"][$inv["currencyID"]]["totalAmount"] += $inv["invoiceAmount"];
			$ret["currencies"][$inv["currencyID"]]["totalAmountPaid"] += $inv["invoiceAmountPaid"];
		}
		
		$ret["numClients"] = count($ret["numClients"]);
		foreach ((array)$ret["currencies"] as $currencyID=>$data){
			$ret["currencies"][$currencyID]["numClients"] = count($ret["currencies"][$currencyID]["numClients"]);
		}
		return $ret;
	}
}
