<?php
require_once ("lib-api-action/apiaction.php");

class GetReportDailySignups extends MB_AdminAPIAction
{
	public function __construct()
    {
		parent::__construct();
		$this->params = array();

		$this->beginMonth = ((int)$_REQUEST["signupSheetBeginMonth"])?(int)$_REQUEST["signupSheetBeginMonth"]:1;
		$this->beginDay = ((int)$_REQUEST["signupSheetBeginDay"])?(int)$_REQUEST["signupSheetBeginDay"]:1;
		$this->beginYear = ((int)$_REQUEST["signupSheetBeginYear"])?(int)$_REQUEST["signupSheetBeginYear"]:date("Y");

		$this->endMonth = ((int)$_REQUEST["signupSheetEndMonth"])?(int)$_REQUEST["signupSheetEndMonth"]:1;
		$this->endDay = ((int)$_REQUEST["signupSheetEndDay"])?(int)$_REQUEST["signupSheetEndDay"]:1;
		$this->endYear = ((int)$_REQUEST["signupSheetEndYear"])?(int)$_REQUEST["signupSheetEndYear"]:date("Y");

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;
		dbg(date("m-d-Y G:i a", $this->startTime));
		dbg(date("m-d-Y G:i a", $this->endTime));
	}


	public function execute()
    {
		parent::execute();
		$this->addTemplate("", $output = array("reportData" => $this->getReportData()));
		return (!$_REQUEST["__JS"] && !$_REQUEST["__JSON"] && !$_REQUEST["__XML"])?$this->output($output):array();
	}

	public function getReportData()
    {
		dbg("RUNNING IN API REPORT!!!");
		$ret = array();
		$ret["startDate"] = $this->startTime;
		$ret["endDate"] = $this->endTime;

		$invoices = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"mergeContactData" => 1,
					"clientDateCreatedLeast" => $this->startTime,
					"clientDateCreatedGreatest" => $this->endTime,
					"getInvoiceLineItemsData" => 1,
                    "vendorID" => getCurrentSession()->getVendorId(),
				),
			),
		)));

		$packageIDs = array();
		$packageAddonIDs = array();
		foreach ((array)$invoices as $invoice){
			foreach ((array)$invoice["lineItems"] as $li){
				if ($li["packageAddonID"]){
					$packageAddonIDs[$li["packageAddonID"]] = 1;
				} else {
					$packageIDs[$li["packageID"]] = 1;
				}
			}
		}
		$packageAddonIDs = array_keys($packageAddonIDs);
		$packageIDs = array_keys($packageIDs);
    	$packagesInfo = array();
        foreach($packageIDs as $id) {
			if (false !== ($subscription = reset(Factory()->SubscriptionList(array("package_id" => $id))))) {
				$packagesInfo[] = $subscription->getCamelCaseFields();
			}
        }

        $packageAddonsInfo = ($packageAddonIDs) ? arrayFor("packageAddons", array("packageAddonID" => $packageAddonIDs)) : array() ;
		$addonsToProducts = $packagesToProducts = array();

		$productIDs = array();
		foreach ((array)$packagesInfo as $pkg){
			$packagesToProducts[$pkg["packageID"]] = $pkg["productID"];
			$productIDs[$pkg["productID"]] = 1;
		}
		foreach ((array)$packageAddonsInfo as $pkg){
			$addonsToProducts[$pkg["packageAddonID"]] = $pkg["packageAddonProductID"];
			$productIDs[$pkg["packageAddonProductID"]] = 1;
		}
		$productIDs = array_keys($productIDs);

		foreach($productIDs as $id) {
			if (false !== ($plan = reset(Factory()->PlanList(array("product_id" => $id))))) {
				$product = $plan->getCamelCaseFields();
				$ret["productNames"][$product["productID"]] =  ((int)$product["productAddonGroupID"]) ? "&nbsp;&nbsp;".blmsg("TRANS_ADDON").": ".$product["productName"] : $product["productName"] ;
			}
		}

		$invoicedClients = array();
		$ret["datedProductTotals"] = array();
		$ret["productTotals"] = array();
		$ret["datedClients"] = array();
		$ret["datedClientTotals"] = array();
		$ret["totalClients"] = 0;
		$ret["totalProducts"] = array();
		$ret["currencyTotals"] = array();


		foreach ((array)$invoices as $x=>$invoice){
			if (!$invoicedClients[$invoice["clientID"]]){
                $date = date("m-d-Y", $invoice["clientDateCreated"]);
				foreach ((array)$invoice["lineItems"] as $xx=>$lineItem){
					if ((int)$lineItem["packageAddonID"]){
						$tpid = $addonsToProducts[$lineItem["packageAddonID"]];
					} else {
						$tpid = $packagesToProducts[$lineItem["packageID"]];
					}

					$ret["totalProducts"][$tpid] = 1;
					$ret["productTotals"][$tpid]["num"]++;
					$ret["productTotals"][$tpid]["rev"][$invoice["currencyID"]] += $lineItem["lineItemTotalAmount"];
					$ret["datedTotalProducts"][$date]++;
					$ret["datedProductTotals"][$date][$tpid]["num"]++;
					$ret["datedProductTotals"][$date][$tpid]["rev"][$invoice["currencyID"]] += $lineItem["lineItemTotalAmount"];

				}
				$ret["currencyTotals"][$invoice["currencyID"]] += $invoice["invoiceAmount"];
				unset($invoices[$x]["lineItems"]);
				$invoicedClients[$invoice["clientID"]] = 1;
				$ret["totalClients"]++;
				$ret["datedClientTotals"][$date]++;
				$ret["datedClients"][$date][] = $invoices[$x];
			} // else its not their first invoice so we don't need it
		}

		$ret["totalProducts"] = count($ret["totalProducts"]);

		return $ret;
	}
}