<?php

require_once("lib-api-action/apiaction.php");

class UpdatePackage extends MB_AdminAPIAction
{
	function UpdatePackage() {
		parent::MB_AdminAPIAction();
		$this->stringRep = "UpdatePackage";
		$this->params = array(
			"taxZoneGroupID",
			"packageName",
			"packageQuantity",
			"packageProratable",
			"packageDateNextRenewal",
			"packageDateStopRenewal",
			"packageActive",
			"packageStatus",
			"packageComments",
			"packageType",
			"packagePrice",
			"packageSetup",
			"packagePriceLock",
			"packageCancellationType",
			"cycleID",
			"usageDateNextRenewal",
			"usageCycleID",
			"usageCalculateOnly",
			"couponNumCycles",
			"packageClientPermissions",
			"couponPrice",
			"packagePendingCancellation",
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));

		if (!(int)$packageInfo["packageID"]){
			Error::api(1001, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to pass a valid package ID.");
		}

		if ((int)$_REQUEST["terminate"]){
			$_REQUEST["packagePendingCancellation"] = getAPITypeID("pendingcancellation", "admin");
		}
		if ((int)$_REQUEST["unterminate"]){
			$_REQUEST["packagePendingCancellation"] = getAPITypeID("pendingcancellation", "none");
		}
		if ((int)$_REQUEST["enable"]){
			$_REQUEST["packageStatus"] = getAPIStatusID("package", "none");
		}

		$params = array();
		foreach ($this->params as $field){
			if (isset($_REQUEST[$field])){
				$params[$field] = $_REQUEST[$field];
			}
		}

		$results = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetPackages",
				"subCommand" => "update",
				"params" => array(
					"packageID" => $packageInfo["packageID"],
				) + $params,
			),
		)), 1);

		if (!(int)$results["mbapi"][0]["header"][0]["success"][0]){
			Error::api(1002, "[Ax".str_pad((int) __LINE__, 6, "0", STR_PAD_LEFT)."] Failed to update package.");
		}

		$retArray = array(
			"api" => array(
				"header" => array(
					"app" => "action-api",
					"action" => "updatePackage",
					"success" => 1,
					"timestamp" => time(),
				),
				"results" => array(),
			)
		);

   		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?".">\n\n";
		echo toXML($retArray);

		return true;
	}
}
