<?php
require_once("action-api/include/lib-action/api/UpdateClientContact.php");

class ValidateContact extends UpdateClientContact
{
    public function execute()
    {
        MB_AdminAPIAction::execute();

        if ( !is_null($id = bgpc("clientID")) ) {
            $customer = Factory()->Customer($id);
        } else if ( !is_null($guid = bgpc("clientGUID")) ) {
            $customer = Factory()->Customer($guid, "guid");
        } else if ( !is_null($externalId = bgpc("customerExternalID")) ) {
            $customer = Factory()->Customer($externalId, "external_id");
        } else {
            throw new ProductException(ProductException::E_OBJECT_NOT_FOUND, "Missing customer identifier");
        }

        $contact = Factory()->Contact();
        $contact->client_id = $customer->id;
        $this->collectContact($contact);
        if (count($violations = Service()->ContactManager->validate($contact))) {
            return $this->output(array("violations" => $violations->toArray()));
        }

        return $this->output();
    }
}