<?php
require_once("action-api/include/lib-action/api/UpdateClientContact.php");

class ValidateCustomer extends UpdateClientContact
{
    public function execute()
    {
        MB_AdminAPIAction::execute();

        if ( !is_null($externalId = bgpc("customerExternalID")) ) {
            $contact = Factory()->Customer($externalId, "external_id")->PrimaryContact;
        } else {
            throw new ProductException(ProductException::E_OBJECT_NOT_FOUND, "Missing customer identifier");
        }

        $this->collectContact($contact);
        if (count($violations = Service()->ContactManager->validate($contact))) {
            return $this->output(array("violations" => $violations->toArray()));
        }

        return $this->output();
    }
}