<?php

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This version of APILoginResponse executes an ADMIN login.
 *
 * @author  Michael Fountain
 */
class APILoginResponse extends MB_Action {
	/**
	 * The constructor for a APILoginResponse action object. This calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function APILoginResponse() {
		parent::MB_Action();
		$this->stringRep = "APILoginResponse";
	}

	/**
	 * The main method of this class that executes the APILoginResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminRemoteAccessHash = secureInput($CONF["user"]["remoteAccessHash"]);
		$internalAdmin = secureInput($CONF["user"]["internalAdmin"]);

		$query = $this->getMBAPIQuery("ProcessAdminLogin", "", array("adminIP" => $CONF["user"]["ip"], "adminRemoteAccessHash" => $adminRemoteAccessHash, "internalAdmin" => $internalAdmin));
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

			if(is_array($data["mbapi"][0]["results"][0]["adminID"])) {
			 	dbg("inside");
				$_REQUEST["sid"] = $data["mbapi"][0]["results"][0]["sessionID"][0];

				//If it's a remote API call, let it bubble back instead of redirect
				$_REQUEST["adminID"] = $data["mbapi"][0]["results"][0]["adminID"][0];
				$CONF["user"]["type"] = 2;
				$CONF["user"]["sessionID"] = $_REQUEST["sid"];
				$this->hasExecutedSuccessfully = 1;
				return $this->hasExecutedSuccessfully();

			}
		} else {
			Error::fatal(blmsg("TRANS_AUTH_FAILED"), "Failed to authenticate.");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
