<?php
require_once("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class AddLedgerAccount extends MB_Action
{
	public function execute()
    {
		global $CONF;
		parent::execute();

        $this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

        $accounts = array();
		foreach (Factory()->LedgerAccountList(array('vendor_id' => getCurrentSession()->getVendorId())) as $account) {
			$accounts[] = array(
				'ledgerAccountID' => $account->id,
				'ledgerAccountNumber' => $account->ledger_account_number,
				'ledgerAccountType' => $account->ledger_account_type,
				'ledgerAccountTransKey' => $account->ledger_account_trans_key
			);
		}
		$this->smartyVars["ledgerAccounts"] = $accounts;
        $this->smartyVars["buttons"] = array(
            array('id' => 'billing-id-save', 'class' => 'action', 'name' => 'save', 'value' => "TRANS_SAVE_LEDGER_ACCOUNT_DETAILS", 'type' => 'submit', 'label' => 'TRANS_SAVE_LEDGER_ACCOUNT_DETAILS'),
        );

        $this->addTemplate("accounting/AddLedgerAccount", $this->smartyVars);


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}