<?php
require_once ("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class EditGeneralJournalEntry extends MB_Action
{
	public function execute()
    {
		parent::execute();
		$generalJournalID = (int)$_REQUEST["generalJournalID"];
		$this->smartyVars["generalJournalID"] = $generalJournalID;
		if(!$generalJournalID) {
			$this->addError('TRANS_ACTIONERROR', "No General Journal ID given.");
		} else {

			$journalInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetAccountingGeneralJournal",
					"params" => array(
						"generalJournalID" => $generalJournalID,
					)
				)
			)));

			if (isset($journalInfo["generalJournalID"])){
				$data =& $journalInfo;
				$this->smartyVars["currencyID"] = $data["currencyID"];
				$this->smartyVars["generalDescription"] = $data["generalDescription"];
				$this->smartyVars["generalDateCreated"] = $data["generalDateCreated"];
				$this->smartyVars["generalDateCreatedYear"] = date("Y", $this->smartyVars["generalDateCreated"]);
				$this->smartyVars["generalDateCreatedMonth"] = date("m", $this->smartyVars["generalDateCreated"]);
				$this->smartyVars["generalDateCreatedDay"] = date("d", $this->smartyVars["generalDateCreated"]);

				$this->smartyVars["formValues"] = $this->smartyVars;

				$entryInfo = correctArray(grabResultsFromMBAPIArraY(array(
					"mbapi" => array(
						"command" => "GetAccountingGeneralLedger",
						"params" => array(
							"journalTableName" => "accounting_general_journal",
							"journalTableID" => $generalJournalID,
						)
					)
				)));

				if (isset($entryInfo[0]["generalLedgerID"])){

					$this->smartyVars["existingEntries"] = $entryInfo;
					$this->addLedgerAccounts();
                    $this->smartyVars["buttons"] = array(
                        array('id' => 'billing-id-save', 'class' => 'action', 'name' => 'save', 'value' => "TRANS_SAVE", 'type' => 'submit', 'label' => 'TRANS_SAVE'),
                    );
					$this->addTemplate("accounting/EditGeneralJournalEntry", $this->smartyVars);

				} else {
					$this->addError('TRANS_ACTIONERROR', "No General Ledger Entries Found.");
				}

			} else {
				$this->addError('TRANS_ACTIONERROR', "General Journal Entry Not Found.");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
