<?php
require_once("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class EditLedgerAccount extends MB_Action
{
    public $params = array("ledgerAccountID");

	public function execute()
    {
		global $CONF;
		parent::execute();

        $this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

        $query = $this->getMBAPIQuery("GetAccountingLedgerAccounts", "", array("ledgerAccountID"=>(int)$_REQUEST["ledgerAccountID"]));
        $data = dispatchMBAPI($query, 1);

        $this->smartyVars["account"] = collapseArrayElements($data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]);

        foreach (Factory()->LedgerAccountList(array('vendor_id' => getCurrentSession()->getVendorId())) as $account) {
            $accounts[] = array(
                'ledgerAccountID' => $account->id,
                'ledgerAccountNumber' => $account->ledger_account_number,
                'parentLedgerAccountID' => $account->parent_ledger_account_id,
                'ledgerAccountType' => $account->ledger_account_type,
                'ledgerAccountName' => $account->ledger_account_name,
                'vendorID' => $account->vendor_id,
                'ledgerAccountTransKey' => $account->ledger_account_trans_key
            );
        }
        foreach ($accounts as $key => $accountLedger){
            if ($accountLedger["ledgerAccountType"]!=$this->smartyVars["account"]["ledgerAccountType"] || $accountLedger["ledgerAccountID"]==$this->smartyVars["account"]["ledgerAccountID"]){
                unset($accounts[$key]);
            }
        }

        $this->smartyVars["ledgerAccounts"] = array_values($accounts);
        $this->smartyVars["buttons"] = array(
            array('id' => 'billing-id-save', 'class' => 'action', 'name' => 'save', 'value' => "TRANS_SAVE_LEDGER_ACCOUNT_DETAILS", 'type' => 'submit', 'label' => 'TRANS_SAVE_LEDGER_ACCOUNT_DETAILS'),
        );

        $this->addTemplate("accounting/EditLedgerAccount", $this->smartyVars);


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}