<?php

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-billing/include/accounting/Accounting.php");

/**
 * This Action object collects information on a ledger account, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class RemoveLedgerAccount extends MB_Action {
	/**
	 * The constructor for a RemoveLedgerAccount action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function RemoveLedgerAccount() {
		parent::MB_Action();
		$this->stringRep = "EditLedgerAccount";
		$this->params = array("ledgerAccountID");

	}

	/**
	 * The main method of this class that executes the RemoveLedgerAccount action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$account = Factory()->LedgerAccount(bgpc('ledgerAccountID'));
		$defaultAccountsInfo = Service()->AccountingLedgerAccountManager->getDefaultAccountsInfo();
		if (isset($defaultAccountsInfo[$account->ledger_account_name])) {
			throw new ForbiddenOperationException('TRANS_ERROR_DELETE_DEFAULT_LEDGER_ACCOUNT');
		}

        $xmlParams = array
        (
            "ledgerAccountID" => ((int)$_REQUEST["ledgerAccountID"])
        );
        $ledgerDataXML = $this->getMBAPIQuery("GetAccountingGeneralLedger", "",  $xmlParams, 1, 1, 1, 1);
        $ledgerDataReturn = dispatchMBAPI($ledgerDataXML, 1);
        $ledgerData = $ledgerDataReturn["mbapi"][0]["header"][0]["numResults"][0];

        $canRemove = ((int)$ledgerData)?0:1;

        $this->smartyVars["canRemove"] = $canRemove;
		$ledgerAccountID = bgpc("ledgerAccountID");
        if ($canRemove && (int)$ledgerAccountID && (int)$_REQUEST["removeLedgerAccount"]){

			if ("taxes_payable" == Factory()->LedgerAccount($ledgerAccountID)->ledger_account_name) {
				billing_put_error(blmsg("TRANS_TAXES_PAYABLE_LEDGER_REMOVE_ERROR"));
				redirect("accounting.php", getActionID("ShowLedgerAccounts"));
			}

            $removeXML = "
            <mbapi>
                <command>SetAccountingGeneralLedgerAccount</command>
                <subCommand>delete</subCommand>
                <params>
                    <ledgerAccountID>".((int)$ledgerAccountID)."</ledgerAccountID>
                </params>
            </mbapi>
            ";
            dispatchMBAPI($removeXML);

            if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
                redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
            } else {
            	redirect(action_url('accounting', 'ShowLedgerAccounts'));
            }

        } else {

            $query = $this->getMBAPIQuery("GetAccountingLedgerAccounts", "", array("ledgerAccountID"=>(int)$_REQUEST["ledgerAccountID"]));
            $CONF["debug"]->add("Action Command (ShowLedgerAccountDetails:GetAccountingLedgerAccounts)", htmlentities($query));
            $data = dispatchMBAPI($query, 1);
            $CONF["debug"]->add("Action Result (EditLedgerAccount:GetAccountingLedgerAccounts)", $data);

            $this->smartyVars["account"] = collapseArrayElements($data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]);

            $this->addTemplate("accounting/RemoveLedgerAccount", $this->smartyVars);

        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditLedgerAccount
?>