<?php

require_once("lib-action/action.php");
require_once("lib-billing/include/accounting/Accounting.php");
require_once("lib-action/include/reports/ARAging.php");

use Billing\Object\LedgerAccount;

class ShowAccountingStats extends MB_Action
{
	public function execute()
    {
		global $CONF;
		parent::execute();

		$this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];
		list($m, $d, $y) = explode("/", date("m/d/Y"));
		$today = mktime(0,0,0,$m,$d,$y);

		$accountsXML = "
                    <mbapi>
                       <command>GetAccountingLedgerAccounts</command>
                       <showXMLHeader>0</showXMLHeader>
                       <params>
                         <sortDir>ASC</sortDir>
                         <sortColumn>ledgerAccountNumber</sortColumn>
                         <recordOffset>0</recordOffset>
                         <numRecords>-1</numRecords>
                       </params>
                    </mbapi>
                    ";
		$accounts = dispatchMBAPI($accountsXML, 1);

		$this->smartyVars["ledgerAccounts"] = array();
		foreach ($accounts["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"] as $ledgerAccount){
			$this->smartyVars["ledgerAccounts"][$ledgerAccount["ledgerAccountID"][0]] = collapseArrayElements($ledgerAccount);
		}

		$ledgerEntriesXML = "
                    <mbapi>
                      <command>GetAccountingGeneralLedger</command>
                      <showXMLHeader>0</showXMLHeader>
                      <params>
                        <generalLedgerDateCreatedGreaterThan>$today</generalLedgerDateCreatedGreaterThan>
                        <groupByAndSum>1</groupByAndSum>
                        <sortDir>ASC</sortDir>
                        <sortColumn>generalLedgerID</sortColumn>
                        <recordOffset>0</recordOffset>
                        <numRecords>-1</numRecords>
                      </params>
                    </mbapi>
                    ";
		$ledgerEntries = dispatchMBAPI($ledgerEntriesXML, 1);


		$this->smartyVars["accountTotals"] = array();

		if (isset($ledgerEntries["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"])){
			foreach ($ledgerEntries["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"] as $entry){
				$this->smartyVars["accountTotals"][$entry["currencyID"][0]][$entry["ledgerAccountID"][0]]["accountInfo"] = $this->smartyVars["ledgerAccounts"][$entry["ledgerAccountID"][0]];
				$this->smartyVars["accountTotals"][$entry["currencyID"][0]][$entry["ledgerAccountID"][0]]["credits"] += $entry["generalLedgerCreditAmount"][0];
				$this->smartyVars["accountTotals"][$entry["currencyID"][0]][$entry["ledgerAccountID"][0]]["debits"] += $entry["generalLedgerDebitAmount"][0];
			}
		}

        $this->smartyVars["ledgerTypeTotals"] = array();
        foreach ($this->smartyVars["accountTotals"] as $currencyID => $accountTotals){
            $this->smartyVars["ledgerTypeTotals"][$currencyID] = array();
            foreach ($accountTotals as $accountID => $totalInfo){
                $accountType = $CONF["ledgerCategories"][$totalInfo["accountInfo"]["ledgerAccountType"]][0];

                switch ($accountType){
                    case "revenue":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["revenue"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["revenue"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] -= $totalInfo["debits"];
                        break;
                    case "otherRev":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["otherRev"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["otherRev"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] -= $totalInfo["debits"];
                        break;
                    case "cogs":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["cogs"] -= $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["cogs"] += $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] -= $totalInfo["debits"];
                        break;
                    case "expense":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["expense"] -= $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["expense"] += $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] -= $totalInfo["debits"];
                        break;
                    case "otherExp":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["otherExp"] -= $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["otherExp"] += $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["total"] -= $totalInfo["debits"];
                        break;

                    default:
                        unset($this->smartyVars["accountTotals"][$currencyID][$accountID]);

                }

            }
        }

        unset($this->smartyVars["accountTotals"]);

        //////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////*/
        $ledgerEntriesXML = "
                    <mbapi>
                      <command>GetAccountingGeneralLedger</command>
                      <showXMLHeader>0</showXMLHeader>
                      <params>
                        <groupByAndSum>1</groupByAndSum>
                        <sortDir>ASC</sortDir>
                        <sortColumn>generalLedgerID</sortColumn>
                        <recordOffset>0</recordOffset>
                        <numRecords>-1</numRecords>
                      </params>
                    </mbapi>
                    ";
        $ledgerEntries = dispatchMBAPI($ledgerEntriesXML, 1);

        $CONF["debug"]->debugMessage("account totals");
        $CONF["debug"]->debugMessage($this->smartyVars["accountTotals"]);

        if (isset($ledgerEntries["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"])){
            foreach ($ledgerEntries["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"] as $entry){
                $this->smartyVars["accountTotals"][$entry["currencyID"][0]][$entry["ledgerAccountID"][0]]["accountInfo"] = $this->smartyVars["ledgerAccounts"][$entry["ledgerAccountID"][0]];
                $this->smartyVars["accountTotals"][$entry["currencyID"][0]][$entry["ledgerAccountID"][0]]["credits"] += $entry["generalLedgerCreditAmount"][0];
                $this->smartyVars["accountTotals"][$entry["currencyID"][0]][$entry["ledgerAccountID"][0]]["debits"] += $entry["generalLedgerDebitAmount"][0];
            }
        }

        $CONF["debug"]->debugMessage("account totals");
        $CONF["debug"]->debugMessage($this->smartyVars["accountTotals"]);

        $this->smartyVars["accountTotals"] = (array)$this->smartyVars["accountTotals"];
        foreach ($this->smartyVars["accountTotals"] as $currencyID => $accountTotals){
            if (!$this->smartyVars["ledgerTypeTotals"][$currencyID])$this->smartyVars["ledgerTypeTotals"][$currencyID] = array();
            foreach ($accountTotals as $accountID => $totalInfo){
                $accountType = $CONF["ledgerCategories"][$totalInfo["accountInfo"]["ledgerAccountType"]][0];

                switch ($accountType){
                    case "asset":
                        $totalInfo["total"] = $totalInfo["debits"]-$totalInfo["credits"];
                        $this->smartyVars["ledgerAccountsTotals"][$currencyID]["asset"][] = $totalInfo;
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["asset"] -= $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["asset"] += $totalInfo["debits"];
                        //$this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] -= $totalInfo["credits"];
                        //$this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] += $totalInfo["debits"];
                        break;
                    case "liability":
                        $totalInfo["total"] = $totalInfo["credits"]-$totalInfo["debits"];
                        $this->smartyVars["ledgerAccountsTotals"][$currencyID]["liability"][] = $totalInfo;
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["liability"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["liability"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] -= $totalInfo["debits"];
                        break;
                    case "equity":
                        $totalInfo["total"] = $totalInfo["credits"]-$totalInfo["debits"];
                        $this->smartyVars["ledgerAccountsTotals"][$currencyID]["equity"][] = $totalInfo;
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equity"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equity"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] -= $totalInfo["debits"];
                        break;
                    case "revenue":
                    case "otherRev":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equityretained"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equityretained"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] -= $totalInfo["debits"];
                        break;
                    case "cogs":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equityretained"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equityretained"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] -= $totalInfo["debits"];
                        break;
                    case "expense":
                    case "otherExp":
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equityretained"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["equityretained"] -= $totalInfo["debits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] += $totalInfo["credits"];
                        $this->smartyVars["ledgerTypeTotals"][$currencyID]["balancetotal"] -= $totalInfo["debits"];
                        break;
                    default:
                        unset($this->smartyVars["accountTotals"][$currencyID][$accountID]);
                }

            }
        }

        //////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////


	// generate the aging report and throw it to smarty.
	$this->reportParams = array(
		"detailLevel" => 0,
		"outputType" => 0,
		"groupByAndSum" => 1,
		);

	$endPointTimestamp = explode("/", date("m/d/Y"));
	$this->smartyVars["endDate"] = $this->reportParams["generalLedgerDateCreatedMax"] = mktime(0,0,0,$endPointTimestamp[0],$endPointTimestamp[1]+1,$endPointTimestamp[2]);

	$this->reportParams["ledgerAccountID"] = array(getGeneralLedgerAccountID(LedgerAccount::NAME_ACCOUNTS_RECEIVABLE, getCurrentSession()->getVendorId()));

	$this->report = new ARAgingReport($this->reportParams);
	$this->smartyVars["reportData"] = $this->report->execute();



        ksort($this->smartyVars["ledgerTypeTotals"]);

		$this->addTemplate("accounting/ShowAccountingStats");

	} // execute
}
