<?php

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-billing/include/accounting/Accounting.php");

/**
 * This Action object collects information on all receipt journal records that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class ShowAccountsPayableLedger extends MB_Action {
	/**
	 * The constructor for a ShowAccountsPayableLedger action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowAccountsPayableLedger() {
		parent::MB_Action();
		$this->stringRep = "ShowAccountsPayableLedger";

		$this->params = array
		(
			"generalLedgerDateCreated",
            "generalLedgerDateCreatedLeast",
            "generalLedgerDateCreatedGreatest"
		);

		$_REQUEST["generalLedgerDateCreatedLeast"] = $this->handleDateSelector("apLedgerBegin", 0);
		$_REQUEST["generalLedgerDateCreatedGreatest"] = $this->handleDateSelector("apLedgerEnd", 0);
		if ((int)$_REQUEST["generalLedgerDateCreatedGreatest"])$_REQUEST["generalLedgerDateCreatedGreatest"] += (24*60*60);

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["dateQuery"][0]){
			$this->origDateQuery = $_REQUEST["dateQuery"];
			if ((int)$_REQUEST["dateQuery"][0]>100000){
				$_REQUEST["dateQuery"][0] = date("Y/m/d", $_REQUEST["dateQuery"][0]);
			}
			list($dY,$dM,$dD) = explode("/",$_REQUEST["dateQuery"][0]);
			$_REQUEST["dateQuery"][0] = $_REQUEST["generalLedgerDateCreatedLeast"] = mktime(0,0,0,$dM,$dD,$dY);
			$_REQUEST["generalLedgerDateCreatedGreatest"] = mktime(0,0,0,$dM,$dD+1,$dY)-1;
		}

		$this->sortColumns = ($_REQUEST["sortColumn"])?array($_REQUEST["sortColumn"]):array("generalLedgerDateCreated");
	}

	/**
	 * The main method of this class that executes the ShowAccountsPayableLedger action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		foreach (array(
			"apLedgerBeginMonth",
			"apLedgerBeginDay",
			"apLedgerBeginYear",
			"apLedgerEndMonth",
			"apLedgerEndDay",
			"apLedgerEndYear",
			"dateQuery") as $field){
			$this->smartyVars[$field] = $_REQUEST[$field];
		}
		$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];

		$xmlArgs = array
		(
			"generalLedgerType" => getGeneralLedgerTypeID("accounts_payable"),
			"vendorID" => getCurrentSession()->getVendorId()
		);
		$query = $this->getMBAPIQuery("GetAccountingGeneralLedger","",$xmlArgs,1,1,1,1);
		$data = dispatchMBAPI($query, 1);

        $this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
        $results =& $data["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"];


        $this->smartyVars["currencies"] = array();

        for ($i = 0; $i < count($results); $i++){

            $this->smartyVars["currencies"][$results[$i]["currencyID"][0]][] = collapseArrayElements($results[$i]);

        }

        $this->addTemplate("accounting/ShowAccountsPayableLedger");


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowAccountsPayableLedger
?>