<?php
set_time_limit(0);
require_once("lib-action/action.php");
require_once("lib-billing/include/accounting/Accounting.php");
require_once("lib-action/include/reports/ARAging.php");

use Billing\Object\LedgerAccount;

class ShowAgingReport extends MB_Action
{
	public function execute()
    {
		parent::execute();

		$this->reportParams = array(
			"detailLevel" => 0,
			"outputType" => 0,
			"recordOffset" => 0,
			);

		if (is_array($_REQUEST["reportParams"])){
			foreach ((array)$_REQUEST["reportParams"] as $k=>$v){
				$this->reportParams[$k] = $v;
			}
		}

		if ((int)$_REQUEST["recordOffset"]){
			$this->reportParams["recordOffset"] = (int)$_REQUEST["recordOffset"];
		}

		if ((int)$_REQUEST["clientID"]){
			$this->reportParams["clientID"] = (int)$_REQUEST["clientID"];
		}

		// sanify our date
		if ($_REQUEST["dateRange"]){
			$endPointTimestamp = explode("/", unsecureInput($_REQUEST["dateRange"]));
			if ($endPointTimestamp[0]<1 || $endPointTimestamp[0]>12)$endPointTimestamp[0] = date("m");
			if ($endPointTimestamp[1]<1 || $endPointTimestamp[1]>31)$endPointTimestamp[1] = date("d");
			if ($endPointTimestamp[2]<2000)$endPointTimestamp[2] = date("Y");
			unset($_REQUEST["dateRange"]); // we dont want addTemplate to throw it to smarty
		} else {
			$endPointTimestamp = explode("/", date("m/d/Y"));
		}
		$this->smartyVars["endDate"] = $this->reportParams["generalLedgerDateCreatedMax"] = mktime(0,0,0,$endPointTimestamp[0],$endPointTimestamp[1]+1,$endPointTimestamp[2]);

		if ($_REQUEST["ledgerAccountIDs"]){
			$this->reportParams["ledgerAccountID"] = array();
			foreach ($_REQUEST["ledgerAccountIDs"] as $acct){
				if ((int)$acct)$this->reportParams["ledgerAccountID"][] = (int)$acct;
			}
		} else {
			$this->reportParams["ledgerAccountID"] = array(getGeneralLedgerAccountID(LedgerAccount::NAME_ACCOUNTS_RECEIVABLE, getCurrentSession()->getVendorId()));
		}

		$this->report = new ARAgingReport($this->reportParams);
		//dbg($this->report->execute());
		$this->smartyVars["reportData"] = $this->report->execute();
		$this->smartyVars["paginationLinks"] =& $this->smartyVars["reportData"]["paginationLinks"];

		$this->addTemplate("accounting/ShowAgingReport");
	}
}
