<?php
require_once("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class ShowCashFlow extends MB_Action {

	public function __construct()
    {
		parent::MB_Action();
		$this->beginMonth = ((int)$_REQUEST["cashFlowBeginMonth"])?(int)$_REQUEST["cashFlowBeginMonth"]:1;
		$this->beginDay = ((int)$_REQUEST["cashFlowBeginDay"])?(int)$_REQUEST["cashFlowBeginDay"]:1;
		$this->beginYear = ((int)$_REQUEST["cashFlowBeginYear"])?(int)$_REQUEST["cashFlowBeginYear"]:date("Y");

		$this->endMonth = ((int)$_REQUEST["cashFlowEndMonth"])?(int)$_REQUEST["cashFlowEndMonth"]:1;
		$this->endDay = ((int)$_REQUEST["cashFlowEndDay"])?(int)$_REQUEST["cashFlowEndDay"]:1;
		$this->endYear = ((int)$_REQUEST["cashFlowEndYear"])?(int)$_REQUEST["cashFlowEndYear"]:date("Y");

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;

		$this->startYearTime = mktime(0,0,0,1,1,$this->beginYear);
	}

	public function execute()
    {
		parent::execute();

		$this->smartyVars["startDate"] = $this->startTime;
		$this->smartyVars["endDate"] = $this->endTime;

		$ledgerEntries = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetAccountingGeneralLedger",
				"params" => array(
					"generalLedgerDateCreatedLeast" => $this->startTime,
					"generalLedgerDateCreatedGreatest" => $this->endTime,
					"groupByAndSum" => 1,
					"ledgerAccountName" => $this->cashFlowAccounts = array(
						"cash",
						"cash_1",
						"cash_2",
						"accounts_receivable",
						"customer_credits",
						"authorized_payments",
						"deferred_revenue",
					),
					"sortColumn" => "currencyID",
					"sortDir" => "ASC",
					"vendorID" => getCurrentSession()->getVendorId()
				),
			),
		)));

		$this->smartyVars["noData"] = (count($ledgerEntries))?0:1;

		if (!$this->smartyVars["noData"]){
			$this->smartyVars["accountTotals"] = array();
			$this->smartyVars["currencies"] = array();

			foreach ($ledgerEntries as $entry){
				$this->smartyVars["currencies"][$entry["currencyID"]] = 1;
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]]["accountInfo"] = $entry;
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]][$entry["currencyID"]]["credits"] += $entry["generalLedgerCreditAmount"];
				$this->smartyVars["accountTotals"][$entry["ledgerAccountName"]][$entry["currencyID"]]["debits"] += $entry["generalLedgerDebitAmount"];
			}

			$this->smartyVars["currencies"] = array_keys($this->smartyVars["currencies"]);
			ksort($this->smartyVars["currencies"]);
		}

		$this->addTemplate("accounting/ShowCashFlow");

	} // execute
}