<?php

require_once("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class ShowGeneralLedger extends MB_Action {

	public function __construct()
    {
		parent::MB_Action();
		$this->params = array
		(
			"generalLedgerDateCreated",
            "generalLedgerDateCreatedLeast",
            "generalLedgerDateCreatedGreatest"
		);

		$_REQUEST["generalLedgerDateCreatedLeast"] = $this->handleDateSelector("generalLedgerBegin", 0);
		$_REQUEST["generalLedgerDateCreatedGreatest"] = $this->handleDateSelector("generalLedgerEnd", 0);
		if ((int)$_REQUEST["generalLedgerDateCreatedGreatest"])$_REQUEST["generalLedgerDateCreatedGreatest"] += (24*60*60);

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["dateQuery"][0]){
			if ((int)$_REQUEST["dateQuery"][0]>100000){
				$_REQUEST["dateQuery"][0] = date("Y/m/d", $_REQUEST["dateQuery"][0]);
			}
			list($dY,$dM,$dD) = explode("/",$_REQUEST["dateQuery"][0]);
			$_REQUEST["dateQuery"][0] = $_REQUEST["generalLedgerDateCreatedLeast"] = mktime(0,0,0,$dM,$dD,$dY);
			$_REQUEST["generalLedgerDateCreatedGreatest"] = mktime(0,0,0,$dM,$dD+1,$dY)-1;
		}

		$this->sortColumns = ($_REQUEST["sortColumn"])?array($_REQUEST["sortColumn"]):array("generalLedgerDateCreated");
	}

	public function execute()
    {
		parent::execute();

    		foreach (array(
			"generalLedgerBeginMonth",
			"generalLedgerBeginDay",
			"generalLedgerBeginYear",
			"generalLedgerEndMonth",
			"generalLedgerEndDay",
			"generalLedgerEndYear",
			"dateQuery") as $field){
			$this->smartyVars[$field] = $_REQUEST[$field];
		}
		$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];

		$xmlArgs = array
		(
			"generalLedgerType" => getGeneralLedgerTypeID("general"),
			"getInvoiceData" => 1,
			"vendorID" => getCurrentSession()->getVendorId()
		);
		$query = $this->getMBAPIQuery("GetAccountingGeneralLedger","",$xmlArgs,1,1,1,1);
		$data = dispatchMBAPI($query, 1);

        $this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
		$results =& $data["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"];

        $this->smartyVars["currencies"] = array();
		$ledgerEntryIDs = array();
		$invoiceIDs = array();
        for ($i = 0; $i < count($results); $i++){
        	$ledgerEntryIDs[] = $results[$i]["generalLedgerID"][0];
        	$invoiceIDs[] = $results[$i]["invoiceID"][0];
            $this->smartyVars["currencies"][$results[$i]["currencyID"][0]][] = collapseArrayElements($results[$i]);
        }

////////////////// getting package names if we can for these entries
		$invoiceData = correctArray(grabResultsFromMBAPIArray2(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"invoiceID" => $invoiceIDs,
					"getInvoiceLineItemsData" => 1,
				),
			),
		)));
		$this->smartyVars["keyedInvoices"] = array();
		$this->smartyVars["lineItemsToPackages"] = array();
		if (is_array($invoiceData)){
			foreach ($invoiceData as $invoice){
				foreach ((array)$invoice["lineItems"] as $li){
					$this->smartyVars["lineItemNames"][$li["lineItemID"]] = array(
						"name" => "(".$li["packageID"].") ".$li["lineItemDescription"],
						"packageID" => $li["packageID"],
						"lineItemID" => $li["lineItemID"],
					);
				}
				$this->smartyVars["keyedInvoices"][$invoice["invoiceID"]] = $invoice;
			}
		}
		// ok, we have successfully gotten the accounting data

		// lets get the packages for those ledger entry ids
		$controlData = correctArray(grabResultsFromMBAPIArray2(array(
			"mbapi" => array(
				"command" => "GetAccountingControlRel",
				"params" => array(
					"groupingType" => 1,
					"controlType" => getAPITypeID("controls", "lineitems"),
					"generalLedgerID" => $ledgerEntryIDs,
				),
			),
		)));
		dbg($controlData);
		$this->smartyVars["controlData"] = $controlData;
		$this->smartyVars["ledgerPackageNames"] = array();
		foreach ((array)$controlData as $data){
			$thisLineItem = $data["controlID"];
			foreach ((array)$data["generalLedgerIDs"] as $glid){
				$this->smartyVars["ledgerPackageNames"][$glid] = $this->smartyVars["lineItemNames"][$thisLineItem];
			}
		}

////////////////// end

        $this->addTemplate("accounting/ShowGeneralLedger");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
