<?php

require_once("lib-action/AccountingReportAction.php");

class ShowLedgerAccounts extends AccountingReportAction
{
	public function __construct()
	{
		parent::__construct();

		$this->params = array("ledgerAccountNumber");

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["query"]!="") {
			// test if the searching for a specific column
			if ($_REQUEST["queryColumn"]!="") {
				$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
			} else {
				// test if query is an int, if yes, assume we are searching for the ID
				if (((int) $_REQUEST["query"])) {
					$_REQUEST["clientID"] = $_REQUEST["query"];
				} else {
					// if not an int, then search all other non-ID columns
					foreach($this->params as $value) {
						if ($value!="clientID") {
							$_REQUEST[$value] = $_REQUEST["query"];
						}
					}
				}
			}
		}

		$this->sortColumns = array("ledgerAccountNumber");
	}

	public function execute()
	{
		parent::execute();

		global $CONF;
		$this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

		$defaultAccountsInfo = Service()->AccountingLedgerAccountManager->getDefaultAccountsInfo();
		$ledgerAccounts = array();
		foreach (Factory()->LedgerAccountList(array('vendor_id' => getCurrentSession()->getVendorId())) as $ledgerAccount) {
			$data = array(
				'ledgerAccountID' => $ledgerAccount->id,
				'ledgerAccountNumber' => $ledgerAccount->ledger_account_number,
				'ledgerAccountType' => $ledgerAccount->ledger_account_type,
				'ledgerAccountTransKey' => $ledgerAccount->ledger_account_trans_key,
				'allowRemove' => isset($defaultAccountsInfo[$ledgerAccount->ledger_account_name]) ? false : true
			);
			$ledgerAccounts[] = $data;
		}
		$this->smartyVars["ledgerAccounts"] = $ledgerAccounts;

		$this->smartyVars['tabs'] = $this->getTabs("ledgerAccounts");
		$this->addTemplate("accounting/ShowLedgerAccounts");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}