<?php
set_time_limit(0);
require_once("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class ShowProductsRevenue extends MB_Action {

	public function __construct()
    {
		parent::MB_Action();
		$this->beginMonth = ((int)$_REQUEST["productsRevenueBeginMonth"])?(int)$_REQUEST["productsRevenueBeginMonth"]:1;
		$this->beginDay = ((int)$_REQUEST["productsRevenueBeginDay"])?(int)$_REQUEST["productsRevenueBeginDay"]:1;
		$this->beginYear = ((int)$_REQUEST["productsRevenueBeginYear"])?(int)$_REQUEST["productsRevenueBeginYear"]:date("Y");

		$this->endMonth = ((int)$_REQUEST["productsRevenueEndMonth"])?(int)$_REQUEST["productsRevenueEndMonth"]:1;
		$this->endDay = ((int)$_REQUEST["productsRevenueEndDay"])?(int)$_REQUEST["productsRevenueEndDay"]:1;
		$this->endYear = ((int)$_REQUEST["productsRevenueEndYear"])?(int)$_REQUEST["productsRevenueEndYear"]:date("Y");

		$this->startTime = mktime(0,0,0,$this->beginMonth,$this->beginDay,$this->beginYear);
		$this->endTime = mktime(0,0,0,$this->endMonth,$this->endDay+1,$this->endYear)-1;

		$this->startYearTime = mktime(0,0,0,1,1,$this->beginYear);

	}

	public function execute()
    {
		parent::execute();

		$this->smartyVars["startDate"] = $this->startTime;
		$this->smartyVars["endDate"] = $this->endTime;

		$data = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetProducts",
				"params" => array(
					"recordOffset" => (int)$_REQUEST["recordOffset"],
					"numRecords" => 10,
					"sortDir" => "ASC",
					"sortColumn" => "productID",
					"vendorID" => getCurrentSession()->getVendorId()
				),
			),
		)), 1);
		$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
		$products = grabSimpleMBAPIResults($data);

		$this->smartyVars["products"] = grabHTMLOpsFromArray($products, "productID", array($this, "constructProductName"));
		$ledgerProductIDs = array_keys($this->smartyVars["products"]);

		// lets get the packages for those ledger entry ids
		$controlData = correctArray(grabResultsFromMBAPIArray2($x = array(
			"mbapi" => array(
				"command" => "GetAccountingControlRel",
				"params" => array(
					"groupingType" => 1,
					"controlType" => getAPITypeID("controls", "products"),
					"controlID" => $ledgerProductIDs,
				),
			),
		)));

		$this->smartyVars["productsTotals"] = array();
		foreach ($controlData as $control){
			$prodID = $control["controlID"];
			$ledgerEntries = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetAccountingGeneralLedger",
					"params" => array(
						"generalLedgerDateCreatedLeast" => $this->startTime,
						"generalLedgerDateCreatedGreatest" => $this->endTime,
						"groupByAndSum" => 1,
						"generalLedgerID" => $control["generalLedgerIDs"],
						"ledgerAccountName" => array(
							"revenue",
						),
						"sortColumn" => "currencyID",
						"sortDir" => "ASC",
					),
				),
			)));

			foreach ($ledgerEntries as $entry){
				$this->smartyVars["productsTotals"][$prodID][$entry["currencyID"]]["credits"] += $entry["generalLedgerCreditAmount"];
				$this->smartyVars["productsTotals"][$prodID][$entry["currencyID"]]["debits"] += $entry["generalLedgerDebitAmount"];
			}

		}
		$this->addTemplate("accounting/ShowProductsRevenue");

	} // execute

	function constructProductName($row){
		if ((int)$row["productAddonGroupID"]){
			return "&nbsp;&nbsp;".blmsg("TRANS_ADDON").": ".$row["productName"];
		} else {
			return $row["productName"];
		}
	}

}