<?php

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-billing/include/accounting/Accounting.php");

/**
 * This Action object collects information on all purchase journal records that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class ShowPurchasesJournal extends MB_Action {
	/**
	 * The constructor for a ShowPurchasesJournal action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowPurchasesJournal() {
		parent::MB_Action();
		$this->stringRep = "ShowPurchasesJournal";

		$this->params = array
		(
			"purchaseDateCreated",
			"purchaseDateCreatedLeast",
			"purchaseDateCreatedGreatest"
		);

		$_REQUEST["purchaseDateCreatedLeast"] = $this->handleDateSelector("purchaseJournalBegin", 0);
		$_REQUEST["purchaseDateCreatedGreatest"] = $this->handleDateSelector("purchaseJournalEnd", 0);
		if ((int)$_REQUEST["purchaseDateCreatedGreatest"])$_REQUEST["purchaseDateCreatedGreatest"] += (24*60*60);

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["dateQuery"][0]) {
            if ((int)$_REQUEST["dateQuery"][0]>100000){
                $_REQUEST["dateQuery"][0] = date("Y/m/d", $_REQUEST["dateQuery"][0]);
            }
			list($dY,$dM,$dD) = explode("/",$_REQUEST["dateQuery"][0]);
			$_REQUEST["dateQuery"][0] = $_REQUEST["purchaseDateCreatedLeast"] = mktime(0,0,0,$dM,$dD,$dY);
			$_REQUEST["purchaseDateCreatedGreatest"] = mktime(23,59,59,$dM,$dD,$dY);
		}

        if (!$_REQUEST["sortColumn"]) {
            $_REQUEST["sortColumn"] = "purchaseDateCreated";
        }
        if (!$_REQUEST["sortDir"]) { 
            $_REQUEST["sortDir"] = "asc";
        }
		$this->sortColumns = array($_REQUEST["sortColumn"]);
	}

	/**
	 * The main method of this class that executes the ShowPurchasesJournal action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		foreach (array(
			"purchaseJournalBeginMonth",
			"purchaseJournalBeginDay",
			"purchaseJournalBeginYear",
			"purchaseJournalEndMonth",
			"purchaseJournalEndDay",
			"purchaseJournalEndYear") as $field){
			$this->smartyVars[$field] = $_REQUEST[$field];
		}
		$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];

        $this->smartyVars["currencies"] = array();
        $this->smartyVars["currencies_totals"] = array();

		$query = $this->getMBAPIQuery("GetAccountingPurchasesJournal", "", array("vendorID" => getCurrentSession()->getVendorId()), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);


///////////////////////////
        $this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);

        $results =& $data["mbapi"][0]["results"][0];
        if($this->addMBAPIErrors($data) === 0) {

            $results = collapseArrayElements($results["accounting_purchases"][0]["purchase"]);
            if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
                $results = array(0 => collapseArrayElements($results["accounting_purchases"][0]["purchase"]));
            }

            $numRows = $data["mbapi"][0]["header"][0]["numResults"][0];
            for ($i = 0; $i < $numRows; $i++){

                $this->smartyVars["currencies"][$results[$i]["currencyID"]][] = $results[$i];
                $r =& $results[$i];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["purchaseDebitAmount"] += $r["purchaseDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["purchaseCreditAmount"] += $r["purchaseCreditAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["purchaseAccPayDebitAmount"] += $r["purchaseAccPayDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["purchaseAccPayCreditAmount"] += $r["purchaseAccPayCreditAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["purchaseCashDebitAmount"] += $r["purchaseCashDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["purchaseCashCreditAmount"] += $r["purchaseCashCreditAmount"];

            }

            ksort($this->smartyVars["currencies"]);

            $this->addTemplate("accounting/ShowPurchasesJournal");

        }
        $this->addErrorTemplates();
        return $this->hasExecutedSuccessfully();

	}
} // ShowPurchasesJournal
?>