<?php

require_once("lib-action/action.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class ShowReceiptsJournal extends MB_Action
{

	public function __construct()
    {
		parent::MB_Action();
		$this->params = array
		(
			"receiptDateCreated",
			"receiptDateCreatedLeast",
			"receiptDateCreatedGreatest"
		);

		$_REQUEST["receiptDateCreatedLeast"] = $this->handleDateSelector("salesJournalBegin", 0);
		$_REQUEST["receiptDateCreatedGreatest"] = $this->handleDateSelector("salesJournalEnd", 0);
		if ((int)$_REQUEST["receiptDateCreatedGreatest"])$_REQUEST["receiptDateCreatedGreatest"] += (24*60*60);

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["dateQuery"][0]) {
			if ((int)$_REQUEST["dateQuery"][0]>100000){
				$_REQUEST["dateQuery"][0] = date("Y/m/d", $_REQUEST["dateQuery"][0]);
			}
			list($dY,$dM,$dD) = explode("/",$_REQUEST["dateQuery"][0]);
			$_REQUEST["dateQuery"][0] = $_REQUEST["receiptDateCreatedLeast"] = mktime(0,0,0,$dM,$dD,$dY);
			$_REQUEST["receiptDateCreatedGreatest"] = mktime(23,59,59,$dM,$dD,$dY);
		}
        if (!$_REQUEST["sortColumn"]) {
            $_REQUEST["sortColumn"] = "receiptDateCreated";
        }
        if (!$_REQUEST["sortDir"]) { 
            $_REQUEST["sortDir"] = "asc";
        }

		$this->sortColumns = array($_REQUEST["sortColumn"]);
	}

	public function execute()
    {
		parent::execute();
		foreach (array(
			"salesJournalBeginMonth",
			"salesJournalBeginDay",
			"salesJournalBeginYear",
			"salesJournalEndMonth",
			"salesJournalEndDay",
			"salesJournalEndYear") as $field){
			$this->smartyVars[$field] = $_REQUEST[$field];
		}
		$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];

        $this->smartyVars["currencies"] = array();
        $this->smartyVars["currencies_totals"] = array();

		$query = $this->getMBAPIQuery("GetAccountingReceiptsJournal", "", array("vendorID" => getCurrentSession()->getVendorId()), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

        $this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

            $results = collapseArrayElements($results["accounting_receipts"][0]["receipt"]);
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$results = array(0 => collapseArrayElements($results["accounting_receipts"][0]["receipt"]));
			}

			$numRows = $data["mbapi"][0]["header"][0]["numResults"][0];
            for ($i = 0; $i < $numRows; $i++){

                $this->smartyVars["currencies"][$results[$i]["currencyID"]][] = $results[$i];
                $r =& $results[$i];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptCashDebitAmount"] += $r["receiptCashDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptCashCreditAmount"] += $r["receiptCashCreditAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptAccRecDebitAmount"] += $r["receiptAccRecDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptAccRecCreditAmount"] += $r["receiptAccRecCreditAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptSalesDebitAmount"] += $r["receiptSalesDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptSalesCreditAmount"] += $r["receiptSalesCreditAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptTaxPayDebitAmount"] += $r["receiptTaxPayDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptTaxPayCreditAmount"] += $r["receiptTaxPayCreditAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptCouponDebitAmount"] += $r["receiptCouponDebitAmount"];
                $this->smartyVars["currencies_totals"][$results[$i]["currencyID"]]["receiptCouponCreditAmount"] += $r["receiptCouponCreditAmount"];

            }

            ksort($this->smartyVars["currencies"]);

			$this->addTemplate("accounting/ShowReceiptsJournal");

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
