<?php

use \Billing\Object\AdminGroup as AdminGroup;
require_once("lib-action/action.php");

class RemoveAdminGroupResponse extends MB_Action
{
	public $params = array("adminGroupID");

	public function execute()
	{
		parent::execute();

		$adminGroupID = bgpc("adminGroupID");
		if(!$adminGroupID) {
			$this->addError('TRANS_ACTIONERROR', "No AdminGroup ID given.");
		} else {

			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect("admins.php", "RemoveAdminGroup", array("adminGroupID" => $adminGroupID));
			}

            try {
                if ($adminGroupID == Service()->AdminGroupManager->getDefaultGroupId(AdminGroup::ROOT_GROUP)
                    || $adminGroupID == Service()->AdminGroupManager->getDefaultGroupId(AdminGroup::RESELLER_GROUP))
                {
                    throw new ProductException(ProductException::E_FORBIDDEN_OPERATION, "You can not remove admin group with id #{$adminGroupID}");
                }
                $query = $this->getMBAPIQuery("SetAdminGroups", "delete");
                require_once("lib-mbapi/mbapi.php");
                $data = dispatchMBAPI($query, 1);
                if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
                    if(!redirect("admins.php",getActionID("ShowAdminGroups"))) {
                        $this->addError('TRANS_ACTIONERROR', "Failed to redirect to adminGroup detail.");
                    }
                }
            }catch(ProductException $e) {
                getCurrentSession()->Storage->errorMessages[] = $e->getMessage();
                redirect("admins.php",getActionID("ShowAdminGroups"));
            }
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}