<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class ShowAdminStats extends MB_Action
{
	public function execute()
	{
		parent::execute();

		// --------------------------------------
		// Fetch config_groups for the nav menu
		// --------------------------------------
		$xmlParams = array
		(
			"parentConfigGroupID"=>0,
			"getNumChildren"=>1,
			"getLevelOneChildren"=>1
		);
		$query = $this->getMBAPIQuery("GetConfigGroups","",$xmlParams,0,0,0,0,0,$this->params);
		$navConfigGroupData = dispatchMBAPI($query, 1);
		$navConfigGroupsResults =& $navConfigGroupData["mbapi"][0]["results"][0];
		// fix child config groups structure when only 1 child group exists
		$numNavGroups = $navConfigGroupData["mbapi"][0]["header"][0]["numResults"][0];
		for($i=0;$i<$numNavGroups;$i++) {
			if ($navConfigGroupsResults["configGroups"][0]["configGroup"][$i]["children"][0]["numChildren"][0]["numChildren"][0]==1) {
				$navConfigGroupsResults["configGroups"][0]["configGroup"][$i]["levelOneConfigGroups"][0]["levelOneConfigGroup"][0] =
					array(0=>$navConfigGroupsResults["configGroups"][0]["configGroup"][$i]["levelOneConfigGroups"][0]["levelOneConfigGroup"][0]);
			}
		}

		$smartyVars = array();

		// setup vars for config navs
		// + 1 is to account for the support category in navNumDisplayResults
		$smartyVars["navNumDisplayResults"] = $numNavGroups + 1;
		$smartyVars["navNumDisplayRows"] = ceil($smartyVars["navNumDisplayResults"]/4);
		$smartyVars["navConfigGroups"] =& $navConfigGroupsResults["configGroups"][0]["configGroup"];

		// Set the templete for output
		$this->addTemplate("admins/ShowAdminStats", collapseArrayElements($smartyVars), 1);
	}
}