<?php

use Billing\Manager\AdminManager;
use Billing\Manager\SecurityManager;

class Admins_AdminProfileController extends Billing_Zend_Controller_Action_AdminController
{
    public function init()
    {
        parent::init();
        $this->_backUrl = $this->view->ActionUrl('admins', 'ShowAdmins');
    }

    public function editAction()
    {
        $adminId = $this->getRequest()->getParam('id');
        $admin = Factory()->Admin($adminId);

        $this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_ADMIN_EDIT_PROFILE'));
        
        $form = new Billing_Zend_Form_Final_AdminProfileForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'admin' => $admin     
        )));

        if ($this->_request->isPost() && $form->isValid($this->_request->getPost())) {
            try {
                $form->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->view->translate('TRANS_ADMIN_EDIT_PROFILE_SUCCESS_MSG'), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }

        $this->view->form = $form;
    }
    
    public function addAction()
    {
        $admin = Factory()->Admin();

        $this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_ADD_ADMIN_PROFILE'));
        
        $form = new Billing_Zend_Form_Final_AdminProfileForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'admin' => $admin     
        )));

        if ($this->_request->isPost() && $form->isValid($this->_request->getPost())) {
            try {
                $form->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->view->translate('TRANS_ADD_ADMIN_PROFILE_SUCCESS_MSG'), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }

        $this->view->form = $form;
    }
    
    public function renewAccessHashAction()
    {
        $adminId = $this->getRequest()->getParam('id');
        if ($this->_request->isPost() && isset($adminId)) {
            try {
                Service()->AdminManager->update(Factory()->Admin($adminId), true);
                $this->_redirect($this->view->ActionUrl('admins', 'ShowAdminDetails', array('adminID' => $adminId)));
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
    }
}