<?php

class Admins_GroupController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('admins', 'ShowAdminGroups');
	}

	public function manageNotificationsAction()
	{
        try {
            $adminGroup = Factory()->AdminGroup($this->_request->getParam('Id'));
        } catch(ProductException $e){
            $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_ADMIN_GROUP_NOT_FOUND", array("ID" => $this->_request->getParam('Id'))), "error");
        }

        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_OBJECT', array('NAME' => $adminGroup->admin_group_name)));
        $editForm = new Billing_Zend_Form_Final_AdminGroupForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'adminGroup' => $adminGroup,
        )));
        if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost()))
        {
            try {
                $editForm->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_ADMIN_GROUP_NOTIFICATIONS_SAVED_MSG"), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
        $this->view->form = $editForm;
    }
}