<?php

require_once mb_path("/lib-action/autocompleteAction.php");

/**
 * This class is a child class of AutocompleteAction. It will return a list of clients that match what you are typing.
 *
 * @author  Kris Bailey
 */
class GetAutocompleteClients extends AutocompleteAction {
	/**
	 * 
	 */
	function GetAutocompleteClients() {
		parent::AutocompleteAction();
		$this->stringRep = "GetAutocompleteClients";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the GetAutocompleteClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clients = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetAutocompleteClients",
				"params" => array(
					"searchTerm" => $_REQUEST["searchTerm"],
				),
			),
		));
		
		$keyedClients = array();
		foreach ($clients as $x=>$c){
			if ($x>MAX_AUTOCOMPLETE_RESULTS) break;
			$c["nameValue"] = $c["contactLastName"].", ".$c["contactFirstName"];
			$keyedClients[] = $c;
		}
		$this->autocompleteOutput($keyedClients);
	
	} // execute
} // GetAutocompleteClients
?>
