<?php

require_once mb_path("/lib-action/autocompleteAction.php");

/**
 * This class is a child class of AutocompleteAction. It will return a list of domains that match what you are typing.
 *
 * @author  Kris Bailey
 */
class GetAutocompleteDomains extends AutocompleteAction {
	/**
	 * 
	 */
	function GetAutocompleteDomains() {
		parent::AutocompleteAction();
		$this->stringRep = "GetAutocompleteDomains";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the GetAutocompleteClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domains = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetAutocompleteDomains",
				"params" => array(
					"searchTerm" => $_REQUEST["searchTerm"],
					"searchType" => $_REQUEST["searchType"],
				),
			),
		));
		
		$keyedDomains = array();
		foreach ($domains as $x=>$c){
			if ($x>MAX_AUTOCOMPLETE_RESULTS) break;
			$c["nameValue"] = $c["domainSLD"].".".$c["domainTLD"];
			$keyedDomains[] = $c;
		}
		$this->autocompleteOutput($keyedDomains);
	
	} // execute
} // GetAutocompleteDomains
?>
