<?php
require_once('lib-action/action.php');

class DownloadBatchFile extends MB_Action
{
	public function execute()
	{
		parent::execute();

        if (!Service()->CryptManager->isEncryptionEnabled()) {
            billing_put_error(blmsg('TRANS_BATCH_FILE_NO_ENCRYPTION_ERROR'));
            redirect('batchfiles.php', getActionID('ShowBatchFiles'));
        }
        if (!Service()->CryptManager->canDecryptData()) {
            billing_put_error(blmsg('TRANS_ENCRYPTION_NO_PASSPHRASE_OR_PRIVATE_KEY_PRESENT_MSG'));
            redirect('batchfiles.php', getActionID('ShowBatchFiles'));
        }

        try {
            $batchFile = Factory()->BatchFile(bgpc("id"));
			header("HTTP/1.1 200 OK");
			header('Content-Type:  text/plain');
			if (!isset($_SERVER['HTTP_ACCEPT_ENCODING']) || '' == $_SERVER['HTTP_ACCEPT_ENCODING']) {
				header('Content-Length: ' . mb_strlen($batchFile->batch_file_content, "8bit"));
			}
			header("Content-Disposition: attachment; filename=\"{$batchFile->batch_file_name}\"");
			if (isset($_SERVER['HTTP_USER_AGENT']) and strpos($_SERVER['HTTP_USER_AGENT'],'MSIE')) {
				header('Content-Type: application/force-download');
			} else {
				header('Content-Type: application/octet-stream');
			}
			echo $batchFile->batch_file_content;
			exit;
		} catch (ProductException $e) {
            billing_put_error($e->getMessage());
            redirect('batchfiles.php', getActionID('ShowBatchFiles'));
		}
		return $this->hasExecutedSuccessfully();
	}
}
