<?php
require_once("lib-action/action.php");

class ShowBatchFileDetails extends MB_Action
{

	public function execute()
	{
		parent::execute();

		if ( is_null($batch_file_id = bgpc("id")) )
			throw new Exception("Missing parameter 'id'");

		$page  = UIFactory()->Page();
		
		$batch_file = Factory()->BatchFile($batch_file_id);

		$page->title = blmsg("TRANS_BATCH_FILE")." #{$batch_file->batch_file_id}";
		if (!is_null($batch_file->batch_file_name))
			$page->title .= " '{$batch_file->batch_file_name}'";
		$page->parent_title = blmsg("TRANS_BATCH_FILES_MANAGER");
		$page->parent_url = action_url("batchfiles", "ShowBatchFiles");

		require_once("UI/List/UIBatchFileTransactionList.php");
		$page->addListPanel( new UIBatchFileTransactionList($batch_file_id, $batch_file->batch_file_status) );

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}
