<?php

require_once("lib-action/action.php");

class EditClientArchiveStateResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		try {
			$customer = Factory()->Customer(bgpc("clientID"));
            if ($customer->isReseller()) {
                $reseller = $customer->getReseller();
                if(1 == bgpc("clientActive")) {
                    Service()->ResellerManager->reinstate($reseller);
		    $successMessage = blmsg("TRANS_RESELLER_REINSTATE_SUCCESS_MSG");
                } else {
                    Service()->ResellerManager->archive($reseller);
		    $successMessage = blmsg("TRANS_RESELLER_ARCHIVE_SUCCESS_MSG");
                }
            } else {
                if(1 == bgpc("clientActive")) {
                    Service()->CustomerManager->reinstate($customer);
		    $successMessage = blmsg("TRANS_REINSTATE_CLIENT_SUCCESS_MSG");
                } else {
                    Service()->CustomerManager->archive($customer);
		    $successMessage = blmsg("TRANS_ARCHIVE_CLIENT_SUCCESS_MSG");
                }
            }


		} catch (ProductException $ex) {
			billing_put_error($ex->getMessage());
			redirect("clients.php", getActionID("EditClientArchiveState"), array("clientID" => $customer->id));
		}

		if (isset($successMessage)) {
		    billing_put_info($successMessage);
		}
		redirect("clients.php", getActionID("ShowClientDetails"), array("clientID" => $customer->id));
	}
}