<?php

require_once("lib-billing/include/config/internal/cycles.php");

class ManageClientAction extends ShowDetailsAction
{
	public function __construct()
	{
		parent::__construct();

		$this->setDataSource(new DataSource("clients",
			array(
				"mergePrimaryContact" => 1,
			)));

		// Override Datasource Params
		$this->sourceParams = "ManageActionParams";
		$this->template = "ManageActionTemplate";

		// Update the Datasource
		$description = $this->d->getDescription();
		$description["display"]["ManageActionTemplate"] = "clients/ManageClientAction";
		$this->d->setDescription($description);
	}

	/**
	 * Executes After MBAPI Query to correct the packages structure
	 * for display.
	 */
	public function showDetailsHandler()
	{
		// Set a flag to only return billable packages
		$getBillablePackagesOnly = 0;
		if ($this->smartyVars["manageClientAction"] == "suspend") {
			$getBillablePackagesOnly = 1;
		}

		// MBAPI call to get the packages for this clients
		$d = new DataSource("packages",
			array(
				"clientID" => $_REQUEST["clientID"],
				"packageActive" => 1,
				"suppressFeePackages" => 1,
				"getBillablePackagesOnly" => $getBillablePackagesOnly
			));
		$packages =& $d->getEssential();

		// Group the package results by packageType to make
		// displaying the results much easier
		$n = count($packages);
		for($i=0;$i<$n;$i++){
			$packageType = $packages[$i]["packageType"];
			$this->smartyVars["groupedPackages"][$packageType][] =& $packages[$i];
		}
        $this->smartyVars["buttons"] = array(
            array('id' => 'billing-id-save', 'class' => 'action', 'name' => 'save', 'value' => "TRANS_SAVE", 'type' => 'submit', 'label' => 'TRANS_SAVE'),
        );
    }
}
