<?php
require_once("lib-action/action.php");


class ManageClientNotes extends MB_Action
{

	public function __construct()
    {
		parent::__construct();
		$this->params = array("clientID");
	}


	public function execute()
    {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError('TRANS_ACTIONERROR', "No client ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetClients", "", array("mergePrimaryContact" => 1));
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				$adminID = $CONF["user"]["id"];
				$adminQuery = $this->getMBAPIQuery("GetAdmins","",array("adminID"=>$adminID),0,0,0,0,0,$this->params);
				$adminData = dispatchMBAPI($adminQuery, 1);
				$adminResults =& $adminData["mbapi"][0]["results"][0];

				$this->smartyVars["admin"] = collapseArrayElements($adminResults["admins"][0]["admin"][0]);
				$noteList = arrayFor(":clientNotes", array(
					"clientID" => $clientID,
				));
				$this->smartyVars["noteList"] = $noteList;
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"][0]);

				$clientNoteID = getParam('clientNoteID');
				if($clientNoteID) {
					$editNotesByID = associateArrayRowByID($noteList, "clientNoteID");
					$this->smartyVars["editNotesByID"] = $editNotesByID;
					$editNote = $editNotesByID[$clientNoteID];
					$this->smartyVars["editNote"] = $editNote;
					$formDefaults = array('clientID' => $clientID, 'clientNoteText' => $editNote['clientNoteText']);
				} else {
					$formDefaults = array('clientID' => $clientID);
				}
				$this->mergeFormState($formDefaults);
				$this->addTemplate("clients/ManageClientNotes", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
