<?php

require_once("lib-action/action.php");

class ManageClientNotesResponse extends MB_Action
{
	public $params = array(
		"clientID",
		"clientNoteID",
		"clientNoteText",
	);

	public function execute()
	{
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("ManageClientNotes"));
		$this->setReferralActionFile("clients.php");
		$success = $this->validateMultiInputs(
			array(
				"clientID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"clientNoteText" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			)
		);
		if($success) {
			$clientID = ((int) $_REQUEST["clientID"]);
			if(!$clientID) {
				$this->addError('TRANS_ACTIONERROR', "No client ID given.");
			} elseif($success) {

				$adminID = $CONF["user"]["id"];
				$adminQuery = $this->getMBAPIQuery("GetAdmins","",array("adminID"=>$adminID),0,0,0,0,0,$this->params);
				$adminData = dispatchMBAPI($adminQuery, 1);
				$adminResults =& $adminData["mbapi"][0]["results"][0];

				$admin = collapseArrayElements($adminResults["admins"][0]["admin"][0]);
				$clientNoteID = ((int) $_REQUEST["clientNoteID"]);

				if($clientNoteID) {
					$editXML = '<clientNoteID>'.$clientNoteID.'</clientNoteID>';
					$createdXML = '';
					$modifiedXML = "<clientNoteDateModified>".time()."</clientNoteDateModified>";
					$successMessage = blmsg("TRANS_EDIT_NOTE_SUCCESS_MSG");
				} else {
					$editXML = '';
					$createdXML = "<clientNoteDateCreated>".time()."</clientNoteDateCreated>";
					$modifiedXML = '<clientNoteDateModified>0</clientNoteDateModified>';
					$successMessage = blmsg("TRANS_ADD_NOTE_SUCCESS_MSG");
				}

				// create sanatized xml command
				$cmd = "
				<mbapi>
				    <command>SetClients</command>
				    <subCommand>update</subCommand>
					<params>
						<clientID>$clientID</clientID>
						<clientNotes>
							<clientNote>
								$editXML
								<adminID>".$admin["adminID"]."</adminID>
								<clientNoteText>".$_REQUEST["clientNoteText"]."</clientNoteText>
								$createdXML
								$modifiedXML
							</clientNote>
						</clientNotes>
					</params>
				</mbapi>
				";

				$data = dispatchMBAPI($cmd, 1);

				$results =& $data["mbapi"][0]["results"][0];

				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if (isset($successMessage)) {
					    billing_put_info($successMessage);
					}
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						$clientNoteID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
						redirect("clients.php", getActionID("ManageClientNotes"), array("clientID"=>$clientID));
					}
				}

			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}