<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class MergeClient extends MB_Action {

    public $params = array("mergeClientID", "masterClientID");

	function execute() {
		parent::execute();

        try {
            if (is_null($mergeClientID = bgpc('mergeClientID'))) {
                billing_put_error("Invalid client ID given.");
                redirect("clients.php", getActionID("ShowClients"), array());
            }

            $masterClientID = bgpc('masterClientID');
            if (!getCurrentSession()->checkVendor(Factory()->Customer($masterClientID))) {
                throw new ProductException(ProductException::E_FORBIDDEN_OPERATION, "Access denied: Client with ID '{$masterClientID}'");
            }
            $this->smartyVars["mergeClient"] = oneByID("clients", $mergeClientID, array("mergePrimaryContact"=>1));
            $this->smartyVars["masterClient"] = oneByID("clients", $masterClientID, array("mergePrimaryContact"=>1));

            Service()->CustomerManager->checkMergeClients($mergeClientID, $masterClientID);
            billing_put_warning(blmsg("TRANS_CLIENT_TO_MERGE_WITH_WILL_BE_ONE_LEFT_OVER"));
            $this->addTemplate("clients/MergeClient", $this->smartyVars);
		} catch(ProductException $e) {
            billing_put_error($e->getMessage());
            redirect("clients.php", getActionID("ShowClientDetails"), array("clientID" => $mergeClientID));
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
