<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class MergeClientResponse extends MB_Action {

    public $params = array("mergeClientID", "masterClientID");

	function execute() {
		parent::execute();

		$mergeClientID = getParam('mergeClientID');
		$masterClientID = getParam('masterClientID');
		if(!$mergeClientID) {
			$this->addError('TRANS_ACTIONERROR', "No merge client ID given.");
		} elseif (!$masterClientID){
			$this->addError('TRANS_ACTIONERROR', "No master client ID given.");
		} else {

			$this->smartyVars["mergeClient"] = oneByID("clients", $mergeClientID, array("mergePrimaryContact"=>1));
			$this->smartyVars["masterClient"] = oneByID("clients", $masterClientID, array("mergePrimaryContact"=>1));
			
			$result = dispatchMBAPI(array(
				"mbapi" => array(
					"command" => "ProcessMergeClient",
					"params" => array(
						"mergeClientID" => $mergeClientID,
						"masterClientID" => $masterClientID,
					),
				),
			), 1);
			
			if (!(int)$result["mbapi"][0]["results"][0]["success"][0]){
				$this->addError('TRANS_ACTIONERROR', "An error occured while trying to merge the clients.");
			} else {
                billing_put_info(blmsg("TRANS_CLIENTS_MERGED_SUCCESSFULLY"));
				$this->addTemplate("clients/MergeClientResponse", $this->smartyVars);
			}
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
