<?php
require_once("lib-action/action.php");

class ResetContactPassword extends MB_Action
{
    public $params = array("clientContactID");

	public function execute()
    {
		parent::execute();

		$clientContactID = getParam("clientContactID");

		if(!notZero( $clientContactID )) {
			$this->addError('TRANS_ACTIONERROR', "No contact ID given.");
		} else {

			$this->smartyVars['contact'] = oneByID('contacts', $clientContactID);
			$this->smartyVars['client'] = oneByID('clients', $this->smartyVars['contact']['clientID']);
			$this->mergeFormState( $this->smartyVars['contact'] );

			if (notZero( $this->smartyVars['contact']['contactActive'] )) {
                $this->addTemplate("clients/ResetContactPassword");
			} else {
				$this->addError('TRANS_ACTIONERROR', "Contact is not active. Please activate contact before attempting to reset password." );
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
