<?php
    require_once ("lib-action/action.php");

class SendClientEmail extends MB_Action
{

	public function __construct()
    {
		parent::MB_Action();
	}

	function execute()
    {
		parent::execute();
		// in case we want to edit & resend an email
		$formDefaults = array();
		if (notZero( $_REQUEST["emailID"] )) {
			$query = new MBQuery("GetEmailQueue", "", array("emailID" => $_REQUEST["emailID"]));
			$results = $query->getResult();
			unset( $query );

			if (!$results->getErrorCount()) {
				$results = grabSimpleMBAPIResults( $results->getStructure() );
				$results = $results[0];

				$this->smartyVars["email"] = $results;
				$this->smartyVars["email"]["emailSubject"] = utf8_html_entity_encode($results["emailSubject"]);
				$this->smartyVars["email"]["emailBody"] = utf8_html_entity_encode($results["emailBody"]);

				if ( isset($results["emailCCAddresses"][0]) ) {
					$ccAddresses = array();
					foreach ( $results["emailCCAddresses"][0]["emailCCAddress"] as $emailCCAddress  ) {
						$ccAddresses[] = $emailCCAddress["emailAddress"];
					}
					$formDefaults["emailCC"] = implode(",", $ccAddresses);
				}
				if ( isset($results["emailBCCAddresses"][0]) ) {
					$bccAddresses = array();
					foreach ( $results["emailBCCAddresses"][0]["emailBCCAddress"] as $emailBCCAddress  ) {
						$bccAddresses[] = $emailBCCAddress["emailAddress"];
					}
					$formDefaults["emailBCC"] = implode(",", $bccAddresses);
				}

				if (!notZero( $_REQUEST["clientID"] )) {
					$_REQUEST["clientID"] = oneOf("contacts", array("clientContactID" => $results["clientContactID"]));
					$_REQUEST["clientID"] = $_REQUEST["clientID"]["clientID"];
				}


			}
		}

		if((int) $_REQUEST["clientID"]) {
			$this->smartyVars["clientID"] = (int) $_REQUEST["clientID"];
			//Pull all of the contact e-mail addresses for multi-select list.
			$query = $this->getMBAPIQuery("GetClients", "", array("clientID" => (int) $_REQUEST["clientID"], "getContactData" => 1, "mergePrimaryContact" => 1));
			$data = dispatchMBAPI($query, 1);

			if($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]) {
				$results = $data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"];
				foreach($results as $key => $value) {
					if($value["contactPrimary"][0]) {
                        $this->smartyVars["doubleListSelectorOptions"][$key] = array(
                            'id' => $value["clientContactID"][0],
                            'title' => $value["contactEmail"][0],
                            'selected' => true
                        );
					} else {
                        $this->smartyVars["doubleListSelectorOptions"][$key] = array(
                            'id' => $value["clientContactID"][0],
                            'title' => $value["contactEmail"][0]
                        );
					}
				}
			} else {
				//No contacts found
			}
		} else {
			//No clientID to e-mail
		}

		$this->mergeFormState($formDefaults);
        $this->smartyVars["doubleListSelectorAttribs"] = array('id' => 'contacts');
        $GLOBALS["tpl"]->assign_by_ref("doubleListSelector", new Billing_Zend_View_Helper_DoubleListSelector());
		$this->addTemplate("clients/SendClientEmail", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action SendClientEmail

