<?php

require_once ("lib-action/action.php");

use Billing\Manager\SecurityManager;

class ShowBillingAccountDetails extends MB_Action
{
	public $params = array("billingAccountID");

	public function execute()
	{
		parent::execute();

		$billingAccountID = ((int) $_REQUEST["billingAccountID"]);
		if(!$billingAccountID) {
			$this->addError('TRANS_ACTIONERROR', "No billing account ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetClients", "", array("getBillingData"=>"3", "mergePrimaryContact" => 1));
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				$smartyVars["client"] = $results["clients"][0]["client"];
				$smartyVars["billingAccount"] = $results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"];

				require_once("object_managers/SecurityManager.php");
				Service()->SecurityManager->pushCurrentActionIntoLog(
					SecurityManager::USER_TYPE_CLIENT,
					$client_id = $results["clients"][0]["client"][0]["clientID"],
					Factory()->Customer($client_id)->PrimaryContact->contact_username,
					"TRANS_ACTION_LOG_REASON_SHOW_BILLING_ACCOUNT_DETAILS",
					blmsg("TRANS_ACTION_LOG_COMMENT_CLIENT_BILLING_ACCOUNT", array(
						"ACCOUNT_NAME" => Factory()->BillingAccount($billingAccountID)->getAccountNameForList(),
						"ACCOUNT_ID" => $billingAccountID,
						"CLIENT_ID" => $client_id,
					))
				);

				$this->addTemplate("clients/ShowBillingAccountDetails", collapseArrayElements($smartyVars));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}