<?php

require_once("lib-action/action.php");
require_once("lib-billing/include/config/internal/cycles.php");

class ShowLastFiveClientPackages extends MB_Action
{
	public $params = array("clientID");

	public function execute()
	{
		parent::execute();
		$query = $this->getMBAPIQuery("GetPackages", "", array(
			"packageActive" => 1,
			"getClientData" => 1,
			"getDomainData" => 1,
			"suppressFeePackages" => 1,
			"sortDir" => "desc",
			"sortColumn" => "packageID",
			"numRecords" => "5",
			"getPackageAttributeData" => 1,
		));

		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {

			// make sure we have packages before we perform any of the sub queries
			if ((int)$data["mbapi"][0]["header"][0]["numResults"][0]) {

			$this->smartyVars["packages"] = correctArray($results["packages"][0]["package"]);
			$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
			/*if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["packages"] = array(0 => $results["packages"][0]["package"]);
			}*/

			//Pull the event queue items out
			$queueStatuses = getStatuses("queue");
			$queueItems = array();

			$packagesTemp = correctArray($results["packages"][0]["package"]);

			// need to put into command post 5.1
            /*
			if($packagesTemp) {
				foreach($packagesTemp as $key => $value) {
					if((int) $value["packageID"]) {
						$query = $this->getMBAPIQuery("GetSystemQueue", "", array("packageID"=>$value["packageID"]));
						$data = dispatchMBAPI($query, 1);


						$results =& $data["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"];
						if($results) {
							foreach($results as $v) {
								$this->smartyVars["packages"][$key]["systemQueueItems"][$v["systemQueueID"][0]] =
														array("configGroupID" => $v["configGroupID"][0],
																		"packageID" => $v["packageID"][0],
																		"serverGroupID" => $v["serverGroupID"][0],
																		"systemQueueStatus" => $queueStatuses[(int)$v["systemQueueStatus"][0]],
																		"systemQueueCommand" => $v["systemQueueCommand"][0],
																		"systemQueueDateFinished" => $v["systemQueueDateFinished"][0],
																			);
							}
						}
					}
				}
			}
            */
			$this->smartyVars["productsTypes"] = getTypes("products");
			$this->smartyVars["packageStatuses"] = getStatuses("package");
			$this->smartyVars["cycles"] = getCyclesArray();

			// process product attributes and create package data
			$include = array("ip", "ipv6", "clientLogin", "domainUserName", "packageUsername", "ftpUsername");
			foreach( (array)$this->smartyVars["packages"] as $pkgK => $package ) {
				foreach( (array)$package["packageAttributes"] as $attribK => $attrib ) {
					if (in_array( $attrib["packageAttributeName"], $include ) && notNull( $attrib["packageAttributeValue"] )) {
						switch( $attrib["packageAttributeName"] ) {
							case "ip":
								$tempIP = $attrib["packageAttributeValue"];
								if($tempIP == ip2long(long2ip($attrib["packageAttributeValue"]))) {
									$attrib["packageAttributeValue"] = long2ip($attrib["packageAttributeValue"]);
								}
								if($tempIP == long2ip(ip2long($attrib["packageAttributeValue"]))) {
									$attrib["packageAttributeValue"] = long2ip(ip2long($attrib["packageAttributeValue"]));
								}
							break;
						}

						if (notZero( $attrib["configGroupID"] )) {
							$cg = oneOf( ":configParams", array("configGroupID" => (int)$attrib["configGroupID"], "configParamName" => "moduleDisplayName"));
							$this->smartyVars["packages"][ $pkgK ]["packageMeta"]["configGroupName"] = $cg["configParamValue"];
							unset( $cg );
						}

						if (notZero( $attrib["serverGroupID"] )) {
							$sg = oneOf( "serverGroups", array("serverGroupID" => (int)$attrib["serverGroupID"]));
							$this->smartyVars["packages"][ $pkgK ]["packageMeta"]["serverGroupName"] = $sg["serverGroupName"];
							unset( $sg );
						}

						$this->smartyVars["packages"][ $pkgK ]["packageMeta"][ $attrib["packageAttributeName"] ] = $attrib["packageAttributeValue"];
					}
				}
				unset( $attribK, $attrib );

				if (isset($package["domains"]) && is_array( $package["domains"][0])) {
					$this->smartyVars["packages"][ $pkgK ]["packageMeta"]["domainName"] = $package["domains"][0]["domainSLD"].".".$package["domains"][0]["domainTLD"];
				}

				$subscription = Factory()->Subscription($package["packageID"]);
				$this->smartyVars["packages"][$pkgK]["canTransfer"] = $subscription->canTransfer();
				$this->smartyVars["packages"][$pkgK]["canUpgrade"] = $subscription->canUpgrade();
				$this->smartyVars["packages"][$pkgK]["canDowngrade"] = $subscription->canDowngrade();
			}
			unset( $pkgK, $package, $include );
			$this->smartyVars = correctArray($this->smartyVars);
			$this->mergePrimaryContactData();

			} // END IF: Do we have packages?

			$this->addTemplate("clients/ShowLastFiveClientPackages");

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
