<?php
require_once ("lib-action/action.php");

class TakeClientPayment extends MB_Action
{
	public function __construct()
    {
		parent::__construct();
		$this->params = array("clientID");
	}

	public function execute()
    {
		parent::execute();
		
		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError('TRANS_ACTIONERROR', "No client ID given.");
		} else {

			$this->smartyVars["client"] = oneByID("clients", $clientID, array(
				"mergePrimaryContact" => 1,
			));
			$this->smartyVars["invoices"] = arrayFor("invoices", array(
				"clientID" => $clientID,
				"getDueInvoicesOnly" => 1,
			));

			$this->addTemplate("clients/TakeClientPayment", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
} 
