<?php
use Billing\Object\AffiliateProgram;

class Clients_AffiliateController extends Billing_Zend_Controller_Action_AdminController
{
    public function payoutAction()
    {
        $backUrl = $this->view->ActionUrl('clients', 'ShowAffiliateProgramsPartners');
        $this->view->placeholder('pageTitle')->set(
            $this->view->translate(
                (Billing_Zend_Form_Final_PayoutAffiliateCommissionsForm::TYPE_CASH == $this->_request->getParam('type'))
                    ? 'TRANS_AFFILIATE_PROGRAM_PAYOUT_TO_CASH'
                    : 'TRANS_AFFILIATE_PROGRAM_PAYOUT_TO_CREDIT'
            )
        );

        $form = new Billing_Zend_Form_Final_PayoutAffiliateCommissionsForm(
            array('context' => array(
                'type' =>  $this->getRequest()->getParam('type'),
                'cancelLink' =>  $backUrl,
                'affiliateProgramPartnerIds' => $this->getRequest()->getParam('id'),
                'postData' => $this->getRequest()->getPost()
            ))
        );

        $initError = $form->getInitError();
        if (!empty($initError)) {
            $this->_redirectWithMessage($backUrl, implode("<br/>", $initError), "error");
        }

        if ($this->getRequest()->isPost()) {
            try {
                if ($form->isValid($this->getRequest()->getPost())) {
                    $form->process();
                    $this->_redirectWithMessage($backUrl, $this->_translator->translate("TRANS_AFFILIATE_PROGRAM_PAYOUT_SUCCESS_MSG"), "info");
                }
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }

        $this->view->form = $form;
    }
}