<?php

use Billing\Object\Store;
use Billing\Manager\StoreManager;

class Clients_ForwardController extends Billing_Zend_Controller_Action_AdminController
{

	public function storeAction()
	{
        if ($target = $this->_request->getParam('target')) {
            $value = (is_null($guid = bgpc('subscriptionGuid', null))) ? bgpc('subscriptionExternalID'): $guid;
            $subscription = is_null($guid) ? Factory()->Subscription($value, 'external_id') : Factory()->Subscription($value, 'guid');

            // prepare parameters for passing to store
            $parameters = $_GET;
            unset($parameters['act'], $parameters['subscriptionGuid'], $parameters['target']);
            $parameters['subscription'] = $subscription->id;
            switch($target) {
				case StoreManager::TARGET_PURCHASE_CERTIFICATE:

                    foreach($parameters as $key => $value) {
                        if (isset($this->_mapCertificateParams[$key])) {
                            $parameters[$this->_mapCertificateParams[$key]]   = $value;
                            unset($parameters[$key]);
                        }
                    }
                    $parameters['planId'] = $subscription->product_id;
                    break;
            }
            $url = Service()->ContactManager->getStoreUrl($subscription->Customer->PrimaryContact, $subscription->Store, $target, $parameters);
        } else {
            $contact = Factory()->Customer($this->_request->getParam('externalId'), "external_id")->PrimaryContact;
            $url = Service()->ContactManager->getStoreUrl($contact);
        }
        redirect_url($url);
    }

    private $_mapCertificateParams = array(
        'dname' => 'commonName',
        'country' => 'countryName',
        'state' => 'stateOrProvinceName',
        'city' => 'localityName',
        'cname' => 'organizationName',
        'cuname' => 'organizationalUnitName',
        'email' => 'emailAddress',
    );
}