<?php

class Companies_IndexController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
        $this->_backUrl = ("ShowDashboard" == bgpc("redirectAction"))
            ? $this->view->adminActionUrl('dashboard', 'home', 'index')
            : $this->view->adminActionUrl('configs', 'system', 'show');
	}

	public function indexAction()
	{
		$this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_SETTINGS_COMPANY'));
        $company = ($reseller = getCurrentSession()->getReseller()) ? $reseller->Company : Service()->CompanyManager->getProviderCompany();
        $form = new Billing_Zend_Form_Final_CompanyForm($company, array(
            'cancelUrl' => $this->_backUrl
        ));
		if ($this->_request->isPost()) {
			try {
				if ($form->isValid($this->_request->getPost())) {
                    $form->process();
                    $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate('TRANS_SETTINGS_COMPANY_SUCCESS_EDIT'));
                }
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $form;
    }

    private $_backUrl = NULL;
}