<?php

use Billing\Object\Reseller;

class Configs_SystemController extends Billing_Zend_Controller_Action_AdminController
{
	public function showAction()
	{
		if ($this->view->reseller = $reseller = getCurrentSession()->getReseller()) {
			// visibility of manage business rules
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_INVOICING)							&&
				!$reseller->hasPermission(Reseller::PERMISSION_SCHET_FACTURAS_ISSUING)				&&
				!$reseller->hasPermission(Reseller::PERMISSION_TAXATION_POLICIES)					&&
				!$reseller->hasPermission(Reseller::PERMISSION_AUTOMATIC_PAYMENTS)					&&
				!$reseller->hasPermission(Reseller::PERMISSION_PROVISIONING_POLICY)					&&
				!$reseller->hasPermission(Reseller::PERMISSION_CANCELATION_UNPAID_SUBSCRIPTIONS)
			) {
				$this->view->hideManageBusinessRules = true;
			}
			// visibility of manage customers
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_EDITABLE_PROFILE_FIELDS)				&&
				!$reseller->hasPermission(Reseller::PERMISSION_ALLOWED_BILLING_ACCOUNT_TYPES)		&&
				!$reseller->hasPermission(Reseller::PERMISSION_UPGRADE_DOWNGRADE_REQUESTS)			&&
				!$reseller->hasPermission(Reseller::PERMISSION_CUSTOMER_GROUPS)
			) {
				$this->view->hideManageCustomers = true;
			}
			// visibility of fraud prevention settings
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_FRAUD_PROTECTION)
			) {
				$this->view->hideFraudPrevention = true;
			}
			// visibility of product settings
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_SUPPORTED_TLDS)
			) {
				$this->view->hideProductSettings = true;
			}
			// visibility of server settings
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_PANELS)								&&
				!$reseller->hasPermission(Reseller::PERMISSION_PAYMENT_GATEWAYS)					&&
				!$reseller->hasPermission(Reseller::PERMISSION_REGISTRARS)							&&
				!$reseller->hasPermission(Reseller::PERMISSION_SSL_CERTIFICATE_PROVIDERS)
			) {
				$this->view->hideServerSettings = true;
			}
			// visibility of manage branding
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_COMPANY_INFO)						&&
				!$reseller->hasPermission(Reseller::PERMISSION_BRANDING)							&&
				!$reseller->hasPermission(Reseller::PERMISSION_EMAIL_TEMPLATES)						&&
				!$reseller->hasPermission(Reseller::PERMISSION_PDF_INVOICES_CUSTOMIZATION)			&&
				(!$reseller->hasPermission(Reseller::PERMISSION_SCHET_FACTURAS_CUSTOMIZATION) || !Settings()->invoiceFactura_enableGeneration)
			) {
				$this->view->hideManageBranding = true;
			}
			// visibility of system settings
			$this->view->hideSystemSettings = true;
			// visibility of manage info
			if (
				!$reseller->hasPermission(Reseller::PERMISSION_CALLBACK_LOG)
			) {
				$this->view->hideManageInfo = true;
			}
		}
		$this->view->configGroupIDs = array(
			'invoice' => Factory()->ConfigGroup(0)->getChild('billing')->getChild('invoice')->id,
			'systemQueue' => Factory()->ConfigGroup(0)->getChild('automation')->getChild('systemQueue')->id,
			'autoSuspension' => Factory()->ConfigGroup(0)->getChild('automation')->getChild('autoSuspension')->id,
			'display' => Factory()->ConfigGroup(0)->getChild('userSettings')->getChild('display')->id,
			'clientSidePaymentOptions' => Factory()->ConfigGroup(0)->getChild('payment')->getChild('clientSidePaymentOptions')->id,
			'managementrules' => Factory()->ConfigGroup(0)->getChild('product')->getChild('managementrules')->id,
			'sslfactory' => Factory()->ConfigGroup(0)->getChild('ssl')->getChild('sslfactory')->id,
			'pdfInvoice' => Factory()->ConfigGroup(0)->getChild('billing')->getChild('pdfInvoice')->id,
			'emailSettings' => Factory()->ConfigGroup(0)->getChild('email')->getChild('emailSettings')->id,
		);
		$this->view->hideCustomizationInvoiceFactura = !Settings()->invoiceFactura_enableGeneration;
		$this->view->isEncryptionEnabled = Service()->CryptManager->isEncryptionEnabled();
	}
}