<?php

require_once("admin/include/lib-action/todos/ShowTodos.php");

class ShowDashboardTodos extends ShowTodos
{
	public function __construct()
	{
		parent::__construct();

		$this->params = array(
			"todoID",
            "vendorID",
			"productID",
			"todoTitle",
			"todoDesc",
			"userID",
			"todoStatusID",
			"todoDateDue",
			"todoDateCreated",
			"todoAssignedAdminID",
			"todoIsPublic");
		$this->sortColumns = array(
			"todoStatusID",
			"todoDateDue",
			"todoTitle",
			"userID",
			"todoAssignedAdminID",
			"todoIsPublic");
		$this->sortDir = "desc";
	}

	public function execute()
	{
		MB_Action::execute();
		// past due todo items
		$query = $this->getMBAPIQuery("GetTodos", "",
            array(
                "vendorID" => getCurrentSession()->getVendorId(),
                "todoDateDueGreatest" => time(),
                "getAdminData" => 1,
                "numRecords" => 5,
                "sortDir" => "desc"
            )
        );
		$data = dispatchMBAPI($query, 1);
		$this->handleGroup( "pastdue", $data );
		$this->smartyVars["rowCount"]["pastdue"] = $this->getMaxCount( "pastdue" );

		// get todo's that are a day old
		$query = $this->getMBAPIQuery("GetTodos", "",
            array(
                "vendorID" => getCurrentSession()->getVendorId(),
                "todoDateDueLeast" => time(),
                "todoDateDueGreatest" => time() + 86400,
                "getAdminData" => 1,
                "numRecords" => 5,
                "sortDir" => "desc"
            )
        );
		$data = dispatchMBAPI($query, 1);
		$this->handleGroup( "near", $data );
		$this->smartyVars["rowCount"]["near"] = $this->getMaxCount( "near" );

        if (!empty($this->smartyVars["todos"]["pastdue"])) {
            $this->smartyVars["todostatusheaders"]["pastdue"] = blmsg("TRANS_DUE");
        }
        if (!empty($this->smartyVars["todos"]["near"])) {
            $this->smartyVars["todostatusheaders"]["near"] = blmsg("TRANS_24HOURS");
        }

		$this->smartyVars['todoAssignHeaders'] = array(
			'mine' => blmsg("TRANS_MY_TODO_ITEMS"),
			'public' => blmsg("TRANS_PUBLIC")
		);
		$this->addTemplate("dashboard/ShowDashboardTodos");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
