<?php

require_once("lib-action/action.php");

use Billing\Manager\CryptManager;
use Billing\Object\Reseller;

class ShowSystemSetup extends MB_Action
{
	public function execute()
	{
		parent::execute();
		$vendorId = getCurrentSession()->getVendorId();
		$this->smartyVars["vendorId"] = !is_null($vendorId) ? $vendorId : 'null';
		$reseller = $this->_getReseller();

		$this->smartyVars["showEncriptionSettings"] = $reseller ? false : true;
		$this->smartyVars["showTaxationPolicies"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_TAXATION_POLICIES) : true;
		$this->smartyVars["showPaymentGateways"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_PAYMENT_GATEWAYS) : true;
		$this->smartyVars["showDomainRegistrars"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_REGISTRARS) : true;
		$this->smartyVars["showFraudStatus"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_FRAUD_PROTECTION) : true;
		$this->smartyVars["showCompanyDetails"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_COMPANY_INFO) : false;
		$this->smartyVars["showBranding"] = $reseller ? $reseller->hasPermission(Reseller::PERMISSION_BRANDING) : false;

		$this->smartyVars["paymentGateways"]["status"] = (0 == count(Factory()->PaymentGatewayList(array('vendor_id' => $vendorId)))) ? "not-configured" : "done";

		$this->smartyVars["registrars"]["status"] = sizeof(Service()->BillingRegistrarManager->getEnabledRegistrars($vendorId)) ? "done" : (sizeof(Service()->BillingRegistrarManager->getDisabledRegistrars($vendorId)) ? "not-managed" : "not-configured");

		$this->smartyVars["taxes"]["status"] = (0 == count(Factory()->TaxPolicyList(array('vendor_id' => $vendorId)))) ? "not-configured" : "done";

		$this->smartyVars["fraud"]["status"] = isset(Settings()->fraudSecurityLevel) ? "done" : "not-configured";
		$this->smartyVars["company"]["status"] = Settings()->settings_isCompanyDetailsConfigured ? "done" : "not-configured";
		$this->smartyVars["branding"]["status"] = Settings()->settings_isBrandingConfigured ? "done" : "not-configured";

		$this->smartyVars["encryption"]["status"] = (in_array(Service()->CryptManager->getEncryptionMode(), array(CryptManager::MODE_SIMPLE, CryptManager::MODE_SECURE))) ? "done" : "not-configured";

		$this->smartyVars["warningHide"] = bgpc("dashboard-system-setup-warning-hide-{$this->smartyVars["vendorId"]}", 0);


		$this->addTemplate("dashboard/ShowSystemSetup");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
