<?php
require_once("lib-action/DomainAction.php");

class RenewDomainResponse extends DomainAction
{
	public $params = array("domainID","domainYears",);

	public function execute()
    {
		parent::execute();

		$mbapiData = $this->getDomain();
		$domainYears = (int) $_REQUEST["domainYears"];

		// is the domainID valid?
		if (!$domainYears || $domainYears > 10) {
			$this->redirectWithErrorMessage("Invalid domain years.");
		}

	 	// fetching domain data from the registrar
	 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = (int)$mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$xml = "
		<mbapi>
		  <command>ProcessRegistrar</command>
		  <showXMLHeader>0</showXMLHeader>
		  <params>
		    <subCommand>renewDomain</subCommand>
            <configID>0</configID>
		    <vendorID>".getCurrentSession()->getVendorId()."</vendorID>
            <domainID>".$domainID."</domainID>
			<domainSLD>".$domainSLD."</domainSLD>
			<domainTLD>".$domainTLD."</domainTLD>
			<domainYears>".$domainYears."</domainYears>
		  </params>
		</mbapi>";
		$data = dispatchMBAPI($xml,1);
		$this->processRegistrarResponse($data);
		return $this->hasExecutedSuccessfully();

	}

}