<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/emailactions.php");

class EditEmailTemplateGroup extends MB_Action
{
	public $params = array("emailTplGroupID");

	public function execute()
	{
		global $CONF;
		parent::execute();

		if(!((int) $_REQUEST["emailTplGroupID"])) {
			$this->addError('TRANS_ACTIONERROR', "No email template group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array("getEmailTemplates" => 2));
			$data = dispatchMBAPI($query, 1);

			if($data["mbapi"][0]["header"][0]["numResults"][0] != 1) {
				$this->addError('TRANS_ACTIONERROR', "Email template group not found.");
			}
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["emailActions"] = blmsg_array($CONF["types"]["emailAction"]);
				$this->smartyVars["emailTplGroup"] = correctArray($data["mbapi"][0]["results"][0]
					["emailTplGroups"][0]["emailTplGroup"][0]);
				$this->smartyVars["emailTemplates"] = correctArray($data["mbapi"][0]["results"][0]
					["emailTplGroups"][0]["emailTplGroup"][0]["emailTemplates"][0]["emailTemplate"]);
				$this->smartyVars["countryTypes"] = getTypes("countryTypes");
				$this->smartyVars["countryRegions"] = getRegions("names");
				$this->smartyVars["saved"] = (int)$_REQUEST["saved"];
				$this->mergeCountryData($CONF["user"]["locale"]->country);

				// find the email action name
				$actionName = getAPITypeName( 'emailAction', $this->smartyVars['emailTplGroup']['emailActionID'] );

				if (mb_path("/lib-mbapi/include/mail/emailTemplates/$actionName.php")) {
					$this->smartyVars['previewAvailable'] = true;
				} else {
					$this->smartyVars['previewAvailable'] = false;
				}

				$this->addTemplate("emails/EditEmailTemplateGroup", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}