<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class GetEmailTemplate extends MB_Action
{
	public $params = array("emailTplID", "emailTplGroupID");

	public function execute()
	{
		parent::execute();

		$output = array();

		$query = $this->getMBAPIQuery("GetEmailTemplates", "", array("getEmailTemplateGroupData" => 2), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0) {
			$results = grabSimpleMBAPIResults($data);

			if (is_array( $results[0] ) && notNull( $results[0]["emailTplBody"] )) {
				for( $i=0, $n=count( $results ); $i<=$n; $i++ ) {
					$results[ $i ]['emailTplTextBody'] = str_replace( "\n", null, nl2br( $results[ $i ]['emailTplTextBody'] ) );
					$results[ $i ]['emailTplBody'] = str_replace("\n", null, nl2br( $results[ $i ]['emailTplBody'] ) );
				}

				$output['emailTemplates']['emailTemplate'] =& $results;

			} else {
				if (notZero( $_REQUEST["emailTplID"] ) || notZero( $_REQUEST["emailTplGroupID"] )) {
					$this->addError('TRANS_ACTIONERROR', "Failed to properly fetch email template.");
				}
			}
		}

		foreach( (array)$this->getErrors() as $err ) {
			$output['errors']['error'][] = array(
				'title' => $err[0],
				'message' => $err[1]);
		}
		$output = array("api"=>$output);
		mbHeader("Content-Type: application/json; charset: UTF-8");
		echo $this->createJavascriptAssociativeArray($this->stripSensitiveData( $output ));

		dbg( $this->createJavascriptAssociativeArray($this->stripSensitiveData( $output )) );

		return $this->hasExecutedSuccessfully();
	}
}