<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-mbapi/include/mail/mail.php");

class GetEmailTemplateVariables extends MB_Action
{
	public $params = array("emailTplID", "emailTplGroupID");

	public function execute()
	{
		parent::execute();

		$output = array();

		if (!notZero( $_REQUEST['emailTplID'] ) && !notZero( $_REQUEST['emailTplGroupID'] )) {
			$this->addError('TRANS_ACTIONERROR', "Please specify an email template or group ID." );
		} elseif (notZero( $_REQUEST['emailTplID'] ) && !notZero( $_REQUEST['emailTplGroupID'] )) {
			$emlTpl = new MBQuery("GetEmailTemplates", "", array("emailTplID" => (int)$_REQUEST["emailTplID"]));
			$emlTpl = $emlTpl->getResult();

			if (!$emlTpl->getErrorCount()) {
				$emlTpl = grabSimpleMBAPIResults( $emlTpl->getStructure() );

				if (notZero( $emlTpl[0]['emailTplGroupID'] )) {
					$_REQUEST['emailTplGroupID'] = (int)$emlTpl[0]['emailTplGroupID'];
				}
			} else {
				$this->addError('TRANS_ACTIONERROR', "Failed to be able to fetch requested email template." );
			}
			unset( $emlTpl );
		}

		if (notZero( $_REQUEST['emailTplGroupID'] ) && !$this->getNumErrors()) {
			$tplObj = new MBTemplateBasedEmail( (int)$_REQUEST['emailTplGroupID'] );
			global $emailTemplateIDCache;
			show($emailTemplateIDCache);
			show($tplObj);exit;
		}

		foreach( (array)$this->getErrors() as $err ) {
			$output['errors']['error'][] = array(
				'title' => $err[0],
				'message' => $err[1]);
		}

		$output = array("api"=>$output);

		mbHeader("Content-Type: application/json; charset: UTF-8");
		echo $this->createJavascriptAssociativeArray($this->stripSensitiveData( $output ));

		dbg( $this->createJavascriptAssociativeArray($this->stripSensitiveData( $output )) );

		return $this->hasExecutedSuccessfully();
	}
}