<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class ReloadEmailTemplateResponse extends MB_Action
{
	public $params = array(
		"emailTplID",
		"templateName",
		"reloadHTML",
		"reloadTXT"
	);

	public function execute()
	{
		parent::execute();

		// Make sure the given text bodies are valid for XML
		$emailTplID = (int)$_REQUEST["emailTplID"];
		$templateName = unsecureInput( $_REQUEST["templateName"] );

		if(!notZero($emailTplID)) {
			$this->addError('TRANS_ACTIONERROR', "No email template ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				$this->_completeAction();
			}

			// get the locale info
			$template = new MBQuery("GetEmailTemplates", "", array("emailTplID" => $emailTplID));

			$template = $template->getResult();
			$template = grabSimpleMBAPIResults( $template->getStructure() );

			$language = oneByID( 'languages', $template[0]["languageID"] );
			$country = oneByID( 'countries', $template[0]["countriesID"] );


			$locale = $language["languageISO2"].'_'.$country["countriesISO2"];

			unset( $language, $country, $template );

			$params = array("emailTplID" => $emailTplID);

			if ($_REQUEST["reloadHTML"]) {
				$fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.$locale.html.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.".$language["languageISO2"]."_US.html.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.en_US.html.tpl" );

				if (is_readable( $fileName ) && is_file( $fileName ))
					$params["emailTplBody"] = utf8_xml_entity_encode(file_get_contents($fileName));
			}

			if ($_REQUEST["reloadTXT"]) {
				$fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.$locale.txt.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.$locale.text.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.".$language["languageISO2"]."_US.txt.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.".$language["languageISO2"]."_US.text.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.en_US.txt.tpl" );
				if (!$fileName) $fileName = mb_path( "/lib-themes/default/lib-billing/templates/emails/$templateName.en_US.text.tpl" );

				if (is_readable( $fileName ) && is_file( $fileName ))
					$params["emailTplTextBody"] = utf8_xml_entity_encode(file_get_contents($fileName));
			}
			unset( $fileName );

			updateFor(":emailTemplates", $params);
			$this->_completeAction();
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function _completeAction()
	{
		redirect("emails.php", "EditEmailTemplate", array("emailTplID" => bgpc("emailTplID")));
	}
}
