<?php
require_once ("lib-action/action.php");

class RemoveEmailTemplateGroup extends MB_Action
{
	public $params = array("emailTplGroupID");

	public function execute()
    {
		parent::execute();

		$emailTplGroupID = bgpc("emailTplGroupID");
		if(!$emailTplGroupID) {
			$this->addError('TRANS_ACTIONERROR', "No email template group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array());
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$this->smartyVars["emailTplGroup"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]["emailTplGroups"]
							[0]["emailTplGroup"][0]);
					$this->addTemplate("emails/RemoveEmailTemplateGroup", $this->smartyVars);
				} else {
					$this->addError('TRANS_ACTIONERROR', "Email template group not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}