<?php
require_once ("lib-action/action.php");
require_once ("lib-billing/include/config/internal/emailactions.php");

class ShowEmailTemplateGroups extends MB_Action
{
	public function __construct()
    {
		parent::__construct();
		$this->params = array("emailTplGroupName");
		$this->sortColumns = array("emailTplGroupID", "emailTplGroupName", "emailActionID");
	}

	public function execute()
    {
		global $CONF;
		parent::execute();
		$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array("getEmailTemplates" => 1, "vendorID" => is_null($vendorId = getCurrentSession()->getVendorId()) ? "NULL" : $vendorId));
		$data = dispatchMBAPI($query, 1);

		$results = $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["emailActions"] = blmsg_array($CONF["types"]["emailAction"]);
			$this->smartyVars["emailActions"] += $CONF["types"]["admin"]["emailAction"];
			$this->smartyVars["emailTplGroups"] = $results["emailTplGroups"][0]["emailTplGroup"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["emailTplGroups"] = array(0 => $results["emailTplGroups"][0]["emailTplGroup"]);
			}
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			$this->smartyVars = collapseArrayElements($this->smartyVars);

			if (is_array($this->smartyVars["emailTplGroups"])){
				foreach ($this->smartyVars["emailTplGroups"] as $tplGroup){
					$this->smartyVars["assocTplGroup"][$tplGroup["emailActionID"]][] = $tplGroup;
				}
				ksort($this->smartyVars["assocTplGroup"]);
				$this->smartyVars = collapseArrayElements($this->smartyVars);
				foreach ($this->smartyVars["assocTplGroup"] as $key=>$atplGroup){
					if ($atplGroup["emailTplGroupID"]){
						$this->smartyVars["assocTplGroup"][$key] = array($atplGroup);
					}
				}
			}
			$this->addTemplate("emails/ShowEmailTemplateGroups");
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}