<?php

require_once("lib-action/action.php");

class ShowEventOutputDetails extends MB_Action
{
	public $params = array("systemQueueID");

	public function execute()
	{
		parent::execute();

		$query = $this->getMBAPIQuery("GetSystemQueue", "", array("getSystemQueueLogData" => 1));
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

		if (0 !== $this->addMBAPIErrors($data)) {
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		$smartyVars = array();
		$systemQueueLogsDirty = $results["systemQueue"][0]["systemQueueEvent"][0]["systemQueueLogs"][0]["systemQueueLog"];
		$result = usort($systemQueueLogsDirty, function($left, $right) { return ($left["systemQueueLogID"][0] > $right["systemQueueLogID"][0]) ? -1 : 1; });
		$c = count($systemQueueLogsDirty);
		for($i=0; $i<$c; $i++) {
			$systemQueueLogMessageParsed = "";
			if ($systemQueueLogsDirty[$i]["systemQueueLogMessage"][0]) {
				$xml = str_replace("&amp;", "&", str_replace("&gt;", ">", str_replace("&lt;", "<", $systemQueueLogsDirty[$i]["systemQueueLogMessage"][0])));
				$xmldoc = new MBXMLLite($xml);
				$systemQueueLogMessageParsed = secureInput($xmldoc->toArray());
				if(!$xmldoc->isValid()) {
					$systemQueueLogMessageParsed = array("Error"=>"XML is corrupt!");
				} else {
					$errors = array();
					preg_match_all("/<message>(.*)<\/message>/", $xml, $errors);
					if (is_array($errors)){
						$systemQueueLogsDirty[$i]["plainErrors"] = (array)$errors[0];
					}
				}
				$cleanedXML = str_replace("<font color='red'>/", "/<font color='red'>", str_replace("	", ". ", preg_replace("/&lt;(.*)&gt;/U", "&lt;<font color='red'>\\1</font>&gt;", preg_replace("/&lt;\/(.*)&gt;/U", "&lt;/<font color='red'>\\1</font>&gt;", str_replace(array("&", "<", ">"), array("&amp;", "&lt;", "&gt;"), toXML($systemQueueLogMessageParsed))))));
				$systemQueueLogsDirty[$i]["cleanedXML"] = $cleanedXML;
			} else {
				$systemQueueLogMessageParsed = array("Error"=>"systemQueueLogMessage is empty!");
			}
			$systemQueueLogsDirty[$i]["systemQueueLogMessageParsed"][0] = $systemQueueLogMessageParsed;
			$systemQueueLogsDirty[$i]["CrashReportNumber"] = ("" != $systemQueueLogsDirty[$i]["systemQueueCrashReportID"][0])
				? Factory()->ErrorReport($systemQueueLogsDirty[$i]["systemQueueCrashReportID"][0])->number
				: "";
		}
		$smartyVars["eventLogs"] = ($c == 1) ? array(0 => $systemQueueLogsDirty) : $systemQueueLogsDirty;

		$this->addTemplate("widgets/showEventOutputDetails", collapseArrayElements($smartyVars));
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}