<?php

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects displays the system events menu.
 *
 * @author  Michael Fountain
 */
class ShowEventsStats extends MB_Action {
	/**
	 * The constructor for a ShowEventsStats action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowEventsStats() {
		parent::MB_Action();
		$this->stringRep = "ShowEventsStats";
		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowEventsStats action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->addTemplate("events/ShowEventsStats", collapseArrayElements($smartyVars));
		return $this->hasExecutedSuccessfully();
	}
}