<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class AddFraudCountryThresholdResponse extends MB_Action
{
	public $params = array(
		"thresholdID",
		"thresholdName",
		"countryType",
		"countriesID",
		"regionsID",
	);

	public function execute()
	{
		parent::execute();

		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			$this->_completeAction();
		}

		$query = $this->getMBAPIQuery("SetFraudCountryThresholds", "insert", array());
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
		    billing_put_info(blmsg("TRANS_DEFINE_NEW_COUNTRY_THRESHOLD_SUCCESS_MSG", array("NAME" => bgpc("thresholdName"))));
		    $this->_completeAction();
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function _completeAction()
	{
		redirect("fraudsets.php", getActionID("ShowFraudSets"));
	}
}