<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class EditFraudCountryThreshold extends MB_Action
{
	public $params = array("thresholdID");

	public function execute()
	{
		global $CONF;
		parent::execute();

		$thresholdID = getParam("thresholdID");
		if(!$thresholdID) {
			$this->addError('TRANS_ACTIONERROR', "No threshold ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetFraudCountryThresholds", "", array());
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

                $this->smartyVars["thresholdData"] = collapseArrayElements($results["countryThresholds"][0]["countryThreshold"]);

                // set default triggers
                $triggers = array (
                    "freeEmailWeight",
                    "countryMatchWeight",
                    "anonProxyWeight",
                    "countryRiskWeight",
                    "ipDistanceWeight",
                    "binMatchWeight",
                    "binBankMatchWeight",
                    "highRiskEmailWeight",
                    "highRiskShippingWeight",
                    "openProxyWeight"
                );
                foreach($triggers as $trigger) {
                    if (empty($this->smartyVars["thresholdData"][$trigger])) {
                        $this->smartyVars["thresholdData"][$trigger] = "0.0";
                    }
                }

                // set default scores
                $scoreScale = array();
                for($i=0;$i<=10;$i++){
                    for($j=0;$j<10;$j++){
                        if ($i<10) {
                            $scoreScale[] = $i.".".$j;
                        } else {
                            $scoreScale[] = "10.0";
                            break;
                        }
                    }
                }
                $this->smartyVars["scoreScale"] = $scoreScale;
                $this->smartyVars["fraudLevelActions"] = getStatuses("fraudLevelActions");
				$this->smartyVars["countryRegions"] = getRegions("names");
				$this->mergeCountryData($CONF["user"]["locale"]->country);
				$smartyVars["countryList"] = $this->smartyVars["countryList"];
				$smartyVars["selectedCountry"] = $this->smartyVars["selectedCountry"];

                $this->mergeSystemNavData();
				$this->addTemplate("fraudsets/EditFraudCountryThreshold", $this->smartyVars);

			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}