<?php
require_once ("lib-action/action.php");

class EditFraudCountryThresholdResponse extends MB_Action
{
	public $params = array(
		"thresholdID",
		"thresholdName",
		"countryType",
		"countriesID",
		"regionsID",
		"levelOneScore",
		"levelTwoScore",
		"levelThreeScore",
		"levelOneAction",
		"levelTwoAction",
		"levelThreeAction",
		"catchAllAction",
		"overrideOneAmount",
		"overrideTwoAmount",
		"overrideThreeAmount",
		"overrideOneAction",
		"overrideTwoAction",
		"overrideThreeAction",
		"primaryScoreToUse",
		"freeEmailWeight",
		"countryMatchWeight",
		"anonProxyWeight",
		"countryRiskWeight",
		"ipDistanceWeight",
		"binMatchWeight",
		"binBankMatchWeight",
		"highRiskEmailWeight",
		"highRiskShippingWeight",
		"openProxyWeight",
		"fraudSoftRejectMessage",
		"fraudHardRejectMessage",
	);

	public function execute()
    {
		parent::execute();

		$thresholdID = ((int) $_REQUEST["thresholdID"]);
		if(!$thresholdID) {
			$this->addError('TRANS_ACTIONERROR', "No threshold ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect('fraudsets.php', getActionID("EditFraudCountryThreshold"), array("thresholdID" => $thresholdID));
			}
			if ($_REQUEST["fraudSoftRejectMessage"]){
				$_REQUEST["fraudSoftRejectMessage"] = utf8_xml_entity_encode(utf8_xml_entity_encode(unsecureInput($_REQUEST["fraudSoftRejectMessage"])));
			}
			if ($_REQUEST["fraudHardRejectMessage"]){
				$_REQUEST["fraudHardRejectMessage"] = utf8_xml_entity_encode(utf8_xml_entity_encode(unsecureInput($_REQUEST["fraudHardRejectMessage"])));
			}
			$query = $this->getMBAPIQuery("SetFraudCountryThresholds", "update", array());
			$data = dispatchMBAPI($query, 1);

		    if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
			    redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
		    } else {
                if (!$adminGroupID && (int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]) {
				    $adminGroupID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
                }
			    redirect("fraudsets.php",getActionID("ShowFraudSets"), array("thresholdID"=>$thresholdID));
		    }

        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
