<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class EditFraudSetResponse extends MB_Action
{
	public $params = array(
		"fraudSetID",
		"configGroupID",
		"fraudSetName",
		"fraudSetEmail",
		"orderFormIDs",
	);

	public function execute()
	{
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError('TRANS_ACTIONERROR', "No fraudSetID ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect('fraudsets.php', getActionID("ShowFraudSetDetails"), array("fraudSetID" => $fraudSetID));
			}

			// test for updating relations
			$assignedOrderFormIDs = $assignedThresholdIDs = $relParams = array();
			//$addOrderFormIDs = (isset($_REQUEST["addOrderFormIDs"])) ? $_REQUEST["addOrderFormIDs"] : array() ;
			//$addThresholdIDs = (isset($_REQUEST["addThresholdIDs"])) ? $_REQUEST["addThresholdIDs"] : array() ;

			if (isset($_REQUEST["stores"]) || isset($_REQUEST["thresholds"])) {
                foreach ((array)$_REQUEST["stores"] as $storeId => $storeIsEnabled){
                    if ($storeIsEnabled) {
                        $relParams["orderFormIDs"]["orderFormID"][] = $storeId;
                    } else {
                        $relParams["removeOrderFormIDs"]["orderFormID"][] = $storeId;
                    }
                }
                foreach ((array)$_REQUEST["thresholds"] as $thresholdId => $thresholdIsEnabled){
                    if ($thresholdIsEnabled) {
                        $relParams["thresholdIDs"]["thresholdID"][] = $thresholdId;
                    } else {
                        $relParams["removeThresholdIDs"]["thresholdID"][] = $thresholdId;
                    }
                }

				// ------------------------------------------------
				// test to see if we are adding or removing relations
				// ------------------------------------------------
				if (count($relParams["orderFormIDs"]["orderFormID"]) ||
					count($relParams["removeOrderFormIDs"]["orderFormID"]) ||
					count($relParams["thresholdIDs"]["thresholdID"]) ||
					count($relParams["removeThresholdIDs"]["thresholdID"])) {
					$query = $this->getMBAPIQuery("SetFraudSets", "update", $relParams);
					$data = dispatchMBAPI($query, 1);
				} else {
					$skipUpdate = 1;
				}
			} else {
				$query = $this->getMBAPIQuery("SetFraudSets", "update", array());
				$data = dispatchMBAPI($query, 1);
			}

			if($skipUpdate || ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors())) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]."&saved=1");
				} else {
					redirect("fraudsets.php",getActionID("ShowFraudSets"),array("fraudSetID"=>$fraudSetID,"saved"=>1));
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
