<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class RemoveFraudCountryThresholdResponse extends MB_Action
{
	public $params = array("thresholdID");

	public function execute()
	{
		parent::execute();

		$thresholdID = bgpc("thresholdID");
		if(!$thresholdID) {
		    billing_put_error(blmsg("TRANS_THRESHOLD_NO_ID_GIVEN_ERROR"));
		    $this->_completeAction();
		}
		if (!getCurrentSession()->isValidToken()) {
		    billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
		    $this->_completeAction();
		}

		$query = $this->getMBAPIQuery("SetFraudCountryThresholds", "delete", array());
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
		    billing_put_info(blmsg("TRANS_REMOVE_THRESHOLD_SUCCESS_MSG"));
		    $this->_completeAction();
		}
		
		return $this->hasExecutedSuccessfully();
	}

	private function _completeAction()
	{
		redirect("fraudsets.php", getActionID("ShowFraudSets"));
	}
}