<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class RemoveFraudSetResponse extends MB_Action
{
	public $params = array("fraudSetID");

	public function execute()
	{
		parent::execute();

		$fraudSetID = bgpc("fraudSetID");
		if(!$fraudSetID) {
		    billing_put_error(blmsg("TRANS_FRAUD_SET_NO_ID_GIVEN_ERROR"));
		    $this->_completeAction();
		}
		if (!getCurrentSession()->isValidToken()) {
		    billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
		    $this->_completeAction();
		}
		$query = $this->getMBAPIQuery("SetFraudSets", "delete", array());
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
		    billing_put_info(blmsg("TRANS_REMOVE_FRAUD_SET_SUCCESS_MSG"));
		    $this->_completeAction();
		}
		
		return $this->hasExecutedSuccessfully();
	}

	private function _completeAction()
	{
		redirect("fraudsets.php", getActionID("ShowFraudSets"));
	}
}