<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class ShowFraudSetDetails extends MB_Action
{
	public $params = array("fraudSetID");

	public function execute()
	{
		parent::execute();

		$fraudSetID = ((int) $_REQUEST["fraudSetID"]);
		if(!$fraudSetID) {
			$this->addError('TRANS_ACTIONERROR', "No fraudSetID ID given.");
		} else {
            $args = array(
                'getOrderForms' => 1,
            	'vendorID' => getCurrentSession()->getVendorId(),
                'getCountryThresholdsData' => 1
            );
		    $query = $this->getMBAPIQuery("GetFraudSets", "", $args);
		    $data = dispatchMBAPI($query, 1);
		    $fraudSets =& $data["mbapi"][0]["results"][0];

		    if($this->addMBAPIErrors($data) === 0) {

			    $this->smartyVars["fraudSet"] = collapseArrayElements($fraudSets["fraudSets"][0]["fraudSet"]);

                // ------------------------------------------------
                // find all usedOrderForms
                // ------------------------------------------------
                $usedOrderForms = array();
                $c = count($fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"]);
                for($i=0;$i<$c;$i++){
                    $id = $fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"][$i]["orderFormID"][0];
                    $usedOrderForms[] = $id;
                    $this->smartyVars["doubleListSelectorOptionsStores"][$id] = array(
                        'id' => $id,
                        'title' => $fraudSets["fraudSets"][0]["fraudSet"][0]["orderForms"][0]["orderForm"][$i]["orderFormName"][0],
                        'selected' => true
                    );
                }
                foreach( Factory()->StoreList(array('vendor_id' => getCurrentSession()->getVendorId())) as $store ) {
                    if (in_array($store->id, $usedOrderForms)) {
                        continue;
                    }
                    $this->smartyVars["doubleListSelectorOptionsStores"][$store->id] = array(
                        'id' => $store->id,
                        'title' => $store->order_form_name,
                    );
                }
                // ------------------------------------------------
                // find all usedThresholds
                // ------------------------------------------------
                $usedThresholds = array();
                $c = count($fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"]);
                for($i=0;$i<$c;$i++){
                    $id = $fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"][$i]["thresholdID"][0];
                    $usedThresholds[] = $id;
                    $this->smartyVars["doubleListSelectorOptionsThresholds"][$id] = array(
                        'id' => $id,
                        'title' => $fraudSets["fraudSets"][0]["fraudSet"][0]["countryThresholds"][0]["countryThreshold"][$i]["thresholdName"][0],
                        'selected' => true
                    );
                }

                // ------------------------------------------------
                // find all availableThresholds
                // ------------------------------------------------
                $availableThresholds = array();
                if($usedThresholds){
					$args = array("notThresholdIDs"=>array("thresholdID"=>$usedThresholds));
                }
			    $query3 = $this->getMBAPIQuery("GetFraudCountryThresholds", "", $args);
			    $data3 = dispatchMBAPI($query3, 1);
                $thresholds =& $data3["mbapi"][0]["results"][0];
                if (isset($thresholds["countryThresholds"][0]["countryThreshold"][0])){
					$c = count($thresholds["countryThresholds"][0]["countryThreshold"]);
					for($i=0;$i<$c;$i++){
						$id = $thresholds["countryThresholds"][0]["countryThreshold"][$i]["thresholdID"][0];
						if ((int) $id) {
                            $this->smartyVars["doubleListSelectorOptionsThresholds"][$id] = array(
                                'id' => $id,
                                'title' => $thresholds["countryThresholds"][0]["countryThreshold"][$i]["thresholdName"][0],
                            );
                        }
					}
                }

			    // Set the templete for output
			    $this->mergeSystemNavData();

                asort($this->smartyVars["doubleListSelectorOptionsStores"]);
                $this->smartyVars["doubleListSelectorAttribsStores"] = array('id' => 'stores');
                asort($this->smartyVars["doubleListSelectorOptionsThresholds"]);
                $this->smartyVars["doubleListSelectorAttribsThresholds"] = array('id' => 'thresholds');

                $GLOBALS["tpl"]->assign_by_ref("doubleListSelector", new Billing_Zend_View_Helper_DoubleListSelector());
                $this->smartyVars["buttons"] = array(
                    array('id' => 'billing-id-save', 'class' => 'action', 'name' => 'save', 'value' => "TRANS_SAVE_ALL", 'type' => 'submit', 'label' => 'TRANS_SAVE_ALL'),
                );

                $this->addTemplate("fraudsets/ShowFraudSetDetails",$this->smartyVars, 1);
		    }
        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}