<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class ShowFraudSets extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetFraudSets", "", array());
		$data = dispatchMBAPI($query, 1);
		$fraudSets =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {

            // GetFraudSets
			$this->smartyVars["fraudSets"] = protectArray($fraudSets["fraudSets"][0]["fraudSet"]);

            // GetFraudCountryThresholds
		    $query2 = $this->getMBAPIQuery("GetFraudCountryThresholds", "", array());
		    $data2 = dispatchMBAPI($query2, 1);
		    $countryThresholds =& $data2["mbapi"][0]["results"][0];
			$this->smartyVars["countryThresholds"] = protectArray($countryThresholds["countryThresholds"][0]["countryThreshold"]);

			// Set the templete for output
            $this->smartyVars = collapseArrayElements($this->smartyVars);

            $this->smartyVars["countryTypes"] = getTypes("countryTypes");
            $this->smartyVars["regionNames"] = getRegions("names");
            $this->smartyVars["nestedRegions"] = getRegions("nested");
            $this->mergeCountryData($CONF["user"]["locale"]->country);
            $smartyVars["countryList"] = $this->smartyVars["countryList"];
            $smartyVars["selectedCountry"] = $this->smartyVars["selectedCountry"];

			$this->mergeSystemNavData();
			$this->addTemplate("fraudsets/ShowFraudSets",$this->smartyVars, 1);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}