<?php

class Fraudsets_FraudProtectionController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
        $this->_backUrl = ("ShowDashboard" == bgpc("redirectAction"))
            ? $this->view->adminActionUrl('dashboard', 'home', 'index')
            : $this->view->adminActionUrl('configs', 'system', 'show');
	}

	public function editAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_FRAUD_PROTECTION_SETTINGS'));
		$editForm = new Billing_Zend_Form_Final_EditFraudProtectionForm(array('context' => array(
			'cancelLink' => $this->_backUrl,
			'postData' => $postData,
		)));
		if ($this->_request->isPost() && $editForm->isValid($postData))
		{
			try {
				$editForm->processForm();
				$this->_redirect($this->_backUrl);
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $editForm;
	}

	private $_backUrl = NULL;
}