<?php
require_once ("lib-action/action.php");

class ShowGraph extends MB_Action
{
	public function execute()
    {
		parent::execute();
        $t = new Timer();
		define("DEFAULT_GFORMAT", "auto");

		// Setup data
		$data =& $_REQUEST["data"];
		$h = new QueryMaster("select");
		$results = NULL;
		if(is_array($data) && count($data)) {
			$c = count($data);
			for($i=0; $i<$c; $i++) {
				$h->addColumns($data[$i]);
			}
			if(is_array($_REQUEST["andClauses"])) {
				foreach($_REQUEST["andClauses"] as $clause) {
					$h->addCustomAndClause($clause);
				}
			}

			$h = NULL;
			$day = 1;
			$month = 8;
			$year = 2005;
			$results = array();
			for($i=$day; $i<=31; $i++) {
				$h = new QueryMaster("select", "$i as client_date_created", "COUNT(clients.client_id) as numClients");
				$h->addAndClause("clients.client_date_created", ">", mktime(0,0,0,$month,$i,$year), "i");
				$h->addAndClause("clients.client_date_created", "<", mktime(23,59,59,$month,$i,$year), "i");
				$h->addGroupByColumns("clients.client_id");
//  			echo $h->getQuery();
// 				print_r($h->getResults());
				$results = array_merge($results, $h->getResults());
			}
		} else {
			$h->addColumns($data);
			$results = $h->getCol();
		}
		if($results === false || !is_array($results) || !count($results)) {
			$results = array();
		}

		// What width & height should our graph have?
		$width = (int) $_REQUEST["width"];
		if($width < 1) {
			$width = 400;
		}
		$height = (int) $_REQUEST["height"];
		if($height < 1) {
			$height = 300;
		}

		// How long (in seconds) should we cache the generated graph for?
		$cacheLength = (int) $_REQUEST["cacheLength"];
		if($cacheLength < 0) {
			$cacheLength = 0;
		}

		// Setup graph
		$graph = new Graph($width, $height, "auto"/*, $cacheLength*/);
		if($_REQUEST["title"]) {
			$graph->title->Set($_REQUEST["title"]);
		}
		if($_REQUEST["titleBold"]) {
			$graph->title->SetFont(FF_FONT1, FS_BOLD);
		}
		$leftMargin = $rightMargin = $topMargin = $bottomMargin = -1;
		$keys = array("leftMargin", "rightMargin", "topMargin", "bottomMargin");
		foreach($keys as $key) {
			if(isset($_REQUEST[$key])) {
				$$key = (int) $_REQUEST[$key];
			}
		}
		$graph->SetMargin(100,40,30,140);
		
		$type = "";
		$plot = NULL;
		// What type of graph should we generate?
		if(false !== stripos($_REQUEST["type"], "bar")) {
			$type = "bar";
			require_once mb_path("/lib-action/include/jpgraph/jpgraph_bar.php");
		} else if(false !== stripos($_REQUEST["type"], "pie")) {
			$type = "pie";
			require_once mb_path("/lib-action/include/jpgraph/jpgraph_pie.php");
		} else {
			$type = "line";
			require_once mb_path("/lib-action/include/jpgraph/jpgraph_line.php");
			
			$yData = $xData = array();
			// Setup the data
			$xScale = $yScale = "lin";
			if(is_array($results[0]) && count($results[0]) > 1) {
				// Multiple columns back
				$c = count($results);
				for($i=0; $i<$c; $i++) {
					$yData[] = array_pop($results[$i]);
					$xData[] = array_pop($results[$i]);
				}
				$graph->SetScale($xScale.$yScale, min($yData), max($yData), min($xData), max($xData));
			} else if(!is_array($results[0]) && count($results)) {
				// Single column back
				$yData =& $results;
				$xData = false;
				$graph->SetScale("textlin", min($yData), max($yData));
			}

			if($xScale == "dat") {
				$graph->xaxis->scale->SetDateFormat("M j, Y");
				$graph->xaxis->SetLabelAngle(90);
			}
			if($yScale == "dat") {
// 				$graph->yaxis->scale->SetDateFormat("n j, Y");
				$graph->yaxis->SetLabelAngle(90);
			}

			// Setup plot
			$plot = new LinePlot($yData, $xData);
			if($_REQUEST["lineColor"]) {
				$plot->SetColor($_REQUEST["lineColor"]);
			}
			if($_REQUEST["lineValues"]) {
				$plot->value->Show();
			}
			if($_REQUEST["lineValueFormat"]) {
				$plot->value->SetFormat($_REQUEST["lineValueFormat"]);
			}

			// Setup axes
			$axes = array("x", "y");
			foreach($axes as $axis) {
				$varName = $axis."axis";
				if($_REQUEST[$axis."Title"]) {
					$graph->$varName->title->Set($_REQUEST[$axis."Title"]);
				}
				if($_REQUEST[$axis."TitleBold"]) {
					$graph->$varName->title->SetFont(FF_FONT1, FS_BOLD);
				}
				if($_REQUEST[$axis."Color"]) {
					$graph->$varName->SetColor($_REQUEST[$axis."Color"]);
				}
				if($_REQUEST[$axis."DateFormat"]) {
					$graph->$varName->scale->SetDateFormat($_REQUEST[$axis."DateFormat"]);
				}
			}
		}
		
		// Add the plot to the graph
		$graph->Add($plot);

		$time = $t->getElapsedTime();

		// Display the graph
		$graph->Stroke();
		
		return $this->hasExecutedSuccessfully();
	}
}

$a = new ShowGraph();
$a->execute();

