<?php

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * @author  Michael Fountain
 */
class ShowNewClientTrendGraph extends MB_Action {
	/**
	 */
	function ShowNewClientTrendGraph() {
		parent::MB_Action();
		$this->stringRep = "ShowNewClientTrendGraph";
		$this->params = array
		(
			"type","dataSource","dataSourceArgs",
			"width","height",
			"title","titleBold","titleColor",
			"text","textBold","textColor","textSize",
			"xTitle","xTitleBold","xTitleColor",
			"yTitle","yTitleBold","yTitleColor",
		);
	}

	/**
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$errorMsg = array();
		

		// define all valid data sources for this type of financial graph
		$validDataSources = array
		(
			"ClientList","ClientTrend"
		);

		if (in_array($this->paramArgs["dataSource"],$validDataSources)) {

			$graph = NULL;

			if ($this->paramArgs["type"]=="bar") {
				require_once mb_path("/lib-action/include/graph/MB_Bar.php");
				$graph = new MB_Bar();
			} else if($this->paramArgs["type"]=="line") {
				require_once mb_path("/lib-action/include/graph/MB_Line.php");
				$graph = new MB_Line();
			} else if($this->paramArgs["type"]=="pie") {
				require_once mb_path("/lib-action/include/graph/MB_Pie.php");
				$graph = new MB_Pie();
			} else if($this->paramArgs["type"]=="canvas") {
				require_once mb_path("/lib-action/include/graph/MB_Canvas.php");
				$graph = new MB_Canvas();
			}

			if ($graph) {
				if (mb_path("/lib-action/include/reports/".$this->paramArgs["dataSource"].".php")){
					require_once mb_path("/lib-action/include/reports/".$this->paramArgs["dataSource"].".php");
					$dsoName = $this->paramArgs["dataSource"]."Report";
					$this->paramArgs["dataSourceArgs"]["outputType"] = 1;
					$dso = new $dsoName($this->paramArgs["dataSourceArgs"]);
					$graph->setGraphDataSource($dso);
					$graph->setGraphSize($this->paramArgs["width"],$this->paramArgs["height"]);
					$graph->setGraphTitle($this->paramArgs["title"],$this->paramArgs["titleBold"],$this->paramArgs["titleColor"]);
					$graph->setGraphXAxisTitle($this->paramArgs["xTitle"],$this->paramArgs["xTitleBold"],$this->paramArgs["xTitleColor"]);
					$graph->setGraphYAxisTitle($this->paramArgs["yTitle"],$this->paramArgs["yTitleBold"],$this->paramArgs["yTitleColor"]);
					$graph->generate();
				} else {
					$errorMsg[] = "Unable to find datasource file. (/lib-action/include/reports/".$this->paramArgs["dataSource"].".php)";
				}
			} else {
				$errorMsg[] = "Unable to create a graph object.";
			}

		} else {
			$errorMsg[] = "Invalid data source.";
		}

		if (count($errorMsg)>0) {
			// error image to be displayed here
			require_once mb_path("/lib-action/include/graph/MB_Canvas.php");
			$graph = new MB_Canvas();
			$graph->setGraphSize($this->paramArgs["width"],$this->paramArgs["height"]);
			$graph->setGraphMargins(2,2,2,2);
			$graph->setGraphTitle("Error: Unable to generate your graph.",1,"red");
			$graph->setGraphText(implode("\n",$errorMsg),1,"#BBBBBB",10);
			$graph->generate();
		}
	}
}

?>
