<?php

require_once("lib-action/action.php");

class ConfirmCreditNoteResponse extends MB_Action
{
	public $params = array("invoiceID");

	public function execute()
	{
		parent::execute();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID) {
			$this->addError(blmsg("TRANS_ACTIONERROR"), "No invoice ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect('invoices.php', getActionID("ConfirmCreditNote"), array("invoiceID" => $invoiceID));
			}

			$creditNote = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"creditNoteForInvoiceID" => $invoiceID,
					),
				),
			)));

			if (!(int)$creditNote["invoiceID"]){
				$result = dispatchMBAPI("
						<mbapi>
							<command>ProcessCreditNote</command>
							<params>
								<invoiceID>".$invoiceID."</invoiceID>
								<rollbackRenewDates>".(int)$_REQUEST["rollbackRenewDates"]."</rollbackRenewDates>
								<invoiceComments>".$_REQUEST["invoiceComments"]."</invoiceComments>
							</params>
						</mbapi>
				", 1);
			} else {
				dbg("tried to credit note something that was already credit noted");
			}

			if (!$this->getNumErrors()) {

				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					$invoiceID = ($result["mbapi"][0]["results"][0]["invoiceID"][0]) ? $result["mbapi"][0]["results"][0]["invoiceID"][0] : $invoiceID;
					redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$invoiceID."&sid=".secureInput($_REQUEST["sid"]));
				}

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}