<?php

require_once("lib-action/action.php");
require_once("lib-tk/include/xml/xml.php");

use Billing\Object\Invoice;

class EditInvoice extends MB_Action
{
	public $params = array("invoiceID");

	public function execute()
	{
		parent::execute();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID) {
			$this->addError('TRANS_ACTIONERROR', "No invoice ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetInvoices", "", array());
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]["invoiceDateDueX"][0] = @date("Y-m-d", $data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]["invoiceDateDue"][0]);
				$s["invoice"] = collapseArrayElements($data["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0]);
				$s["statuses"] = blmsg_array(Invoice::statuses());
				unset($s["statuses"][Invoice::STATUS_VOID]);
                $this->smartyVars["buttons"] = array(
                    array('id' => 'billing-id-save', 'class' => 'action', 'name' => 'save', 'value' => "TRANS_SAVE", 'type' => 'submit', 'label' => 'TRANS_SAVE'),
                );
                $this->addTemplate("invoices/EditInvoice", $s);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
