<?php

require_once("lib-action/action.php");

class EditInvoiceResponse extends MB_Action
{
	public function __construct()
	{
		parent::__construct();
		$this->params = array(
			"invoiceID",
			"taxZoneID",
			"invoiceAmount",
			"invoiceAmountPaid",
			"invoiceDateCreated",
			"invoiceDateDue",
			"invoiceDatePaid",
			"invoicePaymentMethod",
			"invoiceComments",
			"invoiceBatchTimestamp",
			"invoiceSubTotal",
			"invoiceDiscount",
			"invoiceTax",
			"invoiceStatus"
		);
		$_REQUEST["invoiceDateDue"] = $this->handleDateSelector("invoiceDateDue");
	}

	public function execute()
	{
		parent::execute();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID) {
			$this->addError('TRANS_ACTIONERROR', "No invoice ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect('invoices.php', getActionID("EditInvoice"), array("invoiceID" => $invoiceID));
			}
            $_REQUEST["invoiceComments"] = billing_safetyhtml($_REQUEST["invoiceComments"]);
			$query = $this->getMBAPIQuery("SetInvoices", "update", array());
			$data = dispatchMBAPI($query, 1);
			if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$invoiceID."&sid=".secureInput($_REQUEST["sid"]));
				}
            }
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
