<?php

require_once("lib-action/action.php");

class GenerateInvoiceEvents extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect("invoices.php", "ShowGenerateInvoiceMenu");
		}

		if ($_REQUEST["reRequest"]){
			$tmp = unserialize(base64_decode($_REQUEST["reRequest"]));
			if (is_array($tmp)){
				$_REQUEST = secureInput(unsecureInput($tmp));
			}
		}

		$overrideDateDue = $this->handleDateSelector("overrideDateDue", 0);

		// set packageDateNextRenewalLessThan
		if (checkdate($_REQUEST["packageRenewMonth"],$_REQUEST["packageRenewDay"],$_REQUEST["packageRenewYear"])) {
            if (intval($_REQUEST["packageRenewHour"]) <= 23) {
                $packageRenewHour = (int) $_REQUEST["packageRenewHour"];
            } else {
                $packageRenewHour = date("h");
            }
            if (intval($_REQUEST["packageRenewMinute"]) <= 59) {
                $packageRenewMinute = (int) $_REQUEST["packageRenewMinute"];
            } else {
                $packageRenewMinute = date("i");
            }
			$packageDateNextRenewalLessThan = mktime($packageRenewHour,$packageRenewMinute,0,$_REQUEST["packageRenewMonth"],$_REQUEST["packageRenewDay"],$_REQUEST["packageRenewYear"]);
		} else {
			$packageDateNextRenewalLessThan = time();
		}
        $vendorId = getCurrentSession()->getVendorId();
        $vendorXML = "<vendorID>{$vendorId}</vendorID>\n";
		// set domainDateNextRenewalLessThan
		if (checkdate($_REQUEST["domainRenewMonth"],$_REQUEST["domainRenewDay"],$_REQUEST["domainRenewYear"])) {
            if (intval($_REQUEST["domainRenewHour"]) <= 23) {
                $domainRenewHour = (int) $_REQUEST["domainRenewHour"];
            } else {
                $domainRenewHour = date("h");
            }
            if (intval($_REQUEST["domainRenewMinute"]) <= 59) {
                $domainRenewMinute = (int) $_REQUEST["domainRenewMinute"];
            } else {
                $domainRenewMinute = date("i");
            }
			$domainDateNextRenewalLessThan = mktime($domainRenewHour,$domainRenewMinute,0,$_REQUEST["domainRenewMonth"],$_REQUEST["domainRenewDay"],$_REQUEST["domainRenewYear"]);
		} else {
			$domainDateNextRenewalLessThan = time();
		}

		// set systemQueueTime
		if (checkdate($_REQUEST["scheduleTimeMonth"],$_REQUEST["scheduleTimeDay"],$_REQUEST["scheduleTimeYear"])) {
		 	if (intval($_REQUEST["scheduleTimeHour"]) <= 23) {
		 		$scheduleTimeHour = (int) $_REQUEST["scheduleTimeHour"];
			} else {
				$scheduleTimeHour = date("h");
			}
		 	if (intval($_REQUEST["scheduleTimeMinute"]) <= 59) {
		 		$scheduleTimeMinute = (int) $_REQUEST["scheduleTimeMinute"];
			} else {
				$scheduleTimeMinute = date("i");
			}
			$systemQueueTime = mktime($scheduleTimeHour,$scheduleTimeMinute,0,$_REQUEST["scheduleTimeMonth"],$_REQUEST["scheduleTimeDay"],$_REQUEST["scheduleTimeYear"]);
		} else {
			$systemQueueTime = time();
		}

		// count how many invoices will be generated with these params
		if ((int)$_REQUEST["clientID"]){

			$wmXML = ((int)$_REQUEST["disableWalkMode"]>0)?"   <disableWalkMode>1</disableWalkMode>":"";
			$pmXML = ((int)$_REQUEST["previewMode"])?"<generateInvoicePreview>1</generateInvoicePreview>":"";
			$cXML =  ((int)$_REQUEST["clientID"])?"<getClients><clientID>".(int)$_REQUEST["clientID"]."</clientID></getClients>":"";

            $subscriptions = array();
            foreach ((array)$_REQUEST["subscriptions"] as $subscriptionId => $subscriptionIsEnabled){
                if ($subscriptionIsEnabled) {
                    $subscriptions[] = $subscriptionId;
                }
            }
            if (empty($subscriptions)) {
                billing_put_error(blmsg('TRANS_INVOICE_GENERATE_ERROR_NO_PACKAGES'));
                redirect("invoices.php", getActionID("ShowGenerateInvoiceMenu"), array(), array("clientID" => bgpc("clientID")));
            }

			$pXML =  toXML(array(
				"getPackages" => array(
					"packageID" => $subscriptions,
				),
			));
			$ProcessInvoicesXML =
				"<mbapi>
				<command>ProcessInvoices</command>
				<showXMLHeader>0</showXMLHeader>
				<params>
					$pmXML
					$wmXML
					$cXML
					$pXML
					$vendorXML
					<setSendInvoiceEmails>".(int)$_REQUEST["sendInvoiceEmail"]."</setSendInvoiceEmails>
					<packageDateNextRenewalLessThan>$packageDateNextRenewalLessThan</packageDateNextRenewalLessThan>
					<domainDateNextRenewalLessThan>$domainDateNextRenewalLessThan</domainDateNextRenewalLessThan>
					<getActiveClients>".(int) $_REQUEST["getActiveClients"]."</getActiveClients>
					<getSuspendedClients>".(int) $_REQUEST["getSuspendedClients"]."</getSuspendedClients>
					<getActivePackages>".(int) $_REQUEST["getActivePackages"]."</getActivePackages>
					<getSuspendedPackages>".(int) $_REQUEST["getSuspendedPackages"]."</getSuspendedPackages>
					<overrideDateDue>".$overrideDateDue."</overrideDateDue>
				</params>
				</mbapi>";

			dbg($ProcessInvoicesXML);

			$results = dispatchMBAPI($ProcessInvoicesXML, 1);
			$this->smartyVars["invoices"] = correctArray(grabSimpleMBAPIResults($results));
			$this->smartyVars["previewMode"] = (int)$_REQUEST["previewMode"];
			$this->smartyVars["clientInfo"] = grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetClients",
					"params" => array(
						"clientID" => (int)$_REQUEST["clientID"],
						"mergePrimaryContact" => 1,
					),
				),
			));
			$this->smartyVars["numInvoices"] = count($this->smartyVars["invoices"]);

			$this->smartyVars["reRequest"] = base64_encode(serialize(array("previewMode"=>0)+$_REQUEST));

			$customer = Factory()->Customer((int)$_REQUEST["clientID"]);
			if ($customer->isReseller()) {
			    $reseller = $customer->getReseller();
			    $successMessage = blmsg("TRANS_GENERATE_INVOICE_FOR_RESELLER_SUCCESS_MSG", array("NAME" => billing_safetyhtml($reseller->fullName)));
			} else {
			    $primaryContact = $customer->PrimaryContact;
			    $successMessage = blmsg("TRANS_GENERATE_INVOICE_FOR_CUSTOMER_SUCCESS_MSG",
				array("NAME" => billing_safetyhtml($primaryContact->contact_fullname)));
			}

		} else {
			$cmdArgs = array
			(
                "vendorID" => $vendorId,
				"disableWalkMode" => (int) $_REQUEST["disableWalkMode"],
				"getActiveClients" => (int) $_REQUEST["getActiveClients"],
				"getSuspendedClients" => (int) $_REQUEST["getSuspendedClients"],
				"getActivePackages" => (int) $_REQUEST["getActivePackages"],
				"getSuspendedPackages" => (int) $_REQUEST["getSuspendedPackages"],
				"packageDateNextRenewalLessThan" => $packageDateNextRenewalLessThan,
				"domainDateNextRenewalLessThan" => $domainDateNextRenewalLessThan,
				"countInvoicesToBeGeneratedOnly" => 1,
				"setSendInvoiceEmails" => (int)$_REQUEST["sendInvoiceEmail"],
			);

			$query = $this->getMBAPIQuery("ProcessInvoices", "", $cmdArgs);
			$data = dispatchMBAPI($query, 1);

			$numInvoicesGenerated = $data["mbapi"][0]["header"][0]["numInvoicesGenerated"][0];

			$numInvoicesPerEvent = (NUMBER_OF_INVOICES_PER_EVENT>0)?NUMBER_OF_INVOICES_PER_EVENT:5;
			$numEventsToCreate = ceil($numInvoicesGenerated / $numInvoicesPerEvent);

			dbg($numInvoicesPerEvent);

			$wmXML = ((int) $_REQUEST["disableWalkMode"]>0)?"   <disableWalkMode>1</disableWalkMode>":"";

			//for($i=1;$i<=$numEventsToCreate;$i++){
				// Get the time quantities for $current
				// minute;hour;day;month;year
				$timeData = explode(";", date("i;G;j;n;Y", $systemQueueTime));
				$dateToRun = mktime($timeData[1], $timeData[0], 0, $timeData[3], $timeData[2], $timeData[4]);

				$ProcessInvoicesXML =
					"<mbapi>
					<command>ProcessInvoices</command>
					<showXMLHeader>0</showXMLHeader>
					<params>
						<manualRun>1</manualRun>
						$wmXML
						$vendorXML
						<numInvoicesToGenerate>$numInvoicesPerEvent</numInvoicesToGenerate>
						<setBillingMode>anniversary</setBillingMode>
						<setSendInvoiceEmails>".(int)$_REQUEST["sendInvoiceEmail"]."</setSendInvoiceEmails>
						<packageDateNextRenewalLessThan>$packageDateNextRenewalLessThan</packageDateNextRenewalLessThan>
						<domainDateNextRenewalLessThan>$domainDateNextRenewalLessThan</domainDateNextRenewalLessThan>
						<getActiveClients>".(int) $_REQUEST["getActiveClients"]."</getActiveClients>
						<getSuspendedClients>".(int) $_REQUEST["getSuspendedClients"]."</getSuspendedClients>
						<getActivePackages>".(int) $_REQUEST["getActivePackages"]."</getActivePackages>
						<getSuspendedPackages>".(int) $_REQUEST["getSuspendedPackages"]."</getSuspendedPackages>
						<overrideDateDue>".$overrideDateDue."</overrideDateDue>
						".(((int)$_REQUEST["clientID"])?"<clientIDs><clientID>".(int)$_REQUEST["clientID"]."</clientID></clientIDs>":"")."
					</params>
					</mbapi>";

				$cmdArgs = array
				(
					"systemQueueCommand" => "ProcessInvoices",
					"systemQueueCommandInput" => htmlentities($ProcessInvoicesXML),
					"systemQueueMinute" => $timeData[0],
					"systemQueueHour" => $timeData[1],
					"systemQueueDay" => $timeData[2],
					"systemQueueMonth" => $timeData[3],
					"systemQueueYear" => $timeData[4],
					"systemQueueIsRecurring" => 0,
					"systemQueueDateCreated" => time(),
					"systemQueueDateToRun" => $dateToRun,
					"systemQueueDateStarted" => 0,
					"systemQueueDateFinished" => 0,
					"vendorID" => $vendorId
				);
				$query = $this->getMBAPIQuery("SetSystemQueue", "insert", $cmdArgs);
				$data = dispatchMBAPI($query, 1);

			$systemQueueID = (int)$data["mbapi"][0]["header"][0]["lastInsertID"][0];

			//}

			$this->smartyVars["numInovicesToBeGenerated"] = $numInvoicesGenerated;
			$this->smartyVars["systemQueueID"] = $systemQueueID;

			$successMessage = blmsg("TRANS_GENERATE_INVOICE_SUCCESS_MSG");
		}
		if (1 != (int)$_REQUEST["previewMode"] && isset($successMessage)) {
		    billing_put_info($successMessage);
		}

        $this->addTemplate("invoices/ShowGenerateInvoiceEvents");

		return $this->hasExecutedSuccessfully();
	}
}
