<?php
require_once ("lib-action/action.php");

class ProcessManualPayment extends MB_Action
{
	public function execute()
    {
		parent::execute();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if ($_REQUEST["subaction"]=="applypayment"){
			$subaction = $_REQUEST["paymentMethod"];
			$paymentMethod = $_REQUEST["paymentMethod"];
		} else {
			$subaction = getAPITypeID("payments", "credit");
			$paymentMethod = getAPITypeID("payments", "credit");
		}
		$applyPaymentTo = secureInput($_REQUEST["applyPaymentTo"]);
		$billingAccountID = (int)$_REQUEST["billingAccountID"];
		$lineItemPayments = $this->getLineItemsPayments($_REQUEST["lineItemPayments"]);
		$paymentAmount = BillingLocale::getNumberFromInput($_REQUEST["paymentAmount"]);
		$paymentComments = secureInput($_REQUEST["paymentComments"]);
		$transactionCode = secureInput($_REQUEST["transactionCode"]);

		$_REQUEST["transactionDateCreated"] = getMBDateFromRequest("transactionDateCreated");

		$paymentCmd = array(
			"mbapi" => array(
				"command" => "ProcessManualPayment",
				"params" => array(
					"paymentMode" => 0,
					"payments" => array(
						"payment" => array(
							"subaction" => $subaction,
							"paymentMethod" => $paymentMethod,
							"invoiceID" => $invoiceID,
							"billingAccountID" => $billingAccountID,
							"paymentAmount" => ($applyPaymentTo=="invoice") ? $paymentAmount : $lineItemPayments,
							"paymentComments" => $paymentComments,
							"transactionCode" => $transactionCode,
							"transactionDateCreated" => $_REQUEST["transactionDateCreated"],
							"sendPaymentEmail" => (int)$_REQUEST["sendPaymentEmail"],
						),
					),
				),
			),
		);

		if ($applyPaymentTo!="invoice"){
			$lineItemPaymentsArray = array();
			foreach ((array)$_REQUEST["lineItemPayments"] as $liID=>$amount){
				$lineItemPaymentsArray[] = array(
					"lineItemID" => $liID,
					"paymentAmount" => BillingLocale::getNumberFromInput($amount),
				);
			}
			$paymentCmd["mbapi"]["params"]["payments"]["payment"]["lineItems"] = array(
				"lineItem" => $lineItemPaymentsArray,
			);
		}
		
		dbg(dispatchMBAPI($paymentCmd, 1));

        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
        } else {
            redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$invoiceID."&sid=".secureInput($_REQUEST["sid"]));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

    private function getLineItemsPayments($lineItemInfo)
    {
        $result = array();
        foreach ($lineItemInfo as $k=>$v){
            $result[$k] = BillingLocale::getNumberFromInput($v);
        }
        return $result;
    }
}