<?php
require_once ("lib-action/action.php");

class RemoveInvoiceTransaction extends MB_Action
{
    public $params = array("transactionID");

	public function execute()
    {
		parent::execute();
        
		$transactionID = ((int) $_REQUEST["transactionID"]);
		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID || !$transactionID) {
			$this->addError('TRANS_ACTIONERROR', "Invalid invoice or transaction specified.");
		} else {
			
			$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => $invoiceID,
						"getInvoiceLineItemsData" => 1,
					),
				),
			)));
			
			$this->smartyVars["transactionInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetTransactions",
					"params" => array(
						"transactionIDs" => array(
							"transactionID" => $transactionID,
						),
					),
				),
			)));
			
			$this->smartyVars["genericType"] = "remove";
			$this->smartyVars["parentName"] = "TRANS_FINANCES";
			$this->smartyVars["childName"] = "TRANS_MANAGE_INVOICES";
			$this->smartyVars["grandchildName"] = "TRANS_REMOVE_TRANSACTION";
			$this->smartyVars["sideNavMajor"] = "finances";
			$this->smartyVars["sideNavMinor"] = "invoices";
			$this->smartyVars["headerMessage"] = "TRANS_CONFIRM_TRANSACTION_REMOVE";

			$this->smartyVars["inForm"] = "no";
			$this->smartyVars["removeResponseAction"] = "RemoveInvoiceTransactionResponse";
			$this->smartyVars["hiddenFields"] = array(
				"invoiceID" => $invoiceID,
				"transactionID" => $transactionID,
			);

			/** AUTO GENERATE FORM DATA BEGIN **/
			$this->smartyVars["editForm"] = new MBAutoFormFields();
			$this->smartyVars["editForm"]->addFields(array(
				/*"invoiceNumber" => array("text", "TRANS_INVOICE_NUMBER"),*/
				"transactionID" => array("text", "TRANS_TRANSACTION_ID"),
				"transactionCode" => array("text", "TRANS_TRANSACTION_CODE"),
				"transactionAmount" => array("text", "TRANS_AMOUNT"),
			));
	
			$this->smartyVars["editForm"]->addFieldValue("invoiceNumber", $this->smartyVars["invoiceInfo"]["invoiceNumber"]);
			$this->smartyVars["editForm"]->addFieldValue("transactionID", $transactionID);
			$this->smartyVars["editForm"]->addFieldValue("transactionCode", $this->smartyVars["transactionInfo"]["transactionCode"]);
			$this->smartyVars["editForm"]->addFieldValue("transactionAmount", $this->smartyVars["transactionInfo"]["transactionAmount"]);
			
			$this->smartyVars["editForm"]->setFieldData("invoiceNumber", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionID", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionCode", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionAmount", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionAmount", "currencyID", $this->smartyVars["transactionInfo"]["currencyID"]);
			
			$this->smartyVars["editForm"] = $this->smartyVars["editForm"]->getData();
			$this->smartyVars["editFields"] =& $this->smartyVars["editForm"]["fields"];
			
			$this->addTemplate("widgets/genericTemplate", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}