<?php
use Billing\Object\Subscription;

require_once("lib-action/action.php");

class ShowGenerateInvoiceMenu extends MB_Action
{
	public function __construct()
    {
		if ( !is_null($client = $this->_getClient(true)) ) {
			$_REQUEST["clientID"] = $client->id;
		}
		parent::__construct();
	}

	public function execute()
	{
		parent::execute();

    	$this->smartyVars["clientInfo"] = grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetClients",
				"params" => array(
					"clientID" => (int)$_REQUEST["clientID"],
					"mergePrimaryContact" => 1,
				),
			),
		));

		$this->smartyVars["packages"] = array();
		if ($this->smartyVars["clientInfo"]["clientID"]){

			$rawPackages = grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => (int)$_REQUEST["clientID"],
						'suppressFeePackages' => 1
						)
					)
				)
			);
			$sel = array();
			$nonsel = array();
			foreach ($rawPackages as $pkg){
				switch ($pkg["packageStatus"]){
					case Subscription::STATUS_ACTIVE:
					case Subscription::STATUS_PENDING:
					case Subscription::STATUS_PROCESSING:
					case Subscription::STATUS_SUSPENDED:
					case Subscription::STATUS_FAILED:
                    case Subscription::STATUS_PENDINGRENEWAL:
                    case Subscription::STATUS_PENDINGUPGRADE:
                    case Subscription::STATUS_GRACED:
						$sel[] = $pkg;
						break;
					default:
						$nonsel[] = $pkg;
						break;
				}
			}
            $this->smartyVars["doubleListSelectorOptions"] = array();
            foreach(grabHTMLOpsFromArray($sel, 'packageID', 'makePackageNameIDAndStatus') as $id => $name) {
                $this->smartyVars["doubleListSelectorOptions"][$id] = array(
                    'id' => $id,
                    'title' => $name,
                    'selected' => true
                );
            }
            foreach(grabHTMLOpsFromArray($nonsel, 'packageID', 'makePackageNameIDAndStatus') as $id => $name) {
                $this->smartyVars["doubleListSelectorOptions"][$id] = array(
                    'id' => $id,
                    'title' => $name,
                );
            }
            $this->smartyVars["doubleListSelectorAttribs"] = array('id' => 'subscriptions');
            $GLOBALS["tpl"]->assign_by_ref("doubleListSelector", new Billing_Zend_View_Helper_DoubleListSelector());
        }

		$this->smartyVars["suspended"] = (\Billing\Object\Customer::STATUS_SUSPENDED == $this->smartyVars["clientInfo"]["clientStatus"])?1:0;

        $this->addTemplate("invoices/ShowGenerateInvoiceMenu", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
}

function makePackageNameIDAndStatus($row)
{
	$ret = '('.$row["packageID"].', '.getStatusName('package', $row["packageStatus"]).') '.$row["packageName"];
	return $ret;
}
