<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once(dirname(__FILE__)."/../../../../lib-action/action.php");

class ShowInvoices extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$page  = UIFactory()->Page();

		if (1 == Settings()->invoiceFactura_enableGeneration) {
			require_once("UI/Tabs/UIInvoicesTabs.php");
			$invoicesTabs = new UIInvoicesTabs();
			$invoicesTabs->setCurrent("invoices");
			$page->setScreenTabs($invoicesTabs);
		}

		if (bgpc('search')) {
			$page->title = blmsg("TRANS_SHOW_INVOICES_SEARCH", array('SEARCH' => billing_safetyhtml(bgpc('search'))));
		} else {
			$page->title = blmsg("TRANS_SHOW_INVOICES");
		}

		$client = $this->_getClient(true);

		if ($client) {
			$page->parent_title = billing_safetyhtml($client->PrimaryContact->contact_fullname);
			$page->parent_url = action_url("clients", "ShowClientDetails", array("clientID"	=> $client->id));
			$client_id = $client->id;
		} else {
			$page->parent_title = blmsg("TRANS_FINANCES");
			$client_id = null;
		}

		require_once("UI/List/UIAdminInvoiceList.php");
		$page->addListPanel(new UIAdminInvoiceList( $client_id ));

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}
