<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/crypt/crypt.php");

class ForgottenPasswordResponse extends MB_Action
{
	public $params = array("adminEmail", "adminRemoteAccessHash");

	public function execute()
	{
		parent::execute();

		$this->setReferralActionID( getActionID("ShowForgottenPassword") );
        $this->setReferralActionFile( "login.php" );
        $success = \Billing\Checker::emailAddress($_REQUEST["adminEmail"]);

		if ($success) {
			$query = $this->getMBAPIQuery("ProcessAdminForgottenPassword");
			$data = dispatchMBAPI( $query, 1 );

			if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$results = grabSimpleMBAPIResults($data);
				if (isset($results["adminIDs"]) && isset($results["adminIDs"]["adminID"])) {
					redirect("login.php", "ShowForgottenPassword", array("info_msg" => "TRANS_PASSWORD_RESET"));
				} else {
					redirect("login.php", "ShowForgottenPassword", array("msg"=>"TRANS_EMAIL_NOT_FOUND"));
				}
			}
		} else {
            redirect("login.php", "ShowForgottenPassword", array("msg"=>"TRANS_INCORRECT_EMAIL"));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
