<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class LoginResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		$adminRemoteAccessHash = $CONF["user"]["remoteAccessHash"];
		$internalAdmin = isset($CONF["user"]["internalAdmin"]) ? $CONF["user"]["internalAdmin"] : null;

		if (isset($CONF["user"]["remoteSessionID"]) && $CONF["user"]["remoteSessionID"]) {
			list($isSessionActive, $logoutReason) = setSession($CONF["user"]["remoteSessionID"]);
			if($isSessionActive) {
				$this->hasExecutedSuccessfully = 1;
				$CONF["user"]["sessionID"] = $_REQUEST["sid"] = $CONF["user"]["remoteSessionID"];
				return $this->hasExecutedSuccessfully();
			}
		}

		$query = $this->getMBAPIQuery("ProcessAdminLogin", "", array(
			"adminIP" => $CONF["user"]["ip"],
			"adminRemoteAccessHash" => $adminRemoteAccessHash,
			"internalAdmin" => $internalAdmin,
			"adminUsername" => bgpc("user_name"),
			"adminPassword" => bgpc("user_password"),
		));
		$data = dispatchMBAPI($query, 1);

		$errorCount = isset($data["mbapi"][0]["header"][0]["errorCount"][0]) ? $data["mbapi"][0]["header"][0]["errorCount"][0] : 0;
		if (0 === $this->addMBAPIErrors($data) && ! $this->getNumErrors())
		{
			$admin_id = is_array($data["mbapi"][0]["results"][0]["adminID"]) ? $data["mbapi"][0]["results"][0]["adminID"][0] : "";
			if ("" != $admin_id && Factory()->Admin($admin_id)->isActive()) {
                $session = Factory()->Session($data["mbapi"][0]["results"][0]["sessionID"][0]);
                setSidByCookie($session->id);

				// Allow expired users to resume a new session from where their last one left off
				if (isset($_REQUEST["redirectActionID"]) && $_REQUEST["redirectActionID"] && isset($_REQUEST["redirectActionFile"]) && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
                    redirect($_REQUEST["redirectActionFile"]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
				} else {
					//If it's a remote API call, let it bubble back instead of redirect
					if ($adminRemoteAccessHash || $internalAdmin){
						$_REQUEST["adminID"] = $admin_id;
						$CONF["user"]["type"] = 2;
						$CONF["user"]["sessionID"] = $session->id;
						$this->hasExecutedSuccessfully = 1;
						return $this->hasExecutedSuccessfully();
					} else {
						// a change in login process
						redirect("dashboard.php", getActionID("ShowDashboard"));
					}
				}
			} else {
				if ($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					redirect("login.php",getActionID("ShowLogin"), array(
						"msg" => "TRANS_AUTH_FAILED",
						"redirectActionID" => $_REQUEST['redirectActionID'],
						"redirectActionFile" => $_REQUEST['redirectActionFile'],
						"redirectArgs" => $_REQUEST['redirectArgs'],
					));
				} else {
					redirect("login.php",getActionID("ShowLogin"), array("msg" => "TRANS_AUTH_FAILED"));
				}
			}
		} else {
			$msg = "";
			$separator = "";
			foreach ($data["mbapi"][0]["header"][0]["errors"][0]["error"] as $error) {
				$msg .= $separator.blmsg($error["title"][0]);
				$separator = "\n";
			}
			$params = array("msg" => $msg);
			redirect("login.php",getActionID("ShowLogin"), $params);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
