<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class EditEmailConfigResponse extends MB_Action
{
	public $params = array(
		"emailMethod",
		"emailSendmailLocation",
		"emailSMTPServer",
		"emailSMTPAuth",
		"emailSMTPUsername",
		"emailSMTPPassword",
	);

	public function execute()
	{
		parent::execute();

		$configGroupID = (int) $_REQUEST["configGroupID"];

		if(!$configGroupID) {
			$this->addError('TRANS_ACTIONERROR', "No ID given for EditEmailConfig.");
		} else {
			$skipAuthInfo = false;
			if ((int)$_REQUEST["emailSMTPAuth"] != 1) {
				$skipAuthInfo = true;
			}

			switch( $_REQUEST["emailMethod"] ) {
			case "smtp":
				if ($skipAuthInfo) {
					$elements2Test = array(
							"emailMethod" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPServer" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPAuth" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED);
				} else {
					$elements2Test = array(
							"emailMethod" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPServer" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPAuth" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPUsername" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"emailSMTPPassword" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED);
				}
			break;

			case "sendmail":
				if (!is_file( $_REQUEST["emailSendmailLocation"] )) {
					$this->addError('TRANS_ACTIONERROR', "Sendmail file cannot be found." );
					$this->addErrorTemplates();
					return $this->hasExecutedSuccessfully();
				}

				$_REQUEST["emailSMTPAuth"] = 0;

				$elements2Test = array(
					"emailMethod" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"emailSendmailLocation" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED);
			break;
			}

			$this->setReferralActionID( getActionID("EditEmailConfig") );
			$this->setReferralActionFile( "modules.php" );

			$success = $this->validateMultiInputs( $elements2Test, array(), array(), 0, array("configGroupID" => $configGroupID) );

			if ($success) {
				$configParams = array();
				$configParams["configGroupID"] = $configGroupID;

				$configParams["configParams"] = array();
				$configParams["configParams"]["configParam"] = array();
				foreach($this->params as $v) {

					if ($skipAuthInfo == true)
					switch( $v ) {
					case "emailSMTPUsername":
					case "emailSMTPPassword":
						$_REQUEST[ $v ] = null;
					break;
					}

					$configParamID = getConfigParamID($configGroupID, $v);

					$configParams["configParams"]["configParam"][] = array(
								"configParamID" => $configParamID,
								"configParamName" => $v,
								"configParamValue" => $_REQUEST[ $v ]);
				}
				$setConfig = new MBQuery("SetConfigs", "update", $configParams);
				$data = $setConfig->getResult();
				$data = $data->getStructure();
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
                        billing_put_info(blmsg("TRANS_SETTINGS_SAVED_SUCCESSFULLY"));
                        redirect(admin_action_url("configs", "system", "show"));
					}
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
