<?php

require_once("lib-action/action.php");

class EditSSLFactoryConfigResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect("modules.php", getActionID("EditSSLFactoryConfig"));
		}

		$configParams = Factory()->ConfigGroup(0)->getChild("ssl")->getChild("sslfactory")->ConfigParams;
		foreach (array("enableSSLFactory", "usernameSSLFactory", "accessCodeSSLFactory") as $name) {
			$configParams[$name]->value = bgpc($name);
		}
		$configParams->update();

        billing_put_info(blmsg("TRANS_SETTINGS_SAVED_SUCCESSFULLY"));
        redirect(admin_action_url("configs", "system", "show"));
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}