<?php

require_once("lib-action/action.php");

class AddGenericAttributeResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect('orderforms.php', getActionID('AddGenericAttribute'));
		}

		$questionParams = array(
			"questionDisplayName" => $_REQUEST["questionName"],
		);

		$questionResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetQuestions",
				"subCommand" => "insert",
				"params" => $questionParams,
			),
		)), 1);

		$questionID = $questionResult["mbapi"][0]["header"][0]["lastInsertID"][0];

		$this->_setQuestionParam($questionID, "setQuestion", $_REQUEST["question"]);
		$this->_setQuestionParam($questionID, "setType", "QUESTION_INPUT_TEXT");
		$this->_setQuestionParam($questionID, "setDescription", $_REQUEST["questionDescription"]);
		$this->_setQuestionParam($questionID, "addAnswer", $_REQUEST["questionDefaultValue"]);
		//$this->_setQuestionParam($questionID, "addAnswer", $_REQUEST["questionDefaultValue"]);
		//$this->_setQuestionParam($questionID, "addAnswer", $_REQUEST["questionDefaultValue"]);


		$attributeParams = array(
			"attributeName" => $_REQUEST["attributeName"],
			"attributeType" => 0,
			"attributeSubtype" => 0,
			"questionID" => $questionID,
		);

		dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetAttributes",
				"subCommand" => "insert",
				"params" => $attributeParams,
			),
		)));

		billing_put_info(blmsg("TRANS_ADD_GENERIC_ATTRIBUTE_SUCCESS_MSG", array("NAME" => bgpc("attributeName"))));
		redirect("orderforms.php?sid=".$_REQUEST["sid"]."&action=".getActionID("ShowAttributes"));

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function _setQuestionParam($questionID, $name, $value)
	{
		$questionParamParams = array(
			"questionID" => $questionID,
			"questionParamName" => $name,
			"questionParamOrder" => (int)$this->orderInc++,
		);

		$questionParamResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetQuestionParams",
				"subCommand" => "insert",
				"params" => $questionParamParams,
			),
		)), 1);

		$questionParamID = $questionParamResult["mbapi"][0]["header"][0]["lastInsertID"][0];

		$questionParamValueParams = array(
			"questionParamID" => $questionParamID,
			"questionParamValueText" => $value,
		);

		$questionParamValueResult = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetQuestionParamValues",
				"subCommand" => "insert",
				"params" => $questionParamValueParams,
			),
		)), 1);

	}
}
