<?php

require_once("lib-action/action.php");

class EditOrderFormTheme extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$orderFormID = bgpc("orderFormID");
		if ( is_null($orderFormID) ) {
			throw new Exception("Missing parameter 'orderFormID'");
		}

		$orderForm = Factory()->Store($orderFormID);
		$this->smartyVars["orderForm"] = array();
		$this->smartyVars["orderForm"]["orderFormID"] = $orderFormID;
		$this->smartyVars["orderForm"]["orderFormName"] = $orderForm->order_form_name;
		$this->smartyVars["orderForm"]["theme"] = $orderForm->OrderFormParams["theme"]->order_form_param_value;

		$this->smartyVars["themes"] = Service()->StoreManager->getAvailableThemes($orderForm->vendor_id);

		$this->smartyVars["pageTitle"] = blmsg("TRANS_ONLINE_STORE_THEME_FOR_STORENAME", array("STORE_NAME" => $orderForm->order_form_name));

		$this->smartyVars["storeURL"] = admin_action_url("orderforms", "store-overview", "index", array("id" => $orderFormID));
		$this->smartyVars["previewURL"] = Service()->CompanyManager->getCompanyByVendorId($orderForm->vendor_id)->company_order_url."preview/{$orderForm->order_form_code}/@THEME_CODE@.html";

		$this->addTemplate("orderforms/EditOrderFormTheme");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}