<?php
require_once("lib-action/action.php");

class EditOrderFormThemeResponse extends MB_Action
{
	function execute()
	{
		parent::execute();

		$orderFormID = bgpc("orderFormID");
		if(is_null($orderFormID)) {
			throw new Exception("Missing parameter 'orderFormID'");
		}

		if(is_null($theme = bgpc("theme"))) {
			throw new Exception("Missing parameter 'theme'");
		}

		$orderForm = Factory()->Store($orderFormID);
		$orderForm->OrderFormParams["theme"]->order_form_param_value = $theme;
		$orderForm->OrderFormParams->update();

		billing_put_info(blmsg("TRANS_CHANGE_ONLINE_STORE_THEME", array("NAME" => billing_safetyhtml($orderForm->order_form_name))));
		redirect("orderforms.php", "EditOrderFormTheme", array("orderFormID" => $orderFormID));

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}