<?php
require_once("lib-action/action.php");

class RemoveOrderFormResponse extends MB_Action
{
	public $params = array("orderFormID");

	public function execute()
	{
		parent::execute();

		$orderFormID = ((int) $_REQUEST["orderFormID"]);
		if(!$orderFormID) {
			$this->addError('TRANS_ACTIONERROR', "No OrderForm ID given.");
		} else {
			if (!getCurrentSession()->isValidToken()) {
				billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
				redirect('orderforms.php', getActionID("RemoveOrderForm"), array("orderFormID" => $orderFormID));
			}
			$orderFormName = Factory()->Store($orderFormID)->order_form_name;
			$query = $this->getMBAPIQuery("SetOrderForms", "delete", array());
			require_once("lib-mbapi/mbapi.php");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				billing_put_info(blmsg("TRANS_REMOVE_ONLINE_STORE", array("NAME" => billing_safetyhtml($orderFormName))));
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("orderforms.php", getActionID("ShowOrderForms"));
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}