<?php
require_once("lib-action/action.php");

use Billing\Object\Ban;

class ShowBans extends MB_Action
{
	public function execute()
	{
		parent::execute();

        $banType = bgpc('banType', -1);
        $pageTitle = false;

        switch ($banType) {
            case Ban::TYPE_EMAIL:
                $pageTitle = blmsg("TRANS_SHOW_BANS_EMAILS");
                break;
            case Ban::TYPE_IP:
                $pageTitle = blmsg("TRANS_SHOW_BANS_IPS");
                break;
            case Ban::TYPE_COUNTRY:
                $pageTitle = blmsg("TRANS_SHOW_BANS_COUNTRIES");
                break;
            default:
                $this->addError(blmsg("TRANS_ACTIONERROR"), "Wrong ban type is given.");
                $this->addErrorTemplates();
                return $this->hasExecutedSuccessfully();
        }

		$page  = UIFactory()->Page();
		$page->title = $pageTitle;
		require_once("UI/List/UIBanList.php");
		$page->addListPanel(new UIBanList($banType));

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}
