<?php

class Orderforms_BanController extends Billing_Zend_Controller_Action_AdminController
{
    public function init()
	{
		parent::init();

        $this->_banType = $this->getRequest()->getParam('banType');
		$this->_backUrl = $this->view->ActionUrl('orderforms', 'ShowBans', array('banType' => $this->_banType));
	}

    public function addAction()
    {
        $ban = Factory()->Ban();
        $ban->ban_type = $this->_banType;

        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_ADD_BAN'));
        $addForm = new Billing_Zend_Form_Final_BanForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'ban' => $ban
        )));

        if ($this->_request->isPost() && $addForm->isValid($this->_request->getPost())) {
           try {
               $addForm->processForm();
               $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_ADD_BAN_SUCCESS_MSG"), "info");
           } catch (ProductException $e) {
               $this->_status->addError($e->getMessage());
           }
        }
        $this->view->form = $addForm;
    }

    public function editAction()
    {
        $banId = $this->_request->getParam('banID');
        $ban = Factory()->Ban($banId);

        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_EDIT_BAN'));
        $editForm = new Billing_Zend_Form_Final_BanForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'ban' => $ban
        )));

        if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost())) {
           try {
               $editForm->processForm();
               $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_EDIT_BAN_SUCCESS_MSG"), "info");
           } catch (ProductException $e) {
               $this->_status->addError($e->getMessage());
           }
        }
        $this->view->form = $editForm;
    }

    public function removeAction()
    {
        $banId = $this->getRequest()->getParam('banID');
        $ban = Factory()->Ban($banId);

        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_REMOVE_BAN'));
        $removeForm = new Billing_Zend_Form_Final_RemoveBanForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'ban' => $ban,
        )));

        if ($this->_request->isPost() && $removeForm->isValid($this->_request->getPost())) {
           try {
               $removeForm->processForm();
               $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_REMOVE_BAN_SUCCESS_MSG"), "info");
           } catch (ProductException $e) {
               $this->_status->addError($e->getMessage());
           }
        }
        $this->view->form = $removeForm;
    }

    public function activateAction()
    {
        $ids = $this->getRequest()->getParam('id');

        try {
            foreach ($ids as $banId) {
                Service()->BanManager->activate(Factory()->Ban($banId));
            }
            $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_BAN_ACTIVATE_SUCCESS_MSG"), "info");
        } catch (ProductException $e) {
           $this->_status->addError($e->getMessage());
       }
    }

    public function disableAction()
    {
        $ids = $this->getRequest()->getParam('id');

        try {
            foreach ($ids as $banId) {
                Service()->BanManager->disable(Factory()->Ban($banId));
            }
            $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_BAN_DISABLE_SUCCESS_MSG"), "info");
        } catch (ProductException $e) {
           $this->_status->addError($e->getMessage());
       }
    }

    private $_banType = null;
    private $_backUrl = null;
}