<?php
require_once ("lib-action/action.php");

class AddPackageAttribute extends MB_Action
{

	public function execute()
    {
		parent::execute();
		
		$attributes = arrayFor("packageAttributes", array("packageID" => (int)$_REQUEST["packageID"]));
		$serverGroups = array();
		foreach ((array)$attributes as $attribute){
			if (!isset($serverGroups[$attribute["serverGroupID"]])){
				$serverGroups[$attribute["serverGroupID"]] = 1;
			}
		}
		if (array_sum(array_keys($serverGroups))){
			$serverGroups = grabHtmlOpsFromArray(
				grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetServerGroups",
						"array" => array(
							"serverGroupID" => array_keys($serverGroups),
						),
					),
				)),
				"serverGroupID", "serverGroupName"
			);
		} else {
			$serverGroups = array();
		}
		
		$this->smartyVars["parentName"] = "TRANS_PACKAGES";
		$this->smartyVars["childName"] = "TRANS_MANAGE_PACKAGES";
		$this->smartyVars["sideNavMajor"] = "clients";
		$this->smartyVars["sideNavMinor"] = "packages";
		$this->smartyVars["grandchildrenLabels"] = array(
			"edit" => "TRANS_EDIT_ATTRIBUTE",
			"show" => "TRANS_SHOW_ATTRIBUTES",
			"add" => "TRANS_ADD_ATTRIBUTE",
			"showdetails" => "TRANS_ATTRIBUTE_DETAILS",
			"remove" => "TRANS_REMOVE_ATTRIBUTE",
		);
		$this->smartyVars["inForm"] = "no";
		$this->smartyVars["genericType"] = "add";
		$this->smartyVars["grandchildName"] = "TRANS_ADD_ATTRIBUTE";
		$this->smartyVars["addResponseAction"] = "AddPackageAttributeResponse";
		$packageInfo = optionsFor("packages", array("packageID" => (int)$_REQUEST["packageID"]));
		$packageInfo[(int)$_REQUEST["packageID"]] = "(".blmsg('TRANS_ID').": ".(int)$_REQUEST["packageID"].") ".$packageInfo[(int)$_REQUEST["packageID"]];
		$this->smartyVars["editFields"] = array(
			"packageID" => array(
				"fieldType" => "select",
				"showOnly" => "1",
				"fieldTitle" => "TRANS_PACKAGE",
				"fieldValue" => array(
					"selected" => (int)$_REQUEST["packageID"],
					"selectable" => $packageInfo,
				),
			),
			"serverGroupID" => array(
				"fieldType" => "select",
				"showOnly" => "0",
				"allowBlankChoice" => "1",
				"fieldTitle" => "TRANS_SERVER_GROUP",
				"fieldValue" => array(
					"selected" => "",
					"selectable" => $serverGroups,
				),
			),
            "configGroupID" => array(
                "fieldType" => "text",
                "showOnly" => "0",
                "fieldTitle" => "TRANS_SERVER_ID",
                "fieldValue" => ""
            ),
			"packageAttributeName" => array(
				"fieldType" => "text",
				"showOnly" => "0",
				"fieldTitle" => "TRANS_ATTRIBUTE_NAME",
				"fieldValue" => ""
			),
			"packageAttributeValue" => array(
				"fieldType" => "text",
				"showOnly" => "0",
				"fieldTitle" => "TRANS_ATTRIBUTE_VALUE",
				"fieldValue" => ""
			),
		);
		
		$this->smartyVars["hiddenFields"] = array(
			"packageAttributeDateCreated" => time(),
			"packageID" => (int)$_REQUEST["packageID"],
		);
		
		$this->addTemplate("widgets/genericTemplate");
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}