<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/cycles.php");

class ShowPackageAddons extends ShowAction
{
	public function __construct()
	{
		$_REQUEST["packageID"] = $this->_getPackage()->id;

		$this->setDataSource(new DataSource("packageAddons"));
		parent::ShowAction();
		$this->stringRep = "ShowPackageAddons";
		// define all possible params that we will accept
		$this->params = array("packageID");
	}

	public function showHandler()
	{
		$this->smartyVars["types"] = getTypes("products");

		$this->smartyVars["packageInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));

		$taxZoneGroupData = grabHTMLOpsFromArray(
						grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZoneGroups</command></mbapi>", 1)),
						"taxZoneGroupID",
						"taxZoneGroupName");

		foreach ((array)$this->smartyVars["packageAddons"] as $k=>$addon){
			$this->smartyVars["packageAddons"][$k]["taxZoneGroupName"] = $taxZoneGroupData[$addon["taxZoneGroupID"]];
            $this->smartyVars["packageAddons"][$k]["cycleID"] = getCycleName($addon["cycleID"]);
		}

		$this->d->description["columns"]["taxZoneGroupName"] = COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_DISPLAYABLE;
		$this->d->description["columnLabels"]["taxZoneGroupName"] = "TRANS_TAX_ZONE_GROUP";

        if (!Service()->PackageAddonManager->selWithParentCycles()) {
            $this->d->description["columns"]["cycleID"] |= COLUMN_LISTABLE;
            $this->d->description["columns"]["packageAddonDateLastRenewal"] |= COLUMN_LISTABLE;
            $this->d->description["columns"]["packageAddonDateNextRenewal"] |= COLUMN_LISTABLE;
        }

		$this->smartyVars["manualRowActions"][] = array(
			"action" => "ShowPackageAddonAttributes",
			"args" => array(
				"packageAddonID",
			),
			"icon" => "show-all-subscription-addons.png",
		);
		$subscription = Factory()->Subscription(bgpc("packageID"));
		$this->smartyVars["packageInfo"]["canTransfer"] = $subscription->canTransfer();
		$this->smartyVars["packageInfo"]["canUpgrade"] = $subscription->canUpgrade();
		$this->smartyVars["packageInfo"]["canDowngrade"] = $subscription->canDowngrade();

	}
}
