<?php

class Packages_PricesController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
	}

	public function editAction()
	{
		$subscriptionId = $this->_request->getParam('id');
		$backUrl = $this->view->ActionUrl('packages', 'ShowPackageDetails', array("packageID" => $subscriptionId));

		$subscription = Factory()->Subscription($subscriptionId);
		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_SUBSCRIPTION_PRICES'));
		$editForm = new Billing_Zend_Form_Final_EditSubscriptionPricesForm(array('context' => array(
			'cancelLink' => $backUrl,
			'subscription' =>  $subscription
		)));
		if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost()))
		{
			try {
				$editForm->processForm();
				$this->_redirect($backUrl);
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $editForm;
	}
}