<?php

class Packages_StatusController extends Billing_Zend_Controller_Action_AdminController
{
    public function init()
    {
        parent::init();
    }

    public function editAction()
    {
        $subscriptionId = $this->_request->getParam('id');
        $backUrl = $this->view->ActionUrl('packages', 'ShowPackageDetails', array("packageID" => $subscriptionId));

        $subscription = Factory()->Subscription($subscriptionId);
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PACKAGESTATUS'));
        
        $panelDetails = array();
        if ($subscription->isHostingType() || $subscription->isResellerType()) {
            $controlPanels = $subscription->ControlPanelList();
            if (count($controlPanels)) {
                foreach($controlPanels as $controlPanel) {
                    $subscriptionProperties = reset($subscription->SubscriptionPropertiesList(array('config_group_id' => $controlPanel->id)));
                    $panelStatus = $subscriptionProperties['panel_status']->value;
                    $panelStatus = isset($panelStatus) ? $panelStatus : 'none';
                    $statusID = getAPIStatusID("package", $panelStatus);
                    $statusName = getStatusName("package", $statusID);
                    $panelDetails[] = array(
                        'servername' => $controlPanel->name,
                        'configGroupID' => $controlPanel->id,
                        'panel' => $controlPanel->PanelGroup->server_group_name,
                        'statusID' => $statusID,
                        'status' => $statusName,
                    );
                }
            }
        }
        
        $editForm = new Billing_Zend_Form_Final_EditSubscriptionStatusForm(array('context' => array(
            'cancelLink' => $backUrl,
            'subscription' =>  $subscription,
            'panelDetails' => $panelDetails
        )));
        $this->_status->addWarning(blmsg('TRANS_SUBSCRIPTION_EDIT_STATUS_WARNING'));
        if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost())) {
            try {
                $editForm->processForm($this->_request->getPost());
                $this->_redirectWithMessage($backUrl, $this->_translator->translate('TRANS_SUBSCRIPTION_STATUS_WAS_SAVED_MSG'));
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
        $this->view->form = $editForm;
    }
}