<?php

class Packages_SupplementaryController extends Billing_Zend_Controller_Action_AdminController
{
	public function editPropertiesAction()
	{
		$subscriptionId = $this->_request->getParam('id');
		$backUrl = $this->view->ActionUrl('packages', 'ShowPackageDetails', array("packageID" => $subscriptionId));

		$subscription = Factory()->Subscription($subscriptionId);
        $supplementarySubscriptions = Factory()->SupplementarySubscriptions($subscription->parent_package_id);
		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_SUBSCRIPTION_EDIT_SUPPLEMENTARY_PROPERTIES_TITLE'));
		$editForm = new Billing_Zend_Form_Final_Subscription_EditSupplementaryProperties(array('context' => array(
			'cancelLink' => $backUrl,
			'properties' =>  $supplementarySubscriptions[$subscription->id],
		)));
		if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost())) {
			try {
				$editForm->processForm();
				$this->_redirect($backUrl);
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $editForm;
	}
}