<?php
require_once("lib-action/action.php");
require_once("lib-mbapi/include/modules/gateway/gateway.php");

use Billing\Manager\PaymentGatewayManager;
use Billing\Object\PaymentGateway;
use Billing\Object\Store;

class ShowVirtualTerminals extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$gatewayFilter = array("payment_gateway_type" => array(PaymentGateway::TYPE_PRIMARY));
		if (!is_null($invoiceID = bgpc("invoiceID"))) {
			$gatewayFilter["payment_gateway_type"][] = PaymentGateway::TYPE_HSPC_CREDIT_CARD;
		} else if (!is_null($paymentGatewayID = bgpc("paymentGatewayID"))) {
			$gatewayFilter["payment_gateway_id"] = $paymentGatewayID;
            $this->smartyVars["paymentGatewayID"] = $paymentGatewayID;
		}
		$gatewayFilter["vendor_id"] = getCurrentSession()->getVendorId();

		$this->smartyVars["paymentGateways"] = array();
		foreach (Factory()->PaymentGatewayList($gatewayFilter) as $paymentGateway) {
			if ($paymentGateway->hasCapability(GATEWAY_3D_SECURE)) {
				continue;
			}
			$this->smartyVars["paymentGateways"][] = $paymentGateway;
		}
		if (empty($this->smartyVars["paymentGateways"])) {
			$this->smartyVars["warningMessages"][] = blmsg("TRANS_PAYMENT_GATEWAYS_EMPTY_CONFIGURED_LIST");
		}

		if ( "" != ($invoiceID = bgpc("invoiceID")) ) {
			require_once("lib-mbapi/mbapi.php");
			$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => $invoiceID,
						"getInvoiceLineItemsData" => 1,
						"getInvoiceLineItemsPaymentsData" => 1,
						"getTaxZonesData" => 1,
					),
				),
			)));
			if ( $this->smartyVars["invoiceInfo"]["lineItems"] ) {
				$this->smartyVars["clientInfo"] = $this->smartyVars["invoiceInfo"]["lineItems"][0];
			}
		} else {
			$this->smartyVars["currencyList"] = Service()->PaymentGatewayManager->getAcceptedCurrencies();
			$this->smartyVars["selectedCurrency"] = Service()->StoreManager->getDefaultForm(Store::TYPE_CUSTOMER, getCurrentSession()->getVendorId())->currency_id;
		}
        $this->smartyVars["buttons"] = array(
            array('id' => 'billing-id-next', 'class' => 'action', 'name' => 'next', 'value' => "TRANS_NEXT", 'type' => 'submit', 'label' => 'TRANS_NEXT'),
        );

        $this->addTemplate("modules/ShowVirtualTerminals");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}