<?php

require_once("lib-action/action.php");

class CaptureFunds extends MB_Action
{
	public function execute()
	{
		parent::execute();
        if (!Service()->CryptManager->isEncryptionEnabled()) {
            billing_put_error(blmsg('TRANS_ENCRYPTION_IS_NOT_ENABLED_MSG'));
            $this->_redirect();
		}

		set_time_limit(0);
		ignore_user_abort();

		$captureQuery = array(
			"mbapi" => array(
				"command" => "ProcessCaptureFunds",
				"params" => array(
				),
			),
		);
		$capturedTransactions = $failedTransactions = array();

		require_once("lib-mbapi/mbapi.php");
		foreach (bgpc("captureIDs", array()) as $tid => $v) {
			if ($v=='y'){
				$captureQuery["mbapi"]["params"]["transactionID"] = $tid;
				$results = dispatchMBAPI($captureQuery, 1);
				$result = $results["mbapi"][0]["results"][0]["result"][0];
				if ("success" == $result) {
					$capturedTransactions[] = $tid;
				} else {
					$failedTransactions[] = $tid;
                    billing_put_error(blmsg(
						"TRANS_PAYMENT_TRANSACTION_CAPTURE_ERROR_MSG",
						array("TRANSACTION_ID" => $tid, "ERROR" => $results["mbapi"][0]["header"][0]["errors"][0]["error"][0]["message"][0])
					));
				}
			}
		}
		if (!empty($capturedTransactions)) {
			billing_put_info(blmsg('TRANS_CAPTURE_FUNDS_SUCCESSFULLY_MSG'));
		}

		$this->_redirect($failedTransactions);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function _redirect($failedTransactions = array())
	{
		if ((int)$_REQUEST["invoiceID"]){
	            redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".((int)$_REQUEST["invoiceID"])."&failedID=".$failedTransactions[0]."&sid=".secureInput($_REQUEST["sid"]));
		} else {
	        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
	            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
	        } else {
	            redirect("paymentqueue.php?action=".getActionID("ShowUncapturedFunds")."&failedID[]=".@implode("&failedID[]=", $failedTransactions)."&sid=".secureInput($_REQUEST["sid"]));
	        }
		}
	}
}