<?php

require_once("lib-action/action.php");

use Billing\Manager\CryptManager;

class GeneratePaymentQueueResponse extends MB_Action
{
	public function execute()
    {
		global $CONF;
		parent::execute();

        if (checkdate($_REQUEST["dueDateMonth"],$_REQUEST["dueDateDay"],$_REQUEST["dueDateYear"])) {
            if (intval($_REQUEST["dueDateHour"]) <= 23) {
                $dueDateHour = (int) $_REQUEST["dueDateHour"];
            } else {
                $dueDateHour = date("h");
            }
            if (intval($_REQUEST["dueDateMinute"]) <= 59) {
                $dueDateMinute = (int) $_REQUEST["dueDateMinute"];
            } else {
                $dueDateMinute = date("i");
            }
            $dueDate = mktime($dueDateHour,$dueDateMinute,0,$_REQUEST["dueDateMonth"],$_REQUEST["dueDateDay"],$_REQUEST["dueDateYear"]);
        } else {
            $dueDate = time();
        }


        if (checkdate($_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]) && (int) $_REQUEST["runWhen"]==2) {
            if (intval($_REQUEST["laterDateHour"]) <= 23) {
                $laterDateHour = (int) $_REQUEST["laterDateHour"];
            } else {
                $laterDateHour = date("h");
            }
            if (intval($_REQUEST["laterDateMinute"]) <= 59) {
                $laterDateMinute = (int) $_REQUEST["laterDateMinute"];
            } else {
                $laterDateMinute = date("i");
            }
            $laterDate = mktime($laterDateHour,$laterDateMinute,0,$_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]);
        } elseif ((int) $_REQUEST["runWhen"]==1) {
            $laterDate = time();
        }

        $xmlCmd = "<mbapi>\n";
        $xmlCmd .= "    <command>ProcessPaymentQueue</command>\n";
        $xmlCmd .= "    <params>\n";

        $xmlCmd .= "        <clearPaymentQueue>".(((int)$_REQUEST["clearPaymentQueue"]>0)?1:0)."</clearPaymentQueue>\n";
        if (in_array("new", $_REQUEST["generate"])){
            $xmlCmd .= "        <generateNew>1</generateNew>\n";
        }
        if (in_array("declined", $_REQUEST["generate"])){
            $xmlCmd .= "        <generateDeclined>1</generateDeclined>\n";
        }
        if (in_array("error", $_REQUEST["generate"])){
            $xmlCmd .= "        <generateError>1</generateError>\n";
        }

        $xmlCmd .= "        <generateDueDateOnly>".(((int)$_REQUEST["generateDueDateOnly"]>0)?1:0)."</generateDueDateOnly>\n";
        $xmlCmd .= "        <dueDateTimestamp>$dueDate</dueDateTimestamp>\n";
        $xmlCmd .= "        <numInvoicesToQueue>".( (int)$_REQUEST["numInvoicesToQueue"] )."</numInvoicesToQueue>\n";
        $xmlCmd .= "        <ignoreQuarantinePeriod>".(((int)$_REQUEST["ignoreQuarantinePeriod"]>0)?1:0)."</ignoreQuarantinePeriod>\n";
        $xmlCmd .= "        <ignoreFailuresNum>".(((int)$_REQUEST["ignoreFailuresNum"]>0)?1:0)."</ignoreFailuresNum>\n";

        $vendorID = getCurrentSession()->getVendorId();
        $vendorID = !is_null($vendorID) ? $vendorID : "NULL";
        $xmlCmd .= "		<vendorID>{$vendorID}</vendorID>\n";
        $xmlCmd .= "		<manualRun>1</manualRun>\n";

        $xmlCmd .= "    </params>\n";
        $xmlCmd .= "</mbapi>\n";
        $generateReturn = dispatchMBAPI($xmlCmd, 1);

        if ( is_array($generateReturn["mbapi"][0]["results"][0]["successfulCharges"]) && count($generateReturn["mbapi"][0]["results"][0]["successfulCharges"][0]["currencies"]) > 0 ){
            $this->smartyVars["currencies"] = array();
            foreach ($generateReturn["mbapi"][0]["results"][0]["successfulCharges"][0]["currencies"] as $data){
                $this->smartyVars["currencies"][] = array("id"=>$data["paymentCurrency"][0], "number"=>$data["paymentQueueCount"][0], "amount"=>$data["paymentQueueAmount"][0]);
            }
        }

        if ( ($CONF["system"]["internal"]["systemQueueCommand"] != "ProcessPaymentQueue" || !$CONF["system"]["internal"]["systemQueueRunning"])
                && (int) $_REQUEST["runWhen"] ){

            if (!Service()->CryptManager->isEncryptionEnabled()) {
                billing_put_error(blmsg("TRANS_ENCRYPTION_IS_NOT_ENABLED_MSG"));
                redirect("paymentqueue.php", getActionID("GeneratePaymentQueue"));
            }
            if (!Service()->CryptManager->canDecryptData()) {
                billing_put_error(blmsg('TRANS_ENCRYPTION_NO_PASSPHRASE_OR_PRIVATE_KEY_PRESENT_MSG'));
                redirect('paymentqueue.php', getActionID("GeneratePaymentQueue"));
            }
            // its not running our process, so lets put it in the system queue, get the id, then run it and
            // redirect to the page that displays the progress.
            $vendorID = getCurrentSession()->getVendorId();
            $vendorIDParam = !is_null($vendorID) ? $vendorID : "NULL";
            $processQueueXML = "<mbapi>
            <command>ProcessPaymentQueue</command>
            <params>
                <runPaymentQueue>1</runPaymentQueue>
                <transactionAction>".secureInput($_REQUEST["transactionAction"])."</transactionAction>
                <chargeLesserAmounts>".(((int)$_REQUEST["chargeLesserAmounts"]>0)?1:0)."</chargeLesserAmounts>
                <vendorID>{$vendorIDParam}</vendorID>
                <manualRun>1</manualRun>
            </params>
        </mbapi>"; // run everything in the queue with a date charged of 0

            $dateToRun = $laterDate;
            $timeData = explode(";", date("i;G;j;n;Y", $dateToRun-60));
            $cmdArgs = array(
                "systemQueueCommand" => "ProcessPaymentQueue",
                "systemQueueCommandInput" => $processQueueXML,
                "systemQueueMinute" => $timeData[0],
                "systemQueueHour" => $timeData[1],
                "systemQueueDay" => $timeData[2],
                "systemQueueMonth" => $timeData[3],
                "systemQueueYear" => $timeData[4],
                "systemQueueIsRecurring" => 0,
                "systemQueueDateCreated" => time(),
                "systemQueueDateToRun" => $dateToRun,
                "systemQueueDateStarted" => 0,
                "systemQueueDateFinished" => 0
            );
			if (!is_null($vendorID)) {
				$cmdArgs["vendorID"] = $vendorID;
			}
            $query = $this->getMBAPIQuery("SetSystemQueue", "insert", $cmdArgs);
            $data = dispatchMBAPI($query, 1);

            $this->smartyVars["systemQueueID"] = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
        }
        $this->smartyVars["buttons"] = array(
            array('id' => 'billing-id-generate-continue', 'class' => 'action', 'name' => 'continue', 'value' => "TRANS_CONTINUE", 'type' => 'button', 'label' => 'TRANS_CONTINUE', 'onclick' => 'document.location.href=\''.action_url("paymentqueue", "ShowPaymentQueue").'\''),
        );
        $this->addTemplate("paymentqueue/GeneratePaymentQueueResponse", $this->smartyVars);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
