<?php
require_once ("lib-action/action.php");

class ReplayCallbackLog extends MB_Action
{
	public function execute()
    {
		parent::execute();

        $callbackLogID = (int)$_REQUEST["callbackLogID"];
		if (!$callbackLogID) {
			$this->addError('TRANS_ACTIONERROR', "No callback log ID given.");
		} else {
            require_once 'object_managers/PaymentGatewayManager.php';
            $vendorId = getCurrentSession()->getVendorId();
            $paymentGatewayList = Service()->PaymentGatewayManager->getPaymentGatewayIdsByVendorId($vendorId);
            if (null == $vendorId) {
                $paymentGatewayList[] = null;
            }
            $callback = reset(Factory()->CallbackList(array('callback_log_id' => $callbackLogID, 'payment_gateway_id' => $paymentGatewayList)));
            if (empty($callback)) {
                $this->addError('TRANS_ACTIONERROR', "Callback not found.");
            } else {
                $this->smartyVars["callbackLogID"] = $callback->callback_log_id;
                $this->smartyVars["isUserExist"] = reset(Factory()->CustomerList(array('client_id' => $callback->client_id)));
                $this->smartyVars["callbackLogInfo"] = $this->_convertObjectToArray($callback);
                if (null !== $callback->transaction_id) {
                    $transaction = Factory()->PaymentTransaction($callback->transaction_id);
                    $this->smartyVars["transactionLog"] = $this->_convertObjectToArray($transaction);
                }

                $this->addTemplate("paymentqueue/ReplayCallbackLog");
            }
        }
		$this->addErrorTemplates();

		return $this->hasExecutedSuccessfully();
	}
}