<?php
require_once ("lib-action/action.php");

class ReplayCallbackLogResponse extends MB_Action
{
	public function execute()
    {
		parent::execute();
		
		$callbackLogID = (int)$_REQUEST["callbackLogID"];
		if (!$callbackLogID){
			$this->addError('TRANS_ACTIONERROR', "Invalid callback log id passed.");
		} else {
		
			$callbackLogInfo = oneByID("callbackLogs", $callbackLogID);
		
			$createClientRecord = ($_REQUEST["replayAction"]=="create")?1:0;
			$overrideClientID = ($_REQUEST["replayAction"]=="use")?(int)$_REQUEST["clientID"]:0;

            $replayResult = dispatchMBAPI(toXML(array(
                "mbapi" => array(
                    "command" => "ProcessCallbackReplay",
                    "params" => array(
                        "callbackLogID" => $callbackLogID,
                        "gatewayName" => getAPITypeName("callbackLog", $callbackLogInfo["callbackLogType"]),
                        "createClientRecord" => $createClientRecord,
                        "overrideClientID" => $overrideClientID,
                    ),
                ),
            )), 1);
            
            if (!empty($replayResult['mbapi'][0]['header'][0]['errorCount'][0])) {
                $this->addError('TRANS_ACTIONERROR', $replayResult['mbapi'][0]['header'][0]['errors'][0]['error'][0]['title'][0]);
            } else {
                // have to get the info again in case the client id got updated to forward to the right place
                $callbackLogInfo = oneByID("callbackLogs", $callbackLogID);

                if ((int)$callbackLogInfo["clientID"]){
                    redirect("clients.php", "ShowClientDetails", array(
                        "clientID" => $callbackLogInfo["clientID"],
                    ));
                } else {
                    redirect("paymentqueue.php", "ShowCallbackLog");
                }
            }
		}
        unset($_REQUEST['clientID']);
        
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}