<?php
require_once ("lib-action/action.php");

use Billing\Manager\CryptManager;

class RunPaymentQueueResponse extends MB_Action
{
	public function execute()
    {
		parent::execute();

		$this->smartyVars["hideEventStatusBar"] = 1;
		$this->smartyVars["queueRunTime"] = time();

		if (checkdate($_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]) && (int) $_REQUEST["runWhen"]==2) {
			if (intval($_REQUEST["laterDateHour"]) <= 23) {
				$laterDateHour = (int) $_REQUEST["laterDateHour"];
			} else {
				$laterDateHour = date("h");
			}
			if (intval($_REQUEST["laterDateMinute"]) <= 59) {
				$laterDateMinute = (int) $_REQUEST["laterDateMinute"];
			} else {
				$laterDateMinute = date("i");
			}
			$laterDate = mktime($laterDateHour,$laterDateMinute,0,$_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]);
		} else {
			$laterDate = time()-300;
		}

		$timeData = explode(";", date("i;G;j;n;Y", $laterDate));

		if ( (int) $_REQUEST["runWhen"] ){
			if (!Service()->CryptManager->isEncryptionEnabled()) {
				billing_put_error(blmsg('TRANS_ENCRYPTION_IS_NOT_ENABLED_MSG'));
				redirect('paymentqueue.php', 'RunPaymentQueue');
			}
			if (!Service()->CryptManager->canDecryptData()) {
				billing_put_error(blmsg('TRANS_ENCRYPTION_NO_PASSPHRASE_OR_PRIVATE_KEY_PRESENT_MSG'));
				redirect('paymentqueue.php', 'RunPaymentQueue');
			}

			// its not running our process, so lets set the queue command and start it from the tpl or just say we set it
			$vendorID = getCurrentSession()->getVendorId();
			$vendorIDParam = !is_null($vendorID) ? $vendorID : "NULL";
			$processQueueXML = "
				<mbapi>
					<command>ProcessPaymentQueue</command>
					<params>
						<manualRun>1</manualRun>
						<runPaymentQueue>1</runPaymentQueue>
						<numInvoicesToCharge>3</numInvoicesToCharge>
						<transactionAction>".secureInput($_REQUEST["transactionAction"])."</transactionAction>
						<chargeLesserAmounts>".(((int)$_REQUEST["chargeLesserAmounts"]>0)?1:0)."</chargeLesserAmounts>
						<vendorID>{$vendorIDParam}</vendorID>
					</params>
				</mbapi>
				"; // run everything in the queue with a date charged of 0

			$dateToRun = mktime($timeData[1], $timeData[0], 0, $timeData[3], $timeData[2], $timeData[4]);
			$cmdArgs = array(
				"systemQueueCommand" => "ProcessPaymentQueue",
				"systemQueueCommandInput" => $processQueueXML,
				"systemQueueMinute" => $timeData[0],
				"systemQueueHour" => $timeData[1],
				"systemQueueDay" => $timeData[2],
				"systemQueueMonth" => $timeData[3],
				"systemQueueYear" => $timeData[4],
				"systemQueueIsRecurring" => 0,
				"systemQueueDateCreated" => time(),
				"systemQueueDateToRun" => $dateToRun,
				"systemQueueDateStarted" => 0,
				"systemQueueDateFinished" => 0
			);
			if (!is_null($vendorID)) {
				$cmdArgs["vendorID"] = $vendorID;
			}
			$query = $this->getMBAPIQuery("SetSystemQueue", "insert", $cmdArgs);
			$data = dispatchMBAPI($query, 1);
			$this->smartyVars["systemQueueID"] = $data["mbapi"][0]["header"][0]["lastInsertID"][0];

			$this->smartyVars["runWhen"] = (int)$_REQUEST["runWhen"];
			$this->smartyVars["runDate"] = $laterDate;
			$this->smartyVars["showStatus"] = "yes";

		} else { // nope we didnt
			$this->smartyVars["showStatus"] = "yes";
			$this->smartyVars["queueRunTime"] = time(); //$queueItem["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"][0]["systemQueueDateToRun"][0];
		}

		$this->addTemplate("paymentqueue/RunPaymentQueueResponse", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}