<?php

require_once("lib-action/action.php");

class ShowPaymentQueue extends MB_Action
{
	public $params = array(
		"paymentID",
		"invoiceID",
		"billingAccountID",
		"paymentDescription",
		"paymentAmount",
		"paymentDateCreated",
	);

	public $sortColumns = array("payment_id", "payment_date_created");

	public function execute()
	{
		parent::execute();

		$query = $this->getMBAPIQuery("GetPaymentQueue", "", array('getClientData'=>1,'getInvoiceData'=>1), 1, 1, 1, 1);
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if ($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
            if (isset($results["paymentQueue"][0]["payment"])) {
                $smartyVars["paymentqueue"] = $results["paymentQueue"][0]["payment"];
                if (1 == $data["mbapi"][0]["header"][0]["numResults"][0]) {
                    $smartyVars["paymentqueue"] = array(0 => $results["paymentQueue"][0]["payment"]);
                }
            } else {
                $smartyVars["paymentqueue"] = array();
            }
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			$smartyVars['tabs'] = array(
				"transactions" => array(
					"url" => action_url("paymentqueue", "ShowTransactionLog"),
					"title" => blmsg("TRANS_SHOW_TRANSACTIONS"),
					"current" => false,
				),
				"uncapturedFunds" => array(
					"url" => action_url("paymentqueue", "ShowUncapturedFunds"),
					"title" => blmsg("TRANS_SHOW_UNCAPTURED_FUNDS"),
					"current" => false,
				),
				"paymentQueue" => array(
					"url" => action_url("paymentqueue", "ShowPaymentQueue"),
					"title" => blmsg("TRANS_SHOW_PAYMENT_QUEUE"),
					"current" => true,
				),
			);

			$this->addTemplate("paymentqueue/ShowPaymentQueue", collapseArrayElements($smartyVars), 1);
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}