<?php

require_once("lib-action/action.php");

class ShowUncapturedFunds extends MB_Action
{
    public $params = array("transactionID", "clientID", "billingAccountID");
    public $sortColumns = array("transaction_date_created");

    public function execute()
    {
        parent::execute();
        if (!Service()->CryptManager->isEncryptionEnabled()) {
			$this->smartyVars["warningMessages"][] = blmsg("TRANS_ENCRYPTION_IS_NOT_ENABLED_MSG");
		}

        $invalidPoint = time()-(24*60*60*30);
        $this->smartyVars["invalidpoint"] = time()-(24*60*60*30);

        $this->smartyVars["showPassword"] = (Service()->CryptManager->isLekEnabled() ? 0 : 1);

        if ($_REQUEST['failedID']){
            $this->smartyVars['failed'] = $_REQUEST['failedID'];
        }

        $transactionsQuery = "	<mbapi>
									<command>GetTransactions</command>
									<params>
										<authReturn>".getAPIStatusID("transactions", "authorized")."</authReturn>
										<getClientNames>1</getClientNames>
                                        <vendorID>".getCurrentSession()->getVendorId()."</vendorID>
									</params>
								</mbapi>";

        require_once("lib-mbapi/mbapi.php");
        $data = dispatchMBAPI($transactionsQuery, 1);

        $results =& $data["mbapi"][0]["results"][0];
        if($this->addMBAPIErrors($data) === 0) {

            $this->smartyVars["transactions"] = correctArray($results["transactions"][0]["transaction"]);
            foreach($this->smartyVars["transactions"] as $key => $transaction) {
                if ($transaction['transactionDateCreated'] < $invalidPoint) {
                    unset($this->smartyVars["transactions"][$key]);
                }
            }
            $smartyVars["paginationLinks"] = $results["paginationLinks"][0];

            $this->smartyVars['tabs'] = array(
                "transactions" => array(
                    "url" => action_url("paymentqueue", "ShowTransactionLog"),
                    "title" => blmsg("TRANS_SHOW_TRANSACTIONS"),
                    "current" => false,
                ),
                "uncapturedFunds" => array(
                    "url" => action_url("paymentqueue", "ShowUncapturedFunds"),
                    "title" => blmsg("TRANS_SHOW_UNCAPTURED_FUNDS"),
                    "current" => true,
                ),
                "paymentQueue" => array(
                    "url" => action_url("paymentqueue", "ShowPaymentQueue"),
                    "title" => blmsg("TRANS_SHOW_PAYMENT_QUEUE"),
                    "current" => false,
                ),
            );
            $this->smartyVars["buttons"] = array(
                array('id' => 'billing-id-capture', 'class' => 'action', 'name' => 'capture', 'value' => "TRANS_CAPTURE_FUNDS", 'type' => 'submit', 'label' => 'TRANS_CAPTURE_FUNDS'),
            );
            $this->addTemplate("paymentqueue/ShowUncapturedFunds");
        }
        $this->addErrorTemplates();
        return $this->hasExecutedSuccessfully();
    }
}