<?php
require_once("lib-action/action.php");

class AddTLD extends MB_Action
{
    public $params = array("tldID");

	public function execute()
    {
		global $CONF;
		parent::execute();
		$tldNotSupported = (int) $_REQUEST["tldNotSupported"];
		$this->smartyVars["tldRenewTypes"] = $CONF["types"]["tldRenew"];
		$this->smartyVars["enabledDisabled"] = array(blmsg('TRANS_DISABLED'), blmsg('TRANS_ENABLED'));
		$this->smartyVars["yesNo"] = array(blmsg('TRANS_YES'), blmsg('TRANS_NO'));
		$this->smartyVars["transferTypes"] = $CONF["types"]["tldTransfer"];
		$this->smartyVars["IDNTypes"] = $CONF["types"]["tldIDN"];

		if($tldNotSupported) {
			$this->smartyVars["tldNotSupported"] = 1;
		}

		$registrars = array("");
		$registrarTLDs = array(" ", array());
		foreach(Service()->BillingRegistrarManager->getEnabledRegistrars(getCurrentSession()->getVendorId()) as $registrar) {
			list($registrar_id) = $registrar->id;
			$registrars[$registrar_id] = blmsg($registrar->name);
			try {
				$registrarTLDs[$registrar_id] = $registrar->getTLDs();
			} catch (ProductException $e) {
				// skip Registrar errors
			}
		}

		$this->smartyVars["registrars"] = $registrars;
		$this->smartyVars["registrarTLDs"] = $registrarTLDs;
		$this->mergeCycleData();
		$this->mergeFormState($_REQUEST);
        $this->addTemplate("products/AddTLD", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	protected function mergeCycleData()
	{
		$conn = Service()->DatabaseManager->getConnection();
		$cycles = $conn->getAll(
			"SELECT * FROM cycles WHERE
				cycle_num_years >= 1 AND
				cycle_num_years <= 10 AND
				cycle_num_seconds = 0 AND
				cycle_num_minutes = 0 AND
				cycle_num_hours = 0 AND
				cycle_num_days = 0 AND
				cycle_num_months = 0
		");
		$this->smartyVars["cycleList"] = array();
		foreach ($cycles as $cycle) {
			$this->smartyVars["cycleList"][$cycle["cycle_id"]] = blmsg($cycle["cycle_display_name"]);
		}
		return 1;
	}
}
