<?php

require_once mb_path("/lib-action/include/wizard/WizardResolver.php");

/**
 * This Action object collects information on a product so that that product may be added to the 
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddWizardStep extends MB_Action {
	/**
	 * The constructor for a AddWizardStep action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddWizardStep() {
		parent::MB_Action();
		$this->stringRep = "AddWizardStep";
	}

	/**
	 * The main method of this class that executes the AddWizardStep action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$w = new Wizard(intval($_REQUEST["wizardID"]), blmsg('TRANS_ADD_WIZARD_STEP'), blmsg('TRANS_ADD_WIZARD_STEP_MESG'));
		$s = new WizardStep(blmsg('TRANS_ADD_STEP'), blmsg('TRANS_ADD_STEP_MESG'));

		$wr = new WizardResolver("stepName");
				
		$wr->setWizard($w);
		$wr->setWizardStep($s);
		$wr->processForQuestionsReady();

		$questionAnswers = $wr->getQuestionAnswers();
		
		if($wr->isReady("stepName")) {
			$q = new WizardQuestion(QUESTION_INPUT_TEXT, blmsg('TRANS_STEP'));
			$q->setID($wr->getQuestionID("stepName"));
			$q->setSize(64);
			$q->setMaxLength(256);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
			$s->addQuestion($q);		
		}
		
		$confirm = $_REQUEST['confirm'];
		
		if(!$confirm) {
			$this->addTemplate("products/AddWizardStep", $this->smartyVars);
		}
		
		$stepName = "";
		if($confirm || !$wr->display()) {
			$summary = array();
						
			if(isset($questionAnswers['stepName'])) {
				$step = $questionAnswers['stepName'];
				$stepName = blmsg($step);
				$summary[] = array(blmsg('TRANS_QUESTION'), $stepName);
			}

			if(!$confirm) {
				$this->addTemplate("products/AddWizardStep2", array('summary' => $summary, 'wizardID' => $w->getID()));
			}
		}


		if(!$confirm) {

			$this->addTemplate("footer", array());
		} else {
			// insert into database
			
			$cmd = "<mbapi>
	<command>SetWizardSteps</command>
	<subCommand>insert</subCommand>
	<params>
		<stepName>" . $stepName . "</stepName>
	</params>
</mbapi>";

			$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
			$data = dispatchMBAPI($cmd, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("products.php", getActionID("ShowWizardSteps"), array());
			}
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}