<?php

/**
 * This Action object takes information provided by the RemoveProduct action, and removes the specified product. *
 * @author Andy Christ
 */
class CloneProductResponse extends MB_Action {
	/**
	 * The constructor for an RemoveProductResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function CloneProductResponse() {
		parent::MB_Action();
		$this->stringRep = "CloneProductResponse";
        $this->params = array("productID");
	}


	/**
	 * The main method of this class that executes the CloneProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No Product ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetProducts", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);

			$query = $this->getMBAPIQuery("SetProducts", "insert", collapseArrayElements($data['mbapi'][0]['results'][0]['products'][0]['product'][0]));

			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				mbHeader("Location: products.php?action=".getActionID("ShowProductDetails")."&productID=".$data["mbapi"][0]["header"][0]["lastInsertID"][0]);
			}
	}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveProductResponse
?>