<?php
require_once ("lib-action/action.php");
require_once ("admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once ("lib-billing/include/accounting/Accounting.php");

class EditLedgerGroupEntries extends MB_ProductAction
{

	public function __construct()
    {
		parent::__construct("ledgergroups");
	}

	public function execute()
    {
		parent::execute();

        $productVariantID = getParam('productVariantID');
		if(!$productVariantID) {
			$this->addError('TRANS_ACTIONERROR', "No product variant ID given.");
        } else {
		 	$this->smartyVars["productVariantID"] = $productVariantID;
            $this->smartyVars["ledgerGroupID"] = (int)$_REQUEST["ledgerGroupID"];

            $variantInfo = oneByID(":productVariants", $this->smartyVars["productVariantID"]);

            $q = new MBQuery("GetProducts", "", array("productID" => $variantInfo["productID"], "getCouponData" => 1, "getPreCouponData" => 1));
            $r =& $q->getResult();
            $s =& $r->getSubjectFrom(
                array("mbapi", "results", "products", "product", 0),
                "productID", "productName"
            );
            $productInfo = $s->getEssential();
            $product = $s->getCollapsed();

            $this->smartyVars['product'] = $product;
            $this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
                "productID" => $_REQUEST["productID"] = $product["productID"],
            ));

            $this->setupTypeButtons($product["productType"]);
            $this->smartyVars["productButtons"] = $this->productButtons->getButtons();


            $this->addLedgerAccounts();

            // get available currencies
            $currencyIDs = array();
            foreach (Factory()->StoreList(array('vendor_id' => getCurrentSession()->getVendorId())) as $store) {
                $currencyIDs[$store->currency_id] = $store->currency_id;
            }
            $this->smartyVars["currencyIDs"] = $currencyIDs;
            foreach($this->smartyVars["currencyIDs"] as $id => $currency) {
                $this->smartyVars["doubleListSelectorOptionsCurrencies"][$id] = array(
                    'id' => $id,
                    'title' => $currency
                );
            }
            foreach(getCyclesArray() as $id => $cycle) {
                $this->smartyVars["doubleListSelectorOptionsCycles"][$id] = array(
                    'id' => $id,
                    'title' => $cycle
                );
            }
            if ((int)$_REQUEST["ledgerGroupID"]){
                $data = dispatchMBAPI("<mbapi><command>GetLedgerGroups</command><params><ledgerGroupID>".(int)$_REQUEST["ledgerGroupID"]."</ledgerGroupID></params></mbapi>", 1);
                $data = collapseArrayElements($data["mbapi"][0]["results"][0]["groups"][0]["group"]);
                dbg("group info:");
                dbg($data);
                if (isset($data["ledgerEntries"]["entry"]["productVariantID"])){
                    $data["ledgerEntries"]["entry"] = array($data["ledgerEntries"]["entry"]);
                }
                $this->smartyVars["existingEntries"] = $data["ledgerEntries"]["entry"];
                foreach ($this->smartyVars["existingEntries"] as $k=>$v){
                    $this->smartyVars["existingEntries"][$k]["generalLedgerDebitAmount"] = $v["productLedgerDebit"];
                    $this->smartyVars["existingEntries"][$k]["generalLedgerCreditAmount"] = $v["productLedgerCredit"];
                    $this->smartyVars["existingEntries"][$k]["generalLedgerDescription"] = $v["productLedgerComment"];
                }
                $productLedgerID = $data["ledgerEntries"]["entry"][0]["productLedgerID"];

                $query = "<mbapi><command>GetProductLedgerEntries</command><params><productLedgerID>".$productLedgerID."</productLedgerID><getProductLedgerCurrenyIDs>1</getProductLedgerCurrenyIDs><getProductLedgerCycleIDs>1</getProductLedgerCycleIDs></params></mbapi>";
                $ledata = dispatchMBAPI($query, 1);
                $setCycles = array();
                $setCurrencies = array();

                dbg("ledger data");
                dbg($ledata);
                if (isset($ledata["mbapi"][0]["results"][0]["productLedgerEntries"][0]["productLedgerEntry"][0])) {
                    $ledata = $ledata["mbapi"][0]["results"][0]["productLedgerEntries"][0]["productLedgerEntry"][0];
                    $this->smartyVars["currencyID"] = $ledata["currencyID"][0];
                    if (isset($ledata["currencies"][0]["currency"][0]["currencyID"])) {
                        foreach ($ledata["currencies"][0]["currency"] as $curr) {
                            $setCurrencies[$curr["currencyID"][0]] = $curr["currencyID"][0];
                        }
                    }
                    if (isset($ledata["cycles"][0]["cycle"][0]["cycleID"])){
                        foreach ($ledata["cycles"][0]["cycle"] as $cycle){
                            $setCycles[$cycle["cycleID"][0]] = $cycle["cycleID"][0];
                        }
                    }
                }
                foreach ($this->smartyVars["doubleListSelectorOptionsCurrencies"] as $id => $currency){
                    if (isset($setCurrencies[$id])){
                        $this->smartyVars["doubleListSelectorOptionsCurrencies"][$id]['selected'] = true;
                    }
                }
                foreach ($this->smartyVars["doubleListSelectorOptionsCycles"] as $id => $cycle){
                    if (isset($setCycles[$id])){
                         $this->smartyVars["doubleListSelectorOptionsCycles"][$id]['selected'] = true;
                    }
                }

            }

            if (isset($this->smartyVars["existingEntries"][0]["ledgerGroupName"])){
                $this->smartyVars["ledgerGroupName"] = $this->smartyVars["existingEntries"][0]["ledgerGroupName"];
            }

            asort($this->smartyVars["doubleListSelectorOptionsCurrencies"]);
            $this->smartyVars["doubleListSelectorAttribsCurrencies"] = array('id' => 'currencies');
            asort($this->smartyVars["doubleListSelectorOptionsCycles"]);
            $this->smartyVars["doubleListSelectorAttribsCycles"] = array('id' => 'cycles');

            $GLOBALS["tpl"]->assign_by_ref("doubleListSelector", new Billing_Zend_View_Helper_DoubleListSelector());
            $this->mergeFormState();
            $this->addTemplate("widgets/products/EditLedgerGroupEntries", $this->smartyVars);
        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
