<?php

require_once mb_path("/admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> child product relation editor
 *
 * @author  Kris Bailey
 */
class EditOneProductRelations extends MB_ProductAction {
	/**
	 * The constructor for a EditOneProductRelations action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditOneProductRelations() {
		parent::MB_ProductAction("relations");
		$this->stringRep = "EditOneProductRelations";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditOneProductRelations action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		dbg($this);
		
		$productID = (int) $_REQUEST["productID"];
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getProductChildIDs" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;

				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));
				
				$this->smartyVars["productsInfo"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"getNonAddons" => 1,
						),
					),
				)), "productID", "productName");
				
				/* stuff to get relations */
				$this->smartyVars["selectedUpgradeRelations"] = grabHTMLOpsFromArray(arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "upgrade"))), "relatedProductID", array($this, "grabProductName"));
				$this->smartyVars["selectedDowngradeRelations"] = grabHTMLOpsFromArray(arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "downgrade"))), "relatedProductID", array($this, "grabProductName"));

				$this->smartyVars["selectableUpgradeRelations"] = array();
				$this->smartyVars["selectableDowngradeRelations"] = array();
				foreach ($this->smartyVars["productsInfo"] as $pid=>$product){
					if (/*$pid!=$productID && */!$this->smartyVars["selectedUpgradeRelations"][$pid]){
						$this->smartyVars["selectableUpgradeRelations"][$pid] = $product;
					}
				}				
				foreach ($this->smartyVars["productsInfo"] as $pid=>$product){
					if (/*$pid!=$productID && */!$this->smartyVars["selectedDowngradeRelations"][$pid]){
						$this->smartyVars["selectableDowngradeRelations"][$pid] = $product;
					}
				}				


				$q = new MBQuery("GetProducts", "", array());
				$childrenResult =& $q->getResult();
				$childrenSubject =& $childrenResult->getSubjectFrom(
					array("mbapi", "results", "products", "product"),
					"productID", "productName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productChildren", "productChild"));
				$this->assignMultiOptionsFromSubject("children", $childrenSubject, "productChildren", $r, "childProductID");
				
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditOneProductRelations", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
	function grabProductName($row){
		return $this->smartyVars["productsInfo"][$row["relatedProductID"]];
	}
}
?>
