<?php

/**
 * This Action object collects information on a product so that that the product may be modified in the
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditProduct extends MB_Action {
	/**
	 * The constructor for a EditProduct action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProduct() {
		parent::MB_Action();
		$this->stringRep = "EditProduct";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProduct action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetProducts", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["product"] = collapseArrayElements($data["mbapi"][0]["results"][0]["products"][0]["product"][0]);
				$this->addTemplate("products/EditProduct", $s);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditProduct
?>