<?php

require_once mb_path("/admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> child product relation editor
 *
 * @author  Kris Bailey
 */
class EditProductAddonGroups extends MB_ProductAction {
	/**
	 * The constructor for a EditProductAddonGroups action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProductAddonGroups() {
		parent::MB_ProductAction("children");
		$this->stringRep = "EditProductAddonGroups";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductAddonGroups action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getProductAddonGroupIDs" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;				
				
				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));
				
				$this->smartyVars["selectedAddonGroups"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProductAddonGroups",
						"params" => array(
							"getGroupsByProductID" => $productID,
							"productAddonGroupActive" => 1,
						),
					),
				)), "productAddonGroupID", "productAddonGroupName");
				
				$this->smartyVars["selectableAddonGroups"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProductAddonGroups",
						"params" => array(
							"productAddonGroupActive" => 1,
						),
					),
				)), "productAddonGroupID", "productAddonGroupName", array_keys($this->smartyVars["selectedAddonGroups"]));
				
				
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				
				
				$this->addTemplate("widgets/products/EditProductAddonGroups", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
