<?php

require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> addon relation editor
 *
 * @author  Ben Woolley
 */
class EditProductAddons extends MB_Action {
	/**
	 * The constructor for a EditProductAddons action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditProductAddons() {
		parent::MB_Action();
		$this->stringRep = "EditProductAddons";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductAddons action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productID = getParam("productID");
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getProductAddonData" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);

				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;

				$q = new MBQuery("GetProductAddons", "", array());
				$productAddonResult =& $q->getResult();
				$productAddonSubject =& $productAddonResult->getSubjectFrom(
					array("mbapi", "results", "productAddons", "productAddon"),
					"productAddonID", "productAddonName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productAddons", "productAddon"));
				$this->assignMultiOptionsFromSubject("productAddons", $productAddonSubject, "productAddons", $r, "productAddonID");

				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditProductAddons");

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
