<?php

require_once mb_path("/admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> child product relation editor
 *
 * @author  Ben Woolley
 */
class EditProductChildren extends MB_ProductAction {
	/**
	 * The constructor for a EditProductChildren action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProductChildren() {
		parent::MB_ProductAction("children");
		$this->stringRep = "EditProductChildren";
		$this->params = array("productID", "productAddonGroupID");
	}

	/**
	 * The main method of this class that executes the EditProductChildren action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			

			$product = grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productID" => $productID,
					),
				),
			));
			$types = $CONF["types"]["products"];

			$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
				"productID" => $productID,
			));
			
			$this->setupTypeButtons($product["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$this->smartyVars['product'] = $product;
			$this->smartyVars['types'] = $types;				


			$this->smartyVars["selectedChildren"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"parentProductID" => $productID,
							"productAddonGroupID" => (int)$_REQUEST["productAddonGroupID"],
						),
					),
				)), "productID", "productName");
			
			$this->smartyVars["selectableChildren"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"productAddonGroupID" => (int)$_REQUEST["productAddonGroupID"],
						),
					),
				)), "productID", "productName", array_keys($this->smartyVars["selectedChildren"]));
				
			$this->addTemplate("widgets/products/EditProductChildren", $this->smartyVars);
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
