<?php

require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditProductChildren action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditProductChildrenResponse extends MB_Action {
	/**
	 * The constructor for an EditProductChildrenResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductChildrenResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductChildrenResponse";
		$this->params = array(
			"productID",
			"productChildren",
		);
	}

	/**
	 * The main method of this class that executes the EditProductChildrenResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if ($_REQUEST["disassociateID"]){
			dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetProducts",
					"subCommand" => "update",
					"params" => array(
						"productID" => $_REQUEST["productID"],
						"removeProductChildrenIDs" => array(
							"productID" => (int)$_REQUEST["disassociateID"],
						),
					),
				),
			)));
			redirect(
				"products.php", getActionID("ShowProductAddons"),
				array(
					"productID" => $_REQUEST["productID"],
				)
			);
		} else {
		
			if ((int)$_REQUEST["productID"]){
				
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetProducts",
						"subCommand" => "update",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"productChildrenIDs" => array(
								"productID" => (array)$_REQUEST["productChildren"],
							),
							"removeProductChildrenIDs" => array(
								"productID" => (array)$_REQUEST["selectableProductChildren"],
							),
						),
					),
				)));

			}

		}
			
		redirect(
			"products.php", getActionID("ShowProductAddons"),
			array(
				"productID" => $_REQUEST["productID"],
			)
		);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
