<?php

require_once mb_path("/admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> order form relation editor
 *
 * @author  Ben Woolley
 */
class EditProductCoupons extends MB_ProductAction {
	/**
	 * The constructor for a EditProductCoupons action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditProductCoupons() {
		parent::MB_ProductAction("coupons");
		$this->stringRep = "EditProductCoupons";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductCoupons action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productID = getParam("productID");
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getCouponData" => 1, "getPreCouponData" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);

				$productInfo = $s->getEssential();
				dbg($productInfo);
				$this->smartyVars["selectedPreCouponID"] = (isset($productInfo["preappliedCoupons"]) && isset($productInfo["preappliedCoupons"][0]["couponID"]))?$productInfo["preappliedCoupons"][0]["couponID"][0]:0;

				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;
				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

				$q = new MBQuery("GetCoupons", "", array());
				$couponResult =& $q->getResult();
				$couponSubject =& $couponResult->getSubjectFrom(
					array("mbapi", "results", "coupons", "coupon"),
					"couponID", "couponCode"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "coupons", "coupon"));
				$this->assignOptionsFromSubject("precoupons", $couponSubject);
				$this->assignMultiOptionsFromSubject("coupons", $couponSubject, "coupons", $r, "couponID");

				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditProductCoupons");

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
