<?php

require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditProductCoupons action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditProductCouponsResponse extends MB_Action {
	/**
	 * The constructor for an EditProductCouponsResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductCouponsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductCouponsResponse";
		$this->params = array(
			"productID",
			"coupons",
			"preAppliedCouponID",
		);
	}

	/**
	 * The main method of this class that executes the EditProductCouponsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID(getActionID("EditProductCoupons"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT,
			),
			array(),
			array(),
			1,
			array("loadActionFile"=>"products","loadActionID"=>getActionID("EditProductCoupons"))
		);
		if($success) {
	
			$productID = ((int) $_REQUEST["productID"]);
			if(!$productID) {
				$this->addError('TRANS_ACTIONERROR', "No product ID given.");
			} else {
 				$params = array();
				$this->applyRequestTo(
					$params,
					array(
						'coupons',
					)
				);
				$params["preAppliedCouponID"] = (int)$_REQUEST["preAppliedCouponID"];

				$q = new MBQuery(
					"GetProducts", "",
					array(
						"productID" => $productID,
						"getCouponData" => 1,
					)
				);
				$r =& $q->getResult();
				
				$coupons =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", "coupons", "coupon"),
					"couponID"
				);
				$relParams = $this->getRelationParamsFromSubject($coupons, "couponIDs", "couponID", "coupons");
				$params += $relParams;

				//if($relParams) { // commented out so we could set one or the other and not have to change both!
					$setQuery = new MBQuery("SetProducts", "update", $params);
					dbg("set query for products");
					dbg($setQuery->getXMLQuery());
					$setResult =& $setQuery->getResult();
					$skipSuccess = false;
				//} else {
				//	$skipSuccess = true;
				//}
				
				if($skipSuccess || $setResult->getSuccess()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect(
							"products.php", getActionID("EditProductCoupons"),
							array(
								"productID" => $productID,
								"loadActionFile" => "products",
								"loadActionID" => getActionID("EditProductCoupons"),
							)
						);
					}
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
