<?php

require_once mb_path("/admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> order form relation editor
 *
 * @author  Ben Woolley
 */
class EditProductEmails extends MB_ProductAction {
	/**
	 * The constructor for a EditProductEmails action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditProductEmails() {
		parent::MB_ProductAction("emails");
		$this->stringRep = "EditProductEmails";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductEmails action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productID = getParam("productID");
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
			$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getEmailActionGroupData" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);

				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;

				$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
					"productID" => $productID,
				));

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

				$q = new MBQuery("GetEmailTemplateGroups", "", array("emailActionID" => getTypeID("emailAction", blmsg('TRANS_PACKAGE_INFO_EMAIL'))));
				$welcomeResult =& $q->getResult();
				if($welcomeResult->errorCount==0) {
					$emailTemplates = $welcomeResult->structure["mbapi"][0]["results"][0];
				}
				$welcomeResult = correctArray($emailTemplates,1);

				//pull the good stuff out old school
				$templates[0] = " ";
				foreach($welcomeResult["emailTplGroups"] as $value) {
					$templates[$value["emailTplGroupID"]] = $value["emailTplGroupName"];
				}

				$this->smartyVars["templateID"] = (int) $product["emailTplGroupID"];
				$this->smartyVars["templates"] = $templates;
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditProductEmails");

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
