<?php

require_once("lib-action/action.php");

class EditTLD extends MB_Action {

	function EditTLD() {
		parent::MB_Action();
		$this->stringRep = "EditTLD";
		$this->params = array("tldID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$tld = Factory()->Tld(getParam('tldID'));

		$this->smartyVars["tldRenewTypes"] = $CONF["types"]["tldRenew"];
		$this->smartyVars["enabledDisabled"] = array(blmsg('TRANS_DISABLED'), blmsg('TRANS_ENABLED'));
		$this->smartyVars["yesNo"] = array(blmsg('TRANS_YES'), blmsg('TRANS_NO'));
		$this->smartyVars["transferTypes"] = $CONF["types"]["tldTransfer"];
		$this->smartyVars["IDNTypes"] = $CONF["types"]["tldIDN"];

        $registrars = array("");
        $registrarTLDs = array(" ", array());
        foreach(Service()->BillingRegistrarManager->getEnabledRegistrars(getCurrentSession()->getVendorId()) as $registrar) {
            list($registrar_id) = $registrar->id;
            $registrars[$registrar_id] = blmsg($registrar->name);
            try {
                $registrarTLDs[$registrar_id] = $registrar->getTLDs();
            } catch (ProductException $e) {
                // skip Registrar errors
            }
        }

        $this->smartyVars["registrars"] = $registrars;
        $this->smartyVars["registrarTLDs"] = $registrarTLDs;

        $this->mergeCycleData();
		$this->smartyVars["TLD"] = $tld->tld_extension;
        
        $customTLDExtension = !in_array($tld->tld_extension, $registrarTLDs[$tld->registrar_id]);
        
		$this->mergeFormState(array(
			"tldID"				=> $tld->tld_id,
			"registrarID"		=> $tld->registrar_id,
            "tldExtension"      => !$customTLDExtension ? $tld->tld_extension : '',
            "tldCustomExtensionActive" => $customTLDExtension,
			"tldCustomExtension" => $customTLDExtension ? $tld->tld_extension : '',
			"tldName"			=> $tld->tld_name,
			"tldWhoisServer"	=> $tld->tld_whois_server,
			"tldWhoisResp"		=> $tld->tld_whois_resp,
			"tldWhoisMatchRule"	=> $tld->tld_whois_match_rule,
			"tldActive"			=> $tld->tld_active,
			"tldAutoSearch"		=> $tld->tld_auto_search,
			"tldTransferMinimumCycleID" => $tld->tld_transfer_minimum_cycle_id,
			"tldMinimumCycleID"	=> $tld->tld_minimum_cycle_id,
			"tldMaximumCycleID"	=> $tld->tld_maximum_cycle_id,
			"tldRenewType"		=> $tld->tld_renew_type,
			"tldIsTransferable"	=> $tld->tld_is_transferable,
			"tldTransferType"	=> $tld->tld_transfer_type,
			"tldIDNSupport"		=> $tld->tld_idn_support,
			"tldIDNType"		=> $tld->tld_idn_type,
			"tldRemoteLockEnabled" => $tld->tld_remote_lock_enabled,
			"tldDisplayOrder"	=> $tld->tld_display_order,
		));

		$this->addTemplate("products/EditTLD");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
