<?php
require_once("lib-action/action.php");

class EditTLDResponse extends MB_Action
{
    public $params = array(
        "tldID",
        "tldName",
        "tldExtension",
        "tldCustomExtension",
        "tldCustomExtensionActive",
        "registrarID",
        "tldActive",
        "tldWhoisServer",
        "tldWhoisResp",
        "tldWhoisMatchRule",
        "tldAutoSearch",
        "tldTransferMinimumCycleID",
        "tldMinimumCycleID",
        "tldMaximumCycleID",
        "tldRenewType",
        "tldIsTransferable",
        "tldTransferType",
        "tldIDNSupport",
        "tldIDNType",
        "tldRemoteLockEnabled",
        "orderForms",
        "cycles",
    );

	public function execute()
    {
		parent::execute();
        if ('' == bgpc("tldWhoisResp")) {
            $_REQUEST["tldWhoisMatchRule"] = '';
        }
		if ((int)$_REQUEST["moveUpTldID"]){
			$tld = oneByID(":TLDs", (int)$_REQUEST["moveUpTldID"]);

			if ((int)$tld["tldDisplayOrder"]){
				$moveTo = oneOf(":TLDs", array(
					"tldDisplayOrderLessThan" => $tld["tldDisplayOrder"],
					"sortDir" => "DESC",
					"sortColumn" => "tldDisplayOrder",
					"numRecords" => 1,
				));

				if ($moveTo["tldID"]){
					if (updateForKey(":TLDs", $tld["tldID"], array(
						"tldDisplayOrder" => $moveTo["tldDisplayOrder"],
					))){
						updateForKey(":TLDs", $moveTo["tldID"], array(
							"tldDisplayOrder" => $tld["tldDisplayOrder"],
						));
					}
				}
			}
			redirect("products.php", "ShowTLDs");
		}
		if ((int)$_REQUEST["moveDownTldID"]){
			$tld = oneByID(":TLDs", (int)$_REQUEST["moveDownTldID"]);
			if ((int)$tld["tldDisplayOrder"]){
				$moveTo = oneOf(":TLDs", array(
					"tldDisplayOrderGreaterThan" => $tld["tldDisplayOrder"],
					"sortDir" => "ASC",
					"sortColumn" => "tldDisplayOrder",
					"numRecords" => 1,
				));
				if ($moveTo["tldID"]){
					if (updateForKey(":TLDs", $tld["tldID"], array(
						"tldDisplayOrder" => $moveTo["tldDisplayOrder"],
					))){
						updateForKey(":TLDs", $moveTo["tldID"], array(
							"tldDisplayOrder" => $tld["tldDisplayOrder"],
						));
					}
				}
			}
			redirect("products.php", "ShowTLDs");
		}

		$this->setReferralActionID(getActionID("EditTLD"));
		$this->setReferralActionFile("products.php");

        if (1 == bgpc("tldActive") && 0 == bgpc("registrarID")) {
            getCurrentSession()->Storage->errorMessages[] = blmsg("TRANS_TLD_ACTIVE_PARAM_ERROR_MSG");
            $redirectParams = array();
            foreach($this->params as $param) {
                $redirectParams[$param] = $_REQUEST[$param];
            }
            redirect("products.php", "EditTLD", $redirectParams);
        }
        $customTLDExtension = ('1' == bgpc("tldCustomExtensionActive"));
		$success = $this->validateMultiInputs(
			array(
                "tldID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
                "tldExtension" => !$customTLDExtension ? INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED : '',
                "tldCustomExtensionActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
                "tldCustomExtension" => $customTLDExtension ? INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED : '',
                "registrarID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
                "tldWhoisServer" => INPUT_RESTRICTION_STRING,
                "tldWhoisResp" => INPUT_RESTRICTION_STRING,
                "tldWhoisMatchRule" => INPUT_RESTRICTION_STRING,
                "tldAutoSearch" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
                "tldTransferMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldMaximumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldRenewType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldIsTransferable" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
                "tldTransferType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldIDNSupport" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
                "tldIDNType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
                "tldRemoteLockEnabled" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			),
			array(),
			array(),
			1
        );
		if($success) {
			$tldID = ((int) $_REQUEST["tldID"]);
			if(!$tldID) {
				$this->addError('TRANS_ACTIONERROR', "No TLD ID given.");
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}
			$tld = Factory()->Tld($tldID);
			$tld->registrar_id = (int)bgpc("registrarID");
			$tld->tld_extension = $customTLDExtension ? bgpc("tldCustomExtension") : bgpc("tldExtension");
			$tld->tld_name = bgpc("tldName");
			$tld->tld_whois_server = bgpc("tldWhoisServer");
			$tld->tld_whois_resp = bgpc("tldWhoisResp");
			$tld->tld_whois_match_rule = bgpc("tldWhoisMatchRule");
			$tld->tld_active = (int)bgpc("tldActive");
			$tld->tld_auto_search = (int)bgpc("tldAutoSearch");
			$tld->tld_transfer_minimum_cycle_id =(int) bgpc("tldTransferMinimumCycleID");
			$tld->tld_minimum_cycle_id = (int)bgpc("tldMinimumCycleID");
			$tld->tld_maximum_cycle_id = (int)bgpc("tldMaximumCycleID");
			$tld->tld_renew_type = (int)bgpc("tldRenewType");
			$tld->tld_is_transferable = (int)bgpc("tldIsTransferable");
			$tld->tld_transfer_type = (int)bgpc("tldTransferType");
			$tld->tld_idn_support = (int)bgpc("tldIDNSupport");
			$tld->tld_idn_type = (int)bgpc("tldIDNType");
			$tld->tld_remote_lock_enabled = (int)bgpc("tldRemoteLockEnabled");

            try {
                Service()->TldManager->update($tld);
            } catch (ProductException $e) {
                billing_put_error($e->getMessage());
                $this->validationRedirect(array(), array(), true);
            }

			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("products.php", getActionID("ShowTLDs"), array());
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
