<?php

require_once mb_path("/admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-billing/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * edit the prices for usage in each currency neccessary.
 *
 * @author  Kris Bailey
 */
class EditUsagePricing extends MB_ProductAction {
	/**
	 * The constructor for a EditUsagePricing action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditUsagePricing() {
		parent::MB_ProductAction("usage");
		$this->stringRep = "EditUsagePricing";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductOrderForms action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		$this->smartyVars["productID"] = $productID;
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No product ID given.");
		} else {
		 	$getUsagePriceXML = "
				<mbapi>
					<command>GetProductUsagePrices</command>
					<params>
						<productID>".$productID."</productID>
					</params>
				</mbapi>
		 		";
			$usagePriceData = dispatchMBAPI($getUsagePriceXML, 1);
			dbg("usage price data");
			dbg($usagePriceData);
			$usagePrices = array();
			if (isset($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"])){
				if(is_array($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"])) {
					foreach ($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"] as $row){
						$usagePrices[$row["currencyID"][0]] = $row["productUsagePriceAmount"][0];
					}
				}
			}
			$this->smartyVars["oldPrices"] = $usagePrices;
		 	$getProductXML = "
				<mbapi>
					<command>GetProducts</command>
					<params>
						<productID>".$productID."</productID>
						<getOrderFormData>1</getOrderFormData>
					</params>
				</mbapi>
		 		";
			$productInfo = dispatchMBAPI($getProductXML, 1);
			dbg("product info");
			dbg($productInfo);
			if (isset($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]["orderForms"][0]["orderForm"][0])){
				$this->smartyVars["product"] = correctArray($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]);
				$orderForms = collapseArrayElements($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]["orderForms"][0]["orderForm"]);
				if ((int)$orderForms["orderFormID"]){
				 	$orderForms = array($orderForms);
				}

				$makeFields = array();

				foreach ($orderForms as $row){
				 	$makeFields[] = $row["currencyID"];
				}
				$this->smartyVars["makeFields"] = $makeFields;

			}
			$this->smartyVars["helpRowSpan"] = count($this->smartyVars["makeFields"]);
			


			$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
				"productID" => $productID,
			));
			
			$this->setupTypeButtons($this->smartyVars["product"]["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();


			$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);

			$tmp[0] = preg_replace("/^¤#0.00/", "¤#,##0.00", $tmp[0]);
			$tmp[1] = preg_replace("/^¤#0.00/", "¤#,##0.00", $tmp[1]);
			$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
 			$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
			$this->smartyVars["numPrices"] = count($this->smartyVars["makeFields"]);
			dbg($this->smartyVars);
			$this->addTemplate("widgets/products/EditUsagePricing", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
