<?php
require_once("lib-action/action.php");

use Billing\Object\Plan;

class RemoveProduct extends MB_Action
{
    public $params = array("productID");

	public function execute()
    {
		parent::execute();
		$productID = getParam("productID");
		if(!$productID) {
			getCurrentSession()->Storage->errorMessages[] = blmsg("TRANS_PLAN_ERROR_REMOVE_EMPTY_ID");
			redirect("products.php", "ShowProducts");
		} else {
			$plan = Factory()->Plan($productID);
			if ($plan->getPackagesCount() > 0) {
				getCurrentSession()->Storage->errorMessages[] = blmsg("TRANS_PLAN_ERROR_REMOVE_SUBSCRIPTIONS_EXIST");
				redirect("products.php", "ShowProducts");
			}
			$query = $this->getMBAPIQuery("GetProducts", "", array());
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$this->smartyVars["product"] = collapseArrayElements($data["mbapi"][0]["results"][0]["products"][0]["product"][0]);
                    $this->smartyVars["types"] = blmsg_array(Plan::types());

					$this->addTemplate("products/RemoveProduct", $this->smartyVars);
				} else {
					$this->addError('TRANS_ACTIONERROR', "Product not found.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}