<?php
require_once 'lib-action/action.php';

class RemoveProductResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			billing_put_error(blmsg("TRANS_PLAN_ERROR_REMOVE_EMPTY_ID"));
			redirect("products.php", "ShowProducts");
		}
		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect('products.php', getActionID('RemoveProduct'), array('productID' => $productID));
		}

		$plan = Factory()->Plan($productID);
		$planName = $plan->product_name;
		$isResellerType = $plan->isResellerType();
		try {
            Service()->PlanManager->delete($plan);
        } catch (ProductException $e) {
			billing_put_error($e->getMessage());
            redirect("products.php", "ShowProducts");
        }
		billing_put_info(blmsg("TRANS_DELETE_PRODUCT_SUCCESS_MSG", array("NAME" => billing_safetyhtml($planName))));
		if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
			redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
		} else {
			redirect("products.php", getActionID("ShowProducts"), $isResellerType ? array('reseller' => 1) : array());
		}
	}
}