<?php

/**
 * This class is a child class of MB_Action. Using $_REQUEST["productID"] it displays all
 * the details for the found product, and only displays the details of a single product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowProductDetails extends MB_Action {
	/**
	 * The constructor for a ShowProductDetails object. This merely sets up our string represenation, calls 
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowProductDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowProductDetails";
		$this->params = array("productID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			$this->addError('TRANS_ACTIONERROR', "No Product ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetProducts", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$smartyVars = array();
					$smartyVars["product"] = 
						collapseArrayElements($data["mbapi"][0]["results"][0]
							["products"][0]["product"][0]);
					$this->addTemplate("products/ShowProductDetails", $smartyVars);
					
				} else {
					$this->addError('TRANS_ACTIONERROR', "Product does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowProductDetails
?>