<?php

class Products_CycleController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('products', 'ShowCycles');
	}

	public function editAction()
	{
		$cycle = Factory()->Cycle($this->_request->getParam('id'));      
		$this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_EDIT_CYCLE'));
        
        $form = new Billing_Zend_Form_Final_CycleForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'cycle' => $cycle     
        )));

        if ($this->_request->isPost() && $form->isValid($this->_request->getPost())) {
            try {
                $form->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->view->translate('TRANS_EDIT_CYCLE_SUCCESS_MSG'), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }

        $this->view->form = $form;
	}
    
    public function addAction()
	{
		$cycle = Factory()->Cycle();        
		$this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_ADD_CYCLE'));
        
        $form = new Billing_Zend_Form_Final_CycleForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'cycle' => $cycle     
        )));

        if ($this->_request->isPost() && $form->isValid($this->_request->getPost())) {
            try {
                $form->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->view->translate('TRANS_ADD_CYCLE_SUCCESS_MSG'), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }

        $this->view->form = $form;
	}
}