<?php

use Billing\Context;

class Resellers_ResellerController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('resellers', 'ShowResellers');
	}

	public function deleteAction()
	{
        $this->view->placeholder('pageTitle')->set($this->_translator->translate('TRANS_REMOVAL_CONFIRMAITON'));
        $ids = $this->getRequest()->getParam('id');
        $deleteForm = new Billing_Zend_Form_Final_ResellerForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'resellerIds' => $ids,
            'postData' => $this->_request->getPost(),
        )));
        if ($ids) {
            $this->_status->addWarning(blmsg('TRANS_DELETE_RESELLER_PAGE_DESCRIPTION'));
            if (Service()->Context->isMspPackage()) {
                if (Service()->ResellerManager->shouldResellersBeDeletedFromPanels($ids)) {
                    $this->_status->addWarning(blmsg('TRANS_DELETE_RESELLERS_TASKS_POA_MSG'));
                }
                if (Service()->SubscriptionManager->hasVendorsActiveSubscriptions($ids)) {
                    $this->_status->addWarning(blmsg('TRANS_DELETE_RESELLERS_ACTIVE_CUSTOMER_SUBSCRIPTIONS_MSG'));
                }
                if (Service()->SubscriptionManager->hasResellersActiveSubscriptions($ids)) {
                    $this->_status->addWarning(blmsg('TRANS_DELETE_RESELLERS_ACTIVE_SUBSCRIPTIONS_MSG'));
                }
            } else {
                if (Service()->ResellerManager->shouldResellersBeDeletedFromPanels($ids)) {
                    $this->_status->addWarning(blmsg('TRANS_DELETE_RESELLERS_TASKS_MSG'));
                }
            }
        }
        if ($this->_request->isPost() && $deleteForm->isValid($this->_request->getPost()))
        {
            try {
                $result = $deleteForm->processForm($this->_request->getPost());
                if ($result) {
                    $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_DELETE_RESELLERS_SUCCESS_MSG"), "info");
                }
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
        $this->view->form = $deleteForm;
    }
}