<?php

use Billing\Manager\SecurityManager;
use \Billing\Exception\FailOperationException;

class Security_ActionLogController extends Billing_Zend_Controller_Action_AdminController
{
    public function init()
    {
        parent::init();
        $this->_backUrl = $this->view->ActionUrl('security', 'ShowActionLog');
    }

    public function exportAction()
    {
        $conn = Service()->DatabaseManager->getConnection();
        $query = $conn->createQuery("SELECT * FROM `action_log`");
        $query->execute();
        
        $filename = "action-log-".date("Y-m-d");
   
        header("HTTP/1.1 200 OK");
        header('Content-Type: text/csv');
        header('Content-Disposition: attachment; filename="'.$filename.'.csv"');
        if (isset($_SERVER['HTTP_USER_AGENT']) and strpos($_SERVER['HTTP_USER_AGENT'],'MSIE')) {
            header('Content-Type: application/force-download');
        } else {
            header('Content-Type: application/octet-stream');
        }

        $csvFile = fopen('php://output', 'w');
        try {
            Service()->SecurityManager->exportActionLog($query, $csvFile);
        }
        catch(FailOperationException $e) {
            $this->_redirectWithMessage($this->_backUrl, $e->getMessage(), 'error');
        }
        fclose($csvFile);
        
        exit;
    }
}