<?php

class Security_LoginAttemptsController extends Billing_Zend_Controller_Action_AdminController
{
    public function unblockContactAction()
    {
        $contact = Factory()->Contact($this->getRequest()->getParam('id'));
        try{
            if ($contact->Customer->isReseller()) {
                Service()->SecurityManager->UnblockAdmin($contact->contact_username);
                $msg = 'TRANS_RESELLER_UNBLOCK_SUCCESS';
            } else {
                Service()->SecurityManager->UnblockContact($contact->contact_username);
                $msg = 'TRANS_CUSTOMER_UNBLOCK_SUCCESS';
            }
            $this->_redirectWithMessage($this->view->ActionUrl('clients', 'ShowClientDetails', array('clientID' => $contact->client_id)), 
                    $this->view->translate($msg, array('NAME' => billing_safetyhtml($contact->contact_fullname))), "info");
        } catch (ProductException $e) {
            $this->_status->addError($e->getMessage());
        }
    }
    
    public function unblockAdminAction()
    {
        $admin = Factory()->Admin($this->getRequest()->getParam('id'));
        try {
            Service()->SecurityManager->UnblockAdmin($admin->admin_username);
            $this->_redirectWithMessage($this->view->ActionUrl('admins', 'ShowAdminDetails', array('adminID' => $admin->id)),
                    $this->view->translate('TRANS_ADMIN_UNBLOCK_SUCCESS', array('NAME' => billing_safetyhtml($admin->fullName))), "info");
        } catch (ProductException $e) {
            $this->_status->addError($e->getMessage());
        }
    }
}