<?php

require_once("lib-action/action.php");

class AddServerGroupResponse extends MB_Action
{
	public $params = array(
		"serverGroupID",
		"serverGroupName",
		"serverGroupFillType",
	);

	public function execute()
	{
		parent::execute();

		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect("servergroups.php", "AddServerGroup");
		}

		$query = $this->getMBAPIQuery("SetServerGroups", "insert");
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);
		if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			billing_put_info(blmsg("TRANS_ADD_SERVER_GROUP_SUCCESS_MSG", array("NAME" => bgpc("serverGroupName"))));
			redirect("servergroups.php", getActionID("ShowServerGroups"));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}