<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/xml/xml.php");

class EditPanel extends MB_Action
{
	public $params = array("configGroupID");

	public function execute()
	{
		parent::execute();

		$configGroupID = ((int) $_REQUEST["configGroupID"]);
		if(!$configGroupID) {
			$this->addError('TRANS_ACTIONERROR', "No Config Group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetConfigs", "", array("getFormAttributes" => 1));
			$configGroupsData = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($configGroupsData) === 0) {

				$smartyVars = array();

				// setup this config group & its children groups & its params
				$smartyVars["configGroups"] = ($configGroupsData["mbapi"][0]["header"][0]["numResults"][0]==1) ?
					array(0=>$configGroupsResults["configGroups"][0]["configGroup"]) :
					$configGroupsResults["configGroups"][0]["configGroup"];

				// setup this group's config params
				$smartyVars["configParams"] = ($configParamData["mbapi"][0]["header"][0]["numResults"][0]==1) ?
					array(0=>$configParamDataResults["configs"][0]["config"]) :
					$configParamDataResults["configs"][0]["config"];
				$smartyVars["configParamValues"] = $configParamValues;

				$this->addTemplate("modules/EditPanel", collapseArrayElements($smartyVars), 1);

			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}