<?php
require_once ("lib-action/action.php");
require_once ("lib-mbapi/include/modules/panel/panel.php");

class EditServerGroup extends MB_Action
{
	public $params = array("serverGroupID", "serverGroupFillType");

	public function execute()
	{
		parent::execute();

		$serverGroupID = bgpc("serverGroupID");
		if(!$serverGroupID) {
			$this->addError('TRANS_ACTIONERROR', "No servergroup ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetServerGroups", "", array("getPanels" => 1));
			$data = dispatchMBAPI($query, 1);

			if(!$data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]["panels"][0]) {
				//Get list of files in modules/panel to build panel list
				// Only if a Panel isn't associated yet, otherwise, must keep the same Panel.
				$panels = getAvailableModules("panel");
				sort($panels);
				foreach ($panels as $panelClass => $panelFile) {
					require_once ("lib-mbapi/include/modules/panel/".$panelFile);
					$moduleInfo = call_user_func(array($panelClass, "getModuleInfo"));
					$smartyVars["panels"][$panelClass] = $moduleInfo["displayName"];
				}
			}
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();

				$smartyVars["panelSelectionOptions"] = Panel::getPanelSelectionOptions();
				foreach ($smartyVars["panelSelectionOptions"] as $k=>$v){
					$smartyVars["panelSelectionOptions"][$k] = blmsg($v);
				}
				$smartyVars["serverGroup"] = collapseArrayElements($data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]);
				$smartyVars["serverGroupFillType"] = Factory()->PanelGroup($serverGroupID)->server_group_fill_type;
                $this->smartyVars["buttons"] = array(
                    array('id' => 'billing-id-edit', 'class' => 'action', 'name' => 'edit', 'value' => "TRANS_EDIT_SERVER_GROUP", 'type' => 'submit', 'label' => 'TRANS_EDIT_SERVER_GROUP'),
                );
                $this->addTemplate("servers/EditServerGroup", $smartyVars, 1);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
