<?php

require_once("lib-action/action.php");

class RemovePanelResponse extends MB_Action
{
	public function execute()
	{
		if ( is_null($configGroupID = bgpc("configGroupID")) ) {
			throw new \Exception("Missing parameter 'configGroupID'");
		}
		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect("servergroups.php", "RemovePanel", array("configGroupID" => $configGroupID));
		}

		try {
			Service()->ControlPanelManager->delete(Factory()->ControlPanel($configGroupID), bgpc("panel_remove_forced"));
			redirect("servergroups.php", getActionID("ShowServerGroups"));
		} catch (\ProductException $e) {
			billing_put_error($e->getMessage());
			redirect("servergroups.php", "RemovePanel", array("configGroupID" => $configGroupID));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}