<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/xml/xml.php");

class RemoveServerGroup extends MB_Action
{
	public $params = array("serverGroupID");

	public function execute()
	{
		parent::execute();

		$serverGroupID = ((int) $_REQUEST["serverGroupID"]);
		if(!$serverGroupID) {
			$this->addError('TRANS_ACTIONERROR', "No ServerGroup ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetServerGroups");
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["serverGroup"] = collapseArrayElements($data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]);
                    $this->smartyVars["buttons"] = array(
                        array('id' => 'billing-id-remove', 'class' => 'action', 'name' => 'remove', 'value' => "TRANS_CONFIRM_REMOVE_SERVER_GROUP", 'type' => 'submit', 'label' => 'TRANS_CONFIRM_REMOVE_SERVER_GROUP'),
                        array('id' => 'billing-id-cancel', 'name' => 'cancel', 'value' => "TRANS_CANCEL", 'type' => 'button', 'label' => 'TRANS_CANCEL', 'onclick' => 'javascript: history.go(-1);'),
                    );
                    $this->addTemplate("servers/RemoveServerGroup", $s, 1);
				} else {
					$this->addError('TRANS_ACTIONERROR', "ServerGroup not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}