<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class RemoveServerGroupResponse extends MB_Action
{
	public $params = array("serverGroupID");

	public function execute()
	{
		parent::execute();

		$serverGroupID = bgpc("serverGroupID");
		if(!$serverGroupID) {
		    billing_put_error(blmsg("TRANS_SERVERGROUP_NO_ID_GIVEN_ERROR"));
		    redirect("servergroups.php", getActionID("ShowServerGroups"));
		}
		if (!getCurrentSession()->isValidToken()) {
		    billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
		    redirect("servergroups.php", "RemoveServerGroup", array("serverGroupID" => $serverGroupID));
		}
		$serverGroupName = Factory()->PanelGroup($serverGroupID)->server_group_name;
		$query = $this->getMBAPIQuery("SetServerGroups", "delete");
		$data = dispatchMBAPI($query, 1);
		if ($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
		    billing_put_info(blmsg("TRANS_REMOVE_SERVER_GROUP_SUCCESS_MSG", array("NAME" => billing_safetyhtml($serverGroupName))));
		    redirect("servergroups.php", getActionID("ShowServerGroups"));
		}
		
		return $this->hasExecutedSuccessfully();
	}
}