<?php
require_once("lib-action/action.php");
require_once("UI/Page/UIConfirmationGroupPage.php");

class RemoveIPLogPage extends UIConfirmationGroupPage
{
	protected function getObject($id)
	{
		return Factory()->IPLog($id);
	}

	protected function getObjectDisplayName($object)
	{
		return $object->ip;
	}

	protected function executeAction($id)
	{
		Factory()->IPLog($id)->delete();
	}
}

class RemoveIPLog extends MB_Action
{
	function execute()
	{
		parent::execute();

		$confirmation_page_strings = array (
			"title" => blmsg("TRANS_IP_LOG_REMOVE"),
			"list_title" => blmsg("TRANS_IP_LOG_CONFIRM_GROUP_REMOVAL"),
			"confirm_messages" => array( "confirm" => blmsg("TRANS_CONFIRM_REMOVAL"), "confirm_check" => blmsg("TRANS_CONFIRM_REMOVAL_MESSAGE")),
			"error_title" => blmsg("TRANS_APPROVED"),
			"successfully_processed_list_title" => blmsg("TRANS_IP_LOG_EMPTY_REMOVAL_LIST_TITLE"),
			"empty_processed_list_title" => blmsg("TRANS_IP_LOG_EMPTY_REMOVAL_LIST_TITLE"),
		);

		$parent_url = action_url("servers", "ShowIPLog", array("configGroupID" => bgpc("configGroupID")));
		$controller  = UIFactory()->PageController($parent_url);
		$page = $controller->addPage(new RemoveIPLogPage( $controller, $confirmation_page_strings ));
		$page->parent_title = blmsg("TRANS_LIST_IPLOG");
		$page->parent_url = $parent_url;
		$controller->setValue("id", bgpc("id"));
		$controller->processRequest();
		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");

		return $this->hasExecutedSuccessfully();
	}
}