<?php

require_once("lib-action/action.php");

use Billing\Manager\SsoManager;

class SyncSSO extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if ("msp" != PACKAGE_TYPE) {
			try {
				$syncTasks = Service()->SsoManager->getSSOServerSyncTasks();
				$syncTasks |= SsoManager::SYNC_NEED_REPAIR;
				Service()->SsoManager->setSSOServerSyncTasks($syncTasks);
				Service()->SsoManager->sync();
				if (is_null(Service()->SsoManager->getSSOServerSyncError())) {
					getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SYNC_SSO_SERVER_SUCCESS_MSG");
				} else {
					getCurrentSession()->Storage->errorMessages[] = blmsg(
						"TRANS_SYNC_SSO_SERVER_FAILURE_MSG", array("ERROR" => billing_safetyhtml(Service()->SsoManager->getSSOServerSyncError()))
					);
				}
			} catch (ProductException $e) {
				getCurrentSession()->Storage->errorMessages[] = blmsg(
					"TRANS_SYNC_SSO_SERVER_FAILURE_MSG", array("ERROR" => billing_safetyhtml($e->getMessage()))
				);
			}
		}
		redirect("dashboard.php", getActionID("ShowDashboard"));
	}
}
