<?php
require_once("lib-action/action.php");

class TaskList extends MB_Action
{
    public function execute()
    {
        parent::execute();

        $isPeriodicalTaskList = getCurrentSession()->isReseller() ? false : (bool)bgpc("isPeriodicalTaskList", false);

        $page  = UIFactory()->Page();
        $page->title = ($isPeriodicalTaskList) ? blmsg("TRANS_TASK_PERIODICAL_TASK_PAGE_TITLE") : blmsg("TRANS_TASK_PAGE_TITLE");

        $descPanel = UIFactory()->InputPanel(NULL, true);
        $pageDesc = UIFactory()->InputLabel();
        $pageDesc->value = ($isPeriodicalTaskList) ? blmsg("TRANS_TASK_PERIODICAL_TASK_PAGE_DESC") : blmsg("TRANS_TASK_PAGE_DESC");
        $descPanel->addInputControl($pageDesc);
        $page->addInputPanel($descPanel);

        require_once "UI/List/UITaskManagerTaskList.php";
        require_once "UI/List/UITaskManagerPeriodicalTaskList.php";
        $listClass = ($isPeriodicalTaskList) ? "UITaskManagerPeriodicalTaskList" : "UITaskManagerTaskList";
        $page->addListPanel(new $listClass());

		if (!getCurrentSession()->isReseller()) {
			require_once("UI/Tabs/UITaskListScreenTabs.php");
			$screenTabs = new UITaskListScreenTabs();
			$screenTabs->setCurrent(($isPeriodicalTaskList) ? "periodical" : "normal");
			$page->setScreenTabs($screenTabs);
		}

        $this->smartyVars["page"] = $page;
        $this->addTemplate("page");

        return $this->hasExecutedSuccessfully();
    }
}