<?php
require_once("lib-action/action.php");

class RemoveTaxZoneGroupResponse extends MB_Action
{
	function execute()
	{
		parent::execute();

		$taxZoneGroupID = ((int) $_REQUEST["taxZoneGroupID"]);
		if(!$taxZoneGroupID) {
			throw new ProductException(ProductException::E_FAIL_OPERATION, "No Tax Zone Group ID given.");
		}
		if (!getCurrentSession()->isValidToken()) {
			billing_put_error(blmsg("TRANS_ERROR_TOKEN"));
			redirect('taxes.php', getActionID("RemoveTaxZoneGroup"), array("taxZoneGroupID" => $taxZoneGroupID));
		}
		$taxPolicy = Factory()->TaxPolicy($taxZoneGroupID);
		$taxPolicyName = $taxPolicy->tax_zone_group_name;

		Service()->TaxPolicyManager->delete($taxPolicy);

		billing_put_info(blmsg("TRANS_DELETE_TAX_ZONE_GROUP_SUCCESS_MSG", array("NAME" => $taxPolicyName)));
		redirect("taxes.php", getActionID("ShowTaxZoneGroups"));
	}
}