<?php

class Tlds_TldController extends Billing_Zend_Controller_Action_AdminController
{
	public function removeAction()
	{
        $tld = Factory()->Tld($this->_request->getParam('id'));
        $backUrl = $this->view->ActionUrl("products", "ShowTLDs");
        
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_REMOVE'));
		$removeForm = new Billing_Zend_Form_Final_RemoveTldForm(array('context' => array(
			'cancelLink' => $backUrl,
			'tld' =>  $tld
		)));
		if ($this->_request->isPost() && $removeForm->isValid($this->_request->getPost())) {
            try {
                $tldName = $tld->tld_name;
                $removeForm->processForm();
                $this->_redirectWithMessage($backUrl, $this->_translator->translate("TRANS_REMOVE_TLD_SUCCESSFUL", array("NAME" => billing_safetyhtml($tldName))), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
		$this->view->form = $removeForm;
	}
}
 
