<?php
require_once ("lib-action/action.php");


class AddTodo extends MB_Action
{
	public function execute()
    {
		parent::execute();
		$this->smartyVars["todostatus"] = getStatuses("todo");
        $vendorId = getCurrentSession()->getVendorId();
        $this->setupDateSelector("todoDateDue");
        // Get Admins data for select menu
        $adminList = Factory()->AdminList(array("admin_active" => 1));
        if ($vendorId) {
            $this->_removeAllWithoutHimself($adminList, $vendorId);
        } else {
            $this->_removeAllResellers($adminList);
        }
        $this->mergeFormState();
        $this->addTemplate("todos/AddTodo");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

    private function _removeAllResellers($adminList)
    {
		foreach ($adminList as $admin) {
            if ($admin->isReseller()) {
                continue;
            }
            $this->smartyVars["adminsList"][$admin->id] = $admin->fullName . " - " . $admin->admin_username;
		}
    }

    private function _removeAllWithoutHimself($adminList, $vendorId)
    {
        foreach ($adminList as $admin) {
            $reseller = $admin->getReseller();
            if ($vendorId != $reseller->id) {
                continue;
            }
            $this->smartyVars["adminsList"][$admin->id] = $admin->fullName . " - " . $admin->admin_username;
        }
    }
}