<?php
require_once ("lib-action/action.php");

class AddTodoResponse extends MB_Action
{
    public $params = array(
        "todoTitle",
        "userID",
        "todoDesc",
        "todoStatusID",
        "todoDateDue",
        "todoAssignedAdminID",
        "todoIsPublic"
    );

	public function execute()
    {
		global $_REQUEST;
		parent::execute();
        
		$this->handleDateSelector("todoDateDue");
        $this->setReferralActionID(getActionID("AddTodo"));
        $this->setReferralActionFile("todos.php");
        $validate = array(
            "todoTitle" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
            "todoDesc" => INPUT_RESTRICTION_STRING,
            "todoStatusID" => INPUT_RESTRICTION_INT,
            "todoAssignedAdminID" => INPUT_RESTRICTION_INT,
            "todoIsPublic" => INPUT_RESTRICTION_STRING,
        );
        $this->validateMultiInputs($validate);

        $todo = Factory()->Todo();
        foreach ($this->params as $nameInput) {
            $attributeName = getDBCol($nameInput);
            if (isset($_REQUEST[$nameInput])) {
                $todo->$attributeName = $_REQUEST[$nameInput];
            } elseif ('todoIsPublic' == $nameInput) {
                $todo->$attributeName = false;
            }
        }
        $session = getCurrentSession();
        $todo->vendor_id = $session->getVendorId();
        $todo->user_id = $session->user_id;
        $todo->user_type = $session->user_type;
        
        $todo->update();
	billing_put_info(blmsg("TRANS_ADD_TODO_SUCCESS_MSG", array("TITLE" => billing_safetyhtml(bgpc("todoTitle")))));
        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
        } else {
            redirect("todos.php", getActionID("ShowTodoDetails"), array("todoID" => $todo->todo_id));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}