<?php
require_once ("lib-action/action.php");

class EditTodo extends MB_Action
{
	public $params = array("todoID");

	public function execute()
    {
		parent::execute();
		
		$todoID = bgpc("todoID");
		if(!$todoID) {
			$this->addError('TRANS_ACTIONERROR', "No todo ID given.");
		} else {
            $vendorId = getCurrentSession()->getVendorId();
            $todo = Factory()->TodoList(array('todo_id' => $todoID, 'vendor_id' => $vendorId));
			if (empty($todo[0])) {
                $this->addError('TRANS_ACTIONERROR', "Todo not found.");
            } else {
                $todo = $todo[0];
				$this->smartyVars["todostatus"] = getStatuses("todo");

				// Get Admins data for select menu
				$adminList = Factory()->AdminList(array("admin_active" => 1));
                if ($vendorId) {
                    $this->_removeAllWithoutHimself($adminList, $vendorId);
                } else {
                    $this->_removeAllResellers($adminList);
                }
                $todoArray = array();
                foreach ($todo->getFields() as $attributeName => $fieldValue) {
                    $oldAttributeName = getDBXMLCol($attributeName);
                    $todoArray[$oldAttributeName][0] = $todo->$attributeName;
                }
				$this->smartyVars["todo"] = correctArray( $todoArray );
				$this->formDefaults["todoDateDue"] = $this->smartyVars["todo"]["todoDateDue"];
				$this->setupDateSelector("todoDateDue");
				$this->mergeFormState($this->formDefaults + $this->smartyVars["todo"]);
 				$this->addTemplate("todos/EditTodo");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

    private function _removeAllResellers($adminList)
    {
		foreach ($adminList as $admin) {
            if ($admin->isReseller()) {
                continue;
            }
            $this->smartyVars["adminsList"][$admin->id] = $admin->fullName . " - " . $admin->admin_username;
		}
    }

    private function _removeAllWithoutHimself($adminList, $vendorId)
    {
        foreach ($adminList as $admin) {
            $reseller = $admin->getReseller();
            if ($vendorId != $reseller->id) {
                continue;
            }
            $this->smartyVars["adminsList"][$admin->id] = $admin->fullName . " - " . $admin->admin_username;
        }
    }
}