<?php
require_once ("lib-action/action.php");

class EditTodoResponse extends MB_Action
{
    public $params = array(
        "todoTitle",
        "todoDesc",
        "todoStatusID",
        "todoDateDue",
        "todoAssignedAdminID",
        "todoIsPublic"
    );

	public function execute()
    {
		parent::execute();
		$todoID = bgpc("todoID");
		if(!$todoID) {
			$this->addError('TRANS_ACTIONERROR', "No todo ID given.");
		} else {
			$this->handleDateSelector("todoDateDue");
            $validate = array(
                "todoTitle" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
                "todoDesc" => INPUT_RESTRICTION_STRING,
                "todoStatusID" => INPUT_RESTRICTION_INT,
                "todoAssignedAdminID" => INPUT_RESTRICTION_INT,
                "todoIsPublic" => INPUT_RESTRICTION_STRING,
            );
            $this->validateMultiInputs($validate, array(), array(), 1);
            $todo = Factory()->Todo($todoID);
            foreach ($this->params as $nameInput) {
                $attributeName = getDBCol($nameInput);

                if (isset($_REQUEST[$nameInput])) {
                    $todo->$attributeName = $_REQUEST[$nameInput];
                } elseif ('todoIsPublic' == $nameInput) {
                    $todo->$attributeName = false;
                }
            }
            
            $todo->update();
	    billing_put_info(blmsg("TRANS_EDIT_TODO_SUCCESS_MSG", array("TITLE" => billing_safetyhtml(bgpc("todoTitle")))));
    		redirect("todos.php", getActionID("ShowTodoDetails"), array("todoID" => $todoID));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

    protected function validationRedirect($extraArgs = array(), $referralArgs = array(), $force = false)
   	{
   		$this->setReferralActionFile("todos.php");
   		$this->setReferralActionID(getActionID("EditTodo"));
   		$extraArgs = array_merge($extraArgs, array("todoID" => bgpc("todoID")));
   		return parent::validationRedirect($extraArgs, $referralArgs, $force);
   	}
}