<?php
require_once ("lib-action/action.php");

class ShowTodoDetails extends MB_Action
{

    public $params = array("todoID");

	public function execute()
    {
		parent::execute();

		$todoID = bgpc("todoID");
		if(!$todoID) {
			$this->addError('TRANS_ACTIONERROR', "No Todo ID given.");
		} else {
            $todo = Factory()->TodoList(array('todo_id' => $todoID, 'vendor_id' => getCurrentSession()->getVendorId()));
			if (empty($todo[0])) {
                $this->addError('TRANS_ACTIONERROR', "Todo not found.");
            } else {
                $todo = $todo[0];
				$this->smartyVars["todostatus"] = getStatuses("todo");
                $todoArray = array();
                foreach ($todo->getFields() as $attributeName => $fieldValue) {
                    $oldAttributeName = getDBXMLCol($attributeName);
                    $todoArray[$oldAttributeName][0] = $todo->$attributeName;
                }
				$this->smartyVars["todo"] = correctArray( $todoArray );
                $this->smartyVars["todo"]["admin"] = Factory()->Admin($todo->user_id);
                if (null != $todo->todo_assigned_admin_id) {
                    $this->smartyVars["todo"]["assigned"] = Factory()->Admin($todo->todo_assigned_admin_id);
                }
                
                $this->addTemplate("todos/ShowTodoDetails");
			}
		}
		$this->addErrorTemplates();
        
		return $this->hasExecutedSuccessfully();
	}
}