#!/usr/bin/env php
<?php

/**
 * Make sure that you change this to point to the path of your common.php, after you move this file outside of a web
 * accessible directory. (Do not change lines that include { or }.)
 *
 * Example:  require_once "/home/myuser/public_html/modernbill/include/common.php";
 * Example:  require_once "C:\www\modernbill\include\common.php";
 */
if(!$CONF || $_REQUEST["CONF"]) {
	require_once "include/common.php";
}

/**
 * This file takes an email from STDIN and parses it, storing it where needed (usually in the helpdesk or something).
 *
 * @author  Vic Fryzel
 */
// Don't bother checking for valid fp, it's STDIN
$data = "";
while(!@feof(STDIN)) {
	$data .= @fread(STDIN, 1024);
}

if($data) {
	// Gather different pieces of data from this email
	$lines = explode("\n", $data);
	$foundBody = false;
	// We don't use the sender yet, but in the future we might need it.
	$subject = $sender = $body = "";
	foreach($lines as $line) {
		$matches = array();
		// Check the subject for
		if(preg_match("/^Subject:(.*)/i", $line, $matches)) {
			$subject = trim($matches[1]);
		} else if(preg_match("/^From:(.*)/i", $line, $matches)) {
			$sender = trim($matches[1]);
		} else if(!trim($line) && !$foundBody) {
			$foundBody = true;
			continue;
		}
		if($foundBody && !preg_match("/^>/")) {
			$body .= $line."\n";
		}
	}

	// Is this even a ticket?
	if(preg_match("/\[([a-z0-9]{5}\-[a-z0-9]{5})\]/i", $subject, $matches)) {
		$ticketKey = $matches[1];
		// Does this key match a ticket in the database?
		$cols = array(getDBCol("hdTicketID"), getDBCol("userID"), getDBCol("userType"));
		$h = new QueryMaster("select", "hd_tickets");
		foreach($cols as $col) {
			$h->addColumn($col);
		}
		$h->addAndClause(getDBCol("hdTicketKey"), "=", $ticketKey);
		$ticket = $h->getRow();
		$h = NULL;

		$xml = "
<mbapi>
 <command>GetHelpdeskTickets</command>
 <params><hdTicketKey>".$ticketKey."</hdTicketKey><numRecords>1</numRecords></params>
</mbapi>";
		$ticket = dispatchMBAPI($xml, 1);
		$ticket =& collapseArrayElements($ticket["mbapi"][0]["results"][0]["tickets"][0]["ticket"][0]);
		if(is_array($ticket) && count($ticket)) {
			$xml = "
<mbapi>
 <command>SetHelpdeskTicketResponse</command>
 <params>
  <hdTicketID>".$ticket["ticketID"]."</hdTicketID>
  <userID>".$ticket["userID"]."</userID>
  <userType>".$ticket["userType"]."</userType>
  <hdTicketRespDateCreated>".time()."</hdTicketRespDateCreated>
  <hdTicketRespBody>".secureInput($body)."</hdTicketRespBody>
 </params>
</mbapi>";
			dispatchMBAPI($xml);
		}
	}

	// Done
}