<?php
require_once("lib-action/action.php");

class ShowAffiliatePrograms extends MB_Action
{
	public function execute()
	{
		parent::execute();
        
        $contact = Factory()->Contact(getCurrentSession()->user_id);
        if ($contact->Customer->isReseller()) {
            billing_put_error(blmsg("TRANS_AFFILIATE_NOT_FOR_RESELLER_ERROR"));
            redirect(action_url("dashboard", "ShowDashboard"));
        }
        
        if (!$contact->Customer->is_affiliate) {
            billing_put_error(blmsg("TRANS_AFFILIATE_NOT_A_PARTNER_ERROR"));
            redirect(action_url("dashboard", "ShowDashboard"));
        }
        
        $page  = UIFactory()->Page();
        $page->title = blmsg("TRANS_MENU_CLIENT_OPERATIONS_AFFILIATE_STATUS");
        $page->description = blmsg("TRANS_MENU_CLIENT_OPERATIONS_AFFILIATE_STATUS_DESC");

        require_once("UI/List/UIAffiliateProgramList.php");
        $page->addListPanel(new UIAffiliateProgramList());

        $this->smartyVars["page"] = $page;
        $this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}