<?php
require_once ("lib-action/action.php");
require_once ("lib-billing/include/config/internal/certs.php");

class OrderCertContactRequestResponse extends MB_Action
{

		public $params = array(
            "certID",
            "ORGOrganizationName",
            "ORGDUNS",
            "ORGPhone",
            "ORGFax",
            "ORGAddressLine1",
            "ORGAddressLine2",
            "ORGAddressLine3",
            "ORGCity",
            "ORGRegion",
            "ORGPostalCode",

            "ACFirstName",
            "ACLastName",
            "ACPhone",
            "ACEmail",

            "orTechSameAsAdmin",
            "TCFirstName",
            "TCLastName",
            "TCPhone",
            "TCEmail",

            "orBillSameAsPrevious",
            "BCFirstName",
            "BCLastName",
            "BCPhone",
            "BCEmail"
            );

	public function execute()
    {
		parent::execute();

		$certID = (int)$_REQUEST["certID"];

		if (notZero( $certID )) {
			$this->setReferralActionID( getActionID("OrderCertContactRequest") );
			$this->setReferralActionFile( "certs.php" );
			
			/**
			 *	just a basic data check. The requirments for each cert type will be handled only
			 *	if the data can be validated successfully
			 */
			$success = $this->validateMultiInputs(
						array(
							"certID" =>  INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
							"ORGOrganizationName" => INPUT_RESTRICTION_STRING,
							"ORGDUNS" => INPUT_RESTRICTION_STRING,
							"ORGPhone" => INPUT_RESTRICTION_STRING,
							"ORGFax" => INPUT_RESTRICTION_STRING,
							"ORGAddressLine1" => INPUT_RESTRICTION_STRING,
							"ORGAddressLine2" => INPUT_RESTRICTION_STRING,
							"ORGAddressLine3" => INPUT_RESTRICTION_STRING,
							"ORGCity" => INPUT_RESTRICTION_STRING,
							"ORGRegion" => INPUT_RESTRICTION_STRING,
							"ORGPostalCode" => INPUT_RESTRICTION_STRING,
			
							"ACFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"ACLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"ACPhone" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"ACEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			
							"orTechSameAsAdmin" => INPUT_RESTRICTION_STRING,
							"orBillSameAsPrevious" => INPUT_RESTRICTION_STRING,
							), array(), array(), 0, array("certID" => $certID));
			if ($success) {
				/**
				 *	Real Tests need to begin here
				 */
				switch( $_REQUEST["orTechSameAsAdmin"] ) {
				case "new":
					$success = $this->validateMultiInputs(
								array(
									"TCFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
									"TCLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
									"TCPhone" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
									"TCEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED
									), array(), array(), 0, array("certID" => $certID));
				break;

				case "admin":
					$_REQUEST["TCFirstName"] = $_REQUEST["ACFirstName"];
					$_REQUEST["TCLastName"] = $_REQUEST["ACLastName"];
					$_REQUEST["TCPhone"] = $_REQUEST["ACPhone"];
					$_REQUEST["TCEmail"] = $_REQUEST["ACEmail"];
				break;
				}

				switch( $_REQUEST["orBillSameAsPrevious"] ) {
				case "new":
					$success = $this->validateMultiInputs(
								array(
									"BCFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
									"BCLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
									"BCPhone" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
									"BCEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED
									), array(), array(), 0, array("certID" => $certID));
				break;

				case "admin":
					$_REQUEST["BCFirstName"] = $_REQUEST["ACFirstName"];
					$_REQUEST["BCLastName"] = $_REQUEST["ACLastName"];
					$_REQUEST["BCPhone"] = $_REQUEST["ACPhone"];
					$_REQUEST["BCEmail"] = $_REQUEST["ACEmail"];
				break;

				case "tech":
					$_REQUEST["BCFirstName"] = $_REQUEST["TCFirstName"];
					$_REQUEST["BCLastName"] = $_REQUEST["TCLastName"];
					$_REQUEST["BCPhone"] = $_REQUEST["TCPhone"];
					$_REQUEST["BCEmail"] = $_REQUEST["TCEmail"];
				break;
				}

				$params = array();
				$this->applyRequestTo( $params );
				
				dbg( "############ Saving Cert Contact Information ################" );
				dbg( $params );
				
				$setQuery = new MBQuery( "SetCerts", "update", $params );

				if ($this->addErrorsFromResult( $r =& $setQuery->getResult() )) {
					redirect( "certs.php", "OrderCertOrderSummary", array("certID" => $certID) );
				} else {
					$this->addError( 'TRANS_ACTIONERROR', "Cert Update Failed to Record." );
				}
			}
		} else {
			$this->addError( 'TRANS_ACTIONERROR', "Cert ID not set" );
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}