<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all certs that match the given parameters, and
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowCerts extends MB_Action
{
	/**
	 * The constructor for a ShowCerts action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowCerts() {
		parent::MB_Action();
		$this->stringRep = "ShowCerts";
		$this->params = array(
			"certID",
			"packageID",
			"domainName",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
		$this->sortColumns = array("certID");
	}

	/**
	 * The main method of this class that executes the ShowCerts action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$query = $this->getMBAPIQuery("GetCerts", "", array("clientID"=>$CONF["user"]["id"]), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		dbg($data);

		$results = correctArray(grabSimpleMBAPIResults($data));
		dbg($results);
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["certs"] = $results["certs"];
			$smartyVars["paginationLinks"] = $results["paginationLinks"];

			$this->addTemplate("certs/ShowCerts", $smartyVars);

			$this->hasExecutedSuccessfully = 1;
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
