<?php
require_once ("lib-action/action.php");

class LogInToStore extends MB_Action
{
	public function execute()
    {
        $contact = Factory()->Contact(getCurrentSession()->user_id);

        if ($target = bgpc('target')) {
            $value = (is_null($guid = bgpc('subscriptionGuid', null))) ? bgpc('subscriptionExternalID'): $guid;

            $subscription = is_null($guid) ? Factory()->Subscription($value, 'external_id') : Factory()->Subscription($value, 'guid');

        	// prepare parameters for passing to store
			$parameters = $_GET;
			unset($parameters['ctr'], $parameters['act'], $parameters['redirect'], $parameters['subscriptionGuid'], $parameters['target'], $parameters['impContactId']);
			$parameters['subscription'] = $subscription->id;

        	switch ($target) {
        		case \Billing\Manager\StoreManager::TARGET_PURCHASE_CERTIFICATE:
	                foreach($parameters as $key => $value) {
	                    if (isset($this->_mapCertificateParams[$key])) {
	                        $parameters[$this->_mapCertificateParams[$key]]   = $value;
	                        unset($parameters[$key]);
	                    }
	                }
	                $parameters['planId'] = $subscription->product_id;
	                break;
        	}

            $url = Service()->ContactManager->getStoreUrl($contact, $subscription->Store, $target, $parameters);
        } else {
        	$url = Service()->ContactManager->getStoreUrl($contact);
        }
        redirect_url($url);
	}

	private $_mapCertificateParams = array(
        'dname' => 'commonName',
        'country' => 'countryName',
        'state' => 'stateOrProvinceName',
        'city' => 'localityName',
        'cname' => 'organizationName',
        'cuname' => 'organizationalUnitName',
        'email' => 'emailAddress',
    );
}