<?php
require_once ("lib-action/action.php");

class EditDomain extends MB_Action
{
    public $params = array("domainID");

	public function execute()
    {
		global $CONF;
		parent::execute();
		$domainID = blmsg("domainID");
		if(!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError('TRANS_ACTIONERROR', "No domain ID given.");
		} else {
			loadConfigs("domain");
			$registrarData = $CONF["domain"]["registrar"];
			$registrars = array();
			foreach($registrarData as $registrar => $attrs) {
				$registrars[0] = " ";
				if(isset($attrs['configGroupID'])) {
					$registrars[$attrs['configGroupID']] = $registrar;
				}
			}

			$query = $this->getMBAPIQuery("GetDomains", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["registrars"] = $registrars;
				$s["domain"] = collapseArrayElements($data["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
				$this->addTemplate("domains/EditDomain", $s);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
