<?php
require_once("lib-action/DomainAction.php");

class EditDomainAccessPasswordResponse extends DomainAction
{
	public function __construct()
	{
		parent::__construct();
		$this->params = array
		(
			"domainID",
			"domainAccessPassword1",
			"domainAccessPassword2",
		);
	}

	public function execute()
    {
		parent::execute();

		$domainAccessPassword1 = strval(trim($_REQUEST["domainAccessPassword1"]));
		$domainAccessPassword2 = strval(trim($_REQUEST["domainAccessPassword2"]));

		if(!$domainAccessPassword1 || !$domainAccessPassword2) {
			$this->redirectWithErrorMessage("Domain Access Password is Empty.");
		}
		if($domainAccessPassword1 != $domainAccessPassword2) {
			$this->redirectWithErrorMessage("Domain Access Passwords Do Not Match.");
		}

		$mbapiData = $this->getDomain();

		// fetching domain data from the registrar
		$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$xml = "
		<mbapi>
			<command>ProcessRegistrar</command>
			<subCommand>setDomainAccessPassword</subCommand>
			<showXMLHeader>0</showXMLHeader>
			<params>
				<subCommand>setDomainAccessPassword</subCommand>
				<configID>0</configID>
			    <vendorID>".getCurrentSession()->getVendorId()."</vendorID>
				<domainSLD>".$domainSLD."</domainSLD>
				<domainTLD>".$domainTLD."</domainTLD>
				<domainID>".$domainID."</domainID>
				<domainAccessPassword>".$domainAccessPassword1."</domainAccessPassword>
			</params>
		</mbapi>";
		$data = dispatchMBAPI($xml,1);
		$this->processRegistrarResponse($data);
		return $this->hasExecutedSuccessfully();

	}
}
