<?php
require_once("lib-action/DomainAction.php");

class EditDomainContactData extends DomainAction
{
	public function execute()
    {
		parent::execute();
	 	$mbapiData = $this->getDomain();
	 	// build XML for fetching domain data from the registrar
	 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$x = "
		<mbapi>
			<command>ProcessRegistrar</command>
			<subCommand>getDomainContactData</subCommand>
			<showXMLHeader>0</showXMLHeader>
			<params>
				<subCommand>getDomainContactData</subCommand>
				<configID>0</configID>
			    <vendorID>".getCurrentSession()->getVendorId()."</vendorID>
				<domainSLD>".$domainSLD."</domainSLD>
				<domainTLD>".$domainTLD."</domainTLD>
				<domainID>".$domainID."</domainID>
			</params>
		</mbapi>";

		$registrarData = dispatchMBAPI($x,1);
		$registrarResults =& $registrarData["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($registrarData) === 0) {

			$smartyVars = array();
			$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
			$smartyVars["domainData"] = collapseArrayElements($registrarResults["DomainData"]);
			$smartyVars["registrantContactData"] = collapseArrayElements($registrarResults["RegistrantContactData"]);
			$smartyVars["auxBillingContactData"] = collapseArrayElements($registrarResults["AuxBillingContactData"]);
			$smartyVars["techContactData"] = collapseArrayElements($registrarResults["TechContactData"]);
			$smartyVars["adminContactData"] = collapseArrayElements($registrarResults["AdminContactData"]);
			$smartyVars["billingContactData"] = collapseArrayElements($registrarResults["BillingContactData"]);

			$smartyVars["states"] = getStates("us");
			$smartyVars["countries"] = getCountries();
			$smartyVars["countryPhoneCodes"] = getCountryPhoneCodes();

			// if it say's none it's going to loop it as an array to populate the form later.
			foreach( (array)$smartyVars as $k => $v ) {
				if ($v == "None") {
					unset( $smartyVars[ $k ] );
				}
			}

			$this->addTemplate("domains/EditDomainContactData", collapseArrayElements($smartyVars));

		} else {
			$message = $this->createErrorReportMessage();
			$this->redirectWithErrorMessage($message);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} 
