<?php
require_once("lib-action/DomainAction.php");

class EditDomainRenewTypeOptions extends DomainAction
{
	public function execute()
    {
		parent::execute();
		$mbapiData = $this->getDomain();
		// build XML for fetching domain data from the registrar
		$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$x = "
		<mbapi>
			<command>ProcessRegistrar</command>
			<subCommand>getDomainRenewTypeOptions</subCommand>
			<showXMLHeader>0</showXMLHeader>
			<params>
				<subCommand>getDomainRenewTypeOptions</subCommand>
				<configID>0</configID>
			    <vendorID>".getCurrentSession()->getVendorId()."</vendorID>
				<domainSLD>".$domainSLD."</domainSLD>
				<domainTLD>".$domainTLD."</domainTLD>
				<domainID>".$domainID."</domainID>
			</params>
		</mbapi>";

		$registrarData = dispatchMBAPI($x,1);
		$registrarResults =& $registrarData["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($registrarData) === 0) {

			$smartyVars = array();
			$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
			$smartyVars["domainRenewType"] = collapseArrayElements($registrarResults["domainRenewType"]);
			$this->addTemplate("domains/EditDomainRenewTypeOptions", collapseArrayElements($smartyVars));

		} else {
			$message = $this->createErrorReportMessage();
			$this->redirectWithErrorMessage($message);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
