<?php
require_once ("lib-action/action.php");

class ShowDomainDetails extends MB_Action
{
	public $params = array("domainID");

	public function execute()
    {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError('TRANS_ACTIONERROR', "Invalid domain ID given. ($domainID)");
		} else {

			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",blmsg('TRANS_DOMAIN_PRODUCT'))));
			$data = dispatchMBAPI($query, 1);

			//Pull the registrar info
			$capabilities = array();
			$registrarName = NULL;
			$registrarID = $data["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["registrarID"][0];
			if($registrarID) {
				$registrarQuery = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $registrarID));
				$registrar = dispatchMBAPI($registrarQuery, 1);
				if($this->addMBAPIErrors($registrar) === 0 && !$this->getNumErrors()) {
					$registrarName = $registrar["mbapi"][0]["results"][0]["configs"][0]["config"][0]["configGroupName"][0];
				}
				if($registrarName) {
					try {
						require_once("ModuleTool.php");
						$r = ModuleTool::getModuleInstance("registrar", $registrarName);
						$registrarCapabilities = $r->getCapabilities();
						$capabilities["domainGetRenewDate"] = $registrarCapabilities[REGISTRAR_GETDOMAINRENEWDATE];
						//$capabilities[] = $registrarCapabilities[REGISTRAR_GETDOMAINCONTACTDATA];
						$capabilities["domainContact"] = $registrarCapabilities[REGISTRAR_SETDOMAINCONTACTDATA];
						//$capabilities[] = $registrarCapabilities[REGISTRAR_GETDOMAINRENEWTYPEOPTIONS];
						$capabilities["domainRenewType"] = $registrarCapabilities[REGISTRAR_SETDOMAINRENEWTYPEOPTIONS];
						//$capabilities[] = $registrarCapabilities[REGISTRAR_GETDOMAINREGISTRARLOCKOPTIONS];
						$capabilities["domainLock"] = $registrarCapabilities[REGISTRAR_SETDOMAINREGISTRARLOCKOPTIONS];
						//$capabilities[] = $registrarCapabilities[REGISTRAR_GETDOMAINACCESSPASSWORD];
						$capabilities["domainPassword"] = $registrarCapabilities[REGISTRAR_SETDOMAINACCESSPASSWORD];
						//$capabilities[] = $registrarCapabilities[REGISTRAR_GETDOMAINDNS];
						$capabilities["domainDNS"] = $registrarCapabilities[REGISTRAR_SETDOMAINDNS];
						$capabilities["domainLiveRenew"] = $registrarCapabilities[REGISTRAR_LIVERENEW];
						$capabilities["domainUploadDocuments"] = $registrarCapabilities[REGISTRAR_UPLOADDOCUMENTS];
					} catch (ProductException $e) {
						if ($e->getCode() != ProductException::E_MODULE_NOT_FOUND) {
							throw $e;
						}
					}
				}
			}

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$registrarID = (int) $data["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["registrarID"][0];
                    $registrar = Factory()->Registrar(array($registrarID, getCurrentSession()->getVendorId()));
					//Find the domain management settings for this registrar
                    $rules = array();
                    foreach ($registrar->ConfigParams as $configParam) {
                        $rules[$configParam->name] = $configParam->value;
                    }
					$smartyVars = array();
					$smartyVars["capabilities"] = $capabilities;
					$smartyVars["rules"] = $rules;
					$smartyVars["domain"] = collapseArrayElements($data["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);

					$this->addTemplate("domains/ShowDomainDetails", $smartyVars);
				} else {
					$this->addError('TRANS_ACTIONERROR', "Domain does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
