<?php
require_once ("lib-action/action.php");

use Billing\Manager\CryptManager;
use Billing\Object\Customer;

class ForgottenPasswordResponse extends MB_Action
{
	public $params = array("contactEmail", "adminRemoteAccessHash");

	public function execute()
    {
		parent::execute();
        $success = \Billing\Checker::emailAddress($email = bgpc('contactEmail'));

		if ( !$success ) {
            redirect("login.php", "ShowForgottenPassword", array("msg"=>"TRANS_INCORRECT_EMAIL"));
        }

        $contact = reset(Factory()->ContactList(array('contact_email' => $email, 'contact_active' => 1)));
        if ( empty($contact) ) {
            redirect("login.php", "ShowForgottenPassword", array("msg"=>"TRANS_EMAIL_NOT_FOUND"));
        }
        if ( !$contact->isActive() ) {
            redirect("login.php", "ShowForgottenPassword", array("msg"=>"TRANS_CUSTOMER_IS_NOT_ACTIVE"));
        }

        // generate the new password
        $newPass = getRandomPassword();
        if ("msp" == PACKAGE_TYPE) {
            $contact->contact_password = Service()->CryptManager->getPasswordHash($newPass);
            $contact->plainPassword = $newPass;
            $contact->contact_password_type = CryptManager::TYPE_CRYPT;
        } else {
            $contact->contact_temp_password = Service()->CryptManager->getPasswordHash($newPass);
        }
        Service()->ContactManager->update($contact);

        require_once ("lib-mbapi/include/mail/emailTemplates/passwordNotificationEmail.php");
        $email = new PasswordNotificationEmail( $newPass, (int)$contact->id );

        dbg("Email going out");
        dbg($email);

        if (!$email->execute()) {
            $this->addError('TRANS_ACTIONERROR', "Failed to send email");
        } else {
			redirect('login.php', 'ShowForgottenPassword', array('info_msg' => 'TRANS_PASSWORD_RESET'));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
