<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class LoginResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();
		$query = $this->getMBAPIQuery("ProcessClientLogin", "",	array(
			"clientIP" => $CONF["user"]["ip"],
			"contactUsername" => bgpc("user_name"),
			"contactPassword" => bgpc("user_password"),
		));
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

			$client_id = is_array($data["mbapi"][0]["results"][0]["clientID"]) ? $data["mbapi"][0]["results"][0]["clientID"][0] : NULL;
			if (! is_null($client_id) && Factory()->Customer($client_id)->isActive()) {
				$session = Factory()->Session($data["mbapi"][0]["results"][0]["sessionID"][0]);
                setSidByCookie($session->id, $session->session_date_expired);

				// Allow expired users to resume a new session from where their last one left off
				if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					if(preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])) {
						redirect($_REQUEST["redirectActionFile"]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
					}
				} else {
					redirect("dashboard.php", getActionID("ShowDashboard"));
				}
			} else {
				if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					redirect("login.php",getActionID("ShowLogin"), array(
						"msg" => "TRANS_AUTH_FAILED",
						"redirectActionID" => $_REQUEST['redirectActionID'],
						"redirectActionFile" => $_REQUEST['redirectActionFile'],
						"redirectArgs" => $_REQUEST['redirectArgs'],
					));
				} else {
					redirect("login.php",getActionID("ShowLogin"), array("msg" => "TRANS_AUTH_FAILED"));
				}
			}
		} else {
			$msg = "";
			$separator = "";
			foreach ($data["mbapi"][0]["header"][0]["errors"][0]["error"] as $error) {
				$msg .= $separator.blmsg($error["title"][0]);
				$separator = "\n";
			}
			$params = array("msg" => $msg);
			redirect("login.php",getActionID("ShowLogin"), $params);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
