<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all news that match the given parameters, and
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowNews extends MB_Action
{
	/**
	 * The constructor for a ShowNews action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowNews() {
		parent::MB_Action();
		$this->stringRep = "ShowNews";
		$this->params = array(
			"newsID",
			"newsGroupID",
			"clientID",
			"clientGroupID",
			"adminID",
			"newsSubject",
			"newsShortBody",
			"newsBody",
			"newsDateCreatedLessThan",
			"newsDateCreated",
			"newsDateCreatedGreaterThan",
			"newsActive",
			"newsPriority",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
		$this->sortColumns = array("newsID");
	}

	/**
	 * The main method of this class that executes the ShowNews action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$query = $this->getMBAPIQuery("GetNews", "", array(), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["news"] = $results["news"][0]["news"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$smartyVars["news"] = array(0 => $results["news"][0]["news"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			$this->addTemplate("ShowNews", collapseArrayElements($smartyVars));

			$this->hasExecutedSuccessfully = 1;
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}