<?php

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-billing/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class CancelPackage extends MB_Action {
	/**
	 * The constructor for a CancelPackage action object.
	 */
	function CancelPackage() {
		parent::MB_Action();
		$this->stringRep = "CancelPackage";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the CancelPackage action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {

		parent::execute();
		global $CONF;
		$this->smartyVars["package"] = grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
					)
				)
			)
		);


		$this->smartyVars["packageStatuses"] = getStatuses("package");
		$this->smartyVars["cycles"] = getCyclesArray();

		if (!(int)$this->smartyVars["package"]["packageID"]){
			$this->addError('TRANS_ACTIONERROR', "Invalid Package ID Provided.");
			$this->hasExecutedSuccessfully = 0;
		} else {


			if ($this->smartyVars["package"]["packageDateNextRenewal"]<time()){
				$this->smartyVars["immediately"] = 1;
			} else {
				$this->smartyVars["immediately"] = 0;
			}


			$this->addTemplate("packages/CancelPackage", $this->smartyVars);

			$this->hasExecutedSuccessfully = 1;

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CancelPackage
?>
