<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-billing/include/config/internal/cycles.php");

use Billing\Object\Subscription;

class CancelPackageResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		$this->smartyVars["package"] = grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
					)
				)
			)
		);

		dbg("got package, going in");
		if (!(int)$this->smartyVars["package"]["packageID"] || $this->smartyVars["package"]["packageCancellationType"]==getAPITypeID("cancellation", "admin_delete") || $this->smartyVars["package"]["packageCancellationType"]==getAPITypeID("cancellation", "admin_suspend")){
			$this->addError('TRANS_ACTIONERROR', "Invalid Package ID Provided.");
			$this->hasExecutedSuccessfully = 0;
		} else {
			dbg("got past error checking");
			if (Subscription::PENDING_CANCELLATION_TYPE_NO == $this->smartyVars["package"]["packagePendingCancellation"] && $_REQUEST["desiredAction"] == "cancel"){
				dbg("got into cancellation area");
                $statusReason = blmsg('TRANS_SUBSCRIPTION_CANCEL_REASON_PENDING', array('DATE' => BillingLocale::getDateMedium($this->smartyVars["package"]["packageDateNextRenewal"])));
				$query = new MBQuery("SetPackages", "update", array("packageID" => $this->smartyVars["package"]["packageID"], "packagePendingCancellation" => Subscription::PENDING_CANCELLATION_TYPE_CUSTOMER,
                    "packageStatusReason" => $statusReason, "packageCustomerStatusReason" => $statusReason));
				dbg(dispatchMBAPI($query->getXMLQuery()));
                billing_put_info(blmsg('TRANS_SUBSCRIPTION_OPERATION_CANCEL_SUCCESS_MSG', array("DATE" => BillingLocale::getDateMedium($this->smartyVars["package"]["packageDateNextRenewal"]))));
			} elseif (Subscription::PENDING_CANCELLATION_TYPE_CUSTOMER == $this->smartyVars["package"]["packagePendingCancellation"] && $_REQUEST["desiredAction"]=="uncancel"){
                $statusReason = blmsg("TRANS_SUBSCRIPTION_CANCEL_REASON_WITHDRAW");
				$query = new MBQuery("SetPackages", "update", array("packageID" => $this->smartyVars["package"]["packageID"], "packagePendingCancellation" => Subscription::PENDING_CANCELLATION_TYPE_NO,
                    "packageStatusReason" => $statusReason, "packageCustomerStatusReason" => $statusReason));
				dispatchMBAPI($query->getXMLQuery());
                billing_put_info(blmsg('TRANS_SUBSCRIPTION_OPERATION_WITHDRAW_CANCELLATION_SUCCESS_MSG'));
			} else if (Subscription::PENDING_CANCELLATION_TYPE_UPGRADE == $this->smartyVars["package"]["packagePendingCancellation"] && $_REQUEST["desiredAction"] == "cancel") {
				try {
                    $subscription = Factory()->Subscription($this->smartyVars["package"]["packageID"]);
					Service()->SubscriptionManager->cancelUpgrade($subscription);
					billing_put_info(blmsg('TRANS_SUBSCRIPTION_OPERATION_CANCEL_UPGRADE_DOWNGRADE_SUCCESS_MSG'));
				} catch (ProductException $e) {
					billing_put_error($e->getMessage());
				}
			}
			redirect("packages.php?action=".getActionID("ShowPackages"));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
