<?php

exit;

require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-billing/include/config/internal/cycles.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all packages that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class EditPackageAddons extends MB_Action {
	/**
	 * The constructor for a EditPackageAddons action object.
	 */
	function EditPackageAddons() {
		parent::MB_Action();
		$this->stringRep = "EditPackageAddons";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the EditPackageAddons action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

			
		$this->smartyVars["package"] = correctArray(grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
					)
				)
			)
		));
		
		$this->smartyVars["selectedAddons"] = correctArray(grabResultsFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackageAddons",
					"params" => array(
						"packageID" => (int)$_REQUEST["packageID"],
						"getProductInfo" => 1,
						"getPackageAddonAttributes" => 1, 
					)
				)
			)
		));


		$this->smartyVars["packageStatuses"] = getStatuses("package");
		$this->smartyVars["cycles"] = getCyclesArray();

		if (!(int)$this->smartyVars["package"]["packageID"]){
			$this->addError('TRANS_ACTIONERROR', "Invalid Package ID Provided.");
			$this->hasExecutedSuccessfully = 0;
		} else {

			if ($this->smartyVars["package"]["packageDateNextRenewal"]<time()){
				$this->smartyVars["immediately"] = 1;
			} else {
				$this->smartyVars["immediately"] = 0;
			}


			$this->addTemplate("packages/EditPackageAddons", $this->smartyVars);

			$this->hasExecutedSuccessfully = 1;

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CancelPackage
?>
