<?php

require_once("lib-action/action.php");
require_once("lib-billing/include/config/internal/cycles.php");
require_once("lib-mbapi/mbapi.php");

class PerformPanelAction extends MB_Action
{
	public function execute()
	{
		global $CONF;
		$packages = collapsePluralsAndSingulars(grabResultsFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetPackages",
					"params" => array(
						"clientID" => $CONF["user"]["id"],
						"packageID" => (int)$_REQUEST["packageID"],
						"getDomainData" => 1,
						"getPackageAttributeData" => 1,
						"getPackageAddonData" => 1,
						"suppressFeePackages" => $suppressFeePackages,
					)
				)
			)
		));
		$package =& $packages[0];

		$serverGroups = array();

		$keyedAttributes = array();
		$serverGroups = array();
		foreach ((array)$package["packageAttributes"] as $attribute){
			$serverGroups[$attribute["serverGroupID"]] = $attribute["configGroupID"];
			$keyedAttributes[$attribute["serverGroupID"]][$attribute["packageAttributeName"]] = $attribute;
		}

		foreach ((array)$serverGroups as $serverGroupID=>$configGroupID){
			if ($_REQUEST["serverGroupID"]==$serverGroupID){
				$controlPanel = reset(Factory()->PanelGroup($serverGroupID)->ControlPanelList());
				if (false == $controlPanel) {
					return false;
				}
				$panel = $controlPanel->module_name;

				$panelFile = strtolower($panel);
				if ($panel && file_exists(mb_path("/lib-mbapi/include/modules/panel/$panelFile.php"))){
					require_once mb_path("/lib-mbapi/include/modules/panel/$panelFile.php");
					$params = array("subCommand" => "panelDummy", "configGroupID" => $configGroupID);
					$panelObj = new $panel($params);
					$actionResults = $panelObj->handlePerformPanelActions($package["packageID"], $serverGroupID, $configGroupID, $_REQUEST);
				}
				$this->smartyVars["serverGroupID"] = $serverGroupID;
				$this->smartyVars["configGroupID"] = $configGroupID;
				break;
			}
		}

		$this->smartyVars["packageInfo"] = $package;
		$this->smartyVars["actionTemplate"] = $actionResults[0];
		$this->smartyVars["actionTemplateData"] = $actionResults[1];

		$this->addTemplate("packages/PerformPanelAction", $this->smartyVars);

		$this->hasExecutedSuccessfully = 1;

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}