<?php

require_once("admin/include/lib-action/packages/UpgradeDowngradeActionResponse.php");

class UpgradePackageResponse extends UpgradeDowngradeActionResponse
{
	public function __construct()
	{
        parent::__construct();
		global $CONF;
		loadConfigs("product", "managementrules");
        $this->_feeNames = blmsg_array(
            array(
                "proratedXFee" => 'TRANS_PRORATED_UPGRADE_FEE',
                "itemizedXCredits" => 'TRANS_ITEMIZED_UPGRADE_CREDITS',
                "packageX" => 'TRANS_PACKAGE_UPGRADE',
                "packageXDesc" => 'TRANS_PACKAGE_UPGRADE_DESC',
                "xFee" => 'TRANS_UPGRADE_FEE',
            )
        );
		$this->subCommand = "panelUpgrade";
		$this->params = array("packageID");

		$clientID = $CONF["user"]["id"];

		$rules = Factory()->ConfigGroup(0)->getChild("product")->getChild("managementrules")->ConfigParams;
		$_REQUEST["packageUpgradeDowngradeType"] = (0 == $rules["whenUpgrade"]->value)
            ? (1 == $rules["applyUpgradeCredits"]->value
                ? self::INSTANT_UPGRADE_DOWNGRADE_WITH_PRORATION
                : self::INSTANT_UPGRADE_DOWNGRADE_WITHOUT_PRORATION)
            : self::DFFERED_UPGRADE_DOWNGRADE;
		$_REQUEST["packageProvision"] = $rules["provisionUpgrades"]->value;

		$_REQUEST["packagePrices"] = array(
			"original" => 0,
			"general" => 0,
			"fee" => 0,
			"coupon" => 0,
			"couponcycles" => 0,
		);

		$params = array(
			"packageID" => (int)$_REQUEST["packageID"],
			"getPackageAttributeData" => 1,
			"getPackageDatabaseData" => 1,
			"getDomainData" => 1,
			"getCertData" => 1,
			"getPackageAddonData" => 1,
		);
		if (0 != $clientID) {
			$params["clientID"] = $clientID;
		}
		$this->packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => $params,
			),
		)));

		$this->packageInfoCache[(int)$_REQUEST["packageID"]] =& $this->packageInfo;
		$packageInfo =& $this->packageInfo;
		if (!$packageInfo["packageID"]){
			$this->addError('TRANS_ACTIONERROR', "Invalid packageID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		}

		$currencyID = Factory()->Subscription($packageInfo["packageID"])->Store->currency_id;
		$productInfo = oneOf("products", array(
			"productID" => (int)$_REQUEST["productID"],
			"productActive" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getCycleData" => 1,
		));
		$prices = array();
		if (!$productInfo["productID"]){
			$this->addError('TRANS_ACTIONERROR', "Invalid productID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		}

        foreach ($productInfo["productVariantPrices"] as $p){
            if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$currencyID && $p["productVariantID"]==(int)$_REQUEST["productVariantID"]){
                $prices[$p["productVariantPriceType"]] = $p;
            }
        }
        $_REQUEST["packagePrices"] = array(
            "original" => BillingLocale::setNumberToInput($prices[0]["productVariantPriceAmount"]),
            "general" => BillingLocale::setNumberToInput($prices[0]["productVariantPriceAmount"]),
            "fee" => BillingLocale::setNumberToInput($prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"]),
        );

        $this->_setUnassignedAddonsPrices($packageInfo, $productInfo, $currencyID);
	}
}
