<?php

use Billing\Object\Subscription;

class Packages_ActionController extends Billing_Zend_Controller_Action_AdminController
{
    public function renewAction()
    {
        $subscriptionId = $this->_request->getParam('id');
        $subscription = Factory()->Subscription($subscriptionId);
        $backUrl = $this->view->ActionUrl('packages', 'ShowPackageDetails', array("packageID" => $subscriptionId));
        
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_SUBSCRIPTION_OPERATION_RENEW'));

        $renewForm = new Billing_Zend_Form_Final_PackageActionRenewForm(array('context' => array(
            'cancelLink' => $backUrl,
            'subscription' =>  $subscription
        )));

        if ($this->_request->isPost() && $renewForm->isValid($this->_request->getPost())) {
            try {
                $renewForm->processForm();
                $this->_redirectWithMessage($backUrl, $this->_translator->translate('TRANS_SUBSCRIPTION_OPERATION_RENEW_SUCCESS_MSG'));
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
        $this->view->form = $renewForm;
    }
}