<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a client so that that the client may be modified in the
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditClient extends MB_Action
{
	/**
	 * The constructor for a EditClient action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditClient() {
		parent::MB_Action();
		$this->stringRep = "EditClient";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the EditClient action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 1;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$query = $this->getMBAPIQuery("GetClients", "", array("clientID"=>$CONF["user"]["id"]));
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$s = array();
			$s["client"] = collapseArrayElements($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]);
			$this->addTemplate("EditClient", $s);
			$this->hasExecutedSuccessfully = 1;
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}