<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditClient action, applies that information to
 * records in the database, and redirects to the ShowClientDetails action for the given client.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditClientResponse extends MB_Action
{
	/**
	 * The constructor for an EditClientResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditClientResponse() {
		parent::MB_Action();
		$this->stringRep = "EditClientResponse";
		$this->params = array(
			"domainID",
			"packageID",
			"invoiceID",
			"certID",
			"creditID",
			"clientContactID",
			"billingID",
			"clientFirstName",
			"clientLastName",
			"clientEmail",
			"clientCompany",
			"clientAddress",
			"clientAddress2",
			"clientCity",
			"clientState",
			"clientZip",
// 			"countriesID", // don't want users able to modify their country
			"clientPhone",
			"clientPhone2",
			"billingMethod",
			"billingCCType",
			"clientComments",
			"clientDateCreated",
			"contactUsername",
			"currencyID",
			"languageID",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
	}

	/**
	 * The main method of this class that executes the EditClientResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 1;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$query = $this->getMBAPIQuery("SetClients", "update", array("clientID"=>$CONF["user"]["id"]));
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$this->hasExecutedSuccessfully = 1;
			mbHeader("Location: profile.php?action=".getActionID("ShowClientDetails"));
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}