<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["clientContactID"] it displays all
 * the details for the found clientcontact, and only displays the details of a single clientcontact.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowClientContactDetails extends MB_Action
{
	/**
	 * The constructor for a ShowClientContactDetails object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowClientContactDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowClientContactDetails";
		$this->params = array("clientContactID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		// Default to failure, only set this to 1 if we're successful
		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$clientContactID = ((int) $_REQUEST["clientContactID"]);
		if(!$clientContactID) {
			$this->addError('TRANS_ACTIONERROR', "No contact ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetClients", "", array("clientID"=>$CONF["user"]["id"]));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$smartyVars = array();
					$smartyVars["contact"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]
							["contacts"][0]["contact"][0]);
					$this->addTemplate("ShowClientContactDetails", $smartyVars);
					$this->hasExecutedSuccessfully = 1;
				} else {
					$this->addError('TRANS_ACTIONERROR', "Contact does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}