<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["clientID"] it displays all
 * the details for the found client, and only displays the details of a single client.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowClientDetails extends MB_Action
{
	/**
	 * The constructor for a ShowClientDetails object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowClientDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowClientDetails";
		$this->params = array();
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		// Default to failure, only set this to 1 if we're successful
		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$query = $this->getMBAPIQuery("GetClients", "", array("clientID"=>$CONF["user"]["id"]));
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
				$smartyVars = array();
				$smartyVars["client"] =
					collapseArrayElements($data["mbapi"][0]["results"][0]
						["clients"][0]["client"][0]);

				$this->addTemplate("ShowClientDetails", $smartyVars);
				$this->hasExecutedSuccessfully = 1;
			} else {
				$this->addError('TRANS_ACTIONERROR', "Client does not exist.");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}