<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all clients that match the given parameters, and
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowClients extends MB_Action
{
	/**
	 * The constructor for a ShowClients action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowClients() {
		parent::MB_Action();
		$this->stringRep = "ShowClients";
		$this->params = array(
			"domainID",
			"packageID",
			"invoiceID",
			"certID",
			"creditID",
			"clientContactID",
			"billingID",
			"clientFirstName",
			"clientLastName",
			"clientEmail",
			"clientCompany",
			"clientAddress",
			"clientAddress2",
			"clientCity",
			"clientState",
			"clientZip",
			"countriesID",
			"clientPhone",
			"clientPhone2",
			"billingMethod",
			"billingCCType",
			"clientComments",
			"clientDateCreated",
			"contactUsername",
			"currencyID",
			"languageID",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
		$this->sortColumns = array("");
	}

	/**
	 * The main method of this class that executes the ShowClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = time();

		$query = $this->getMBAPIQuery("GetClients", "", array("clientID"=>$CONF["user"]["id"]), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["clients"] = $results["clients"][0]["client"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$smartyVars["clients"] = array(0 => $results["clients"][0]["client"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			$this->addTemplate("ShowClients", collapseArrayElements($smartyVars));

			$this->hasExecutedSuccessfully = 1;
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}