<?php

/**
 * This Action object takes information provided by the EditClient action, applies that information to
 * records in the database, and redirects to the ShowClientDetails action for the given client.
 *
 * @author  Kris Bailey
 */
class ShowSellerStatus extends MB_Action {
	/**
	 * The constructor for an ShowSellerStatus action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function ShowSellerStatus() {
		parent::MB_Action();
		$this->stringRep = "ShowSellerStatus";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowSellerStatus action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->smartyVars["sellerInfo"] = oneOf("marketplaceSellers", array(
			"clientID" => $CONF["user"]["id"],
		));

		$this->addTemplate("sellers/ShowSellerStatus", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowSellerStatus
?>