<?php

/**
 * Connects to an api url and tests it.
 *
 * @author  Kris Bailey
 */
class TestSellerApiURL extends MB_Action {
	function TestSellerApiURL() {
		parent::MB_Action();
		$this->stringRep = "TestSellerApiURL";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowClients action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$sellerInfo = oneOf("marketplaceSellers", array(
			"clientID" => $CONF["user"]["id"],
		));
		dbg($sellerInfo);

		if ($_REQUEST["sellerApiURL"]){
			$results = runActionAPICommand($_REQUEST["sellerApiURL"], "getCompanyInformation", array(
				"adminUsername" => ($_REQUEST["sellerUsername"])?$_REQUEST["sellerUsername"]:$sellerInfo["sellerUsername"],
				"adminPassword" => ($_REQUEST["sellerPassword"])?$_REQUEST["sellerPassword"]:getStuff($sellerInfo["sellerPassword"]),
			));
			dbg($results);
			if ($results["api"][0]["header"][0]["errors"][0]["title"][0]=="1001"){
				echo "login<|>";
			} elseif ($results["api"][0]["header"][0]["errors"][0]["title"][0]=="1000"){
				echo "invalid<|>";
			} else {
				echo $results["api"][0]["results"][0]["company"][0]["companyName"][0]."<|>".$results["api"][0]["results"][0]["company"][0]["companyURL"][0];
			}
			flush();
			exit;
		} else {
			echo "invalid<|>";
			flush();
			exit;
		}
		
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowClients
?>