<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty constant modifier plugin
 *
 * Type:     modifier<br>
 * Name:     constant<br>
 * Purpose:  checks to see if sting is a constant and returns the value of that constant
 * @param string
 * @return string
 */
function smarty_modifier_constant($string)
{
	if (strpos($string, "::")) return $string;
	if (defined($string)) {
		$string = constant($string);
	}elseif(strpos($string, "TRANS_") !== false){
        $string = preg_replace_callback("/(TRANS_\w+)/", 
                function ($matches) {
                    return ((defined($matches[1])) ? constant($matches[1]) : $matches[1]);
                }, $string
        );
	}
	return $string;
}

?>
