<?php

require_once("lib-tk/mbapimap.php");

$CONF['sources']['productVariantPrices'] = array(
	"names" => array(
		"singular" => "productVariantPrice",
		"plural" => "productVariantPrices",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductVariants",
		'subCommand' => "",
		'params' => array("getProductVariantPriceData" => 1),
	),
	"response" => array(
		'path' => array("productVariants", "productVariant", "productVariantPrices", "productVariantPrice"),
	),
	"insert" => array(
		"command" => "SetProducts",
		"subCommand" => "insert",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => array(
						"productVariantPrices" => array(
							"productVariantPrice" => array(), // $allParams
						),
					),
				),
			)
		),
	),
	"update" => array(
		"command" => "SetProducts",
		"subCommand" => "update",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => array(
						"productVariantPrices" => array(
							"productVariantPrice" => array(), // $allParams
						),
					),
				),
			)
		),
	),
	"delete" => array(
		"command" => "SetProductVariants",
		"subCommand" => "delete",
		"params" => new Params(
			array(
				"removeProductVariantPriceIDs" => new Param("productVariantPriceID"),
			)
		),
	),
	"table" => "product_variant_prices",
	"columns" => array(
		"productVariantPriceID" => COLUMN_PRIMARY_KEY,
		"productVariantID" => COLUMN_ID,
		"productVariantPriceType" => COLUMN_TYPE,
		"cycleID" => COLUMN_ID,
		"currencyID" => COLUMN_TEXT,
		"productVariantPriceAmount" => COLUMN_AMOUNT|COLUMN_NAME,
		"costCurrencyID" => COLUMN_TEXT,
		"costAmount" => COLUMN_AMOUNT,
	),
	"types" => array(
		"productVariantPriceType" => "price",
	),
	"display" => array(
		'showTemplate' => "products/ShowProductVariantPrices",
		'options' => array("TLDs", "cycles", "products", "productVariants"),
		'context' => array(
			"productVariantID" => "variants",
			"cycleID" => "cycles",
		),
	),
);
