<?php

require_once("lib-tk/mbapimap.php");

/**
 * generate the productVariantPrimaryName column
 */
class VariantColumnGenerator extends NameColumnGenerator
{
	public function generateRowByRef(&$row)
    {
		parent::generateRowByRef($row);
		if(preg_match("/^TRANS_/", $row["productVariantDisplayName"])) {
			$row["productVariantDisplayName"] = blsmg($row["productVariantDisplayName"]);
		}
		if (!empty($row["tldName"])) {
			$variable = $row["tldName"];
		} else if(!empty($row["productVariableValue"])) {
			$variable = $row["productVariableValue"];
		} else {
			$variable = blmsg('TRANS_ITSELF');
		}
		$row["productVariantPrimaryName"] = str_replace(
			array(
				"{product}",
				"{variable}",
			),
			array(
				$row["productName"],
				$variable,
			),
			$row["productVariantDisplayName"]
		);
		return true;
	}
}

$CONF['sources']['productVariants'] = array(
	"names" => array(
		"singular" => "productVariant",
		"plural" => "productVariants",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductVariants",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("productVariants", "productVariant"),
	),
	"insert" => array(
		"command" => "SetProducts",
		"subCommand" => "insert",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => array(), // $allParams
				),
			)
		),
	),
	"update" => array(
		"command" => "SetProducts",
		"subCommand" => "update",
		"params" => new Params(
			array(
				"productVariants" => array(
					"productVariant" => array(), // $allParams
				),
			)
		),
	),
	"delete" => array(
		"command" => "SetProducts",
		"subCommand" => "delete",
		"params" => new Params(
			array(
				"removeProductVariantIDs" => new Param("productVariantID"),
			)
		),
	),
	"table" => "product_variants",
	"columns" => array(
		"productVariantID" => COLUMN_PRIMARY_KEY,
		"productVariantPrimaryName" => COLUMN_PRIMARY_NAME, // generated by the VariantColumnGenerator class
		"productVariantDisplayName" => COLUMN_TEXT,
		"productVariantActive" => COLUMN_ACTIVE,
		"productVariableValueID" => COLUMN_ID,
		"tldID" => COLUMN_ID,
		"productID" => COLUMN_ID,
		"taxZoneGroupID" => COLUMN_ID,
		"cycleDiscountGroupID" => COLUMN_ID,
		"invoicingGroupID" => COLUMN_ID,
	),
	"refColumnGenerator" => "VariantColumnGenerator",
	"display" => array(
		'showTemplate' => "products/ShowProductVariants",
		'options' => array("TLDs", "products"),
		"noFilter" => array("products"),
		'context' => array(
			"productID" => "products",
			"productVariableValueID" => "productVariableValues",
			"tldID" => "TLDs",
			"cycleDiscountGroupID" => "cycleDiscountGroups",
		),
		"revContext" => array(
			"productVariantPrices" => "productVariantID",
			"productLedgerEntries" => "productVariantID",
		),
	),
);
