<?php
/***************************************************************************
 *   Copyright (C) 2011 by Vasily M. Stashko                               *
 *   vstashko@mail.ru                                                      *
 ***************************************************************************/
/* $Id$ */

	final class RegRuReplace
	{
		const PHONE_PATTERN					= '/(\s*\+[0-9]{1,3} [0-9]{1,5} [0-9]+\s*(\n)*)/';
		const MAIL_PATTERN					= '/([a-zA-Z0-9\!\#\$\%\&\'\*\+\-\/\=\?\^\_\`\{\|\}\~]+(\.[a-zA-Z0-9\!\#\$\%\&\'\*\+\-\/\=\?\^\_\`\{\|\}\~]+)*@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z](\n)*)/';
		const DATE_PATTERN					= '/^(\d{1,2})\.(\d{1,2})\.(\d{4})$/';
		const PASSPORT_PATTERN				= '/^(\d{2})\s*(\d{2})\s*(\d{6}) выдан([\s\d\S]+) (\d{1,2})\.(\d{1,2})\.(\d{4})$/';
		
		protected static $names = array(
			'date'			=> 'date',
			'birth_date'	=> 'date',
			'passport'		=> 'passport',
			'phone'			=> 'phones',
			'mail'			=> 'mails',
		);
		
		private static $lettersMapping = array(
			'а' => 'a',		'б' => 'b',		'в' => 'v',		'г' => 'g',
			'д' => 'd',		'е' => 'e',		'ё' => 'jo',	'ж' => 'zh',
			'з' => 'z',		'и' => 'i',		'й' => 'jj',	'к' => 'k',
			'л' => 'l',		'м' => 'm',		'н' => 'n',		'о' => 'o',
			'п' => 'p',		'р' => 'r',		'с' => 's',		'т' => 't',
			'у' => 'u',		'ф' => 'f',		'х' => 'kh',	'ц' => 'c',
			'ч' => 'ch',	'ш' => 'sh',	'щ' => 'shh',	'ъ' => '\'',
			'ы' => 'y',		'ь' => '\'',	'э' => 'eh',	'ю' => 'ju',
			'я' => 'ja',
			
			'А' => 'A',		'Б' => 'B',		'В' => 'V',		'Г' => 'G',
			'Д' => 'D', 	'Е' => 'E',		'Ё' => 'JO',	'Ж' => 'ZH',
			'З' => 'Z',		'И' => 'I',		'Й' => 'JJ',	'К' => 'K',
			'Л' => 'L',		'М' => 'M',		'Н' => 'N',		'О' => 'O',
			'П' => 'P',		'Р' => 'R',		'С' => 'S',		'Т' => 'T',
			'У' => 'U',		'Ф' => 'F',		'Х' => 'KH',	'Ц' => 'C',
			'Ч' => 'CH',	'Ш' => 'SH',	'Щ' => 'SHH',	'Ъ' => '\'',
			'Ы' => 'Y',		'Ь' => '\'',	'Э' => 'EH',	'Ю' => 'JU',
			'Я' => 'JA'
		);
		
		public static function replace($type, $value)
		{
			if (isset(self::$names[$type])) {
				$method = self::$names[$type];
				return self::$method($value);
			}
			
			return false;
		}
		
		public static function toTranslit($sourceString)
		{
			return strtr($sourceString, self::$lettersMapping);
		}
		
		private static function date($value)
		{
			if (!preg_match(self::DATE_PATTERN, $value, $matches))
				return false;
			
			if (!checkdate($matches[2], $matches[1], $matches[3]))
				return false;
			
			return date('d.m.Y', strtotime($matches[2].'/'.$matches[1].'/'.$matches[3]));
		}
		
		private static function passport($value)
		{
			if (!preg_match(self::PASSPORT_PATTERN, $value, $matches))
				return false;
			
			if (!checkdate($matches[6], $matches[5], $matches[7]))
				return false;

			if ((int)$matches[7] < 1991)
				return "invalid";
			
			return
				$matches[1]
				.' '
				.$matches[2]
				.' '
				.$matches[3]
				.' выдан'
				.$matches[4]
				.' '
				.date('d.m.Y', strtotime($matches[6].'/'.$matches[5].'/'.$matches[7]));
		}

		public function mails($values)
		{
			return self::replaceManyValuesInOneField(self::MAIL_PATTERN, $values);
		}

		public function phones($values)
		{
			return self::replaceManyValuesInOneField(self::PHONE_PATTERN, $values);
		}

		public function replaceManyValuesInOneField($regexp, $values)
		{
			$todoBeEmpty = $values;
			if (preg_match_all($regexp, $values, $arrayValues) > 0) {
				if (isset($arrayValues[1])) {
					$todoBeEmpty = str_replace($arrayValues[1], '', $todoBeEmpty);
					$todoBeEmpty = trim($todoBeEmpty);
					if (empty($todoBeEmpty)){
						$answer = "";
						$endOfLine = "";
						foreach ($arrayValues[1] as $value) {
							$answer .= "$endOfLine"."$value";
							$endOfLine = "\n";
						}
						return $answer;
					} else {
						return "invalid";	
					}
				}
			} 
			return false;
		}
	}
?>
