<?php

require_once("lib-mbapi/include/modules/registrar/registrar.php");
use Billing\Object\Contact;
use Billing\Checker;

$className = "OpenSRS";
$GLOBALS["moduleInfo"][$className] = array(
    "type" => "registrar",
    "status" => Registrar::STATUS_STABLE,
    "version" => "1.0.4",
    "displayName" => "OpenSRS",
    "author" => "Parallels",
	"file" => __FILE__,
	"countryCodes" => array("US"),
);

class OpenSRS extends Registrar
{
	public function getModuleInfo()
    {
		return $GLOBALS["moduleInfo"]["OpenSRS"];
	}

    public function __construct($input)
    {
		$this->capabilities[REGISTRAR_REGISTERDOMAIN] = 1;
		$this->capabilities[REGISTRAR_TRANSFERDOMAIN] = 1;
		$this->capabilities[REGISTRAR_RENEWDOMAIN] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINEXTENDEDINFO] = 1;
		$this->capabilities[REGISTRAR_CHECKDOMAINAVAILABILITY] = 0;
		$this->capabilities[REGISTRAR_CHECKDOMAINTRANSFERAVAILABILITY] = 0;

		//Domain Management options
		$this->capabilities[REGISTRAR_GETDOMAINCONTACTDATA] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINCONTACTDATA] = 0;
		$this->capabilities[REGISTRAR_GETDOMAINRENEWTYPEOPTIONS] = 0;
		$this->capabilities[REGISTRAR_SETDOMAINRENEWTYPEOPTIONS] = 0;
		$this->capabilities[REGISTRAR_GETDOMAINREGISTRARLOCKOPTIONS] = 0;
		$this->capabilities[REGISTRAR_SETDOMAINREGISTRARLOCKOPTIONS] = 0;
		$this->capabilities[REGISTRAR_GETDOMAINACCESSPASSWORD] = 0;
		$this->capabilities[REGISTRAR_SETDOMAINACCESSPASSWORD] = 0;
		$this->capabilities[REGISTRAR_GETDOMAINDNS] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINDNS] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINRENEWDATE] = 0;
		$this->capabilities[REGISTRAR_LIVERENEW] = 0;

		$this->capabilities[REGISTRAR_CHECKACCOUNTBALANCE] = 0;
		$this->capabilities[REGISTRAR_GETTLDPRICING] = 0;
		$this->capabilities[REGISTRAR_GETTRANSFERSTATUS] = 0;
		$this->capabilities[REGISTRAR_GETTLDLIST] = 0;
        $this->capabilities[REGISTRAR_TLDS] = array(
            'asia', 'be', 'biz', 'ca', 'cc', 'de', 'es', 'eu', 'info',
            'me', 'mobi', 'name', 'org', 'tel', 'tv', 'us', 'at', 'ch',
            'com.mx', 'dk', 'fr', 'it', 'li', 'mx', 'nl', 'pl', 'cn',
            'com.cn', 'net.cn', 'org.cn', 'co.uk', 'ltd.uk', 'me.uk',
            'net.uk', 'org.uk', 'plc.uk', 'com', 'net', 'com.vc',
            'net.vc', 'org.vc', 'vc', 'in', 'co.in', 'firm.in', 'gen.in',
            'ind.in', 'net.in', 'org.in', 'co.za'
        );
        $this->capabilities[REGISTRAR_TLDS] = array_merge($this->capabilities[REGISTRAR_TLDS], $this->_auTlds);
        $this->capabilities[REGISTRAR_IDN_TLDS] = array('com', 'net', 'cc', 'tv', 'biz', 'de', 'info', 'org', 'co', 'es', 'eu');


		//Setup the array of all items to send for new registration
		$this->registrationArray = array(
			"action" => "SW_REGISTER",
			"object" => "DOMAIN",
			"protocol" => "XCP",
			"attributes" => array(
				"affiliate_id" => "",
				"domain" => $this->input["domainSLD"].".".$this->input["domainTLD"],
				"us_link_domain" => "",

				"auto_renew" => 0,
				"link_domains" => "",
				"custom_tech_contact" => 1,	//If 0 use the reseller contact

				"custom_nameservers" => "",	//Only used on transfers.  reg_type = transfer.  If 1, send at least 2 new nameservers for the transfer
				"custom_transfer_nameservers" => "",
				"domain_description" => "",	//Only used for dot.us domains
				"encoding_type" => "",	//If punycode, send a three letter language tag
				"f_whois_privacy" => "",
				"f_lock_domain" => "",
				"handle" => "process",
				"isa_tradmark" => "",	//Only used for dot.us domains
				"lang_pref" => "",		//Required for dot.us (probably really for .ca, documentation error)
				"legal_type" => "",		//required for .ca same list as eNom
				"link_domains" => "",
				"period" => 1,
				"reg_password" => "",
				"reg_type" => "new",	//new, transfer, whois_privacy
				"reg_username" => "",
				"nameserver_list" => "",
				"tld_data" => array(
					"forwarding_email" => "",
				),
				"contact_set" => array(
					"admin" => array(
						"first_name" => "",
						"last_name" => "",
						"org_name" => "",
						"address1" => "",
						"address2" => "",
						"address3" => "",
						"city" => "",
						"state" => "",
						"country" => "",
						"postal_code" => "",
						"email" => "",
						"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
						"fax" => "",
						"url" => "",
						"lang_pref" => "",
					),
					"billing" => array(
						"first_name" => "",
						"last_name" => "",
						"org_name" => "",
						"address1" => "",
						"address2" => "",
						"address3" => "",
						"city" => "",
						"state" => "",
						"country" => "",
						"postal_code" => "",
						"email" => "",
						"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
						"fax" => "",
						"url" => "",
						"lang_pref" => "",
					),
					"owner" => array(
						"first_name" => "",
						"last_name" => "",
						"org_name" => "",
						"address1" => "",
						"address2" => "",
						"address3" => "",
						"city" => "",
						"state" => "",
						"country" => "",
						"postal_code" => "",
						"email" => "",
						"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
						"fax" => "",
						"url" => "",
						"lang_pref" => "",
					),
					"tech" => array(
						"first_name" => "",
						"last_name" => "",
						"org_name" => "",
						"address1" => "",
						"address2" => "",
						"address3" => "",
						"city" => "",
						"state" => "",
						"country" => "",
						"postal_code" => "",
						"email" => "",
						"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
						"fax" => "",
						"url" => "",
						"lang_pref" => "",
					),
				),
			),
			"registrant_ip" => "",
			"handle" => "process",
		);

        if (isset($input['domainSLD']) && trim($input['domainSLD']) != '') {
            $input['domainSLD'] = $this->getPUNYCode($input);
        }
		parent::Registrar($input);
	}

	/*
	 * Call opensrs and return the result.
	 *
	 * @param   string	xml to send to opensrs
	 * @param   bool	optional, set to 'true' in order to get the raw xml returned
	 * @return  mixed	the result of the opensrs call, raw xml or parsed xml array
	 */
	function callOpenSRS($xml, $rawXML=false){
		global $CONF;
		$settings =& $CONF["domain"]["registrar"][strtolower(__CLASS__)];

		$this->PW = $settings["modulePrivateKey"];
		if (empty($this->PW)){
			$this->PW = $settings['modulePassword'];
		}

		$xml = str_replace(array("\n", "\t"), "", trim($xml));

		$url = "https://".((int)$settings["moduleTestMode"]?"horizon.opensrs.net":"rr-n1-tor.opensrs.net").":55443/";

		$signature = md5(md5($xml.$this->PW).$this->PW);
		$c = new Curl();

		$c->addHeader("Content-Type: text/xml");
		$c->addHeader("X-Username: ".$settings['moduleUsername']);
		$c->addHeader("X-Signature: ".$signature);
		$c->setURL($url);
		$c->addField("",$xml,0);
		$this->lastCurlCall =& $c;
		if (!$rawXML){
			$x = new MBXMLLite($c->toString());
			return $x->toArray();
		} else {
			return $c->toString();
		}
	}

	function filterUsername($u){
		return preg_replace('/[^' . Checker::C_POSIX_ALNUM . ']/', '', $u);
	}

	/*
	 * Call the registrar to check a domain's availability for registration.@updater
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	public function checkDomainAvailability()
    {

		$xml = "
		<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>
		<!DOCTYPE OPS_envelope SYSTEM \"ops.dtd\">
		<OPS_envelope>
			<header>
				<version>0.9</version>
			</header>
			<body>
				<data_block>
					<dt_assoc>
						<item key=\"object\">DOMAIN</item>
						<item key=\"action\">LOOKUP</item>
						<item key=\"protocol\">XCP</item>
						<item key=\"attributes\">
							<dt_assoc>
								<item key=\"domain\">".$this->input["domainSLD"].".".$this->input["domainTLD"]."</item>
							</dt_assoc>
						</item>
					</dt_assoc>
				</data_block>
			</body>
		</OPS_envelope>";
		$rawResult = $this->callOpenSRS($xml, true);

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * Call the registrar to check a domain's availability for transfer.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function checkDomainTransferAvailability() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * Call the registrar to register a new domain
	 *
	 * @return  string  XML containing registration results for this domain registration
	 */
	public function registerDomain()
    {
		if (!isset($this->input["domainRemotePurchaseID"])) {
            //Popluate contact fields
            $this->getRegistrationContactsData();

            if (1 == $this->input['domain_renew_type']) { // 1 = registrar, 2 = ppb renew, 0 = don't renew
                $this->registrationArray["attributes"]["auto_renew"] = 1;
            }

            //What nameservers do we need to pass
            if($this->input["domainNameserver1"]) {
                $dnsServers[] = $this->input["domainNameserver1"];
                $dnsServers[] = $this->input["domainNameserver2"];
                $dnsServers[] = $this->input["domainNameserver3"];
                $dnsServers[] = $this->input["domainNameserver4"];

                $this->registrationArray["attributes"]["custom_nameservers"] = 1;
            }

            $this->registrationArray["attributes"]["domain"] = $this->input["domainSLD"].".".$this->input["domainTLD"];
            $this->registrationArray["attributes"]["period"] = $this->input["domainYears"];
            if (isset($this->input['idnDomainLanguage'])) {
                $this->registrationArray["attributes"]["encoding_type"] = $this->input["idnDomainLanguage"];
            }
            $this->registrationArray["attributes"]["reg_username"] = $this->filterUsername(substr($this->input["domainSLD"],0,14)."".$this->input["domainTLD"]);
            $domainPassword = getRandomPassword(8, 1);
            $this->registrationArray["attributes"]["reg_password"] = $domainPassword;

            //Do the TLD specific hoop jumping

            //Nameserver needs special XML
            $nameserverXML = NULL;
            if($this->registrationArray["attributes"]["custom_nameservers"]) {
                $nameserverXML = "<dt_array>\n";
                foreach($dnsServers as $key => $value) {
                    if($value) {
                        $nameserverXML .= "\t<item key='$key'>\n";
                        $nameserverXML .= "\t\t<dt_assoc>\n";
                        $nameserverXML .= "\t\t\t<item key='sortorder'>" .($key+1) ."</item>\n";
                        $nameserverXML .= "\t\t\t<item key='name'>$value</item>\n";
                        $nameserverXML .= "\t\t</dt_assoc>\n";
                        $nameserverXML .= "\t</item>\n";

                    }
                }
                $this->nameserverXML = $nameserverXML."</dt_array>\n";
            }

            $this->getAdditionalRegistrantFields();

            $registrationXML = $this->toXML($this->registrationArray, "", $nameserverXML);

            $registrationXML = "<?xml version='1.0' encoding='UTF-8' standalone='no'?>
                <!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
                <OPS_envelope>
                    <header>
                        <version>0.9</version>
                    </header>
                    <body>
                        <data_block>
                            <dt_assoc>
                                $registrationXML
                            </dt_assoc>
                        </data_block>
                    </body>
                </OPS_envelope>";

            $tlds = $this->capabilities[REGISTRAR_TLDS];

            if (in_array($this->input["domainTLD"], $tlds)){
                $result = $this->callOpenSRS($registrationXML, true);

                preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s", $result, $message);
                preg_match("/<item key=\"forced_pending\">([^<]*)<\\/item>/s", $result, $pendingID);
                preg_match("/<item key=\"id\">([^<]*)<\\/item>/s", $result, $orderID);

                if ((array)$pendingID[1]){
                    $pendingID = (int) $pendingID[1];
                if (false !== preg_match("/<item key=\"error\">([^<]*)<\\/item>/s", $result, $pendingDueToErrors))
                    $pendingDueToErrors = $pendingDueToErrors[1];
                } else {
                    $pendingID = 0;
                }
                if((array)$orderID[1]){
                    $orderID = (int) $orderID[1];
                } else {
                    $orderID = 0;
                }

                if ($message[0]){
                    $x = new MBXMLLite($message[0]);
                    $result = $x->toArray();
                }

                $response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
                $message = $response["responseText"];
                $responseCode = $response["responseCode"];

            } else {
                $message = "TLD not supported";
                $responseCode = 999;
            }

            if ($responseCode == 200){
                $this->hasExecutedSuccessfully = 1;
                $this->arrayData = array(
                    "OrderID" => $orderID,
                    "domainRemotePurchaseID" => $orderID,
                    "reg_username" => $this->registrationArray["attributes"]["reg_username"],
                    "reg_password" => $this->registrationArray["attributes"]["reg_password"],
                );
                $this->execOutput['nsPassed'] = $dnsServers;
            } else {
                if ($pendingID){
                    $this->arrayData = array(
                        "OrderID" => $pendingID,
                    );
                    $this->errors[] = array("OpenSRS Error:", $message.". Order set to pending at the registrar.");
                    if (! empty($pendingDueToErrors))
                        $this->errors[] = array("OpenSRS Error:", $pendingDueToErrors);
                } else {
                    $this->errors[] = array("OpenSRS Error:", $message);
                }
                $this->numErrors++;
                $this->hasExecutedSuccessfully = 0;
            }
        }

        $this->hasExecutedSuccessfully = $this->hasExecutedSuccessfully && (int)$this->_setWhoisPrivacyState();
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * Call the registrar to transfer an existing domain
	 *
	 * @return  string  XML containing registration results for this domain registration
	 */
	function transferDomain() {
		//Popluate contact fields
		$this->getRegistrationContactsData();

		if (1 == $this->input['domain_renew_type']) { // 1 = registrar, 2 = ppb renew, 0 = don't renew
			$this->registrationArray["attributes"]["auto_renew"] = 1;
		}

		//What nameservers do we need to pass
		if($this->input["domainNameserver1"]) {
			$dnsServers[] = $this->input["domainNameserver1"];
			$dnsServers[] = $this->input["domainNameserver2"];
			$dnsServers[] = $this->input["domainNameserver3"];
			$dnsServers[] = $this->input["domainNameserver4"];

			$this->registrationArray["attributes"]["custom_nameservers"] = 1;
		}

		$this->registrationArray["action"] = "SW_REGISTER";
		$this->registrationArray["attributes"]["reg_type"] = "transfer";
		$this->registrationArray["attributes"]["domain"] = $this->input["domainSLD"].".".$this->input["domainTLD"];
		$this->registrationArray["attributes"]["period"] = $this->input["domainYears"];
		$this->registrationArray["attributes"]["reg_username"] = $this->filterUsername(substr($this->input["domainSLD"],0,14)."".$this->input["domainTLD"]);
		$domainPassword = getRandomPassword(8, 1);
		$this->registrationArray["attributes"]["reg_password"] = $domainPassword;

		//Do the TLD specific hoop jumping

		//Nameserver needs special XML
		$nameserverXML = NULL;
		if($this->registrationArray["attributes"]["custom_nameservers"]) {
			$nameserverXML = "<dt_array>\n";
			foreach($dnsServers as $key => $value) {
				if($value) {
					$nameserverXML .= "\t<item key='$key'>\n";
					$nameserverXML .= "\t\t<dt_assoc>\n";
					$nameserverXML .= "\t\t\t<item key='sortorder'>" .($key+1) ."</item>\n";
					$nameserverXML .= "\t\t\t<item key='name'>$value</item>\n";
					$nameserverXML .= "\t\t</dt_assoc>\n";
					$nameserverXML .= "\t</item>\n";

				}
			}
			$this->nameserverXML = $nameserverXML."</dt_array>\n";
		}

		$this->getAdditionalRegistrantFields();

		$registrationXML = $this->toXML($this->registrationArray, "", $nameserverXML);

		$registrationXML = "<?xml version='1.0' encoding='UTF-8' standalone='no'?>
			<!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
			<OPS_envelope>
				<header>
					<version>0.9</version>
				</header>
				<body>
					<data_block>
						<dt_assoc>
							$registrationXML
						</dt_assoc>
					</data_block>
				</body>
			</OPS_envelope>";

		$tlds = $this->capabilities[REGISTRAR_TLDS];


		if (in_array($this->input["domainTLD"], $tlds)){
			$result = $this->callOpenSRS($registrationXML, true);

			preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s", $result, $message);
			preg_match("/<item key=\"forced_pending\">([^<]*)<\\/item>/s", $result, $pendingID);
			preg_match("/<item key=\"order_id\">([^<]*)<\\/item>/s", $result, $orderID);

			if ((array)$pendingID[1]){
				$pendingID = (int)$pendingID[1];
			} else {
				$pendingID = 0;
			}
			if ((array)$orderID[1]){
				$orderID = (int)$orderID[1];
			} else {
				$orderID = 0;
			}

			if ($message[0]){
				$x = new MBXMLLite($message[0]);
				$result = $x->toArray();
			}

			$response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
			$message = $response["responseText"];
			$responseCode = $response["responseCode"];

		} else {
			$message = "TLD not supported";
			$responseCode = 999;
		}

		if ($responseCode == 200){
			$this->hasExecutedSuccessfully = 1;
			$this->arrayData = array(
				"OrderID" => $orderID,
				"domainRemotePurchaseID" => $orderID,
				"reg_username" => $this->registrationArray["attributes"]["reg_username"],
				"reg_password" => $this->registrationArray["attributes"]["reg_password"],
			);
		} else {
            $this->errors[] = ($pendingID) ? array("OpenSRS Error:", $message." order set to pending at the registrar") : array("OpenSRS Error:", $message) ;
			$this->numErrors++;
			$this->hasExecutedSuccessfully = 0;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for renewing a domain.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	public function renewDomain()
    {
        //Have to pass the current exp. year to OpenSRS to renew
        $currentYear = date("Y",$this->input["domainDateExpires"]);

        //Popluate contact fields
        $this->getRegistrationContactsData();

        $this->registrationArray["action"] = "renew";
        $this->registrationArray["attributes"]["domain"] = $this->input["domainSLD"].".".$this->input["domainTLD"];
        $this->registrationArray["attributes"]["period"] = $this->input["domainYears"];
        $this->registrationArray["attributes"]["currentexpirationyear"] = $currentYear;

        unset($this->registrationArray["attributes"]["reg_type"]);
        unset($this->registrationArray["attributes"]["contact_set"]);

        $registrationXML = $this->toXML($this->registrationArray, "", "");

        $registrationXML = "<?xml version='1.0' encoding='UTF-8' standalone='no'?>
            <!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
            <OPS_envelope>
                <header>
                    <version>0.9</version>
                </header>
                <body>
                    <data_block>
                        <dt_assoc>
                            $registrationXML
                        </dt_assoc>
                    </data_block>
                </body>
            </OPS_envelope>";

        $result = $this->callOpenSRS($registrationXML, true);

        preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s", $result, $message);
        preg_match("/<item key=\"forced_pending\">([^<]*)<\\/item>/s", $result, $pendingID);
        preg_match("/<item key=\"order_id\">([^<]*)<\\/item>/s", $result, $orderID);

        if ((array)$pendingID[1]){
            $pendingID = (int) $pendingID[1];
        } else {
            $pendingID = 0;
        }
        if ((array)$orderID[1]){
            $orderID = (int) $orderID[1];
        } else {
            $orderID = 0;
        }

        if ($message[0]){
            $x = new MBXMLLite($message[0]);
            $result = $x->toArray();
        }

        $response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
        $message = $response["responseText"];
        $responseCode = $response["responseCode"];

        if ($responseCode == 555 || $responseCode == 465 || $responseCode == 200){
            $this->hasExecutedSuccessfully = 1;
            $this->arrayData = array(
                "OrderID" => $orderID,
                "domainRemotePurchaseID" => $orderID,
            );
        } else {
            if ($pendingID){
                $this->errors[] = array("OpenSRS Error:", $message." order set to pending at the registrar");
            } else {
                $this->errors[] = array("OpenSRS Error:", $message);
            }
            $this->numErrors++;
            $this->hasExecutedSuccessfully = 0;
        }
        $this->hasExecutedSuccessfully = $this->hasExecutedSuccessfully && (int)$this->_setWhoisPrivacyState();
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	public function isOrganizationNameRequired()
	{
	    return ("" == $this->getParameter('adminCompany') || "" == $this->getParameter('auxBillingCompany') || "" == $this->getParameter('techCompany'));
	}

	/**
	 * Set any additional attributes for .ca, .us, .uk, .be, etc...
	 *
	 */
	private function getAdditionalRegistrantFields()
	{
		switch ($this->input["domainTLD"]) {
            case "us":
                //This API uses the same codes that eNom takes, so don't have to do anything special
                $this->registrationArray["attributes"]["tld_data"]["nexus"]["app_purpose"] = $this->input["us_purpose"];
                $this->registrationArray["attributes"]["tld_data"]["nexus"]["category"] = $this->input["us_nexus"];
                if ($this->input["us_nexus"] == "C31" || $this->input["us_nexus"] == "C32"){
                    $countryCode = NULL;
                    //make sure it is two first, if not, just pass the client's country code
                    if (strlen($this->input["global_cc_us"] == 2)){
                        $countryCode = $this->input["global_cc_us"];
                    } else {
                        $countryCode = $this->input["registrantCountry"];
                    }
                    $this->registrationArray["attributes"]["tld_data"]["nexus"]["validator"] = $countryCode;
                }
                return;
            case "asia":
                $this->registrationArray["attributes"]["tld_data"]["ced_info"]["contact_type"] = "owner";
                $this->registrationArray["attributes"]["tld_data"]["ced_info"]["id_number"] = $this->input["asia_ident:number"];
                $this->registrationArray["attributes"]["tld_data"]["ced_info"]["id_type"] = $this->input["asia_identform"];
                if ("other" == $this->input["asia_identform"]) {
                    $this->registrationArray["attributes"]["tld_data"]["ced_info"]["id_type_info"] = $this->input["asia_otheridentform"];
                }
                $this->registrationArray["attributes"]["tld_data"]["ced_info"]["legal_entity_type"] = $this->input["asia_legalentitytype"];
                if ("other" == $this->input["asia_legalentitytype"]) {
                    $this->registrationArray["attributes"]["tld_data"]["ced_info"]["legal_entity_type_info"] = $this->input["asia_otherletype"];
                }
                $this->registrationArray["attributes"]["tld_data"]["ced_info"]["locality_country"] = $this->input["asia_cclocality"];
                return;
        }
        if (in_array($this->input["domainTLD"], $this->_auTlds)) {
            foreach($this->_auAddParams as $addParam) {
                $this->registrationArray["attributes"]["tld_data"]["au_registrant_info"][$addParam] = $this->input[$addParam];
            }
        }
	}

	/**
	 * Put the contact info in place.  The contact settings can be use as:
	 * $this->registrationArray["contact_set"]["owner"]
	 * $this->registrationArray["contact_set"]["admin"]
	 * $this->registrationArray["contact_set"]["billing"]
	 * $this->registrationArray["contact_set"]["tech"]
	 *
	 */
	private function getRegistrationContactsData()
    {
    	//Set the owner info
		$this->registrationArray["attributes"]["contact_set"]["owner"]["first_name"] = $this->input["registrantFirstName"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["last_name"] = $this->input["registrantLastName"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["org_name"] = ($this->input["registrantOrganizationName"])? $this->input["registrantOrganizationName"] : $this->input["domainSLD"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["address1"] = $this->input["registrantAddress1"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["address2"] = $this->input["registrantAddress2"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["address3"] = "";
		$this->registrationArray["attributes"]["contact_set"]["owner"]["city"] = $this->input["registrantCity"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["state"] = $this->input["registrantState"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["country"] = $this->input["registrantCountry"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["postal_code"] = $this->input["registrantPostalCode"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["email"] = $this->input["registrantEmail"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["phone"] = $this->input["registrantPhone"];
		$this->registrationArray["attributes"]["contact_set"]["owner"]["fax"] = (strlen($this->input["registrantFax"])>4)? $this->input["registrantFax"] : "";
		$this->registrationArray["attributes"]["contact_set"]["owner"]["url"] = "";
		$this->registrationArray["attributes"]["contact_set"]["owner"]["lang_pref"] = $this->input["domain_idn_language"];

		$contactTypes = array(
            'admin' => 'admin',
            'billing' => 'auxBilling',
            'tech' => 'tech',
        );
        $fields = array(
            "first_name" => "Firstname",
            "last_name" => "LastName",
            "org_name" => "Company",
            "address1" => "Address1",
            "address2" => "Address2",
            "address3" => "",
            "city" => "City",
            "state" => "State",
            "country" => "Country",
            "postal_code" => "Zip",
            "email" => "Email",
            "phone" => "Phone",
            "fax" => "Fax",
            "url" => "",
        );
        $registrantFields = array(
            "first_name" => "FirstName",
            "last_name" => "LastName",
            "org_name" => "OrganizationName",
            "address1" => "Address1",
            "address2" => "Address2",
            "address3" => "",
            "city" => "City",
            "state" => "State",
            "country" => "Country",
            "postal_code" => "PostalCode",
            "email" => "Email",
            "phone" => "Phone",
            "fax" => "Fax",
            "url" => "",
        );

        foreach($contactTypes as $regType => $inputType) {
            //If the module has contact fields set, override the client info
            if ($this->config["{$inputType}Firstname"] || $this->config["{$inputType}LastName"] || $this->config["{$inputType}Company"]){
                foreach($fields as $regField => $inputField) {
                    $value = ("" == $inputField) ? "" : $this->config["{$inputType}{$inputField}"];
                    $this->registrationArray["attributes"]["contact_set"][$regType][$regField] = $value;
                }
            } else {
                foreach($registrantFields as $regField => $inputField) {
                    $value = ("" == $inputField) ? "" : $this->input["registrant{$inputField}"];
                    $this->registrationArray["attributes"]["contact_set"][$regType][$regField] = $value;
                }
            }
        }
	}


	/**
	* create XML from an array with attributes specific to opensrs
	*
	* @author  Kris Bailey
	* @author  Andy Christ
	* @param  array  array to convert to XML
	* @param  string  starting indentation whitespace. Defaults to emtpy string.
	* @return  string  XML
	*/
	function toXML($array, $prefix="") {
		$output = "";
		if (count($array) && !is_numeric(key($array))){
			foreach ($array as $k => $v) {
				if($k == "nameserver_list") {
					$output .= "<item key='nameserver_list'>\n".$this->nameserverXML."</item>";
				} else {
					if((string) $v == "") {
						// add this back to send item tags that have no value
						//$output .= $prefix."<item key='$k'/>\n";
						continue;
					}

					$output .= $prefix."<item key='$k'>";
					if (is_array($v) && !is_numeric(key($v))){
						$output .= "\n<dt_assoc>\n".$this->toXML($v, $prefix."\t").$prefix."\n</dt_assoc>";
					} elseif (is_array($v)){
						for ($i=0; $i<count($v); $i++){
							if ($i>0){
								$output .= "</$k>\n$prefix<$k>";
							}
							if (is_array($v[$i])){
								$output .= "\n".$this->toXML($v[$i], $prefix."\t").$prefix;
							} else {
								$output .= utf8_xml_entity_encode($v[$i]);
							}
						}
					} else {
						$output .= utf8_xml_entity_encode($v);
					}
					$output .= "</item>\n";
				}
			}
		}
		return $output;
	}


	/**
	 * Get all domains from the registrar.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomains() {
		$start = $end = time(); //Will be the timestamp values
		$domainCount = $domainpages = 0;
		$domains = array();
		// Loop over the same date until the return value for remainder is 0
		// Then advance the date range and start looping agin

		//Need to go out the next 10 years
		for($i=1;$i<=10;$i++) {
			//Format the dates
			$start = $end;
			$end = mktime(0,0,0,date("m"),date("d"),date("Y")+$i);

			$exp_from = date("Y-m-d", $start);
			$exp_to = date("Y-m-d", $end);
			$page = 0;
			$remainder = 1;
			while($remainder) {

				$domainpages ++;
				$result = $this->callOpenSRS("<?xml version=\"1.0\" encoding=\"UTF-8\"?>
					<OPS_envelope>
						<header>
							<version>0.9</version>
						</header>
						<body>
							<data_block>
								<dt_assoc>
									<item key=\"object\">domain</item>
									<item key=\"action\">get_domains_by_expiredate</item>
									<item key=\"protocol\">XCP</item>
									<item key=\"attributes\">
										<dt_assoc>
											<item key=\"limit\">25</item>
											<item key=\"exp_from\">$exp_from</item>
											<item key=\"exp_to\">$exp_to</item>
											<item key=\"page\">$page</item>
										</dt_assoc>
									</item>
								</dt_assoc>
							</data_block>
						</body>
					</OPS_envelope>", true);

				preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s", $result, $message);

				if ($message[0]){
					$x = new MBXMLLite($message[0]);
					$result = $x->toArray();
				}

				$response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);

				if ($response["responseCode"] == 200){
					if ($response["exp_domains"]){
						//Grab the domains
						foreach ($response["exp_domains"] as $domain){
							$sld = $tld = NULL;
							$domainParts = explode(".",$domain["dt_assoc"][0]["item"][1][0]);
							$sld = $domainParts[0];
							foreach ($domainParts as $index => $tmpTLD){
								if ($index > 0){
									if ($tld){
										$tld .= ".".$tmpTLD;
									} else {
										$tld .= $tmpTLD;
									}
								}
							}

							$domains[] = array(
								"domainName" => $domain["dt_assoc"][0]["item"][1][0],
								"domainSLD" => $sld,
								"domainTLD" => $tld,
								"domainDateExpires" => strtotime($domain["dt_assoc"][0]["item"][2][0]),
								"domainAutoRenew" => ($domain["dt_assoc"][0]["item"][3][0]=="N")? 0 : 1,
							);
							$domainCount ++;
						}
					} //IF Domains

					//Time to move on to the next date range if remander is 0
					$remainder = $response["remainder"];
					if ($remainder){
						$page++;
					} else {
						$page = 0;
					}
				} else {
					//Bad call
					$this->errors[] = array("Resellone Error Getting Domain List:", $response["responseText"]);
					$this->numErrors ++;
					$this->hasExecutedSuccessfully = 0;
					$remainder = 0;
					continue;
				}
			} // End while
		}

		$this->arrayData["domains"] = $domains;
		$this->arrayData["totalDomains"] = $domainCount;
		$this->arrayData["domainStartPosition"] = 0;
		$this->arrayData["domainEndPosition"] = $domainpages;

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	} // get Domains

	/**
	 * Call the registrar to fetch a domain's contact data
	 *
	 * @return  string  XML containing contact data for this domain
	 */
	function getDomainContactData() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	} // END getDomainContactData()

	/**
	 * Send the updated domain contact data to the registrar
	 *
	 * @return  string  XML result
	 */
	function setDomainContactData() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for setting a domain's auto-renewal options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setdomainRenewTypeOptions() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for fetching the domain registrar-lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainRegistrarLockOptions() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for setting the domain registrar-lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainRegistrarLockOptions() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for fetching the domain access password.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainAccessPassword() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for setting the domain access password.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainAccessPassword() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for fetching the domain expiration date.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainExpDate() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for fetching a domain's extended information.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainExtendedInfo() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/*
	 * Call the registrar to check an account's balance.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function checkAccountBalance() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/*
	 * Call the registrar to check TLD pricing cost (cogs).
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getTLDPricing() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/*
	 * Call the registrar to check the status of a transfer
	 *
	 * @return  string status of the transfer
	 */
	function getTransferStatus() {
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for fetching the domain registrar-lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainDNS() {
		//Must have the username and password to manage domains with any HRS system
		//They will be saved as package attributes:
		//	domain_reg_username
		//	domain_reg_password
		$reg_username = $this->input["domain_reg_username"];
		$reg_password = $this->input["domain_reg_password"];

		$result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
			<!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
			<OPS_envelope>
				<header>
					<version>0.9</version>
				</header>
				<body>
					<data_block>
						<dt_assoc>
							<item key='action'>SET</item>
							<item key='object'>COOKIE</item>
							<item key='protocol'>XCP</item>
							<item key='attributes'>
								<dt_assoc>
									<item key='reg_username'>".$reg_username."</item>
									<item key='reg_password'>$reg_password</item>
									<item key='domain'>".$this->input["domainSLD"].".".$this->input["domainTLD"]."</item>
								</dt_assoc>
							</item>
						</dt_assoc>
					</data_block>
				</body>
			</OPS_envelope>", true);

		preg_match("/<item key=\"cookie\">([^<]*)<\\/item>/s",$result,$cookieID);

		if ((array)$cookieID[1]){
			$cookieID = $cookieID[1];
		} else {
			$cookieID = 0;
		}

		$result = NULL;

		//For type, use all_info, nameservers, owner, admin, billing, tech, list, forwarding_email
		// doamin_auth_info, rsp_whois_info, status, nexus_info, expire_action, trademark, whois_privacy_state
		$result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
			<!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
			<OPS_envelope>
				<header>
					<version>0.9</version>
				</header>
				<body>
					<data_block>
						<dt_assoc>
							<item key='attributes'>
								<dt_assoc>
									<item key='type'>nameservers</item>
								</dt_assoc>
							</item>
							<item key='object'>domain</item>
							<item key='cookie'>$cookieID</item>
							<item key='action'>get</item>
							<item key='protocol'>XCP</item>
						</dt_assoc>
					</data_block>
				</body>
			</OPS_envelope>", true);

		preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s",$result,$message);

		if ($message[0]){
			$x = new MBXMLLite($message[0]);
			$result = $x->toArray();
		}

		$response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
		$message = $response["responseText"];
		$responseCode = $response["responseCode"];


			/* What to return

			Array
			(
				[listDNS] => Array
					(
						[0] => ns2.domainhop.com
						[1] => ns1.domainhop.com
					)

				[UseDNS] => 0
				[host] => Array
					(
						[0] => Array
							(
								[name] => www
								[type] => A
								[address] => 69.25.142.5
								[hostid] => 80553171
							)

						[1] => Array
							(
								[name] => @
								[type] => A
								[address] => 69.25.142.5
								[hostid] => 80553172
							)

						[2] => Array
							(
								[name] => *
								[type] => A
								[address] => 69.25.142.5
								[hostid] => 80553173
							)

					)

				[DomainServices] => Array
					(
						[EmailForwarding] =>
						[HostRecords] =>
					)

				[dnsOptions] => Array
					(
						[A] => A
						[URL] => URL
						[MX] => MX
						[MXE] => MXE
						[CNAME] => CNAME
						[FRAME] => FRAME
						[TXT] => TXT
					)

			)
			*/
		if ($responseCode == 200){
			$this->hasExecutedSuccessfully = 1;
			$nameservers = $result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"][4]["dt_assoc"][0]["item"];
			$nameservers = $nameservers[0]["dt_array"][0]["item"];
			foreach ($nameservers as $nameserverArray){
				$dns[] = $nameserverArray["dt_assoc"][0]["item"][0][0];
			}
			if ($dns){
				$this->arrayData["listDNS"] = $dns;
				$this->arrayData["UseDNS"] = 0;
			} else {
				$this->arrayData["UseDNS"] = 1;
			}
			$this->hasExecutedSuccessfully = 1;

		} else {
			if ($pendingID){
				$this->errors[] = array("OpenSRS Error:", $message." order set to pending at the registrar");
			} else {
				$this->errors[] = array("OpenSRS Error:", $message);
			}
			$this->numErrors ++;
			$this->hasExecutedSuccessfully = 0;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}



	/**
	 * This method contains the registrar specific code for fetching a domain's extended information.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainDNS() {
		//Must have the username and password to manage domains with any HRS system
		//They will be saved as package attributes:
		//	domain_reg_username
		//	domain_reg_password
		$reg_username = $this->input["domain_reg_username"];
		$reg_password = $this->input["domain_reg_password"];

		$result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
			<!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
			<OPS_envelope>
				<header>
					<version>0.9</version>
				</header>
				<body>
					<data_block>
						<dt_assoc>
							<item key='action'>SET</item>
							<item key='object'>COOKIE</item>
							<item key='protocol'>XCP</item>
							<item key='attributes'>
								<dt_assoc>
									<item key='reg_username'>".$reg_username."</item>
									<item key='reg_password'>".$reg_password."</item>
									<item key='domain'>".$this->input["domainSLD"].".".$this->input["domainTLD"]."</item>
								</dt_assoc>
							</item>
						</dt_assoc>
					</data_block>
				</body>
			</OPS_envelope>", true);

		preg_match("/<item key=\"cookie\">([^<]*)<\\/item>/s",$result,$cookieID);

		if ((array)$cookieID[1]){
			$cookieID = $cookieID[1];
		} else {
			$cookieID = 0;
		}

		//For type, use all_info, nameservers, owner, admin, billing, tech, list, forwarding_email
		// doamin_auth_info, rsp_whois_info, status, nexus_info, expire_action, trademark, whois_privacy_state
		$result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
			<!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
			<OPS_envelope>
				<header>
					<version>0.9</version>
				</header>
				<body>
					<data_block>
						<dt_assoc>
							<item key='attributes'>
								<dt_assoc>
									<item key='type'>nameservers</item>
								</dt_assoc>
							</item>
							<item key='object'>domain</item>
							<item key='cookie'>$cookieID</item>
							<item key='action'>get</item>
							<item key='protocol'>XCP</item>
						</dt_assoc>
					</data_block>
				</body>
			</OPS_envelope>", true);

		preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s",$result,$message);

		if ($message[0]){
			$x = new MBXMLLite($message[0]);
			$result = $x->toArray();
		}

		$response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
		$message = $response["responseText"];
		$responseCode = $response["responseCode"];

		if ($responseCode == 200){
			$this->hasExecutedSuccessfully = 1;
			$nameservers = $result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"][4]["dt_assoc"][0]["item"];
			$nameservers = $nameservers[0]["dt_array"][0]["item"];
			foreach ($nameservers as $nameserverArray){
				$dns[] = $nameserverArray["dt_assoc"][0]["item"][0][0];
			}
		}

		$newDNS = array();
		foreach ((array)$this->input['domainNameserver'] as $ns)
			if (!empty($ns))
				$newDNS[] = trim($ns);


		$addDNS = array_diff($newDNS, $dns);
		$removeDNS = array_diff($dns, $newDNS);

		//Now we have to figure out what to do.  We have the old and new.  You can only
		//update or add seperatly.  So if we have more new than old, we need 2 calls.

		// lets add first
		$dnsXML = NULL;
		$i = 0;
		foreach ($addDNS as $sortOrder => $dnsURL){
			if ($dnsURL){
				$dnsXML .= "
					<item key='$i'>
						<dt_assoc>
							<item key='sortorder'>$sortOrder</item>
							<item key='name'>$dnsURL</item>
							<item key='action'>add</item>
						</dt_assoc>
					</item>";
				$i++;
			}
		}

		if (!is_null($dnsXML)) {
            $result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
                <!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
                <OPS_envelope>
                    <header>
                        <version>0.9</version>
                    </header>
                    <body>
                        <data_block>
                            <dt_assoc>
                                <item key='attributes'>
                                    <dt_assoc>
                                        <item key='data'>nameserver_list</item>
                                        <item key='nameserver_list'>
                                            <dt_array>
                                                $dnsXML
                                            </dt_array>
                                        </item>
                                    </dt_assoc>
                                </item>
                                <item key='object'>domain</item>
                                <item key='cookie'>$cookieID</item>
                                <item key='action'>modify</item>
                                <item key='protocol'>XCP</item>
                            </dt_assoc>
                        </data_block>
                    </body>
                </OPS_envelope>", true);

            preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s",$result,$message);

            if ($message[0]){
                $x = new MBXMLLite($message[0]);
                $result = $x->toArray();
            }

            $response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
            $message = $response["responseText"];
            $responseCode = $response["responseCode"];

            $result = NULL;

            if ($responseCode == 200){
                $this->hasExecutedSuccessfully = 1;
            } else {
                $this->errors[] = array("OpenSRS Error:", $message);
                $this->numErrors++;
                $this->hasExecutedSuccessfully = 0;
            }
        } else {
            $this->hasExecutedSuccessfully = 1;
        }

		if ($this->hasExecutedSuccessfully && count($removeDNS)>0){
			$dnsXML = NULL;
			$i = 0;
			foreach ($removeDNS as $sortOrder => $dnsURL){
				if ($dnsURL){
					$dnsXML .= "
						<item key='$i'>
							<dt_assoc>
								<item key='sortorder'>$sortOrder</item>
								<item key='name'>$dnsURL</item>
								<item key='action'>remove</item>
							</dt_assoc>
						</item>
						";
					$i++;
				}
			}

			$result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
				<!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
				<OPS_envelope>
					<header>
						<version>0.9</version>
					</header>
					<body>
						<data_block>
							<dt_assoc>
								<item key='attributes'>
									<dt_assoc>
										<item key='data'>nameserver_list</item>
										<item key='nameserver_list'>
											<dt_array>
												$dnsXML
											</dt_array>
										</item>
									</dt_assoc>
								</item>
								<item key='object'>DOMAIN</item>
								<item key='cookie'>$cookieID</item>
								<item key='action'>MODIFY</item>
								<item key='protocol'>XCP</item>
							</dt_assoc>
						</data_block>
					</body>
				</OPS_envelope>", true);

			preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s",$result,$message);

			if ($message[0]){
				$x = new MBXMLLite($message[0]);
				$result = $x->toArray();
			} else {
				dbg("unable to parse ops envelope out of result");
				dbg($result);
			}

			$response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
			$message = $response["responseText"];
			$responseCode = $response["responseCode"];

			$result = NULL;

			if ($responseCode == 200){
				$this->hasExecutedSuccessfully = 1;
			} else {
				$this->errors[] = array("OpenSRS Error:", $message);
				$this->numErrors++;
				$this->hasExecutedSuccessfully = 0;
			}
		}

		if ($this->hasExecutedSuccessfully){
			$this->arrayData["result"] = "TRANS_REGISTRAR_MANAGE_DNS_UPDATED";
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method will parse the OpenSRS response and find the Message and response code
	 *
	 * @return  var[]  array with the orderID, responseCode, and responseText
	 */
	function getOpenSRSResponse($response=array()) {
		$retVal = array("responseCode" => 0, "responseText" => "", "orderID" => "");
		$message = $code = NULL;

		foreach($response as $key => $value) {
			if($value["_attributes"]["key"] == "response_code") {
				$retVal["responseCode"] = (int) $value[0];
			}
			if($value["_attributes"]["key"] == "response_text") {
				$retVal["responseText"] = secureInput($value[0]);
			}
			if($value["_attributes"]["key"] == "transaction_id") {
				$retVal["orderID"] = secureInput($value[0]);
			}
			if($value["_attributes"]["key"] == "attributes") {
				foreach ((array)$value["dt_assoc"][0]["item"] as $v){
					// in error responses this doesn't have content
					// of this structure and a fatal error will occur
					// if we continue and treat it as an array.  So, we
					// test to make sure :-)
					if (!is_array($v)) continue;
					switch ($v["_attributes"]["key"]) {
						case "page":
							$retVal["page"] = (isset($v[0]))? secureInput($v[0]) : 0;
							break;
						case "remainder":
							$retVal["remainder"] = (isset($v[0]))? secureInput($v[0]) : 0;
							break;
						case "total":
							$retVal["total"] = (isset($v[0]))? secureInput($v[0]) : 0;
							break;
					default:
						//whaterver the call was looking for
						$retVal[$v["_attributes"]["key"]] = secureInput($v["dt_array"][0]["item"]);
					}
				}
			}
		}
		return $retVal;
	}

	 /**
	  *	This fucntion will return the map of all possible values with the names needed to pass to the registrar
	  *
	  * @return Returns the Registrar map array for this registrar
	 */
	 function getAttributesMap() {

		return array(
			// Primary Domain Vars
			"domainSLD" => "SLD",
			"domainTLD" => "TLD",
			"domainIDN" => "IDNCode",
			"domainYears" => "period",
			"domainDNS" => "UseDNS",
			"domainNameserver1" => "NS1",
			"domainNameserver2" => "NS2",
			"domainNameserver3" => "NS3",
			"domainNameserver4" => "NS4",
			"domainNameserver5" => "NS5",
			"domainNameserver6" => "NS6",
			"domainNameserver7" => "NS7",
			"domainNameserver8" => "NS8",

			// check availability
			"checkNameSpinner" => "DomainSpinner",
			"checkAllTLDs" => "checkAllTLDs",
			"checkWithDashes" => "AllowDash",
			"checkKeyword1" => "Word1",
			"checkKeyword2" => "Word2",
			"checkKeyword3" => "Word3",

			// Extended Domain Vars
			// .us domains
			"domainNexusCategory" => "category",
			"domainNexusPurpose" => "app_purpose",
			"domainNexusValidator" => "validator",
			// .jp domains
			"domainPrefecture" => "jp_prefecture",
			// .eu
			"eu_agreedelete" => "",
			"eu_adr_lang" => "",

			// RegistrarLock Options Vars
			"domainRegistrarLock" => "UnlockRegistrar",

			// AutoRenew Options Vars
			"domainRenewType" => "RenewFlag", // "RenewName"
			"emailForwardAutoRenew" => "EmailForwardRenew",
			"IDProtectAutoRenew" => "IDProtectRenew",
			"URLForwardAutoRenew" => "URLForwardRenew",

			// Access Password Vars for Registrar Domain Management
			"domainAccessPassword" => "DomainPassword",
			"domainAccessUsername" => "reg_username",

			// ContactType=REGISTRANT Vars
			"registrantFirstName" => "registrant_first_name",
			"registrantLastName" => "registrant_last_name",
			"registrantJobTitle" => "",
			"registrantCompany" => "registrant_org_name",
			"registrantAddress1" => "registrant_address1",
			"registrantAddress2" => "registrant_address2",
			"registrantAddress3" => "registrant_address3",
			"registrantCity" => "registrant_city",
			"registrantStateProvinceChoice" => "",
			"registrantState" => "registrant_state",
			"registrantPostalCode" => "registrant_postal_code",
			"registrantCountry" => "registrant_country",
			"registrantPhone" => "registrant_phone",
			"registrantPhoneExt" => "",
			"registrantFax" => "registrant_fax",
			"registrantEmail" => "registrant_email",

			// ContactType=TECH Vars
			"techFirstName" => "tech_first_name",
			"techLastName" => "tech_last_name",
			"techJobTitle" => "",
			"techCompany" => "tech_org_name",
			"techAddress1" => "tech_address1",
			"techAddress2" => "tech_address2",
			"techAddress3" => "tech_address3",
			"techCity" => "tech_city",
			"techStateProvinceChoice" => "",
			"techState" => "tech_state",
			"techPostalCode" => "tech_postal_code",
			"techCountry" => "tech_country",
			"techPhone" => "tech_phone",
			"techPhoneExt" => "",
			"techFax" => "tech_fax",
			"techEmail" => "tech_email",

			// ContactType=ADMIN Vars
			"adminFirstName" => "admin_first_name",
			"adminLastName" => "admin_last_name",
			"adminJobTitle" => "",
			"adminCompany" => "admin_org_name",
			"adminAddress1" => "admin_address1",
			"adminAddress2" => "admin_address2",
			"adminAddress3" => "admin_address3",
			"adminCity" => "admin_city",
			"adminStateProvinceChoice" => "",
			"adminState" => "admin_state",
			"adminPostalCode" => "admin_postal_code",
			"adminCountry" => "admin_country",
			"adminPhone" => "admin_phone",
			"adminPhoneExt" => "",
			"adminFax" => "admin_fax",
			"adminEmail" => "admin_email",

			// ContactType=AUXBILLING Vars
			"auxBillingFirstName" => "auxBilling_first_name",
			"auxBillingLastName" => "auxBilling_last_name",
			"auxBillingJobTitle" => "",
			"auxBillingCompany" => "auxBilling_org_name",
			"auxBillingAddress1" => "auxBilling_address1",
			"auxBillingAddress2" => "auxBilling_address2",
			"auxBillingAddress3" => "auxBilling_address3",
			"auxBillingCity" => "auxBilling_city",
			"auxBillingStateProvinceChoice" => "",
			"auxBillingState" => "auxBilling_state",
			"auxBillingPostalCode" => "auxBilling_postal_code",
			"auxBillingCountry" => "auxBilling_country",
			"auxBillingPhone" => "auxBilling_phone",
			"auxBillingPhoneExt" => "",
			"auxBillingFax" => "auxBilling_fax",
			"auxBillingEmail" => "auxBilling_email",
		);
	 }


	/**
	 * Returns the default configuration parameters for the OpenSRS module. The number of elements in each array must be identical to
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 *
	 * @return	An array of arrays containing all the parameters the module uses.
	 */
	function addDefaultConfigParams(){
		$defaultConfigParams = array(
			array(NULL, NULL, "moduleUsername", "", "TRANS_REGISTRAR_MODULE_SETTINGS", "TRANS_REGISTRAR_USERNAME", "", "t", 1,2,0, NULL),
			array(NULL, NULL, "modulePassword", "", "TRANS_REGISTRAR_MODULE_SETTINGS", "TRANS_REGISTRAR_PASSWORD", "", "p", 1,3,0, NULL),
			array(NULL, NULL, "modulePrivateKey", "", "TRANS_REGISTRAR_MODULE_SETTINGS", "TRANS_REGISTRAR_PRIVATE_KEY", "", "t", 1,4,0, NULL),
			array(NULL, NULL, "moduleTestMode", "1", "TRANS_REGISTRAR_MODULE_SETTINGS", "TRANS_REGISTRAR_ENABLE_OPENSRS_TEST_MODE", "", "b", 0,5,0, NULL),
			array(NULL, NULL, "moduleAllowAutoRenew", "0","TRANS_REGISTRAR_MODULE_SETTINGS", "TRANS_REGISTRAR_OPENSRS_ALLOW_AUTORENEW", "TRANS_REGISTRAR_OPENSRS_ALLOW_AUTORENEW_DESC", "r", 0,8, 0,array
				(array(NULL, NULL, "0","TRANS_OBEY_TLD",1),
				array(NULL, NULL, "1","TRANS_REGISTRAR_AUTORENEW_OPTION",2),
				array(NULL, NULL, "2","TRANS_MODERNBILL_RENEW_OPTION",3))),
			array(NULL, NULL, "moduleAllowChangeDNS", "0","TRANS_REGISTRAR_MODULE_SETTINGS", "TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_DNS", "TRANS_REGISTRAR_OPENSRS_ALLOW_CHANGE_DNS_DESC", "b", 0,13, 0, NULL),
			// admin contact data
			array(NULL, NULL, "adminFirstname", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_FIRST_NAME", "", "t", 0,19,0, NULL),
			array(NULL, NULL, "adminLastName", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_LAST_NAME", "", "t", 0,20,0, NULL),
			array(NULL, NULL, "adminCompany", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_COMPANY", "", "t", 0,21,0, NULL),
			array(NULL, NULL, "adminEmail", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_EMAIL", "", "t", 0,22,0, NULL),
			array(NULL, NULL, "adminAddress1", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_ADDRESS1", "", "t", 0,23,0, NULL),
			array(NULL, NULL, "adminAddress2", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_ADDRESS2", "", "t", 0,24,0, NULL),
			array(NULL, NULL, "adminCity", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_CITY", "", "t", 0,25,0, NULL),
			array(NULL, NULL, "adminState", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_STATE", "", "t", 0,26,0, NULL),
			array(NULL, NULL, "adminZip", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_ZIP", "", "t", 0,27,0, NULL),
			array(NULL, NULL, "adminCountry", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_COUNTRY", "", "s", 0,28,0, $this->_getCountryOptions()),
			array(NULL, NULL, "adminPhone", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_PHONE", "", "t", 0,29,0, NULL),
			array(NULL, NULL, "adminFax", "", "TRANS_ADMINISTRATIVE_CONTACT", "TRANS_REGISTRAR_FAX", "", "t", 0,30,0, NULL),
			// tech contact data
			array(NULL, NULL, "techFirstname", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_FIRST_NAME", "", "t", 0,31,0, NULL),
			array(NULL, NULL, "techLastName", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_LAST_NAME", "", "t", 0,32,0, NULL),
			array(NULL, NULL, "techCompany", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_COMPANY", "", "t", 0,33,0, NULL),
			array(NULL, NULL, "techEmail", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_EMAIL", "", "t", 0,34,0, NULL),
			array(NULL, NULL, "techAddress1", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_ADDRESS1", "", "t", 0,35,0, NULL),
			array(NULL, NULL, "techAddress2", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_ADDRESS2", "", "t", 0,36,0, NULL),
			array(NULL, NULL, "techCity", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_CITY", "", "t", 0,37,0, NULL),
			array(NULL, NULL, "techState", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_STATE", "", "t", 0,38,0, NULL),
			array(NULL, NULL, "techZip", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_ZIP", "", "t", 0,39,0, NULL),
			array(NULL, NULL, "techCountry", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_COUNTRY", "", "s", 0,40,0, $this->_getCountryOptions()),
			array(NULL, NULL, "techPhone", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_PHONE", "", "t", 0,41,0, NULL),
			array(NULL, NULL, "techFax", "", "TRANS_TECHNICAL_CONTACT", "TRANS_REGISTRAR_FAX", "", "t", 0,42,0, NULL),
			// aux billing contact data
			array(NULL, NULL, "auxBillingFirstname", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_FIRST_NAME", "", "t", 0,43,0, NULL),
			array(NULL, NULL, "auxBillingLastName", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_LAST_NAME", "", "t", 0,44,0, NULL),
			array(NULL, NULL, "auxBillingCompany", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_COMPANY", "", "t", 0,45,0, NULL),
			array(NULL, NULL, "auxBillingEmail", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_EMAIL", "", "t", 0,46,0, NULL),
			array(NULL, NULL, "auxBillingAddress1", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_ADDRESS1", "", "t", 0,47,0, NULL),
			array(NULL, NULL, "auxBillingAddress2", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_ADDRESS2", "", "t", 0,48,0, NULL),
			array(NULL, NULL, "auxBillingCity", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_CITY", "", "t", 0,49,0, NULL),
			array(NULL, NULL, "auxBillingState", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_STATE", "", "t", 0,50,0, NULL),
			array(NULL, NULL, "auxBillingZip", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_ZIP", "", "t", 0,51,0, NULL),
			array(NULL, NULL, "auxBillingCountry", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_COUNTRY", "", "s", 0,52,0, $this->_getCountryOptions()),
			array(NULL, NULL, "auxBillingPhone", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_PHONE", "", "t", 0,53,0, NULL),
			array(NULL, NULL, "auxBillingFax", "", "TRANS_BILLING_CONTACT", "TRANS_REGISTRAR_FAX", "", "t", 0,54,0, NULL),
			array(NULL, NULL, "domainNameserver1", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS1", "", "t", 0,55,0, array(), "TRANS_REGISTRAR_NS_DESC"),
			array(NULL, NULL, "domainNameserver2", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS2", "", "t", 0,56,0, array(), "TRANS_REGISTRAR_NS_DESC"),
			array(NULL, NULL, "domainNameserver3", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS3", "", "t", 0,57,0, array(), "TRANS_REGISTRAR_NS_DESC"),
			array(NULL, NULL, "domainNameserver4", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS4", "", "t", 0,58,0, array(), "TRANS_REGISTRAR_NS_DESC")
		); // $defaultConfigParams = array(

		// Grab the configs set at the registrar level
		return array_merge($this->configParams,$defaultConfigParams);
	} // END addDefaultConfigParams()

    protected function getTLDParamsData($tld, Contact $contact = NULL)
    {
        $params = parent::getTLDParamsData($tld, $contact);
        if (!in_array($tld, $this->_auTlds)) {
            return $params;
        }
        $eIdTypes = array(
            'ACN' => 'TRANS_REGISTRAR_OPENSRS_AUSTRALIAN_COMPANY_NUMBER',
            'ABN' => 'TRANS_REGISTRAR_OPENSRS_AUSTRALIAN_BUSINESS_NUMBER',
            'VIC BN' => 'TRANS_REGISTRAR_OPENSRS_VIC_BUSINESS_NUMBER',
            'NSW BN' => 'TRANS_REGISTRAR_OPENSRS_NSW_BUSINESS_NUMBER',
            'SA BN' => 'TRANS_REGISTRAR_OPENSRS_SA_BUSINESS_NUMBER',
            'NT BN' => 'TRANS_REGISTRAR_OPENSRS_NT_BUSINESS_NUMBER',
            'WA BN' => 'TRANS_REGISTRAR_OPENSRS_WA_BUSINESS_NUMBER',
            'TAS BN' => 'TRANS_REGISTRAR_OPENSRS_TAS_BUSINESS_NUMBER',
            'ACT BN' => 'TRANS_REGISTRAR_OPENSRS_ACT_BUSINESS_NUMBER',
            'QLD BN' => 'TRANS_REGISTRAR_OPENSRS_QLD_BUSINESS_NUMBER',
            'TM' => 'TRANS_REGISTRAR_OPENSRS_TM',
            'OTHER' => 'TRANS_REGISTRAR_OPENSRS_OTHER',
        );
        $eTypes = array(
            'Charity' => 'TRANS_REGISTRAR_OPENSRS_CHARITY',
            'Child Care Centre' => 'TRANS_REGISTRAR_OPENSRS_CCC',
            'Citizen/Resident' => 'TRANS_REGISTRAR_OPENSRS_CITIZEN',
            'Club' => 'TRANS_REGISTRAR_OPENSRS_CLUB',
            'Commercial Statutory Body' => 'TRANS_REGISTRAR_OPENSRS_CSB',
            'Company' => 'TRANS_REGISTRAR_OPENSRS_COMPANY',
            'Government School' => 'TRANS_REGISTRAR_OPENSRS_GOV_SCHOOL',
            'Higher Education Institution' => 'TRANS_REGISTRAR_OPENSRS_HEI',
            'Incorporated Association' => 'TRANS_REGISTRAR_OPENSRS_IA',
            'Industry Body' => 'TRANS_REGISTRAR_OPENSRS_IBODY',
            'National Body' => 'TRANS_REGISTRAR_OPENSRS_NBODY',
            'Non-Government School' => 'TRANS_REGISTRAR_OPENSRS_NON_GOV_SCHOOL',
            'Non-profit Organisation' => 'TRANS_REGISTRAR_OPENSRS_NON_PROF_ORG',
            'Partnership' => 'TRANS_REGISTRAR_OPENSRS_PARTNERSHIP',
            'Pending TM Owner' => 'TRANS_REGISTRAR_OPENSRS_PENDING_TM_OWNER',
            'Political Party' => 'TRANS_REGISTRAR_OPENSRS_PP',
            'Pre-school' => 'TRANS_REGISTRAR_OPENSRS_PRE_SCHOOL',
            'Registered Business' => 'TRANS_REGISTRAR_OPENSRS_RB',
            'Religious/Church Group' => 'TRANS_REGISTRAR_OPENSRS_CG',
            'Research Organisation' => 'TRANS_REGISTRAR_OPENSRS_RO',
            'Sole Trader' => 'TRANS_REGISTRAR_OPENSRS_ST',
            'Trade Union' => 'TRANS_REGISTRAR_OPENSRS_TU',
            'Trademark Owner' => 'TRANS_REGISTRAR_OPENSRS_TOWNER',
            'Training Organisation' => 'TRANS_REGISTRAR_OPENSRS_TORG',
            'Other' => 'TRANS_REGISTRAR_OPENSRS_OTHER',
        );
        $rIdTypes = array(
            'ACN' => 'TRANS_REGISTRAR_OPENSRS_AUSTRALIAN_COMPANY_NUMBER',
            'ABN' => 'TRANS_REGISTRAR_OPENSRS_AUSTRALIAN_BUSINESS_NUMBER',
            'OTHER' => 'TRANS_REGISTRAR_OPENSRS_OTHER',
        );
        $eIdTypeOptions = $eTypeOptions = $rIdTypeOptions = array();
        foreach($rIdTypes as $key => $value) {
            $rIdTypeOptions[] = array('title' => blmsg($value), 'value' => $key);
        }
        foreach($eIdTypes as $key => $value) {
            $eIdTypeOptions[] = array('title' => blmsg($value), 'value' => $key);
        }
        foreach($eTypes as $key => $value) {
            $eTypeOptions[] = array('title' => blmsg($value), 'value' => $key);
        }
        $required = (in_array($tld, array('com.au', 'net.au'))) ? true : false ;
        $auParams = array(
            "title" => blmsg("TRANS_REGISTRAR_OPENSRS_AU_SPECIFIC_DATA"),
            "additionalMessage" => blmsg("TRANS_REGISTRAR_OPENSRS_AU_SPECIFIC_DATA_DESC"),
            "attributes" => array(
                array(
                    "name" => "eligibility_id",
                    "required" => $required,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_ID"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_ID_DESC"),
                    "userdefined" => "True",
                ),
                array(
                    "name" => "eligibility_id_type",
                    "required" => true,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_ID_TYPE"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_ID_TYPE_DESC"),
                    "options" => $eIdTypeOptions,
                ),
                array(
                    "name" => "eligibility_name",
                    "required" => $required,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_NAME"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_NAME_DESC"),
                    "userdefined" => "True",
                ),
                array(
                    "name" => "eligibility_type",
                    "required" => true,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_TYPE"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_ELIGIBILITY_TYPE_DESC"),
                    "options" => $eTypeOptions,
                ),
                array(
                    "name" => "registrant_id",
                    "required" => true,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_REGISTRANT_ID"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_REGISTRANT_ID_DESC"),
                    "userdefined" => "True",
                ),
                array(
                    "name" => "registrant_name",
                    "required" => true,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_REGISTRANT_NAME"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_REGISTRANT_NAME_DESC"),
                    "default" => $contact->contact_fullname,
                    "userdefined" => "True",
                ),
                array(
                    "name" => "registrant_id_type",
                    "required" => true,
                    "description" => blmsg("TRANS_REGISTRAR_OPENSRS_REGISTRANT_ID_TYPE"),
                    "hint" => blmsg("TRANS_REGISTRAR_OPENSRS_REGISTRANT_ID_TYPE_DESC"),
                    "options" => $rIdTypeOptions,
                ),
            ),
        );
        return array_merge($params, $auParams);
    }

    protected function getLanguageMapByTLD($tld)
    {
        static $languages;
        if (is_null($languages)) {
            $infoLanguages = array(
                'DAN' => 'da', 'GER' => 'de', 'HUN' => 'hu', 'ICE' => 'is',
                'KOR' => 'ko', 'LAV' => 'lv', 'LIT' => 'lt', 'POL' => 'pl', 'SWE' => 'sv',
                'DAN' => 'da', 'GER' => 'de', 'ICE' => 'is', 'SWE' => 'sv'
            );
            $deLanguages = array(
                'DAN' => 'da', 'GER' => 'de', 'CHI' => 'zh_Hans', 'ICE' => 'is',
                'JPN' => 'ja', 'NOR' => 'nb', 'SPA' => 'es','SWE' => 'sv',
                'DAN' => 'da', 'GER' => 'de', 'ICE' => 'is', 'SWE' => 'sv'
            );
            $orgLanguages = array(
                'BEL' => 'be', 'BOS' => 'bs' ,'BUL' => 'bg',
                'HUN' => 'hu', 'KOR' => 'ko', 'LAV' => 'lv',
                'LIT' => 'lt', 'MAC' => 'mk', 'POL' => 'pl',
                'SCC' => 'sr_Cyrl', 'SPA' => 'es', 'SWE' => 'sv',
                'UKR' => 'uk', 'ZH-CN' => 'zh_Hans', 'ZH-TW' => 'zh_Hant',
                'DAN' => 'da', 'GER' => 'de', 'ICE' => 'is'
            );
            $bizLanguages = array(
                'CHI' => 'zh_Hans', 'FIN' => 'fi', 'POR' => 'pt',
                'HUN' => 'hu', 'JPN' => 'ja', 'KOR' => 'ko',
                'LAV' => 'lv', 'LIT' => 'lt', 'POL' => 'pl', 'POR' => 'pt',
                'SPA' => 'es', 'NOR' => 'nb',
            );
            $otherLanguages = array(
                'ALB' => 'sq', 'ARA' => 'ar', 'ARM' => 'hy', 'ASM' => 'as',
                'AZE' => 'az_Cyrl', 'BEL' => 'be', 'BEN' => 'bn', 'BOS' => 'bs' ,
                'BUL' => 'bg', 'CAT' => 'ca', 'CHI' => 'zh_Hans', 'CZE' => 'cs',
                'DUT' => 'nl', 'ENG' => 'en', 'EST' => 'et', 'FIN' => 'fi',
                'GEO' => 'ka', 'GRE' => 'el', 'HIN' => 'hi', 'HUN' => 'hu',
                'IND' => 'id', 'ITA' => 'it', 'JPN' => 'ja', 'KAZ' => 'kk',
                'KHM' => 'km', 'KIR' => 'ky', 'KOR' => 'ko', 'LAO' => 'lo',
                'LAV' => 'lv', 'LIT' => 'lt', 'MAC' => 'mk', 'MON' => 'mn',
                'NEP' => 'ne', 'NOR' => 'nb', 'POL' => 'pl', 'POR' => 'pt',
                'RUS' => 'ru', 'RUM' => 'ro', 'SCC' => 'sr_Cyrl', 'SLO' => 'sk',
                'SLV' => 'sl', 'SPA' => 'es', 'SYR' => 'syr', 'TGK' => 'tg',
                'THA' => 'th', 'TUR' => 'tr', 'UKR' => 'uk', 'UZB' => 'uz_Cyrl',
                'VIE' => 'vi', 'wel' => 'cy', 'FRE' => 'fr', 'HEB' => 'he',
                'DAN' => 'da', 'GER' => 'de', 'ICE' => 'is', 'SWE' => 'sv',
            );


            $languages = array(
                'com' => $otherLanguages,
                'net' => $otherLanguages,
                'cc' => $otherLanguages,
                'tv' => $otherLanguages,
                'name' => $otherLanguages,
                'biz' => $bizLanguages,
                'de' => $deLanguages,
                'info' => $infoLanguages,
                'me' => $infoLanguages,
                'org' => $orgLanguages,
                'co' => array('SPA' => 'es'),
                'es' => array('SPA' => 'es'),
                'eu' => array(),
            );
        }
        return (isset($languages[$tld])) ? $languages[$tld] : array();
    }

    private function _setWhoisPrivacyState()
    {
        if ( isset($this->input['idProtect']) && $this->input['idProtect'] ) {

            dbg("============= WHOIS PRIVACY SUPPORT WAS ATTEMPTED ==============");
            $result = $this->callOpenSRS("<?xml version='1.0' encoding='UTF-8' standalone='no'?>
                <!DOCTYPE OPS_envelope SYSTEM 'ops.dtd'>
                <OPS_envelope>
                    <header>
                        <version>0.9</version>
                    </header>
                    <body>
                        <data_block>
                            <dt_assoc>
                                <item key='object'>domain</item>
                                <item key='domain'>".$this->input["domainSLD"].".".$this->input["domainTLD"]."</item>
                                <item key='action'>modify</item>
                                <item key='protocol'>XCP</item>
                                <item key='attributes'>
                                    <dt_assoc>
                                        <item key='state'>enable</item>
                                        <item key='data'>whois_privacy_state</item>
                                    </dt_assoc>
                                </item>
                            </dt_assoc>
                        </data_block>
                    </body>
                </OPS_envelope>", true
            );

            preg_match("/<OPS_envelope>(.*)<\\/OPS_envelope>/s",$result,$message);

            if ($message[0]){
                $x = new MBXMLLite($message[0]);
                $result = $x->toArray();
            }

            $response = $this->getOpenSRSResponse($result["OPS_envelope"][0]["body"][0]["data_block"][0]["dt_assoc"][0]["item"]);
            $message = $response["responseText"];
            $responseCode = $response["responseCode"];
            $result = NULL;

            if ($responseCode == 200){
                dbg("============= WHOIS PRIVACY SUPPORT IS SET ==============");
                return true;
            } else {
                $this->errors[] = array("OpenSRS Error:", $message);
                $this->numErrors++;
                return false;
            }
        } else {
            return true;
        }
    }

    private $_auTlds = array('com.au', 'net.au', 'org.au', 'edu.au', 'gov.au', 'csiro.au', 'asn.au', 'id.au');
    private $_auAddParams = array('eligibility_id', 'eligibility_id_type', 'eligibility_name',
        'eligibility_type', 'registrant_id', 'registrant_name', 'registrant_id_type'
    );
}
