<?php

namespace Module\Ssl\Opensrs;

$services = array(
	\OpensrsSsl::SERVICE_GEOTRUST_QUICKSSL => array(
		'code' => 'quickssl',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_DOMAIN					=> true,
			ServicesDescriptor::REQUIREMENT_APPROVER_EMAIL			=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true
		)
	),
	\OpensrsSsl::SERVICE_GEOTRUST_QUICKSSLPREMIUM	=> array(
		'code' => 'quickssl_premium',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_DOMAIN					=> true,
			ServicesDescriptor::REQUIREMENT_APPROVER_EMAIL			=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true
		)
	),
	\OpensrsSsl::SERVICE_GEOTRUST_TRUEBUSINESSID => array(
		'code' => 'truebizid',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	),
	\OpensrsSsl::SERVICE_GEOTRUST_TRUEBUSINESSIDEV => array(
		'code' => 'truebizid_ev',
		'period' => 2,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_DOMAIN					=> true,
			ServicesDescriptor::REQUIREMENT_APPROVER_EMAIL			=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_GEOTRUST_TRUEBUSINESSIDWILDCARD => array(
		'code' => 'truebizid_wildcard',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	),
	\OpensrsSsl::SERVICE_THAWTE_SGCSUPERCERTS	=> array(
		'code' => 'sgcsuper_certs',
		'period' => 4,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_THAWTE_SSL123 => array(
		'code' => 'ssl123',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_DOMAIN					=> true,
			ServicesDescriptor::REQUIREMENT_APPROVER_EMAIL			=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_THAWTE_SSLWEBSERVER => array(
		'code' => 'sslwebserver',
		'period' => 3,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_THAWTE_SSLWEBSERVEREV => array(
		'code' => 'sslwebserver_ev',
		'period' => 2,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_THAWTE_SSLWEBSERVERWILDCARD => array(
		'code' => 'sslwebserver_wildcard',
		'period' => 2,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_TRUSTWAVE_DV => array(
		'code' => 'trustwave_dv',
		'period' => 3,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_DOMAIN					=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
		)
	),
	\OpensrsSsl::SERVICE_TRUSTWAVE_EV => array(
		'code' => 'trustwave_ev',
		'period' => 2,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
		)
	),
	\OpensrsSsl::SERVICE_TRUSTWAVE_PREMIUMSSL => array(
		'code' => 'trustwave_premiumssl',
		'period' => 3,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
		)
	),
	\OpensrsSsl::SERVICE_TRUSTWAVE_PREMIUMSSL_WILDCARD => array(
		'code' => 'trustwave_premiumssl_wildcard',
		'period' => 3,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
		)
	),
	\OpensrsSsl::SERVICE_VERISIGN_SECURESITE => array(
		'code' => 'securesite',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_VERISIGN_SECURESITEEV => array(
		'code' => 'securesite_ev',
		'period' => 2,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_VERISIGN_SECURESITEPRO => array(
		'code' => 'securesite_pro',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_VERISIGN_SECURESITEPROEV => array(
		'code' => 'securesite_pro_ev',
		'period' => 2,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMMON,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_BILLING			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_TECH			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_TITLE					=> true
		)
	),
	\OpensrsSsl::SERVICE_COMODO_SSL => array(
		'code' => 'comodo_ssl',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMODO,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	),
	\OpensrsSsl::SERVICE_COMODO_INSTANTSSL => array(
		'code' => 'comodo_instantssl',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMODO,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	),
	\OpensrsSsl::SERVICE_COMODO_PREMIUMSSL => array(
		'code' => 'comodo_premiumssl',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMODO,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	),
	\OpensrsSsl::SERVICE_COMODO_EV => array(
		'code' => 'comodo_ev',
		'period' => 2,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMODO,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ADMIN			=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true,
			ServicesDescriptor::REQUIREMENT_CONTACT_SIGNER			=> true
		)
	),
	\OpensrsSsl::SERVICE_COMODO_WILDCARD => array(
		'code' => 'comodo_wildcard',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMODO,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	),
	\OpensrsSsl::SERVICE_COMODO_PREMIUMWILDCARD => array(
		'code' => 'comodo_premiumssl_wildcard',
		'period' => 5,
		'server_types' => ServicesDescriptor::SERVER_TYPES_COMODO,
		'requirements' => array(
			ServicesDescriptor::REQUIREMENT_SERVER_TYPE				=> true,
			ServicesDescriptor::REQUIREMENT_SERVER_COUNT			=> true,
			ServicesDescriptor::REQUIREMENT_CSR						=> true,
			ServicesDescriptor::REQUIREMENT_SPECIAL_INSTRUCTIONS	=> false,
			ServicesDescriptor::REQUIREMENT_CONTACT_ORGANIZATION	=> true
		)
	)
);

$serverTypes = array(
	ServicesDescriptor::SERVER_TYPES_COMMON => array(
		'apache',
		'apache2',
		'apacheopenssl',
		'apacheraven',
		'apachessl',
		'apachessleay',
		'c2net',
		'cobaltseries',
		'cobaltraq3',
		'cobaltraq2',
		'cpanel',
		'domino',
		'dominogo4626',
		'dominogo4625',
		'ensim',
		'hsphere',
		'iis',
		'iis4',
		'iis5',
		'iplanet',
		'ipswitch',
		'netscape',
		'ibmhttp',
		'plesk',
		'tomcat',
		'weblogic',
		'website',
		'webstar',
		'webstar4',
		'zeusv3',
		'other'
	),
	ServicesDescriptor::SERVER_TYPES_COMODO => array(
		'apachessl',
		'citrix',
		'domino',
		'ensim',
		'hsphere',
		'iis4',
		'iis6',
		'iis7',
		'iplanet',
		'javawebserver',
		'netscape',
		'ibmhttp',
		'novell',
		'oracle',
		'plesk',
		'redhat',
		'sap',
		'tomcat',
		'webstar',
		'whmcpanel',
		'other'
	)
);