<?php

namespace Module\Ssl\Opensrs;

class Command
{
	const COMMAND_QUERY_APPROVER_LIST = 'query_approver_list';
	const COMMAND_REGISTER = 'register';
	const COMMAND_GET_ORDER_INFO = 'get_order_info';
	
	public function __construct(Negotiator $negotiator, $command)
	{
		$this->_negotiator = $negotiator;
		$template = dirname(__FILE__) . '/../templates/' . $command . '.phtml';
		if (!file_exists($template)) {
			throw new Exception('Could not find template of command "' . $command . '".');
		}
		$this->_template = $template;
	}
	
	public function __set($name, $value)
	{
		$this->_parameters[$name] = $value;
	}
	
	public function run()
	{
		dbg('Run OpenSRS command "' . $this->_template . '"');
		$escapedParameters = array();
		foreach ($this->_parameters as $name => $value) {
			$escapedParameters[$name] = htmlspecialchars($value, ENT_COMPAT | ENT_HTML401, 'UTF-8');
		}
		extract($escapedParameters);
		ob_start();
		include $this->_template;
		$message = '<?xml version="1.0" encoding="UTF-8"?>' . ob_get_clean();
		dbg($message);
		foreach (array_keys($escapedParameters) as $name => $value) {
			unset($$name);
		}
		$response = $this->_negotiator->say($message);
		dbg($response);
		return new Response($response);
	}
	
	private $_parameters = array();
	private $_template;
	private $_negotiator;
}