<?php

namespace Module\Ssl\Opensrs;

class Response
{
	public function __construct($response)
	{
		$this->_response = simplexml_load_string($response);
	}
	
	public function __get($name)
	{
		switch ($name) {
			case 'attributes':
				return new Response\Attributes(reset($this->_response->xpath('//body/data_block/dt_assoc/item[@key="attributes"]/dt_assoc')));
			case 'isSuccess':
				$isSuccess = (int)reset($this->_response->xpath('//body/data_block/dt_assoc/item[@key="is_success"]'));
				return $isSuccess > 0;
			case 'code':
				return (int)reset($this->_response->xpath('//body/data_block/dt_assoc/item[@key="response_code"]'));
			case 'message':
				return (string)reset($this->_response->xpath('//body/data_block/dt_assoc/item[@key="response_text"]'));
			case 'errors':
				$node = reset($this->_response->xpath('//body/data_block/dt_assoc/item[@key="error_details"]/dt_array'));
				if (!$node) {
					return array();
				}
				$errors = array();
				foreach ($node->xpath('//item/dt_assoc') as $errorNode) {
					$errors[] = new Response\Error($errorNode);
				}
				return $errors;
			default:
				throw new Exception('Property "' . $name . '" is not supported.');
		}
	}
	
	private $_response;
}