<?php

namespace Module\Ssl\Opensrs;

class ServicesDescriptor
{
	const SERVER_TYPES_COMMON						= 'common';
	const SERVER_TYPES_COMODO						= 'comodo';
	
	const REQUIREMENT_DOMAIN						= 'domain';
	const REQUIREMENT_APPROVER_EMAIL				= 'approver_email';
	const REQUIREMENT_SERVER_TYPE					= 'server_type';
	const REQUIREMENT_SERVER_COUNT					= 'server_count';
	const REQUIREMENT_CSR							= 'csr';
	const REQUIREMENT_SPECIAL_INSTRUCTIONS			= 'special_instructions';
	const REQUIREMENT_CONTACT_ORGANIZATION			= 'organization';
	const REQUIREMENT_CONTACT_ADMIN					= 'admin';
	const REQUIREMENT_CONTACT_BILLING				= 'billing';
	const REQUIREMENT_CONTACT_TECH					= 'tech';
	const REQUIREMENT_CONTACT_SIGNER				= 'signer';
	const REQUIREMENT_TITLE							= 'title';
	
	public function __construct($path)
	{
		include $path;
		if (!isset($services)) {
			throw new Exception('Unable to load services from file "' . $path . '".');
		}
		$this->_services = $services;
		unset($services);
		if (!isset($serverTypes)) {
			throw new Exception('Unable to load server types from file "' . $path . '".');
		}
		$this->_serverTypes = $serverTypes;
		unset($serverTypes);
	}
	
	public function __get($name)
	{
		return isset($this->_services[$name]) ? $this->_services[$name] : null;
	}
	
	public function getNames()
	{
		return array_keys($this->_services);
	}
	
	public function getServerTypes($group)
	{
		return isset($this->_serverTypes[$group]) ? $this->_serverTypes[$group] : array();
	}
	
	private $_services;
	private $_serverTypes;
}