{* $Id: ShowAccountsReceivableLedger.tpl 10261 2006-12-11 19:48:58Z kbailey $
 * --------------------------------------------------------------
 * This template displays the daily purchases journal.
 *
 * Smarty Variables:
 *	$generalLedger (array of ledger entries)
 *		generalLedgerID
 *		clientID
 *		invoiceID
 *		journalTableID
 *		journalTableName
 *		generalLedgerDateCreated
 *		generalLedgerDescription
 *		generalLedgerDebitAmount
 *		generalLedgerCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_GENERAL_LEDGERS' => action_url('accounting', 'ShowLedgersMenu'), 'TRANS_ACCOUNTS_RECEIVABLE_LEDGER');{/php}

{foreach key="currencyID" item="generalLedger" from=$currencies}
    {include file="$tplDirectory/widgets/list-box-header.tpl" title=$currencyID}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                {assign var="queryArgs" value="dateQuery[]=`$dateQuery.0`&arLedgerBeginMonth=`$arLedgerBeginMonth`&arLedgerBeginDay=`$arLedgerBeginDay`&arLedgerBeginYear=`$arLedgerBeginYear`&arLedgerEndMonth=`$arLedgerEndMonth`&arLedgerEndDay=`$arLedgerEndDay`&arLedgerEndYear=`$arLedgerEndYear`"}
                <tr class="odd">
                    <th class="green">{include sortColumn="generalLedgerDateCreated" text="TRANS_DATE"|lmsg file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowAccountsReceivableLedger" queryArgs=$queryArgs}</th>
                    <th class="green">{include sortColumn="invoiceID" text="TRANS_INVOICE"|lmsg file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowAccountsReceivableLedger" queryArgs=$queryArgs}</th>
                    <th>{"TRANS_PACKAGE_NAME"|lmsg}</th>
                    <th class="green">{include sortColumn="generalLedgerDescription" text="TRANS_DESCRIPTION"|lmsg file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowAccountsReceivableLedger" queryArgs=$queryArgs}</th>
                    <th>{include sortColumn="ledgerAccountNumber" text="TRANS_GL_ACCOUNT"|lmsg file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowAccountsReceivableLedger" queryArgs=$queryArgs}</th>
                    <th class="green">{include sortColumn="generalLedgerDebitAmount" text="TRANS_DEBIT"|lmsg file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowAccountsReceivableLedger" queryArgs=$queryArgs}</th>
                    <th>{include sortColumn="generalLedgerCreditAmount" text="TRANS_CREDIT"|lmsg file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowAccountsReceivableLedger" queryArgs=$queryArgs}</th>
                </tr>
            <thead>
            <tbody>
                {section name="i" loop=$generalLedger}
                    {assign var="generalLedgerID" value=$generalLedger[i].generalLedgerID}
                    <tr class="{cycle values="even,odd"}">
                        <td class="green text-center">{$generalLedger[i].generalLedgerDateCreated|getDate}</td>
                        <td class="green" class="text-right"><a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$generalLedger[i].invoiceID`"}">{$generalLedger[i].invoiceNumber}</a></td>
                        <td><a href="{getHREF page="packages.php" actionName="ShowPackageDetails" args="packageID=`$ledgerPackageNames[$generalLedgerID].packageID`"}">{$ledgerPackageNames[$generalLedgerID].name}</a></td>
                        <td class="description">{$generalLedger[i].generalLedgerDescription|lmsg}</td>
                        {assign var="tkey" value=$generalLedger[i].ledgerAccountTransKey}
                        <td>{$generalLedger[i].ledgerAccountNumber} - {$tkey|lmsg}</td>
                        <td width="10%" class="text-right">{$generalLedger[i].generalLedgerDebitAmount|getAmount:$currencyID:false}</td>
                        <td width="10%" class="text-right">{$generalLedger[i].generalLedgerCreditAmount|getAmount:$currencyID:false}</td>
                    </tr>
                {/section}
            </tbody>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{foreachelse}
    {"TRANS_NO_ACCOUNTS_PAYABLE_LEDGER_ENTRIES"|lmsg}
{/foreach}
{include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="dateQuery[]=`$dateQuery.0`&arLedgerBeginMonth=`$arLedgerBeginMonth`&arLedgerBeginDay=`$arLedgerBeginDay`&arLedgerBeginYear=`$arLedgerBeginYear`&arLedgerEndMonth=`$arLedgerEndMonth`&arLedgerEndDay=`$arLedgerEndDay`&arLedgerEndYear=`$arLedgerEndYear`"}