{* $Id: ShowInvoiceSheet.tpl 10322 2006-12-15 20:29:33Z kbailey $
 * --------------------------------------------------------------
 * Author: Kris Bailey
 *}

<h2 class="text-center">{"TRANS_INVOICE_SHEET"|lmsg} {"TRANS_FOR"|lmsg} {"TRANS_DATE"|lmsg} {$startDate|getDate:short}</h2>
<div class="list">
    <table width="100%" cellspacing="0">
        <thead>
            <tr>
                <th>{"TRANS_INVOICE_NUMBER"|lmsg}</th>
                <th>{"TRANS_CLIENT"|lmsg}</th>
                <th>{"TRANS_CURRENCY"|lmsg}</th>
                <th>{"TRANS_AMOUNT"|lmsg}</th>
                <th>{"TRANS_AMOUNT_PAID"|lmsg}</th>
                <th>{"TRANS_AMOUNT_DUE"|lmsg}</th>
            </tr>
        </thead>
        <tbody>
            {foreach item="invoice" key="i" from=$invoices}
                {assign var="clientName" value="`$invoice.contactFirstName` `$invoice.contactLastName`"}
                <tr class="{cycle values="odd,even"}">
                    <td><a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoice.invoiceID`"}">{$invoice.invoiceNumber}</a></td>
                    <td>{include file="$tplDirectory/widgets/actionLink.tpl"
                            page="clients.php"
                            actionName="ShowClientDetails"
                            args="clientID=`$invoice.clientID`"
                            clientID=$invoice.clientID
                            clientContactID=$invoice.clientContactID
                            altText=$clientName
                            linkText=$clientName
                        }</td>
                    <td>{$invoice.currencyID}</td>
                    <td>{$invoice.invoiceAmount|getAmount:$invoice.currencyID}</td>
                    <td>{$invoice.invoiceAmountPaid|getAmount:$invoice.currencyID}</td>
                    <td>{$invoice.invoiceAmount-$invoice.invoiceAmountPaid|getAmount:$invoice.currencyID}</td>
                </tr>
            {foreachelse}
                <tr class="odd">
                    <td colspan="6">{"TRANS_NONE"|lmsg}</td>
                </tr>
            {/foreach}
        </tbody>
    </table>
</div>

{if $numInvoices>0}
    {include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_SUMMARY"}
    <div class="form-row"><div class="field-name">{"TRANS_TOTAL_INVOICES"|lmsg}</div>
        <div class="field-value"><div class="text-value">
            {$numInvoices}
        </div></div>
    </div>
    <div class="form-row"><div class="field-name">{"TRANS_TOTAL_CLIENTS"|lmsg}</div>
        <div class="field-value"><div class="text-value">
            {$numClients}
        </div></div>
    </div>
    {foreach item="totals" key="currencyID" from=$currencies}
        <div class="list">
            <table width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <th colspan="2">{$currencyID} {"TRANS_TOTALS"|lmsg}</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="odd">
                        <td class="field-name">{"TRANS_INVOICES"|lmsg}</td>
                        <td class="field-value">{$totals.numInvoices}</td>
                    </tr>
                    <tr class="even">
                        <td class="field-name">{"TRANS_CLIENTS"|lmsg}</td>
                        <td class="field-value">{$totals.numClients}</td>
                    </tr>
                    <tr class="odd">
                        <td class="field-name">{"TRANS_AMOUNT"|lmsg}</td>
                        <td class="field-value">{$totals.totalAmount|getAmount:$currencyID}</td>
                    </tr>
                    <tr class="even">
                        <td class="field-name">{"TRANS_AMOUNT_PAID"|lmsg}</td>
                        <td class="field-value">{$totals.totalAmountPaid|getAmount:$currencyID}</td>
                    </tr>
                    <tr class="odd">
                        <td class="field-name">{"TRANS_AMOUNT_DUE"|lmsg}</td>
                        <td class="field-value">{$totals.totalAmount-$totals.totalAmountPaid|getAmount:$currencyID}</td>
                    </tr>
                </tbody>
            </table>
        </div>
    {/foreach}
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{/if}