{* $Id: ShowLedgerAccounts.tpl 5685 2006-03-22 00:48:07Z kbailey $
 * --------------------------------------------------------------
 * This template displays the ledger accounts management page.
 *
 * Smarty Variables:
 *	$ledgerAccounts (array of ledger account data)
 *		ledgerAccountID
 *		ledgerAccountNumber
 *		ledgerAccountType
 * 		ledgerAccountName
 *		ledgerAccountTransKey
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_LEDGER_ACCOUNTS');{/php}

{include file="$commonTplDirectory/widgets/tabs.tpl" tabs=$tabs}

<div class="actions-box">
    <div class="objects-toolbar clearfix">
        <a id="billing-id-add-new" class="s-btn sb-add-new" title="{"TRANS_ADD_LEDGER_ACCOUNT"|lmsg}" href="{getHREF page="accounting.php" actionName="AddLedgerAccount"}">
            <i><i><i><span>{"TRANS_ADD_LEDGER_ACCOUNT"|lmsg}</span></i></i></i>
        </a>
    </div>
</div>
{include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_BALANCE_SHEET_ACCOUNTS"}
<div class="list">
    <table width="100%" cellspacing="0">
        <thead>
            <tr>
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_GL_NUMBER" sortColumn="ledgerAccountNumber"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_NAME"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
            </tr>
        </thead>
        <tbody>
            {section name=i loop=$ledgerAccounts}
                {assign var="ledgerAccountID" value=$ledgerAccounts[i].ledgerAccountID}
                {if $ledgerAccounts[i].ledgerAccountType < 4}
                    {if $ledgerAccounts[i].ledgerAccountType != $ledgerAccountType}
                        {assign var="ledgerAccountType" value=$ledgerAccounts[i].ledgerAccountType}
                        <tr>
                            <td colspan="3">
                                {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
                                {$transkey|lmsg}
                            </td>
                        </tr>
                    {/if}
                    <tr class="{cycle values="odd,even"}">
                        <td width="70">
                            {$ledgerAccounts[i].ledgerAccountNumber}
                        </td>
                        <td>
                            {assign var="ledgerAccountTransKey" value=$ledgerAccounts[i].ledgerAccountTransKey}
                                    {$ledgerAccountTransKey|lmsg}
                        </td>
                        <td>
                            {strip}
                                {assign var="bookmarkArgsLink" value=$bookmarkArgs|escape:url}
                                {include file="$tplDirectory/widgets/actionLink.tpl"
                                    page="accounting.php"
                                    actionName="ShowLedgerAccountDetails"
                                    args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgsLink"
                                    icoImage="details"
                                    altText="TRANS_DETAILS"
                                    linkText="TRANS_DETAILS"}
                                &nbsp;&nbsp;&nbsp;
                                {include file="$tplDirectory/widgets/actionLink.tpl"
                                    page="accounting.php"
                                    actionName="EditLedgerAccount"
                                    args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgsLink"
                                    icoImage="edit"
                                    altText="TRANS_EDIT"
                                    linkText="TRANS_EDIT"}
                                {if $ledgerAccounts[i].allowRemove}
                                    &nbsp;&nbsp;&nbsp;
                                    {include file="$tplDirectory/widgets/actionLink.tpl"
                                        page="accounting.php"
                                        actionName="RemoveLedgerAccount"
                                        args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgsLink"
                                        icoImage="remove"
                                        altText="TRANS_REMOVE"
                                        linkText="TRANS_REMOVE"}
                                {/if}
                            {/strip}
                        </td>
                    </tr>
                {/if}
            {sectionelse}
                <tr class="odd">
                    <td colspan="3">
                        {"TRANS_NO_LEDGER_ACCOUNTS_FOUND"|lmsg}
                    </td>
                </tr>
            {/section}
        </tbody>
    </table>
</div>
{include file="$tplDirectory/widgets/list-box-footer.tpl"}

{include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_FINANCIAL_STATEMENT_ACCOUNTS"}
<div class="list">
    <table width="100%" cellspacing="0">
        <thead>
            <tr>
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_GL_NUMBER" sortColumn="ledgerAccountNumber"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_NAME"}
                {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
            </tr>
        </thead>
        <tbody>
            {section name=i loop=$ledgerAccounts}
                {assign var="ledgerAccountID" value=$ledgerAccounts[i].ledgerAccountID}
                {if $ledgerAccounts[i].ledgerAccountType > 3}
                    {if $ledgerAccounts[i].ledgerAccountType != $ledgerAccountType}
                        {assign var="ledgerAccountType" value=$ledgerAccounts[i].ledgerAccountType}
                        <tr>
                            <td colspan="3" >
                                {assign var="transkey" value=$accountTypes.$ledgerAccountType.1}
                                {$transkey|lmsg}
                            </td>
                        </tr>
                    {/if}
                    <tr class="{cycle values="odd,even"}">
                        <td>{$ledgerAccounts[i].ledgerAccountNumber}</td>
                        <td>
                            {assign var="ledgerAccountTransKey" value=$ledgerAccounts[i].ledgerAccountTransKey}
                            {$ledgerAccountTransKey|lmsg}
                        </td>
                        <td>
                            {strip}
                                {assign var="bookmarkArgsLink" value=$bookmarkArgs|escape:url}
                                {include file="$tplDirectory/widgets/actionLink.tpl"
                                    page="accounting.php"
                                    actionName="ShowLedgerAccountDetails"
                                    args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgsLink"
                                    icoImage="details"
                                    altText="TRANS_DETAILS"
                                    linkText="TRANS_DETAILS"}
                                &nbsp;&nbsp;&nbsp;
                                    {include file="$tplDirectory/widgets/actionLink.tpl"
                                        page="accounting.php"
                                        actionName="EditLedgerAccount"
                                        args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgsLink"
                                        icoImage="edit"
                                        altText="TRANS_EDIT"
                                        linkText="TRANS_EDIT"}
                                {if $ledgerAccounts[i].allowRemove}
                                    &nbsp;&nbsp;&nbsp;
                                    {include file="$tplDirectory/widgets/actionLink.tpl"
                                        page="accounting.php"
                                        actionName="RemoveLedgerAccount"
                                        args="ledgerAccountID=`$ledgerAccounts[i].ledgerAccountID`&redirectArgs=$bookmarkArgsLink"
                                        icoImage="remove"
                                        altText="TRANS_REMOVE"
                                        linkText="TRANS_REMOVE"}
                                {/if}
                            {/strip}
                        </td>
                    </tr>
                {/if}
            {sectionelse}
                <tr>
                    <td colspan="3">
                            {"TRANS_NO_LEDGER_ACCOUNTS_FOUND"|lmsg}
                    </td>
                </tr>
            {/section}
        </tbody>
    </table>
</div>
{include file="$tplDirectory/widgets/list-box-footer.tpl"}