{* $Id: ShowProfitAndLoss.tpl 9331 2006-10-06 14:56:50Z mfountain $
 * --------------------------------------------------------------
 * This template displays a mini accounting stats report.
 *
 * Smarty Variables:
 *	$invoiceStats (array of invoice status and their count)
 *		invoiceStatus
 *		numInovices
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
<h2 class="text-center">{"TRANS_PANDL"|lmsg} {$startDate|getDate:short} - {$endDate|getDate:short}</h2>
{foreach key="currencyID" item="totals" from=$ledgerAccountsTotals}
    {include file="$tplDirectory/widgets/list-box-header.tpl" title=$currencyID}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>{"TRANS_GL_ACCOUNT_NUMBER"|lmsg}</th>
                    <th>{"TRANS_GL_ACCOUNT_NAME"|lmsg}</th>
                    <th class="text-right">{"TRANS_GL_BALANCE"|lmsg}</th>
                    <th class="text-right">{"TRANS_YTD_GL_BALANCE"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
            {* ------------------------ REVENUE ----------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.revenue}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.revenue}
            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdrevenue}

            {foreach key="i" item="Data" from=$loopData}
                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
                    <tr>
                        <td colspan="4">{"TRANS_REVENUE_LABEL"|lmsg}</td>
                    </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="odd"}
                {/if}

                <tr class="{$class}">
                    <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                    {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                    <td>{$tkey|lmsg}</td>
                    <td class="text-right">{$Data.total|getAmount:$currencyID}</td>
                    <td class="text-right">{$Data.ytdtotal|getAmount:$currencyID}</td>
                </tr>
            {/foreach}
            <tr>
                <td colspan="2"><i>{"TRANS_REVENUE_TOTALS"|lmsg}</i></td>
                <td class="text-right">{$totalsData|getAmount:$currencyID}</td>
                <td class="text-right">{$ytdTotalsData|getAmount:$currencyID}</td>
            </tr>
            {* ------------------------ OTHER REV -------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.otherRev}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.otherRev}
            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdotherRev}

            {foreach key="i" item="Data" from=$loopData}
                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
                    <tr>
                        <td colspan="4">{"TRANS_OTHER_REVENUE_LABEL"|lmsg}</td>
                    </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="odd"}
                {/if}

                <tr class="{$class}">
                    <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                    {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                    <td>{$tkey|lmsg}</td>
                    <td class="text-right">{$Data.total|getAmount:$currencyID}</td>
                    <td class="text-right">{$Data.ytdtotal|getAmount:$currencyID}</td>
                </tr>
            {/foreach}
            <tr>
                <td colspan="2"><i>{"TRANS_OTHER_REVENUE_TOTALS"|lmsg}</i></td>
                <td class="text-right">{$totalsData|getAmount:$currencyID}</td>
                <td class="text-right">{$ytdTotalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            <tr>
                <td colspan="2" class="text-right">{"TRANS_GROSS_PROFIT"|lmsg}</td>
                <td class="text-right">{$ledgerTypeTotals.$currencyID.revenue+$ledgerTypeTotals.$currencyID.otherRev|getAmount:$currencyID}</td>
                <td class="text-right">{$ledgerTypeTotals.$currencyID.ytdrevenue+$ledgerTypeTotals.$currencyID.ytdotherRev|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------ COGS ------------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.cogs}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.cogs}
            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdcogs}

            {foreach key="i" item="Data" from=$loopData}
                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
                    <tr>
                        <td colspan="4">{"TRANS_COGS_LABEL"|lmsg}</td>
                    </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="odd"}
                {/if}

                <tr class="{$class}">
                    <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                    {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                    <td>{$tkey|lmsg}</td>
                    <td class="text-right">{$Data.total|getAmount:$currencyID}</td>
                    <td class="text-right">{$Data.ytdtotal|getAmount:$currencyID}</td>
                </tr>
            {/foreach}

            <tr>
                <td colspan="2"><i>{"TRANS_COGS_TOTALS"|lmsg}</i></td>
                <td class="text-right">{$totalsData|getAmount:$currencyID}</td>
                <td class="text-right">{$ytdTotalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            {* ------------------------ EXPENSE ---------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.expense}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.expense}
            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdexpense}

            {foreach key="i" item="Data" from=$loopData}
                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
                    <tr>
                        <td colspan="4">{"TRANS_EXPENSE_LABEL"|lmsg}</td>
                    </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="odd"}
                {/if}

                <tr class="{$class}">
                    <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                    {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                    <td>{$tkey|lmsg}</td>
                    <td class="text-right">{$Data.total|getAmount:$currencyID}</td>
                    <td class="text-right">{$Data.ytdtotal|getAmount:$currencyID}</td>
                </tr>
            {/foreach}

            <tr>
                <td colspan="2"><i>{"TRANS_EXPENSE_TOTALS"|lmsg}</i></td>
                <td class="text-right">{$totalsData|getAmount:$currencyID}</td>
                <td class="text-right">{$ytdTotalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            {* ------------------------ OTHER EXPENSE ---------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.otherExp}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.otherExp}
            {assign var="ytdTotalsData" value=$ledgerTypeTotals.$currencyID.ytdotherExp}

            {foreach key="i" item="Data" from=$loopData}
                {assign var="accountid" value=$Data.accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
                    <tr>
                        <td colspan="4">{"TRANS_OTHER_EXPENSE_LABEL"|lmsg}</td>
                    </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="odd"}
                {/if}

            <tr class="{$class}">
                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                <td>{$tkey|lmsg}</td>
                <td class="text-right">{$Data.total|getAmount:$currencyID}</td>
                <td class="text-right">{$Data.ytdtotal|getAmount:$currencyID}</td>
            </tr>
            {/foreach}

            <tr>
                <td colspan="2"><i>{"TRANS_OTHER_EXPENSE_TOTALS"|lmsg}</i></td>
                <td class="text-right">{$totalsData|getAmount:$currencyID}</td>
                <td class="text-right">{$ytdTotalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            <tr>
                <td colspan="2" class="text-right">{"TRANS_NET_PROFIT"|lmsg}</td>
                <td class="text-right">{$ledgerTypeTotals.$currencyID.total|getAmount:$currencyID}</td>
                <td class="text-right">{$ledgerTypeTotals.$currencyID.ytdtotal|getAmount:$currencyID}</td>
            </tr>

            </tbody>
        </table>
    </div>
{/foreach}