{* $Id: ShowPurchasesJournal.tpl 10261 2006-12-11 19:48:58Z kbailey $
 * --------------------------------------------------------------
 * This template displays the daily purchases journal.
 *
 * Smarty Variables:
 *	$purchasesJournal (array of journal entries)
 *		purchaseJournalID
 *		clientID
 *		invoiceID
 *		purchaseDateCreated
 *		purchaseDescription
 *		purchaseDebitAmount
 *		purchaseAccPayDebitAmount
 *		purchaseAccPayCreditAmount
 *		purchaseCashCreditAmount
 *	$purchasesJournalTotals (array of this pages totals)
 *		purchaseDebitAmount
 *		purchaseAccPayDebitAmount
 *		purchaseAccPayCreditAmount
 *		purchaseCashCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{php}$GLOBALS['__pagePath'] = array('TRANS_DAILY_JOURNALS' => action_url('accounting', 'ShowJournalsMenu'), 'TRANS_PURCHASES_JOURNAL');{/php}

{assign var="firstCurrency" value=1}
{foreach key="currencyID" item="purchasesJournal" from=$currencies}
    {assign var="purchasesJournalTotals" value=$currencies_totals.$currencyID}

    {include file="$tplDirectory/widgets/list-box-header.tpl" title=$currencyID}
    {if $firstCurrency==1}
        <div class="text-right">
            {include file="$tplDirectory/widgets/context/sortedBy.tpl" displaySortColumnName=$smarty.request.sortColumn displaySortDir=$smarty.request.sortDir}
        </div>
        {assign var="firstCurrency" value=0}
    {/if}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th colspan="2">&nbsp;</th>
                    <th>&nbsp;</th>
                    <th colspan="2">{"TRANS_PURCHASE"|lmsg}</th>
                    <th colspan="2">{"TRANS_ACCOUNTS_PAYABLE"|lmsg}</th>
                    <th colspan="2">{"TRANS_CASH_STRING"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                {assign var="queryArgs" value="dateQuery=`$dateQuery.0`&purchaseJournalBeginMonth=`$purchaseJournalBeginMonth`&purchasesJournalBeginDay=`$purchasesJournalBeginDay`&purchasesJournalBeginYear=`$purchasesJournalBeginYear`&purchasesJournalEndMonth=`$purchasesJournalEndMonth`&purchasesJournalEndDay=`$purchasesJournalEndDay`&purchasesJournalEndYear=`$purchasesJournalEndYear`"}
                <tr class="odd">
                    <th class="green">{include text="TRANS_DATE"|lmsg sortColumn="purchasesDateCreated" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_INVOICE"|lmsg sortColumn="invoiceID" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_DESCRIPTION"|lmsg sortColumn="purchasesDescription" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="purchasesDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="purchasesCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="purchasesAccPayDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="purchasesAccPayCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="purchasesCashDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="purchasesCashCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowPurchasesJournal" queryArgs=$queryArgs}</th>
                </tr>
                {section name="i" loop=$purchasesJournal}
                    <tr class="{cycle values="even,odd"}">
                        <td class="green" align="center">{$purchasesJournal[i].purchaseDateCreated|getDate}</td>
                        <td align="right">{$purchasesJournal[i].invoiceID}</td>
                        <td>{$purchasesJournal[i].purchaseDescription|lmsg}</td>
                        <td class="divider" align="right">{$purchasesJournal[i].purchaseDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$purchasesJournal[i].purchaseCreditAmount|getAmount:$currencyID:false}</td>
                        <td class="divider" align="right">{$purchasesJournal[i].purchaseAccPayDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$purchasesJournal[i].purchaseAccPayCreditAmount|getAmount:$currencyID:false}</td>
                        <td class="divider" align="right">{$purchasesJournal[i].purchaseCashDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$purchasesJournal[i].purchaseCashCreditAmount|getAmount:$currencyID:false}</td>
                    </tr>
                {/section}
            </tbody>
            <tfoot>
                <tr>
                    <td width="10%" class="green">&nbsp;</td>
                    <td width="5%">&nbsp;</td>
                    <td width="40%">&nbsp;</td>
                    <td width="10%" class="divider" align="right"><strong>{$purchasesJournalTotals.purchaseDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="right"><strong>{$purchasesJournalTotals.purchaseCreditAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" class="divider" align="right"><strong>{$purchasesJournalTotals.purchaseAccPayDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="right"><strong>{$purchasesJournalTotals.purchaseAccPayCreditAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" class="divider" align="right"><strong>{$purchasesJournalTotals.purchaseCashDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="right"><strong>{$purchasesJournalTotals.purchaseCashCreditAmount|getAmount:$currencyID:false}</strong></td>
                </tr>
            </tfoot>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{foreachelse}
    {"TRANS_NO_PURCHASES_MATCH_QUERY"|lmsg}
{/foreach}

{include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="dateQuery=`$dateQuery.0`&purchaseJournalBeginMonth=`$purchaseJournalBeginMonth`&purchasesJournalBeginDay=`$purchasesJournalBeginDay`&purchasesJournalBeginYear=`$purchasesJournalBeginYear`&purchasesJournalEndMonth=`$purchasesJournalEndMonth`&purchasesJournalEndDay=`$purchasesJournalEndDay`&purchasesJournalEndYear=`$purchasesJournalEndYear`"}