{* $Id: ShowReceiptsJournal.tpl 10261 2006-12-11 19:48:58Z kbailey $
 * --------------------------------------------------------------
 * This template displays the daily sales & receipts journal
 *
 * Smarty Variables:
 *	$salesReceiptsJournal (array of journal entries)
 *		receiptJournalID
 *		clientID
 *		invoiceID
 *		transactionID
 *		receiptDateCreated
 *		receiptDescription
 *		receiptCashDebitAmount
 *		receiptAccRecDebitAmount
 *		receiptAccRecCreditAmount
 *		receiptSalesCreditAmount
 *		receiptTaxPayCreditAmount
 *	$salesReceiptsJournalTotals (array of this pages totals)
 *		receiptCashDebitAmount
 *		receiptAccRecDebitAmount
 *		receiptAccRecCreditAmount
 *		receiptSalesCreditAmount
 *		receiptTaxPayCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_DAILY_JOURNALS' => action_url('accounting', 'ShowJournalsMenu'), 'TRANS_SALES_AND_RECEIPTS_JOURNAL');{/php}

{assign var="firstCurrency" value=1}
{foreach key="currencyID" item="salesReceiptsJournal" from=$currencies}
    {assign var="salesReceiptsJournalTotals" value=$currencies_totals.$currencyID}

    {include file="$tplDirectory/widgets/list-box-header.tpl" title=$currencyID}
    {if $firstCurrency==1}
        <div class="text-right">
            {include file="$tplDirectory/widgets/context/sortedBy.tpl" displaySortColumnName=$smarty.request.sortColumn displaySortDir=$smarty.request.sortDir}
        </div>
        {assign var="firstCurrency" value=0}
    {/if}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th colspan="2">&nbsp;</th>
                    <th>&nbsp;</th>
                    <th colspan="2">{"TRANS_CASH_STRING"|lmsg}</th>
                    <th colspan="2">{"TRANS_ACCOUNTS_RECEIVABLE"|lmsg}</th>
                    <th colspan="2">{"TRANS_SALES"|lmsg}</th>
                    <th colspan="2">{"TRANS_TAX"|lmsg}</th>
                    <th colspan="2">{"TRANS_COUPON"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                {assign var="queryArgs" value="dateQuery=`$dateQuery.0`&salesJournalBeginMonth=`$salesJournalBeginMonth`&salesJournalBeginDay=`$salesJournalBeginDay`&salesJournalBeginYear=`$salesJournalBeginYear`&salesJournalEndMonth=`$salesJournalEndMonth`&salesJournalEndDay=`$salesJournalEndDay`&salesJournalEndYear=`$salesJournalEndYear`"}
                <tr class="odd">
                    <th class="green">{include file="$tplDirectory/widgets/headerSortLink.tpl" text="TRANS_DATE"|lmsg action="ShowReceiptsJournal" sortColumn="receiptDateCreated" queryArgs=$queryArgs}</th>
                    <th>{include file="$tplDirectory/widgets/headerSortLink.tpl" text="TRANS_INVOICE"|lmsg action="ShowReceiptsJournal" sortColumn="invoiceID" queryArgs=$queryArgs}</th>
                    <th>{include file="$tplDirectory/widgets/headerSortLink.tpl" text="TRANS_DESCRIPTION"|lmsg action="ShowReceiptsJournal" sortColumn="receiptDescription" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="receiptCashDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="receiptCashCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="receiptAccRecDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="receiptAccRecCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="receiptSalesDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="receiptSalesCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="receiptTaxPayDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="receiptTaxPayCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th class="green">{include text="TRANS_DEBIT"|lmsg sortColumn="receiptCouponDebitAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                    <th>{include text="TRANS_CREDIT"|lmsg sortColumn="receiptCouponCreditAmount" file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowReceiptsJournal" queryArgs=$queryArgs}</th>
                </tr>
                {section name="i" loop=$salesReceiptsJournal}
                    <tr class="{cycle values="even,odd"}">
                        <td class="green" align="center">{$salesReceiptsJournal[i].receiptDateCreated|getDate}</td>
                        <td align="right">{$salesReceiptsJournal[i].invoiceID}</td>
                        <td>{$salesReceiptsJournal[i].receiptDescription|lmsg}</td>
                        <td class="divider" align="right">{$salesReceiptsJournal[i].receiptCashDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$salesReceiptsJournal[i].receiptCashCreditAmount|getAmount:$currencyID:false}</td>
                        <td class="divider" align="right">{$salesReceiptsJournal[i].receiptAccRecDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$salesReceiptsJournal[i].receiptAccRecCreditAmount|getAmount:$currencyID:false}</td>
                        <td class="divider" align="right">{$salesReceiptsJournal[i].receiptSalesDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$salesReceiptsJournal[i].receiptSalesCreditAmount|getAmount:$currencyID:false}</td>
                        <td class="divider" align="right">{$salesReceiptsJournal[i].receiptTaxPayDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$salesReceiptsJournal[i].receiptTaxPayCreditAmount|getAmount:$currencyID:false}</td>
                        <td class="divider" align="right">{$salesReceiptsJournal[i].receiptCouponDebitAmount|getAmount:$currencyID:false}</td>
                        <td align="right">{$salesReceiptsJournal[i].receiptCouponCreditAmount|getAmount:$currencyID:false}</td>
                    </tr>
                {/section}
            </tbody>
            <tfoot>
                <tr>
                    <td width="10%" class="green">&nbsp;</td>
                    <td width="5%">&nbsp;</td>
                    <td width="30%">&nbsp;</td>
                    <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptCashDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptCashCreditAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptAccRecDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptAccRecCreditAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptSalesDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptSalesCreditAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptTaxPayDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptTaxPayCreditAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" class="divider" align="center"><strong>{$salesReceiptsJournalTotals.receiptCouponDebitAmount|getAmount:$currencyID:false}</strong></td>
                    <td width="10%" align="center"><strong>{$salesReceiptsJournalTotals.receiptCouponCreditAmount|getAmount:$currencyID:false}</strong></td>
                </tr>
            </tfoot>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{foreachelse}
    {"TRANS_NO_RECEIPTS_MATCH_YOUR_QUERY"|lmsg}
{/foreach}

{include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="dateQuery=`$dateQuery.0`&salesJournalBeginMonth=`$salesJournalBeginMonth`&salesJournalBeginDay=`$salesJournalBeginDay`&salesJournalBeginYear=`$salesJournalBeginYear`&salesJournalEndMonth=`$salesJournalEndMonth`&salesJournalEndDay=`$salesJournalEndDay`&salesJournalEndYear=`$salesJournalEndYear`"}