{* $Id: EditBasicClientAttributes.tpl 9374 2006-10-10 00:55:16Z mfountain $
 * --------------------------------------------------------------
 * This template displays a form to edit an existing client.
 *
 * Smarty Variables:
 *
 * Author: Kris Bailey
 *}

{if $clientIsReseller}
    {php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_RESELLERS', 'TRANS_RESELLER_EDIT_ATTRIBUTES');{/php}
{else}
    {php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_CLIENTS', 'TRANS_EDIT_CLIENT_ATTRIBUTES');{/php}
{/if}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}
{include file="$tplDirectory/widgets/context/client.tpl" client=$client suppressEditLink="yes" suppressDeleteLink="yes"}

<script>
    {literal}
        function toggleElementByID(elem, id){
            if (elem.checked){
                jQuery('#'+id).removeAttr('disabled');
            } else {
                jQuery('#'+id).attr('disabled', 'disabled');
            }
        }

        function showDefaultgroupValues(elem) {
            var groups=Array();
            {/literal}
                {foreach key="groupID" item="group" from=$attributeGroupValues}
                        groups[{$groupID}] = Array();
                    {foreach key="attrName" item="attr" from=$group}
                        groups[{$groupID}]['{$attrName}'] = '{$attr}';
                    {/foreach}
                {/foreach}
            {literal}
            for (var i in groups[elem.value]) {
                jQuery('#default-'+i).text(groups[elem.value][i]);
            }
            return false;
        }
    {/literal}
</script>


<form method="post" action="{getFormAction controller="clients"}">
    <input type="hidden" name="act" value="{getActionID action="EditBasicClientAttributesResponse"}">
    <input type="hidden" name="clientID" value="{$client.clientID}">
    <input type="hidden" name="token" value="{$token}">

    {include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_CLIENT_GROUP"}
    <div class="form-row {if $invalid.groupID}error{/if}"><div class="field-name"><label for="groupID">{"TRANS_CLIENT_GROUP"|lmsg}</label></div>
        <div class="field-value"><div class="text-value">
            <select class="f-large-size" onchange="showDefaultgroupValues(this); return false;" id="groupID" name="groupID">
                {html_options options=$attributeGroups selected=$formValues.groupID}
            </select>
        </div></div>
    </div>
    {include file="$tplDirectory/widgets/form-box-footer.tpl"}

    {include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_CUSTOMER_GROUP_ATTRIBUTES"}
    <div class="form-row">
        <div class="single-row list">
            <table width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <th>{"TRANS_ATTRIBUTE_DISPLAY_NAME"|lmsg}</th>
                        <th>{"TRANS_OVERRIDE"|lmsg}</th>
                        <th>{"TRANS_ATTRIBUTE_CUSTOM_VALUE"|lmsg}</th>
                        <th>{"TRANS_CUSTOMER_GROUP_DEFAULT_VALUE"|lmsg}</th>
                    </tr>
                </thead>
                <tbody>
                    {foreach key="attributeName" item="attrID" from=$customerGroupAttributes}
                        <tr class="{cycle values="odd,even"}">
                            <td>{$programaticAttributes.$attributeName|lmsg}</td>
                            <td><input type="checkbox" value='1' name="activeAttributes[{$attributeName}]" onchange="toggleElementByID(this, 'attributeValues-{$attributeName}')" {if $attributeValues.$attrID.attributeID==$attrID}checked="checked"{/if}></td>
                            <td>
                                {if $suspentionExemptAttribute != $attributeName}
                                    <input type="text" name="attributeValues[{$attributeName}]" id="attributeValues-{$attributeName}"
                                           {if $attributeValues.$attrID.attributeID!=$attrID}disabled{/if}
                                           value="{$attributeValues.$attrID.clientAttributeValue}">
                                {else}
                                    <input type="radio" value="1" name="attributeValues[{$attributeName}]" id="attributeValues-{$attributeName}" {if $attributeValues.$attrID.clientAttributeValue == 1}checked="checked"{/if}> {"TRANS_YES"|lmsg}
                                    <br>
                                    <input type="radio" value="0" name="attributeValues[{$attributeName}]" id="attributeValues-{$attributeName}" {if $attributeValues.$attrID.clientAttributeValue == 0}checked="checked"{/if}> {"TRANS_NO"|lmsg}
                                    <br>
                                {/if}
                            </td>
                            <td id="default-{$attributeName}">
                                {assign var=groupID value=$client.groupID}
                                {$attributeGroupValues.$groupID.$attributeName}
                            </td>
                        </tr>
                    {/foreach}
                </tbody>
            </table>
        </div>
    </div>
    {include file="$tplDirectory/widgets/form-box-footer.tpl"}

    {if $namedAttributes}
        {if $clientIsReseller}
            {assign var='title' value='TRANS_RESELLER_ATTRIBUTES'}
        {else}
            {assign var='title' value='TRANS_CLIENT_ATTRIBUTES'}
        {/if}
        {include file="$tplDirectory/widgets/form-box-header.tpl" title="`$title`"}
        <div class="form-row">
            <div class="single-row list">
                <table width="100%" cellspacing="0">
                    <thead>
                        <tr>
                            <th>{"TRANS_ATTRIBUTE_DISPLAY_NAME"|lmsg}</th>
                            <th>{"TRANS_ACTIVE"|lmsg}</th>
                            <th>{"TRANS_ATTRIBUTE_INTERNAL_VALUE"|lmsg}</th>
                        </tr>
                    </thead>
                    <tbody>
                        {foreach key="attributeName" item="attrID" from=$namedAttributes}
                            <tr class="{cycle values="odd,even"}">
                                <td>{$attributeName|lmsg}:</td>
                                <td>
                                    <input type="checkbox" value='1' onchange="toggleElementByID(this, 'attributeValues-{$attributeName}')" name="activeAttributes[{$attributeName}]"
                                        {if $attributeValues.$attrID.attributeID==$attrID}checked="checked"{/if}>
                                </td>
                                <td>
                                    <input type="text" name="attributeValues[{$attributeName}]" id="attributeValues-{$attributeName}"
                                    {if $attributeValues.$attrID.attributeID!=$attrID}disabled{/if}
                                        value="{$attributeValues.$attrID.clientAttributeValue}">
                                </td>
                            </tr>
                        {/foreach}
                    </tbody>
                </table>
            </div>
        </div>
        {include file="$tplDirectory/widgets/form-box-footer.tpl"}
    {/if}
    {include file="$tplDirectory/widgets/buttons.tpl" buttons=$buttons isSingleRow=true}
</form>