{* $Id: ShowDashboardTodos.tpl 10248 2006-12-08 20:04:16Z eradtke $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template
 * will eventually display less information about a to-do item than the ShowTodoDetails action; but
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *
 * Author: Brian Smith
 *}

{* for todo assignments of certs *}

{foreach key=key item=title from=$todostatusheaders}
    <table class="form-table" width="100%">
    <tbody>
        {foreach from=$todoAssignHeaders key=assignment item=todos_ptr}
            {assign var=todos_ptr value=$todos.$key.$assignment}
            <tr class="form-row">
                <td><b>{$todoAssignHeaders.$assignment}</b></td>
            </tr>
            {foreach from=$todos_ptr item=todo}
                <tr class="form-row">
                    <td>
                        {if $todo.todoID != ''}
                            &nbsp;&nbsp;&nbsp;<a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=`$todo.todoID`"}">{$todo.todoTitle|constant}</a><br />
                            &nbsp;&nbsp;&nbsp;({$todo.todoDateDue|getDateTime:short})
                        {/if}
                    </td>
                </tr>
            {foreachelse}
                <tr class="form-row">
                    <td>&nbsp;&nbsp;&nbsp;{"TRANS_NO_TODO_ITEMS"|lmsg}</td>
                </tr>
            {/foreach}
        {/foreach}
    </tbody>
    </table>
{foreachelse}
    <table class="form-table" width="100%">
    <tbody>
        <tr class="form-row">
            <td class="text-center">{"TRANS_NO_TODO_ITEMS"|lmsg}</td>
        </tr>
    </tbody>
    </table>
{/foreach}
