{* $Id: RemoveEmail.tpl 8729 2006-09-08 15:29:03Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to remove an email from the email queue.
 *
 * Smarty Variables:
 *	$email (array of this email's data)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Vic Fryzel
 *}{strip}
{/strip}
{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_EMAILS' => action_url('events', 'ShowEmailQueue'), 'TRANS_SHOW_EMAILS', '');{/php}
{include file="$tplDirectory/header.tpl"}

{include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_REMOVE_EMAILS"}
{if $email.0.emailID}
    {foreach from=$email item=eml}
        <div class="form-row"><div class="field-name">{$eml.emailID}</div>
            <div class="field-value">
                <div class="text-value">{$eml.emailSubject}</div>
            </div>
        </div>
    {/foreach}
{else}
    <div class="form-row"><div class="single-row">
        #{$email.emailID}?
    </div></div>
{/if}
{include file="$tplDirectory/widgets/form-box-footer.tpl"}
<div class="btns-box">
    <div class="box-area">
        <table width="100%" cellspacing="0" class="form-table">
            <tbody><tr class="form-row">
                <td class="single-row">
                    <form method="post" action="{getFormAction controller="events"}" style="display: inline;">
                        <input type="hidden" name="act" value="{getActionID action="RemoveEmailResponse"}">
                        {if $email.0.emailID}
                            {foreach from=$email item=eml}
                                <input type="hidden" name="emailIDs[]" value="{$eml.emailID}">
                            {/foreach}
                        {else}
                            <input type="hidden" name="emailID" value="{$email.emailID}">
                        {/if}
                        <input type="hidden" name="token" value="{$token}">
                        <span class="btn action"><button type="submit" value="{"TRANS_YES"|lmsg}" name="yes" id="billing-id-yes">{"TRANS_YES"|lmsg}</button></span>
                    </form>

                    <form method="get" action="{getFormAction}" style="display: inline;">
                        <input type="hidden" name="ctr" value="events"/>
                        <input type="hidden" name="token" value="{$token}">
                        {if $email.0.emailID}
                            <input type="hidden" name="act" value="{getActionID action="ShowEmailQueue"}">
                        {else}
                            <input type="hidden" name="act" value="{getActionID action="ShowEmailDetails"}">
                            <input type="hidden" name="emailID" value="{$email.emailID}">
                        {/if}
                        <span class="btn action"><button type="submit" value="{"TRANS_NO"|lmsg}" name="no" id="billing-id-no">{"TRANS_NO"|lmsg}</button></span>
                    </form>
                </td>
            </tr>
            </tbody>
        </table>
    </div>
</div>