{* $Id: ShowEmailDetails.tpl 12424 2008-01-03 21:25:24Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to remove an email from the email queue.
 *
 * Smarty Variables:
 *	$email (array of this email's data)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Brian Smith
 *}{strip}


{/strip}
{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_EMAILS' => action_url('events', 'ShowEmailQueue'), 'TRANS_SHOW_EMAILS', '');{/php}
{include file="$tplDirectory/header.tpl"}

{include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_VIEW_EMAIL_DETAILS"}
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_ID"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailID}
        &nbsp;&nbsp;&nbsp;
        {include file="$tplDirectory/widgets/actionLink.tpl"
            page="events.php"
            actionName="ResendEmail"
            args="emailID=`$email.emailID`"
            icoImage="resend-email.png"
            altText="TRANS_RESEND"
            linkText="TRANS_RESEND"}
        &nbsp;&nbsp;&nbsp;
        {include file="$tplDirectory/widgets/actionLink.tpl"
            page="clients.php"
            actionName="SendClientEmail"
            args="emailID=`$email.emailID`"
            icoImage="edit"
            altText="TRANS_EDIT_EMAIL"
            linkText="TRANS_EDIT_EMAIL"}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_FROM_NAME"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailFromName}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_FROM_ADDRESS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailFromAddress}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_DELIVERY_STATUS_OPTION"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailSent == 1}
            {"TRANS_SUCCESS"|lmsg}
        {elseif $email.emailFailed == 1}
            {"TRANS_FAILURE"|lmsg}
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_ENTERED_OPTION"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailDateCreated|getDateTime:long}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_SENT_ON_OPTION"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailDateSent|getDateTime:long}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_ACTIVE"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailActive|getArrayValueByID:$yesNo}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_ADDRESS_DESTINATIONS_OPTION"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailToAddresses}
            <ul>
                {foreach from=$email.emailToAddresses.0.emailToAddress item=to}
                    {if $to.emailAddressName}
                        <li>"{$to.emailAddressName}" &lt;{$to.emailAddress}&gt;</li>
                    {else}
                        <li>{$to.emailAddress}</li>
                    {/if}
                {foreachelse}
                    <li>{"TRANS_NORESULTS"|lmsg}</li>
                {/foreach}
            </ul>
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_CC_ADDRESS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailCCAddresses}
            <ul>
                {foreach from=$email.emailCCAddresses.0.emailCCAddress item=cc}
                    {if $cc.emailAddressName}
                        <li>"{$cc.emailAddressName}" &lt;{$cc.emailAddress}&gt;</li>
                    {else}
                        <li>{$cc.emailAddress}</li>
                    {/if}
                {/foreach}
            </ul>
        {else}
            {"TRANS_NORESULTS"|lmsg}
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_BCC_ADDRESS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailBCCAddresses}
            <ul>
                {foreach from=$email.emailBCCAddresses.0.emailBCCAddress item=bcc}
                    {if $bcc.emailAddressName}
                        <li>"{$bcc.emailAddressName}" &lt;{$bcc.emailAddress}&gt;</li>
                    {else}
                        <li>{$bcc.emailAddress}</li>
                    {/if}
                {/foreach}
            </ul>
        {else}
            {"TRANS_NORESULTS"|lmsg}
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_REPLY_ADDRESS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailReplyToAddresses}
            <ul>
                {foreach from=$email.emailReplyToAddresses.0.emailReplyToAddress item=reply}
                    {if $reply.emailAddressName}
                        <li>"{$reply.emailAddressName}" &lt;{$reply.emailAddress}&gt;</li>
                    {else}
                        <li>{$reply.emailAddress}</li>
                    {/if}
                {foreachelse}
                    <li>{"TRANS_NORESULTS"|lmsg}</li>
                {/foreach}
            </ul>
        {else}
            {"TRANS_NORESULTS"|lmsg}
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_ATTACHMENTS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailAttachments}
            <ul>
                {foreach from=$email.emailAttachments.0.emailAttachment item=emailAttachment}
                    <li>{$emailAttachment.emailAttachmentName}</li>
                {foreachelse}
                    <li>{"TRANS_NORESULTS"|lmsg}</li>
                {/foreach}
            </ul>
        {else}
            {"TRANS_NORESULTS"|lmsg}
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_HEADERS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if $email.emailHeaders}
            <ul>
                {foreach from=$email.emailHeaders item=header}
                    <li>{$header.emailHeader}</li>
                {foreachelse}
                    <li>{"TRANS_NORESULTS"|lmsg}</li>
                {/foreach}
            </ul>
        {/if}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_MESSAGE_SUBJECT"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$email.emailSubject}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_MESSAGE_BODY"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if "" != $email.emailBody}{$email.emailBody}{else}{$email.emailTextBody}{/if}
    </div></div>
</div>
{include file="$tplDirectory/widgets/form-box-footer.tpl"}