{* $Id: EditFraudCountryThreshold.tpl 11472 2007-06-28 23:32:18Z kbailey $
 * --------------------------------------------------------------
 * This template displays a fraud country threshold data for editing.
 *
 * Smarty Variables:
 *  $thresholdData (array of fraud countries threshold data)
 *
 * Author: Michael Fountain
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_SYSTEM', 'TRANS_MANAGE_FRAUD_SETTINGS', 'TRANS_THRESHOLD_DETAILS');{/php}

{if $saved}
    {include file="$tplDirectory/widgets/showInvalidCustom.tpl" duration="4" message="TRANS_SETTINGS_SAVED_SUCCESSFULLY"|lmsg}
{/if}

<form action="{getFormAction controller="fraudsets"}" xmlns="http://www.w3.org/1999/html" method="post"
      name="removeFraudCountryThreshold" id="removeFraudCountryThreshold">
    <input type="hidden" name="token" value="{$token}"/>
    <input type="hidden" name="act" value="{getActionID action="RemoveFraudCountryThresholdResponse"}"/>
    <input type="hidden" name="thresholdID" value="{$thresholdData.thresholdID}"/>
</form>


<form action="{getFormAction controller="fraudsets"}" method="post" name="EditFraudCountryThresholdResponse">
    <input type="hidden" name="act" value="{getActionID action="EditFraudCountryThresholdResponse"}">
    <input type="hidden" name="thresholdID" value="{$thresholdData.thresholdID}">
    <input type="hidden" name="redirectURL" value="{$fileName}">
    <input type="hidden" name="redirectAction" value="{$actionName}">
    <input type="hidden" name="redirectArgs" value="{$bookmarkArgs}">
    <input type="hidden" name="token" value="{$token}">

    {include file="$tplDirectory/widgets/list-box-header.tpl"}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>{"TRANS_THRESHOLD_NAME"|lmsg}</th>
                    <th>{"TRANS_THRESHOLD_TYPE"|lmsg}</th>
                    <th>{"TRANS_THRESHOLD_COUNTRY_OR_REGION"|lmsg}</th>
                    <th>{"TRANS_ACTIONS"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                <tr class="odd">
                    <td>
                        {$thresholdData.thresholdName|safetyhtml}
                        {include
                            file="$tplDirectory/widgets/quickEditLink.tpl"
                            editActionName="EditFraudCountryThresholdResponse"
                            editID=$thresholdData.thresholdID
                            editKey="thresholdID"
                            editName="TRANS_THRESHOLD_NAME"
                            editColumn="thresholdName"
                            editValue=$thresholdData.thresholdName}
                    </td>
                    <td>
                        {assign var="countryType" value=$thresholdData.countryType}
                        {if ($countryType==0)}
                            {"TRANS_APPLY_TO_ALL_COUNTRIES"|lmsg}
                        {elseif ($countryType==1)}
                            {"TRANS_APPLY_TO_ONE_COUNTRY"|lmsg}
                        {elseif ($countryType==2)}
                            {"TRANS_APPLY_TO_REGION_OF_COUNTRIES"|lmsg}
                        {/if}
                    </td>
                    <td>
                        {if ($countryType==0)}
                            {"TRANS_COUNTRY"|lmsg} *
                        {elseif ($countryType==1)}
                            {assign var="countriesID" value=$thresholdData.countriesID}
                            {"TRANS_COUNTRY"|lmsg} {$countryList[$countriesID]}
                        {elseif ($countryType==2)}
                            {assign var="regionsID" value=$thresholdData.regionsID}
                            {"TRANS_REGION"|lmsg} {$countryRegions[$regionsID]}
                        {/if}
                    </td>
                    <td>
                        {include file="$tplDirectory/widgets/actionLink.tpl"
                            javascriptLink="jQuery('#removeFraudCountryThreshold').submit();"
                            icoImage="remove"
                            altText="TRANS_REMOVE"
                            linkText="TRANS_REMOVE"}
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}

    {include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_CONFIGURE_FRAUD_SCORE_THRESHOLD_ACTIONS" isContentCollapsible=true}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>&nbsp;</th>
                    <th>{"TRANS_ACTION"|lmsg}</th>
                    <th>&nbsp;</th>
                    <th>{"TRANS_SCORE"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                <tr class="odd">
                    <td>{"TRANS_SCORE_1"|lmsg}:</td>
                    <td>
                        <select id="levelOneAction" name="levelOneAction">
                            {html_options options=$fraudLevelActions selected=$thresholdData.levelOneAction}
                        </select>
                    </td>
                    <td>&lt;=</td>
                    <td >
                        <select id="levelOneScore" name="levelOneScore">
                            {html_options values=$scoreScale output=$scoreScale selected=$thresholdData.levelOneScore}
                        </select>
                    </td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_SCORE_2"|lmsg}:</strong></td>
                    <td>
                        <select id="levelTwoAction" name="levelTwoAction">
                            {html_options options=$fraudLevelActions selected=$thresholdData.levelTwoAction}
                        </select>
                    </td>
                    <td><div>&lt;=</div></td>
                    <td >
                        <select id="levelTwoScore" name="levelTwoScore">
                            {html_options values=$scoreScale output=$scoreScale selected=$thresholdData.levelTwoScore}
                        </select>
                    </td>
                </tr>
                <tr class="odd">
                    <td><strong>{"TRANS_SCORE_3"|lmsg}:</strong></td>
                    <td>
                        <select id="levelThreeAction" name="levelThreeAction">
                            {html_options options=$fraudLevelActions selected=$thresholdData.levelThreeAction}
                        </select>
                    </td>
                    <td><div>&lt;=</div></td>
                    <td >
                        <select id="levelThreeScore" name="levelThreeScore">
                            {html_options values=$scoreScale output=$scoreScale selected=$thresholdData.levelThreeScore}
                        </select>
                    </td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_SCORE_4"|lmsg}:</strong></td>
                    <td>
                        <select id="catchAllAction" name="catchAllAction">
                            {html_options options=$fraudLevelActions selected=$thresholdData.catchAllAction}
                        </select>
                    </td>
                    <td><div>&nbsp;&gt;</div></td>
                    <td ><strong>{"TRANS_SCORE_3"|lmsg}</strong></td>
                </tr>
                <tr class="odd">
                    <td>&lt;=</td>
                    <td colspan="3">{"TRANS_SCORE_LESS_THAN"|lmsg}</td>
                </tr>
                <tr class="even">
                    <td>&nbsp;&gt;</td>
                    <td colspan="3">{"TRANS_SCORE_GREATER_THAN"|lmsg}</td>
                </tr>
            </tbody>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
    {include file="$tplDirectory/widgets/showTips.tpl" title="TRANS_FRAUD_SCORE_TIPS" msg="TRANS_FRAUD_SCORE_TIPS_MSG"}

    {include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_CONFIGURE_AMOUNT_OVERRIDE_THRESHOLD_ACTIONS" isContentCollapsible=true}
    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>&nbsp;</th>
                    <th>{"TRANS_ACTION"|lmsg}</th>
                    <th>&nbsp;</th>
                    <th>{"TRANS_AMOUNT"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                <tr class="odd">
                    <td ><strong>{"TRANS_AMOUNT_1"|lmsg}:</strong></td>
                    <td >
                        <select id="overrideOneAction" name="overrideOneAction" style="width:180px">
                            {html_options options=$fraudLevelActions selected=$thresholdData.overrideOneAction}
                        </select>
                    </td>
                    <td>&gt;=</td>
                    <td >
                        <input type="text" name="overrideOneAmount" value="{$thresholdData.overrideOneAmount}">
                    </td>
                </tr>
                <tr class="even">
                    <td ><strong>{"TRANS_AMOUNT_2"|lmsg}:</strong></td>
                    <td >
                        <select id="overrideTwoAction" name="overrideTwoAction" style="width:180px">
                            {html_options options=$fraudLevelActions selected=$thresholdData.overrideTwoAction}
                        </select>
                    </td>
                    <td>&gt;=</td>
                    <td >
                        <input type="text" name="overrideTwoAmount" value="{$thresholdData.overrideTwoAmount}">
                    </td>
                </tr>
                <tr class="odd">
                    <td ><strong>{"TRANS_AMOUNT_3"|lmsg}:</strong></td>
                    <td>
                        <select id="overrideThreeAction" name="overrideThreeAction" style="width:180px">
                            {html_options options=$fraudLevelActions selected=$thresholdData.overrideThreeAction}
                        </select>
                    </td>
                    <td>&gt;=</td>
                    <td>
                        <input type="text" name="overrideThreeAmount" value="{$thresholdData.overrideThreeAmount}">
                    </td>
                </tr>
                <tr class="even">
                    <td>&gt;=</td>
                    <td colspan="3">{"TRANS_AMOUNT_GREATER_THAN"|lmsg}</td>
                </tr>
            </tbody>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
    {include file="$tplDirectory/widgets/showTips.tpl" title="TRANS_AMOUNT_OVERRIDE_TIPS" msg="TRANS_AMOUNT_OVERRIDE_TIPS_MSG"}

    {include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_ADJUST_FRAUD_SCORE_TRIGGERS" isContentCollapsible=true}
    <div class="form-row"><div class="single-row">
        <label for="primaryScoreToUse0"><input type="radio" name="primaryScoreToUse" id="primaryScoreToUse0" value="0" {if $thresholdData.primaryScoreToUse!="1"}checked="checked"{/if}> {"TRANS_USE_DEFAULT_SCORE"|lmsg}</label>
    </div></div>
    <div class="form-row"><div class="single-row">
        <label for="primaryScoreToUse1"><input type="radio" name="primaryScoreToUse" id="primaryScoreToUse1" value="1" {if $thresholdData.primaryScoreToUse=="1"}checked="checked"{/if}> {"TRANS_USE_ADJUSTED_SCORE"|lmsg}</label>
    </div></div>

    <div class="list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>{"TRANS_TRIGGER"|lmsg}</th>
                    <th>{"TRANS_ADJUSTED_VALUE"|lmsg}</th>
                    <th>{"TRANS_DEFAULT_VALUE"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                <tr class="odd">
                    <td width="45%"><strong>{"TRANS_EMAIL_IS_FREE"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="freeEmailWeight" id="freeEmailWeight" value="{$thresholdData.freeEmailWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('freeEmailWeight').value=2.5;">2.5</a></td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_EMAIL_IS_HIGH_RISK"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="highRiskEmailWeight" id="highRiskEmailWeight" value="{$thresholdData.highRiskEmailWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('highRiskEmailWeight').value=5.0;">5.0</a></td>
                </tr>
                <tr class="odd">
                    <td><strong>{"TRANS_COUNTRY_MATCHES_IP"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="countryMatchWeight" id="countryMatchWeight" value="{$thresholdData.countryMatchWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('countryMatchWeight').value=2.5;">2.5</a></td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_COUNTRY_IS_HIGH_RISK"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="countryRiskWeight" id="countryRiskWeight" value="{$thresholdData.countryRiskWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('countryRiskWeight').value=5.0;">5.0</a></td>
                </tr>
                <tr class="odd">
                    <td><strong>{"TRANS_IP_DISTANCE_FROM_BILLING"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="ipDistanceWeight" id="ipDistanceWeight" value="{$thresholdData.ipDistanceWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('ipDistanceWeight').value=10;">10.0*</a></td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_BIN_COUNTRY_MATCH"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="binMatchWeight" id="binMatchWeight" value="{$thresholdData.binMatchWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('binMatchWeight').value=2.0;">2.0</a></td>
                </tr>
                <tr class="odd">
                    <td><strong>{"TRANS_BIN_BANK_MATCH"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="binBankMatchWeight" id="binBankMatchWeight" value="{$thresholdData.binBankMatchWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('binBankMatchWeight').value=1.0;">1.0</a></td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_SHIPPING_IS_HIGH_RISK"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="highRiskShippingWeight" id="highRiskShippingWeight" value="{$thresholdData.highRiskShippingWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('highRiskShippingWeight').value=5.0;">5.0</a></td>
                </tr>
                <tr class="odd">
                    <td><strong>{"TRANS_IP_IS_ANON_PROXY"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="anonProxyWeight" id="anonProxyWeight" value="{$thresholdData.anonProxyWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('anonProxyWeight').value=5.0;">5.0</a></td>
                </tr>
                <tr class="even">
                    <td><strong>{"TRANS_IP_IS_OPEN_PROXY"|lmsg}</strong></td>
                    <td><input class="f-small-size" type="text" name="openProxyWeight" id="openProxyWeight" value="{$thresholdData.openProxyWeight}" onblur="checkFraudScoreLimits(this)"></td>
                    <td><a href="javascript:void(0);" onclick="document.getElementById('openProxyWeight').value=2.5;">2.5</a></td>
                </tr>
            </tbody>
        </table>
    </div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}

    {include file="$tplDirectory/widgets/showTips.tpl" title="TRANS_SOFT_REJECT_MESSAGE" msg="TRANS_SOFT_REJECT_MESSAGE_HELP" notExpandable="true"}
    <div class="form-row"><div class="single-row">
        <textarea name="fraudSoftRejectMessage" rows="4">{$thresholdData.fraudSoftRejectMessage}</textarea>
    </div></div>
    {include file="$tplDirectory/widgets/showTips.tpl" title="TRANS_HARD_REJECT_MESSAGE" msg="TRANS_HARD_REJECT_MESSAGE_HELP" notExpandable="true"}
    <div class="form-row"><div class="single-row">
        <textarea name="fraudHardRejectMessage" rows="4">{$thresholdData.fraudHardRejectMessage}</textarea>
    </div></div>
    <div class="btns-box">
        <div class="box-area">
            <table width="100%" cellspacing="0" class="form-table">
                <tbody><tr class="form-row">
                    <td class="single-row">
                        <span class="btn action"><button id="billing-id-save" name="save" value="{"TRANS_CLICK_HERE_TO_SAVE_ALL_SETTINGS"|lmsg}" type="submit">{"TRANS_CLICK_HERE_TO_SAVE_ALL_SETTINGS"|lmsg}</button></span>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
    </div>
</form>

<script>
    {literal}
    function checkFraudScoreLimits(element) {
        value = Math.floor(parseFloat(element.value)*10)/10;
        if (value < 0 || value != value*1) {
            value = 0.0;
        } else if (value > 10) {
            value = 10.0;
        }
        element.value = value;
    }
    {/literal}
</script>