{* $Id: ShowGenerateInvoiceEvents.tpl 10044 2006-11-17 20:13:20Z kbailey $
 * --------------------------------------------------------------
 * This template displays the menu for generating invoices.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}


{php}$GLOBALS['__pagePath'] = array('TRANS_FINANCES', 'TRANS_INVOICES', 'TRANS_GENERATE_INVOICES');{/php}
{include file="$tplDirectory/header.tpl"}

{if $clientInfo.clientID}
    {include file="$tplDirectory/widgets/context/client.tpl" client=$clientInfo suppressEditLink=1 suppressDeleteLink=1}

    {if $previewMode==1}
        <form method="post" action="{getFormAction controller="invoices"}">
            <input type="hidden" name="act" value="{getActionID action="GenerateInvoiceEvents"}">
            <input type="hidden" name="token" value="{$token}">
            <input type="hidden" name="reRequest" value="{$reRequest}">
            {include file="$tplDirectory/widgets/form-box-header.tpl"}
            <div class="form-row"><div class="field-name">{"TRANS_INVOICES_THAT_WOULD_GENERATE"|lmsg}</div>
                <div class="field-value"><div id="invoices-to-generate" class="text-value">{$numInvoices}</div></div>
            </div>
            {include file="$tplDirectory/widgets/form-box-footer.tpl"}
            {buttons id='billing-id-generate' class='action' name='generate' value='TRANS_PROCEED_WITH_INVOICE_GENERATION' type='submit' label='TRANS_PROCEED_WITH_INVOICE_GENERATION'}
            {include file="$tplDirectory/widgets/buttons.tpl" buttons=$buttons isSingleRow=true}
        </form>
    {else}
        {include file="$tplDirectory/widgets/form-box-header.tpl"}
        <div class="form-row"><div class="field-name">{"TRANS_INVOICES_GENERATED"|lmsg}</div>
            <div class="field-value"><div id="invoices-generated" class="text-value">{$numInvoices}</div></div>
        </div>
        {include file="$tplDirectory/widgets/form-box-footer.tpl"}
    {/if}

    {include file="$tplDirectory/widgets/list-box-header.tpl" title="TRANS_INVOICES"}
    <div class="form-row"><div class="single-row list">
        {if $invoice.invoiceNumber}
            {"TRANS_INVOICE_NUMBER"|lmsg} <a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoice.invoiceID`"}"><strong>{$invoice.invoiceNumber}</strong></a><br>
        {/if}
        {foreach key="k" item="invoice" from=$invoices}
            {assign var="currencyID" value=$invoice.currencyID}
            <div class="list">
                <table width="100%" cellspacing="0">
                    <thead>
                        <tr>
                            <th colspan="2">{"TRANS_ITEM"|lmsg}</th>
                            <th>{"TRANS_RENEWAL_DATE"|lmsg}</th>
                            <th>{"TRANS_NEXT_RENEWAL_DATE"|lmsg}</th>
                            <th class="text-right">{"TRANS_PRICE"|lmsg}</th>
                            <th class="text-right">{"TRANS_DISCOUNT"|lmsg}</th>
                            <th class="text-right">{"TRANS_SETUP"|lmsg}</th>
                            <th class="text-right">{"TRANS_TAX"|lmsg}</th>
                            <th class="text-right">{"TRANS_TOTALS"|lmsg}</th>
                        </tr>
                    </thead>
                    {section name="i" loop=$invoice.packages}
                        <tr class="{if ($smarty.section.i.index+1)%2==0}even{else}odd{/if}">
                            <td style="{if $invoice.packages[i].isAddon==1}padding-left: 15px;{/if}border-top: 1px solid #ccc;" colspan="2">
                                {assign var="tpid" value=$invoice.packages[i].packageID}
                                {if $invoice.packages[i].isAddon<1}({"TRANS_ID"|lmsg}{$tpid}){/if} {$invoice.packages[i].packageName}
                                {if $domains.$tpid}
                                    <br>{"TRANS_DOMAIN"|lmsg} {$domains.$tpid.domainName}
                                {/if}
                            </td>
                            <td>{$invoice.packages[i].lastBillingDate|getDate}</td>
                            <td>{$invoice.packages[i].nextBillingDate|getDate}</td>
                            {assign var="tmpPrice" value=$invoice.packages[i].packagePrice+$invoice.packages[i].packageDiscountAmount}
                            <td class="text-right">{$tmpPrice|getAmount:$currencyID}</td>
                            <td class="text-right">{$invoice.packages[i].packageDiscountAmount|getAmount:$currencyID}</td>
                            <td class="text-right">{$invoice.packages[i].packageSetupAmount|getAmount:$currencyID}</td>
                            <td class="text-right">{$invoice.packages[i].packageTaxAmount|getAmount:$currencyID}</td>
                            <td class="text-right">{$invoice.packages[i].packageTotalAmount|getAmount:$currencyID}</td>
                        </tr>
                        {if $invoice.packages[i].taxZones.0.amount}
                            {assign var="firstTaxZone" value="1"}
                            {section name="j" loop=$invoice.packages[i].taxZones}
                                {if $invoice.packages[i].taxZones[j].amount>0}
                                    <tr class="{if ($smarty.section.i.index+1)%2==0}even{else}odd{/if}">
                                        <td class="text-right">{if $firstTaxZone==1}{assign var="firstTaxZone" value="0"}{"TRANS_ITEM_TAXES"|lmsg} {/if}</td>
                                        <td colspan="4">{$invoice.packages[i].taxZones[j].tax_zone_description}</td>
                                        <td class="text-right">{if $invoice.packages[i].taxZones[j].tax_zone_amount_type==0}
                                            {$invoice.packages[i].taxZones[j].tax_zone_amount}%
                                            {else}
                                            {$invoice.packages[i].taxZones[j].tax_zone_amount|getAmount:$currencyID}
                                        {/if}</td>
                                        <td></td>
                                        <td class="text-right">{$invoice.packages[i].taxZones[j].amount|getAmount:$currencyID}</td>
                                        <td></td>
                                    </tr>
                                {/if}
                            {/section}
                        {/if}
                    {/section}
                </table>
                <br>
                <table width="100%" cellpadding="4" cellspacing="0" border="0">
                    <tr>
                        <td class="text-right" style="border-top: 2px solid #ccc;">
                            <table class="text-right" cellpadding="4" cellspacing="0" border="0">
                                <tr>
                                    <td style="padding: 2px; text-align: right; font-size: 11pt;">{"TRANS_SUB_TOTAL"|lmsg}</td>
                                    <td style="padding: 2px; text-align: right; font-size: 11pt;"> {$invoice.invoiceSubTotalAmount|getAmount:$currencyID}</td>
                                </tr>
                                <tr>
                                    <td style="padding: 2px; text-align: right; font-size: 11pt;">{"TRANS_TAX"|lmsg} </td>
                                    <td style="padding: 2px; text-align: right; font-size: 11pt;"> {$invoice.invoiceTax|getAmount:$currencyID}</td>
                                </tr>
                                <tr>
                                    <td style="padding: 2px; text-align: right; font-size: 11pt;">{"TRANS_INVOICE_TOTAL"|lmsg} </td>
                                    <td style="padding: 2px; text-align: right; font-size: 11pt;"><strong>{$invoice.invoiceTotalAmount|getAmount:$currencyID}</strong></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            </div>
        {foreachelse}
            {"TRANS_NONE"|lmsg}
        {/foreach}
    </div></div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{else}
    {include file="$tplDirectory/widgets/list-box-header.tpl"}
    <div class="form-row"><div class="single-row">
        {"TRANS_INITIATING"|lmsg}<br>
        {"TRANS_INVOICES_TO_BE_GENERATED"|lmsg}: {$numInovicesToBeGenerated}
    </div></div>
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{/if}