{* $Id: ShowInvoiceStats.tpl 9809 2006-10-24 22:11:55Z kbailey $
 * --------------------------------------------------------------
 * This template displays a mini invoice stats report.
 *
 * Smarty Variables:
 *	$invoiceStats (array of invoice status and their count)
 *		invoiceStatus
 *		numInovices
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_FINANCES', 'TRANS_INVOICES', 'TRANS_QUICK_STATS');{/php}
{include file="$tplDirectory/header.tpl"}
{include file="$tplDirectory/widgets/list-box-header.tpl"}
<div class="form-row"><div class="single-row list">
    <table width="100%" cellspacing="0">
        <thead>
            <tr>
                {foreach item="statusName" key="status" from=$statusLabels}
                    {include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName=$statusName}
                {/foreach}
                {include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_TOTAL"}
            </tr>
        </thead>
        {assign var="total" value="0"}
        <tbody>
            <tr class="{cycle values="odd,even"}">
                {assign var="totalCount" value=0}
                {assign var="totalAmount" value=0}
                {assign var="totalAmountPaid" value=0}
                {foreach item="statusName" key="status" from=$statusLabels}
                    {assign var="stats" value=$invoiceStats.$status}
                    {assign var="totalCount" value=$totalCount+$stats.total}
                    {assign var="totalAmount" value=$totalAmount+$stats.invoiceAmount}
                    {assign var="totalAmountPaid" value=$totalAmountPaid+$stats.invoiceAmountPaid}
                    <td>
                        {if $stats.total == 0}
                            0
                        {else}
                            {include file="$tplDirectory/widgets/actionLink.tpl"
                                page="invoices.php"
                                actionName="ShowInvoices"
                                args="filter[invoice_status]=`$stats.invoiceStatus`"
                                altText=$stats.total
                                linkText=$stats.total
                            }
                        {/if}
                    </td>
                {/foreach}
                <td>
                    {if $totalCount == 0}
                        0
                    {else}
                        {include file="$tplDirectory/widgets/actionLink.tpl"
                            page="invoices.php"
                            actionName="ShowInvoices"
                            altText=$totalCount
                            linkText=$totalCount
                        }
                    {/if}
                </td>
            </tr>
            <tr class="{cycle values="odd,even"}">
                {foreach item="statusName" key="status" from=$statusLabels}
                    {assign var="stats" value=$invoiceStats.$status}
                    <td>
                        {if $totalCount == 0}
                            0%
                        {else}
                            {$stats.total/$totalCount*100|round}%
                        {/if}
                    </td>
                {/foreach}
                <td>&nbsp;</td>
            </tr>
        </tbody>
    </table>
</div></div>
<div class="form-row"><div class="field-name">{"TRANS_INVOICES_READY_TO_BE_GENERATED"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {$numInovicesToBeGenerated}
    </div></div>
</div>
{include file="$tplDirectory/widgets/list-box-footer.tpl"}