{* $Id: EditTodo.tpl 7228 2006-06-05 19:25:33Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to edit a To-Do item. Using the given smarty variable 
 * $todo, the form is prepopulated with the to-do's current information. The 
 * form should post to todos.php, with the action ID for the EditTodoResponse action.
 *
 * Smarty Variables:
 *	$todo  An array of this to-do data. Every element in this array can be considered
 *		   to be one to-do, and as such, every element is an array. Every to-do
 *		   has the following keys:
 *			todoID  -- The ID of the to-do item.
 *			todoTitle  -- The title of the to-do item.
 *			todoDesc -- A short description of the to-do item.
 *			adminID -- The ID of the admin who generated this to-do item.
 *			todoStatusID -- The status of the to-do item.
 *			todoDateDue -- The date and time that this item should be finished before.
 *  $todostatus -- Array of possible statuses for the To Do item. The current status is selected.
 *  $adminlist -- Array of all active admins on the system so that a To-Do can be
 * 				  assigned to any of them. The current admin is selected.
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_TODOS', 'TRANS_EDIT_TODO', '');{/php}
{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form method="post" action="{getFormAction controller="todos"}">
    <input type="hidden" name="act" value="{getActionID action="EditTodoResponse"}">
    <input type="hidden" name="todoID" value="{$todo.todoID}">
    <input type="hidden" name="token" value="{$token}">

    {include file="$tplDirectory/widgets/addTodo.tpl"}

    {buttons id='billing-id-ok' class='action' name='ok' value='TRANS_OK' type='submit' label='TRANS_OK'}
    {buttons id='billing-id-cancel' name='cancel' value='TRANS_CANCEL' type='button' label='TRANS_CANCEL' onclick='history.go(-1);'}
    {include file="$tplDirectory/widgets/buttons.tpl" buttons=$buttons isSingleRow=true}
</form>