{* $Id: RemoveTodo.tpl 8004 2006-07-10 16:10:11Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to verify the removal of a to-do. This template 
 * is provided an array of information about the to-do about to be removed, and 
 * can display that information to the user. This template should contain a form that 
 * posts the todoID to the RemoveTodoResponse action of todos.php, and also 
 * a cancel option, that returns to the ShowTodos action.
 *
 * Smarty Variables:
 *	$todo  An array of this to-do data. Every element in this array can be considered
 *		   to be one to-do, and as such, every element is an array. Every to-do
 *		   has the following keys:
 *			todoID  -- The ID of the to-do item.
 *			todoTitle  -- The title of the to-do item.
 *			todoDesc -- A short description of the to-do item.
 *			adminID -- The ID of the admin who generated this to-do item.
 *			todoStatusID -- The status of the to-do item.
 *			todoDue -- The date and time that this item should be finished before.
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_TODOS', 'TRANS_TODOS', 'TRANS_REMOVE');{/php}
{include file="$tplDirectory/header.tpl"}

<form method="post" action="{getFormAction controller="todos"}">
    <input type="hidden" name="act" value="{getActionID action="RemoveTodoResponse"}">
	<input type="hidden" name="token" value="{$token}">
	<input type="hidden" name="todoID" value="{$todo.todoID}">
    {include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_REMOVE_TODO_MESG"}
    <div class="form-row"><div class="field-name">{"TRANS_SUBJECT"|lmsg}</div>
        <div class="field-value">
            <div class="text-value">{$todo.todoTitle}</div>
        </div>
    </div>
    <div class="form-row"><div class="field-name">{"TRANS_AUTHOR"|lmsg}</div>
        <div class="field-value">
            <div class="text-value">{$todo.admin->fullName|safetyhtml} - {$todo.admin->admin_username|safetyhtml}</div>
        </div>
    </div>
    {include file="$tplDirectory/widgets/form-box-footer.tpl"}

    {buttons id='billing-id-ok' class='action' name='ok' value='TRANS_OK' type='submit' label='TRANS_OK'}
    {buttons id='billing-id-cancel' name='cancel' value='TRANS_CANCEL' type='button' label='TRANS_CANCEL' onclick='history.go(-1);'}
    {include file="$tplDirectory/widgets/buttons.tpl" buttons=$buttons isSingleRow=true}
</form>