{include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_INVOICE_SUMMARY"}
<div class="form-row">
    <div class="single-row">
        <div class="list">
            <table width="100%" cellspacing="0">
                {foreach key="currencyID" item="totals" from=$invoiceStats}
                    <thead>
                        <tr>
                            <th colspan="4" class="text-center">{"TRANS_TOTALS"|lmsg} {$currencyID}</th>
                        </tr>
                        <tr>
                            <th>{"TRANS_STATUS"|lmsg}</th>
                            <th class="text-center">#</th>
                            <th class="text-right">{"TRANS_PAID"|lmsg}</th>
                            <th class="text-right">{"TRANS_DUE_HEADER"|lmsg}</th>
                        </tr>
                    </thead>
                    {assign var="invoiceStatsByCurrency" value=$invoiceStats[$currencyID]}
                    <tbody>
                        {section name=i loop="$invoiceStatsByCurrency"}
                            <tr class="{cycle values='odd,even'}">
                                <td>
                                {include
                                    file="$tplDirectory/widgets/actionLink.tpl"
                                    page="invoices.php"
                                    actionName="ShowInvoices"
                                    args="clientID=`$client.clientID`&filter[invoice_status]=`$invoiceStatsByCurrency[i].invoiceStatus`"
                                    altText=$invoiceStatsByCurrency[i].invoiceStatusName
                                    linkText=$invoiceStatsByCurrency[i].invoiceStatusName}
                                </td>
                                <td class="text-center">{$invoiceStatsByCurrency[i].numInvoices|default:0}</td>
                                <td class="text-right" style="color:green;">{$invoiceStatsByCurrency[i].sumInvoicesAmountPaid|default:0|getAmount:$currencyID}</td>
                                <td class="text-right" style="color:red;">{$invoiceStatsByCurrency[i].sumInvoicesAmountDue|default:0|getAmount:$currencyID}</td>
                            </tr>
                        {/section}
                    </tbody>
                {/foreach}
            </table>
        </div>
    </div>
</div>
<div class="form-row">
    <div class="single-row">
        {include
            file="$tplDirectory/widgets/actionLink.tpl"
            page="invoices.php"
            actionName="ShowInvoices"
            args="clientID=`$client.clientID`"
            icoImage="view-invoice.png"
            altText="TRANS_VIEW_ALL_INVOICES"
            linkText="TRANS_VIEW_ALL_INVOICES"}
    </div>
</div>
<div class="form-row">
    <div class="single-row">
        {include
            file="$tplDirectory/widgets/actionLink.tpl"
            page="invoices.php"
            actionName="ShowGenerateInvoiceMenu"
            args="clientID=`$client.clientID`"
            icoImage="add-new-invoice.png"
            altText="TRANS_GENERATE_INVOICES"
            linkText="TRANS_GENERATE_INVOICES"}
    </div>
</div>
{if $clientIsReseller}
    {assign var='altText' value='TRANS_RESELLER_TAKE_PAYMENT'}
{else}
    {assign var='altText' value='TRANS_TAKE_CLIENT_PAYMENT'}
{/if}

<div class="form-row">
    <div class="single-row">
        {include
            file="$tplDirectory/widgets/actionLink.tpl"
            page="clients.php"
            actionName="TakeClientPayment"
            args="clientID=`$client.clientID`"
            icoImage="take-customer-payment.png"
            altText=$altText
            linkText=$altText}
    </div>
</div>

{if !empty($orderForms)}

    <script>
        var orderFormsCurrencies = new Object();
        {foreach key="orderFormID" item="orderFormCurrencyID" from=$orderFormsCurrencies}
            orderFormsCurrencies['{$orderFormID}'] = '{$orderFormCurrencyID}';
        {/foreach}
        {literal}
        function formatInvoiceCurrencyValue(id, value, separator, groupSeparator){
            var selectedOrderFormID = document.getElementById(id).value;
            return formatCurrencyValue(orderFormsCurrencies[selectedOrderFormID], value, separator, groupSeparator);
        }

        {/literal}
    </script>

    {include file="$tplDirectory/widgets/popup-panel-header.tpl" id="quickAddInvoiceContainer" heading="TRANS_ADD_SINGLE_INVOICE" class="add-new-invoice" isScrollEnabled=true}
    <div class="popup-content-area">
        <form method="post" action="{getFormAction controller="invoices"}" name="{$formName}" id="{$formName}">
            <input type='hidden' name='act' value='{getActionID action="AddSingleInvoiceResponse"}'>
            <input type='hidden' name='clientID' value='{$clientID}'>
            <div class="form-box">
                <div class="box-area">
                    <div class="title ">
                        <div class="title-area">
                            <h3><span>{"TRANS_SINGLE_INVOICE"|lmsg}</span></h3>
                        </div>
                    </div>
                    <div class="content">
                        <div class="content-area">
                            <div class="content-wrapper">
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_ORDERFORM_NAME_OPTION"|lmsg}</div>
                                    <div class="field-value"><div class="text-value">
                                        <select id="orderFormID" name='orderFormID'>
                                            {html_options options=$orderForms}
                                        </select>
                                    </div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_INVOICE_SHORT_DESCRIPTION"|lmsg}</div>
                                    <div class="field-value"><div class="text-value"><input type="text" name="packageName" value="{"TRANS_HOURLY_SERVICE"|lmsg}" ></div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_INVOICE_LONG_DESCRIPTION"|lmsg}</div>
                                    <div class="field-value"><div class="text-value"><textarea rows="4" cols="35" name="packageDescription"></textarea></div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_INVOICE_DATE_DUE"|lmsg}</div>
                                    <div class="field-value"><div class="text-value">{include file="$tplDirectory/widgets/dateSelector.tpl" disableTime=1 optional=0 param="invoiceDate" default="invoiceDate" real="invoiceDate"}</div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_INVOICE_AMOUNT_OPTION"|lmsg}</div>
                                    <div class="field-value"><div class="text-value"><input type="text" name="amount" value="{0|getAmount:" "}" onchange="this.value=formatInvoiceCurrencyValue('orderFormID', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');"></div></div>
                                </div>
                                <div class="form-row">
                                    <div class="single-row"><input class="checkbox" type="checkbox" name="enableInvoiceEmail" id="enableInvoiceEmail" value="1"><label for="enableInvoiceEmail">{"TRANS_SEND_INVOICE_EMAIL"|lmsg}</div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_DEFER_REVENUE_OVER"|lmsg}</div>
                                    <div class="field-value"><div class="text-value">
                                        <select name='cycleID'>
                                            <option value="0">{"TRANS_DONT_DEFER_REVENUE"|lmsg}</option>
                                            {html_options options=$cycles}
                                        </select><br>
                                        <div class="hint">({"TRANS_DEFERRED_REVENUE_EXP"|lmsg})</div>
                                    </div></div>
                                </div>
                                <div class="form-row">
                                    <div class="single-row">
                                        <input class="checkbox" type="checkbox" id="applyPaymentAsWell" value="1" name="applyPaymentAsWell"><label for="applyPaymentAsWell">{"TRANS_APPLY_A_PAYMENT_AS_WELL"|lmsg}</label>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="singleInvoicePaymentTB" class="box-area" style="display:none;">
                    <div class="title ">
                        <div class="title-area">
                            <h3><span>{"TRANS_PAYMENT_APPLY_LEGEND"|lmsg}</span></h3>
                        </div>
                    </div>
                    <div class="content">
                        <div class="content-area">
                            <div class="content-wrapper">
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_PAYMENT_AMOUNT"|lmsg}</div>
                                    <div class="field-value"><div class="text-value">
                                        <input type="text" name="amountPaid" value="{0|getAmount:" "}" onchange="this.value=formatInvoiceCurrencyValue('orderFormID', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');"><br>
                                        <div class="hint">({"TRANS_APPLY_A_PAYMENT_WARNING"|lmsg})</div>
                                    </div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_CHOOSE_BILLING_ACCOUNT"|lmsg}</div>
                                    <div class="field-value"><div class="text-value">
                                        <select name='billingAccountID'>
                                            {html_options options=$billingAccounts}
                                        </select>
                                    </div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_QUICKPAYMENT_COMMENTS"|lmsg}</div>
                                    <div class="field-value"><div class="text-value"><input type="text" name="paymentComments" size="25" value="{"TRANS_MANUAL_PAYMENT"|lmsg}"></div></div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name">{"TRANS_PAYMENT_DATE"|lmsg}</div>
                                    <div class="field-value"><div class="text-value">
                                        {include file="$tplDirectory/widgets/dateSelector.tpl" disableTime=1 optional=0 param="transactionDateCreated" default="transactionDateCreated" real="transactionDateCreated"}
                                    </div></div>
                                </div>
                                <div class="form-row">
                                    <div class="single-row">
                                        <input type="checkbox" class="checkbox" name="enablePaymentEmail" id="enablePaymentEmail" value="1"><label for="enablePaymentEmail">{"TRANS_SEND_PAYMENT_RECEIPT_EMAIL"|lmsg}</label>
                                    </div>
                                </div>
                                <div class="form-row">
                                    <div class="field-name"></div>
                                    <div class="field-value"><div class="text-value">
                                    </div></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="btns-box">
                <div class="box-area">
                    <div class="form-row">
                        <div class="single-row">
                            <div class="field-value">
                                <span class="btn action"><button id="billing-id-process-invoice" value="" type="submit">{"TRANS_PROCESS_INVOICE"|lmsg}</button></span>
                                <span class="btn"><button id="billing-id-cancel-add-new-invoice" value="">{"TRANS_CANCEL"|lmsg}</button></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
    {include file="$tplDirectory/widgets/popup-panel-footer.tpl"}

    <script>
        {literal}
            jQuery(document).ready(function() {
                jQuery('#applyPaymentAsWell').live('click', function(event) {
                    if (this.checked){
                        jQuery("#singleInvoicePaymentTB").show();
                    } else {
                        jQuery("#singleInvoicePaymentTB").hide();
                    }
                });
            });
        {/literal}
    </script>
    <div class="form-row">
        <div class="single-row">
            {include
                id="billing-id-add-new-invoice"
                file="$tplDirectory/widgets/actionLink.tpl"
                icoImage="add-new-invoice.png"
                altText="TRANS_ADD_SINGLE_INVOICE"
                linkText="TRANS_ADD_SINGLE_INVOICE"}
        </div>
    </div>

{/if}

{include file="$tplDirectory/widgets/form-box-footer.tpl"}