{* $Id: package.tpl 12525 2008-01-18 23:27:22Z btyra $
 * --------------------------------------------------------------
 * This widget template is used to display the client context bar.
 *
 * Smarty Variables:
 *	$client		array of client information
 * $contact		array of contact information
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/context/package.tpl" package=$package types=$types activeInactive=$activeInactive}
 *}


{assign var="packageID" value=$package.packageID}
{assign var="thisType" value=$package.packageType}

{if "products"|getTypeID:"hosting" == $thisType}
    {assign var="showDomain" value=true}
{else}
    {assign var="showDomain" value=false}
{/if}

<div class="list">
    <table width="100%" cellspacing="0">
    <thead>
        <tr>
            {include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="10%" headerName="TRANS_PACKAGE_ID"}
            {include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_PACKAGE"}
            {if $showDomain}
                {include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_ASSOCIATED_DOMAIN"}
            {else}
                {include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_PRODUCT_TYPE"}
            {/if}
            {include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_PACKAGE_STATUS"}
            {include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="15%" headerName="TRANS_ACTIONS"}
        </tr>
    </thead>
    <tbody>
        <tr class="odd">
            <td>
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    page="packages.php"
                    actionName="ShowPackageDetails"
                    args="packageID=$packageID"
                    altText=$packageID
                    linkText=$packageID}
            </td>
            <td>
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="products"
                    controller="plan-overview"
                    action="index"
                    arguments="id=`$package.productID`"
                    altText=$package.packageName
                    linkText=$package.packageName}
                {if $showDomain}
                    <div class="hint">({$types.$thisType})</div>
                {/if}
            </td>
            <td>
                {if $showDomain}
                    {if count($package.domains)}
                        {section name=i loop=$package.domains}
                            {$package.domains[i].domainSLD}.{$package.domains[i].domainTLD}<br />
                        {/section}
                    {/if}
                {else}
                    {$types.$thisType}
                {/if}
            </td>
            <td>{assign var="thisStatus" value=$package.packageStatus} {$thisStatus|getStatusName:"package"}</td>
            <td>&nbsp;</td>
        </tr>
    </table>
</div>
<div class="actions-box">
    <div class="objects-toolbar clearfix">
    {if !$suppressDetailsLink}
        <a href="{getBaseUrl page="packages" actionName="ShowPackageDetails"}&packageID={$packageID}" class="s-btn sb-view-subscription">
            <i><i><i><span>{"TRANS_DETAILS"|lmsg}</span></i></i></i>
        </a>
    {/if}
    {if !$suppressEditLink}
        <a href="{getBaseUrl page="packages" actionName="EditPackage"}&packageID={$packageID}" class="s-btn sb-edit-subscription">
            <i><i><i><span>{"TRANS_SUBSCRIPTION_CHANGE_SETTINGS"|lmsg}</span></i></i></i>
        </a>
    {/if}
    {if !$suppressEditPricesLink}
        <a href="{getAdminActionUrl module="packages" controller="prices" action="edit" arguments="id=`$packageID`"}" class="s-btn sb-edit-subscription-prices">
            <i><i><i><span>{"TRANS_SUBSCRIPTION_EDIT_PRICES"|lmsg}</span></i></i></i>
        </a>
    {/if}
    {if $package.canUpgrade}
        <a href="{getBaseUrl page="packages" actionName="UpgradePackage"}&packageID={$packageID}" class="s-btn sb-upgrade-subscription">
            <i><i><i><span>{"TRANS_UPGRADE"|lmsg}</span></i></i></i>
        </a>
    {/if}
    {if $package.canDowngrade}
        <a href="{getBaseUrl page="packages" actionName="DowngradePackage"}&packageID={$packageID}" class="s-btn sb-downgrade-subscription">
            <i><i><i><span>{"TRANS_DOWNGRADE"|lmsg}</span></i></i></i>
        </a>
    {/if}
    <a href="{getBaseUrl page="packages" actionName="ShowPackageAttributes"}&packageID={$packageID}" class="s-btn sb-show-all-subscription-properties">
        <i><i><i><span>{"TRANS_ATTRIBUTES"|lmsg}</span></i></i></i>
    </a>
    {if $package.parentPackageID}
        <a href="{getAdminActionUrl module="packages" controller="supplementary" action="edit-properties" arguments="id=`$packageID`"}" class="s-btn sb-edit-subscription-supplementary-properties">
            <i><i><i><span>{"TRANS_SUBSCRIPTION_EDIT_SUPPLEMENTARY_PROPERTIES_CMD"|lmsg}</span></i></i></i>
        </a>
    {/if}
    {if $resellerProductType != $package.packageType}
        <a href="{getBaseUrl page="packages" actionName="ShowPackageAddons"}&packageID={$packageID}" class="s-btn sb-show-all-subscription-addons">
            <i><i><i><span>{"TRANS_ADDONS"|lmsg}</span></i></i></i>
        </a>
    {/if}
    {if $package.canTransfer}
        <a id="billing-id-transfer-subscription" href="javascript: void(0);" class="s-btn sb-transfer-subscription">
            <i><i><i><span>{"TRANS_TRANSFER_PACKAGE"|lmsg}</span></i></i></i>
        </a>
        {include file="$tplDirectory/widgets/popup-panel-header.tpl" id="billing-id-transfer-subscription-popup-panel" heading="TRANS_TRANSFER_PACKAGE" class="transfer-subscription"}
            <div class="popup-content-area">
                <form method="post" action="{getFormAction controller="packages"}">
                    <input type="hidden" name="act" value="{getActionID action="ChangePackageClient"}">
                    <input type="hidden" name="packageID" value="{$packageID}">
                    <div class="form-box">
                        <div class="box-area">
                            <div class="form-row">
                                <div class="field-name">{"TRANS_CLIENT_ID"|lmsg}</div>
                                <div class="field-value"><div class="text-value">
                                    <input type="text" name="clientID" value="" onClick="javascript:this.form.editValue.focus();this.form.editValue.select();">
                                </div></div>
                            </div>
                        </div>
                    </div>
                    <div class="btns-box">
                        <div class="box-area">
                            <div class="form-row">
                                <div class="single-row">
                                    <div class="field-value">
                                        <span class="btn action"><button id="billing-id-process-transfer-subscription" value="">{"TRANS_TRANSFER"|lmsg}</button></span>
                                        <span class="btn"><button id="billing-id-cancel-transfer-subscription" value="">{"TRANS_CANCEL"|lmsg}</button></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        {include file="$tplDirectory/widgets/popup-panel-footer.tpl"}
    {/if}
    </div>
</div>
