{include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_CURRENT_STATUS"}
<div class="form-row">
    <div class="field-name">{"TRANS_PACKAGESTATUS"|lmsg}</div>
    <div class="field-value"><div class="text-value">
        {if ("failed"|get_status_id:"package") == $packageInfo.packageStatus}
            <img src="/theme/icons/16/billing/sync-status-error.png" width="16" height="16" alt="{$packageStatuses[$packageInfo.packageStatus]}" title="{$packageStatuses[$packageInfo.packageStatus]}">
        {/if}
        {$packageStatuses[$packageInfo.packageStatus]}
    </div></div>
</div>
<div class="form-row">
    <div class="field-name">{"TRANS_STATUS_CHANGE_REASON"|lmsg}</div>
    <div class="field-value"><div class="text-value">{$packageInfo.packageStatusReason}</div></div>
</div>
<div class="form-row">
    <div class="field-name">
        {if "reseller" == ($packageInfo.packageType|getAPITypeName:"products")}
            {"TRANS_PACKAGE_RESELLER_STATUS_REASON_OPTION"|lmsg}
        {else}
            {"TRANS_PACKAGE_CUSTOMER_STATUS_REASON_OPTION"|lmsg}
        {/if}
    </div>
    <div class="field-value"><div class="text-value">{$packageInfo.packageCustomerStatusReason}</div></div>
</div>
{include file="$tplDirectory/widgets/form-box-footer.tpl"}

{include file="$tplDirectory/widgets/form-box-header.tpl" title="TRANS_ADMINISTRATIVE_ACTIONS"}
<div class="form-row">
    <div class="single-row">
        {assign var="packageID" value=$packageInfo.packageID}
        {include
            file="$tplDirectory/widgets/actionLink.tpl"
            module="packages"
            controller="status"
            action="edit"
            arguments="id=$packageID"
            icoImage="edit-subscription.png"
            id="iconChangeStatus"
            altText="TRANS_SUBSCRIPTION_EDIT_STATUS"
            linkText="TRANS_SUBSCRIPTION_EDIT_STATUS"}
    </div>
</div>
{if $packageInfo.packageActive && (
    $packageInfo.packageStatus == ("none"|get_status_id:"package") || $packageInfo.packageStatus == ("suspended"|get_status_id:"package") ||
    $packageInfo.packageStatus == ("pending"|get_status_id:"package") || $packageInfo.packageStatus == ("work_in_progress"|get_status_id:"package") ||
    $packageInfo.packageStatus == ("pending_renewal"|get_status_id:"package") || $packageInfo.packageStatus == ("user_input_required"|get_status_id:"package") ||
    $packageInfo.packageStatus == ("graced"|get_status_id:"package")
)}
    {if $packageInfo.packageStatus == ("none"|get_status_id:"package")} {* Show operation "Suspend" *}
        <div class="form-row">
            <div class="single-row">
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="packages"
                    controller="action"
                    action="index"
                    arguments="id=$packageID&packAction=suspend"
                    icoImage="suspend-subscription.png"
                    id="actionSuspend"
                    altText="TRANS_SUBSCRIPTION_OPERATION_SUSPEND"
                    linkText="TRANS_SUBSCRIPTION_OPERATION_SUSPEND"}
            </div>
        </div>
    {/if}
    {if $packageInfo.showActivateLink} {* Show operation "Activate" *}
        <div class="form-row">
            <div class="single-row">
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="packages"
                    controller="action"
                    action="index"
                    arguments="id=$packageID&packAction=activate"
                    icoImage="activate-subscription.png"
                    id="actionActivate"
                    altText="TRANS_SUBSCRIPTION_OPERATION_ACTIVATE"
                    linkText="TRANS_SUBSCRIPTION_OPERATION_ACTIVATE"}
            </div>
        </div>
    {/if}
    {if $packageInfo.packageStatus == ("none"|get_status_id:"package") || $packageInfo.packageStatus == ("suspended"|get_status_id:"package")} {* Show operations "Cancel" or "Rollback" *}
        {if $packageInfo.packagePendingCancellation == 0} {* Show operation "Cancel" *}
            <div class="form-row">
                <div class="single-row">
                    {include file="$tplDirectory/widgets/actionLink.tpl"
                        module="packages"
                        controller="action"
                        action="index"
                        arguments="id=$packageID&packAction=cancel"
                        icoImage="cancel-subscription.png"
                        id="actionCancel"
                        altText="TRANS_SUBSCRIPTION_OPERATION_CANCEL"
                        linkText="TRANS_SUBSCRIPTION_OPERATION_CANCEL"}
                </div>
            </div>
        {elseif $packageInfo.packagePendingCancellation == 1 || $packageInfo.packagePendingCancellation == 2}{* Show operation "Rollback" *}
            <div class="form-row">
                <div class="single-row">
                    {include file="$tplDirectory/widgets/actionLink.tpl"
                        module="packages"
                        controller="action"
                        action="index"
                        arguments="id=$packageID&packAction=withdrawCancellation"
                        icoImage="cancel-subscription.png"
                        id="actionWithdrawCancellation"
                        altText="TRANS_SUBSCRIPTION_OPERATION_WITHDRAW_CANCELLATION"
                        linkText="TRANS_SUBSCRIPTION_OPERATION_WITHDRAW_CANCELLATION"}
                </div>
            </div>
        {/if}
    {/if}
    {if "upgrade" != ($packageInfo.packagePendingCancellation|getAPITypeName:"pendingcancellation") && !($packageInfo.packageStatus == ("pending"|get_status_id:"package") && "" != $packageInfo.packagePriorID)}
        <div class="form-row">
            <div class="single-row">
                {* Show operation "Cancel immediately" *}
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="packages"
                    controller="action"
                    action="index"
                    arguments="id=$packageID&packAction=cancelImmediately"
                    icoImage="cancel-subscription.png"
                    id="actionCancelImmediately"
                    altText="TRANS_SUBSCRIPTION_OPERATION_CANCEL_IMMEDIATELY"
                    linkText="TRANS_SUBSCRIPTION_OPERATION_CANCEL_IMMEDIATELY"}
            </div>
        </div>
    {/if}
    {if $packageInfo.canCancelUpgrade}
        <div class="form-row">
            <div class="single-row">
                {* Show operation "Cancel upgrade or downgrade" *}
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="packages"
                    controller="action"
                    action="index"
                    arguments="id=$packageID&packAction=cancelUpgrade"
                    icoImage="upgrade-subscription.png"
                    id="actionCancelImmediately"
                    altText="TRANS_SUBSCRIPTION_OPERATION_CANCEL_UPGRADE_DOWNGRADE"
                    linkText="TRANS_SUBSCRIPTION_OPERATION_CANCEL_UPGRADE_DOWNGRADE"}
            </div>
        </div>
    {/if}
    {if $packageInfo.canRenew}
        <div class="form-row">
            <div class="single-row">
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="packages"
                    controller="action"
                    action="index"
                    arguments="id=$packageID&packAction=renew"
                    icoImage="refresh.png"
                    id="actionRenew"
                    altText="TRANS_SUBSCRIPTION_OPERATION_RENEW"
                    linkText="TRANS_SUBSCRIPTION_OPERATION_RENEW"}
            </div>
        </div>
    {/if}
    {if !$packageInfo.provisioningApproved}
        <div class="form-row">
            <div class="single-row">
                {include file="$tplDirectory/widgets/actionLink.tpl"
                    module="packages"
                    controller="action"
                    action="index"
                    arguments="id=$packageID&packAction=approveProvisioning"
                    icoImage="on.png"
                    id="actionApproveProvisioning"
                    altText="TRANS_SUBSCRIPTION_OPERATION_APPROVE_PROVISIONING"
                    linkText="TRANS_SUBSCRIPTION_OPERATION_APPROVE_PROVISIONING"}
            </div>
        </div>
    {/if}
{/if}
{include file="$tplDirectory/widgets/form-box-footer.tpl"}

{foreach key="serverGroupID" item="attribute" from=$serverGroupStatuses}
    {if !$attribute.absent}
        {assign var="panel_status" value=$attribute.packageAttributeValue}
        {assign var="configGroupID" value=$attribute.configGroupID}
        {assign var="queueID" value=$queueItems[$configGroupID].systemQueueID}
        {if $panel_status=="none"}
            {assign var="panel_status" value="Active"}
        {elseif $panel_status=="suspended"}
            {assign var="panel_status" value="Suspended"}
        {/if}

        {if $panel_status=="Active" || $panel_status=="Suspended" || !$isReseller}
            <div class="form-box">
                <div class="box-area">
                    <div class="title"><div class="title-area"><h3><span>{"TRANS_SUBSCRIPTION_ON_PANEL_GROUP"|lmsg:"PANEL_GROUP":$serverGroupList.$serverGroupID}</span></h3></div></div>
                    <div class="content">
                        <div class="content-area">
                            <div class="content-wrapper">
        {/if}

        {if $panel_status=="Active" || $panel_status=="Suspended"}
            <div class="form-row">
                <div class="field-name">{"TRANS_PACKAGE_DETAILS_STATUS_ON_PANEL"|lmsg}</div>
                <div class="field-value"><div class="text-value">{$panel_status}</div></div>
            </div>
            <div class="form-row">
                <div class="field-name">{"TRANS_SYSTEM_QUEUE_STATUS_OPTION"|lmsg}</div>
                <div class="field-value"><div class="text-value">{$queueItems[$configGroupID].subCommand}: <a href="{getHREF page="events.php" actionName="ShowTask" args="systemQueueID=$queueID"}">{$queueItems[$configGroupID].systemQueueStatus}</a></div></div>
            </div>
        {/if}
        {if !$isReseller}
            {if 1 != $panels|@count}
                <form action="{getFormAction controller="packages"}&act={getActionID action="EditPackageAttributeResponse}"}" method="post" name="delete_section">
                    <input type="hidden" name="token" value="{$token}">
                    <input type="hidden" name="act" value="{getActionID action="ReassignPackageAttributeResponse"}">
                    <input type="hidden" name="oldConfigID" value="{$configGroupID}">
                    <input type="hidden" name="referralActionID" value="{getActionID action="ShowPackageDetails"}">
                    <input type="hidden" name="referralActionFile" value="packages.php">
                    <input type="hidden" name="packageID" value="{$packageInfo.packageID}">
                    <div class="form-row">
                        <div class="single-row">
                            <select name="configGroupID">
                                {html_options options=$panels selected=$configGroupID}
                            </select>
                            <span class="btn action"><button id="billing-id-reassign" name="submit_update" value="{"TRANS_REASSIGN"|lmsg}" type="submit">{"TRANS_REASSIGN"|lmsg}</button></span>
                            <div class="hint">{"TRANS_REASSIGN_DESC"|lmsg}</div>
                        </div>
                    </div>
                </form>
            {else}
                <div class="form-row">
                    <div class="field-name">{"TRANS_PANEL_SERVERNAME_OPTION"|lmsg}</div>
                    <div class="field-value"><div class="text-value">
                        {$panels.$configGroupID}&nbsp;&nbsp;&nbsp;
                        {if $panel_status == "Active" && $serverDetails[$configGroupID].loginUrl}
                            <a href="{$serverDetails[$configGroupID].loginUrl}" class="i-link " target="_blank" id="loginPanel_{$configGroupID}">
                                <img width="16" height="16" title="Show All Contacts" alt="Show All Contacts" src="/theme/icons/16/billing/login-as-customer.png"><span>{"TRANS_LOGIN"|lmsg}</span>
                            </a>
                        {/if}
                    </div></div>
                </div>
            {/if}
        {/if}

        {if $panel_status=="Active" || $panel_status=="Suspended" || !$isReseller}
            {include file="$tplDirectory/widgets/form-box-footer.tpl"}
        {/if}

    {/if} {* ! absent *}
{/foreach}