{* $Id: paginationLinks.tpl 9110 2006-09-22 19:10:06Z mfountain $
 * --------------------------------------------------------------
 * This template is a widget that displays the pagination links for a list of results.
 *
 * Smarty Variables:
 *	$fileName 				The name of the file to link to in the URL
 *	$queryArgs 				All urldecoded query args to append to the URL
 *	$filterArgs 			All urldecoded filter args to append to the URL
 *	$sortArgs 				All urldecoded sort args to append to the URL
 *	$paginationLinks 		An array of all pagination information if you want to override our biz rules
 *	$displayMinorPageList 	The flag to display minor page list
 *	$displayPrevMinorLink 	The flag to display previous minor href link
 *  $displayNextMinorLink   The flag to display next minor href link
 *  $displayAllPageSelect   The flag to display a select menu to go to any page.
 *
 * Example Usage:
 *  {include file="$tplDirectory/widgets/paginationLinks.tpl"}
 *}
{strip}
    {include file="$tplDirectory/widgets/list-box-header.tpl"}
    {if $smarty.request}
        {foreach from=$smarty.request key=keyID item=val}
            {if (!in_array($keyID, array('SSOSID', 'PHPSESSID')) && preg_match('/.+ID/', $keyID))}
                {assign var=queryArgs value="$queryArgs&$keyID=$val"}
            {/if}
        {/foreach}
    {/if}
    {if $paginationLinks.paginationStats.totalRows > 0}
        <p class="text-center">{"TRANS_RESULTS"|lmsg} <strong>{$paginationLinks.paginationStats.startingRowNum} - {$paginationLinks.paginationStats.stoppingRowNum}</strong> ~ {$paginationLinks.paginationStats.totalRows}</p>
        <p class="text-center">
            {if $displayPrevMinorLink && $paginationLinks.paginationStats.totalPages > 1}
                {assign var="recordOffset" value=$paginationLinks.prevNextLinks.previousLinkOffset}
                <a class="i-link" href="{getHREF page=$fileName actionID=$actionID args="$filterArgs&$queryArgs&$sortArgs&recordOffset=$recordOffset"}">
                    <img src="/theme/icons/16/billing/previous.png" alt="{"TRANS_PREVIOUS"|lmsg}" title="{"TRANS_PREVIOUS"|lmsg}">
                </a>
            {else}
                <img src="/theme/icons/16/billing/previous.png" alt="{"TRANS_PREVIOUS"|lmsg}" title="{"TRANS_PREVIOUS"|lmsg}" class="pad10">
            {/if}
            &nbsp;
            {section name=page loop=$paginationLinks.pageLinks.pages}
                {if $paginationLinks.pageLinks.currentPageNumber == $paginationLinks.pageLinks.pages[page].pageNumber}
                    <em>{$paginationLinks.pageLinks.pages[page].pageNumber}</em>
                {else}
                    {assign var="recordOffset" value=$paginationLinks.pageLinks.pages[page].pageOffset}
                    <a href="{getHREF page=$fileName actionID=$actionID args="$filterArgs&$queryArgs&$sortArgs&recordOffset=$recordOffset"}">{$paginationLinks.pageLinks.pages[page].pageNumber}</a>
                {/if}
                &nbsp;
            {sectionelse}
                <em>1</em>
                &nbsp;
            {/section}
            &nbsp;
            {if $displayNextMinorLink && $paginationLinks.paginationStats.totalPages > 1}
                {assign var="recordOffset" value=$paginationLinks.prevNextLinks.nextLinkOffset}
                <a class="i-link" href="{getHREF page=$fileName actionID=$actionID args="$filterArgs&$queryArgs&$sortArgs&recordOffset=$recordOffset"}">
                    <img src="/theme/icons/16/billing/next.png" alt="{"TRANS_NEXT"|lmsg}" title="{"TRANS_NEXT"|lmsg}">
                </a>
            {else}
                <img src="/theme/icons/16/billing/next.png" alt="{"TRANS_NEXT"|lmsg}" title="{"TRANS_NEXT"|lmsg}">
            {/if}
        </p>
        <p class="text-center">
            {if $displayAllPageSelect && $paginationLinks.paginationStats.totalPages>1}
                {"TRANS_GOTO"|lmsg}
                <select name="pageinationSelect" onChange="document.location.href='{getHREF page=$fileName actionID=$actionID args="$filterArgs&$queryArgs&$sortArgs"}&amp;recordOffset='+this.options[this.selectedIndex].value;">
                    {mb_html_options selected=$paginationLinks.paginationStats.startingRowNum-1 paginationrowsperpage=$paginationLinks.paginationStats.rowsPerPage paginationtotalpages=$paginationLinks.paginationStats.totalPages paginationtotalrows=$paginationLinks.paginationStats.totalRows}
                </select>
            {/if}
        </p>
    {/if}
    {include file="$tplDirectory/widgets/list-box-footer.tpl"}
{/strip}