{* $Id: quickAddLink.tpl 7177 2006-06-01 23:26:34Z bwoolley $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for amount columns, that when you click on
 * the header name, will only search this column using amounts!
 *
 * Smarty Variables:
 *	$addActionName	The action name to get the action id for.
 *	$addID  		The id of the record to add.
 *	$addKey		The primary key column name of the record to add.
 *  $addColumn		The the column to add.
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 * $extraparam	Extra parameter, if necessary
 * $extravalue	Extra param value, if necessary
 *  $sid			The current sessionID
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/quickAddLink.tpl" useEditIcon=0 addActionName="addAdminGroupResponse" addName="TRANS_FIRST_NAME" addColumn="clientCompany" addValue="$clients[i].clientCompany"}
 *}

{include file="$tplDirectory/widgets/tooltip-header.tpl" id=`$addColumn` heading=$addMessage}
<form method='post' action='{getFormAction controller="`$fileName`"}'>
    <input type='hidden' name='act' value='{getActionID action="$addActionName"}'>
    <input type='hidden' name='redirectURL' value='{$fileName}'>
    <input type='hidden' name='redirectAction' value='{$actionName}'>
    <input type='hidden' name='redirectArgs' value='{$bookmarkArgs}'>
    <input type='hidden' name='token' value='{$token}'>
    {if $extraparam}
        <input type='hidden' name='{$extraparam}' value='{$extravalue}'>
    {/if}

    {$addName|lmsg}:&nbsp;<input type='text' name='{$addColumn}' value='{$addValue}'>
    <div class="btns-box">
        <div class="box-area text-center">
            <span class="btn action"><button name="add" type="submit" value="{"TRANS_ADD"|lmsg}">{"TRANS_ADD"|lmsg}</button></span>
        </div>
    </div>
</form>
{include file="$tplDirectory/widgets/tooltip-footer.tpl"}

{if !$disableLink}
    <a href="javascript:void(0);" class="button-tooltip i-link" id="billing-id-{$addColumn}">
        {if $useEditIcon}
            <img src="/theme/icons/16/billing/edit.png" width="16" height="16" alt="{"TRANS_ADD"|lmsg}" title="{"TRANS_ADD"|lmsg}">
        {elseif $addMessage}
            {$addMessage|lmsg}
        {/if}
    </a>
{/if}