{* $Id: quickApplyCredit.tpl 11760 2007-08-08 22:48:12Z kbailey $
 * --------------------------------------------------------------
 * This widget template is used to display the quick manual credit popup div.
 *
 *
 * Smarty Variables:
 *	$actionName     The action name to get the action id for.
 *	$invoiceID 	    The primary key column name of the record to add.
 *  $lineItems      The line items they can pay for in an array
 *  $redirectURL    The php script to redirect to
 *  $redirectAction The action name for the redirect
 *  $redirectArgs   The args to send through the url to the redirectURL BESIDES the sid and actionID
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/quickApplyCredit.tpl"
 *            actionName="ProcessManualPayment"
 *            formName="quickpaymentform"
 *            lineItems=$lineItemsArray
 *            invoiceID=$invoiceID
 *            defaultAmount=$defaultAmount
 *            localeArray=$localeArray
 *            currencyID=$currencyID
 *            paymentTypes=$typesArray
 *            redirectURL="invoice.php"
 *            redirectAction="ShowInvoiceDetails"
 *            redirectArgs=""}
 *}


{include file="$tplDirectory/widgets/popup-panel-header.tpl" id="billing-id-process-manual-credit-popup-panel" heading="TRANS_QUICK_APPLY_CREDIT" class="process-manual-credit" isScrollEnabled=true}
<form method='post' action='{getFormAction controller="invoices"}' name='{$formName}' id='{$formName}'>
    <input type='hidden' name='act' value='{getActionID action="ProcessManualPayment"}'>
    <input type='hidden' name='invoiceID' value='{$invoiceID}'>
    <input type='hidden' name='subaction' value='credit'>
    <input type='hidden' name='invoiceID' value='{$invoiceID}'>
    <input type='hidden' name='redirectURL' value='{$redirectURL}'>
    <input type='hidden' name='redirectAction' value='{$redirectAction}'>
    <input type='hidden' name='redirectArgs' value='{$redirectArgs}'>

    <div class="popup-content-area">
        <div class="form-box">
            <div class="form-row"><div class="field-name">{"TRANS_CREDIT_AMOUNT_AVAILABLE"|lmsg}</div>
                <div class="field-value">
                    {$defaultCreditAmount|getAmount:$currencyID|escape:html}
                </div>
            </div>
            <div class="form-row"><div class="field-name">{"TRANS_APPLY_CREDIT_TO"|lmsg}</div>
                <div class="field-value">
                    <label for="applyCreditTo1" onmouseup="XKtoggleOff('{$formName}_lineitems');XKtoggleOn('{$formName}_amount');"><input id="applyCreditTo1" type="radio" name="applyPaymentTo" checked="checked" value="invoice" onmouseup="XKtoggleOff('{$formName}_lineitems');XKtoggleOn('{$formName}_amount');"> {"TRANS_CREDIT_ENTIRE_INVOICE"|lmsg}</label><br>
                    <label for="applyCreditTo2" onmouseup="XKtoggleOn('{$formName}_lineitems');XKtoggleOff('{$formName}_amount');"><input id="applyCreditTo2" type="radio" name="applyPaymentTo" value="lineitems" onmouseup="XKtoggleOn('{$formName}_lineitems');XKtoggleOff('{$formName}_amount');"> {"TRANS_CREDIT_SELECTED_LINEITEMS"|lmsg}</label>
                </div>
            </div>
            <div id='{$formName}_lineitems' class="list" style="height: 200px; display: none;">
                <table width="100%" cellspacing="0">
                    <thead>
                    <tr>
                        <th>{"TRANS_PACKAGE_ID"|lmsg}</th>
                        <th>{"TRANS_DESCRIPTION"|lmsg}</th>
                        <th>{"TRANS_LINE_ITEM_BALANCE"|lmsg}</th>
                        <th>{"TRANS_AMOUNT_TO_PAY"|lmsg}</th>
                    </tr>
                    </thead>
                    <tbody>
                        {section name="j" loop=$lineItems}
                            <tr class="{cycle values="odd,even"}">
                                {if $lineItems[j].packageAddonID>0}
                                    <td>{"TRANS_ADDON_PREFIX"|lmsg}{$lineItems[j].packageAddonID}</td>
                                {else}
                                    <td>{$lineItems[j].packageID}</td>
                                {/if}
                                <td>{$lineItems[j].lineItemDescription|escape:quotes|escape:htmlall}</td>
                                <td class="text-right">{$lineItems[j].lineItemAmountDue|getAmount:$currencyID|escape:javascript}</td>
                                <td><input type=text onkeyup="document.getElementById('{$formName}_totaldiv').innerHTML=XKformatNumber('{1000|getAmount:$currencyID:true:true}', XKgetFormFieldTotals(document.{$formName}, 'lineItemPayments'), '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');" onblur="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true}', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');" size="13" name="lineItemPayments[{$lineItems[j].lineItemID}]" value="0.00"></td>
                            </tr>
                        {/section}
                    </tbody>
                    <tfoot>
                        <tr>
                            <td colspan="4"><hr></td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td>&nbsp;</td>
                            <td class="text-right">{"TRANS_LINEITEM_ADDUP_TOTAL"|lmsg}</td>
                            <td><div id="{$formName}_totaldiv">&nbsp;</div></td>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <div id='{$formName}_amount' class="form-row">
                <div class="field-name">{"TRANS_QUICKCREDIT_INVOICE_AMOUNT"|lmsg}</div>
                <div class="field-value">
                    <input class="f-large-size" type="text" onblur="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true}', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');" name="paymentAmount" size="9" value="{$defaultAmount|escape:htmlall|getAmount:$currencyID}">
                </div>
            </div>
            <div class="form-row">
                <div class="field-name">{"TRANS_QUICKCREDIT_COMMENTS"|lmsg}</div>
                <div class="field-value">
                    <input type="text" name="paymentComments" size="25" value="">
                </div>
            </div>
        </div>
    </div>
    <div class="btns-box">
        <div class="box-area">
            <div class="form-row">
                <div class="single-row">
                    <div class="field-value">
                        <span class="btn action"><button id="billing-id-apply-process-manual-credit" value="{"TRANS_CREDIT_APPLY"|lmsg}" name="process" type="submit">{"TRANS_CREDIT_APPLY"|lmsg}</button></span>
                        <span class="btn"><button id="billing-id-cancel-process-manual-credit" value="{"TRANS_CANCEL"|lmsg}" name="cancel" type="button">{"TRANS_CANCEL"|lmsg}</button></span>
                    </div>
                </div>
            </div>
        </div>
    </div>
</form>
{include file="$tplDirectory/widgets/popup-panel-footer.tpl"}