{* $Id: quickApplyPayment.tpl 12532 2008-01-21 19:54:57Z kbailey $
 * --------------------------------------------------------------
 * This widget template is used to display the quick manual payment popup div.
 *
 *
 * Smarty Variables:
 *	$actionName     The action name to get the action id for.
 *	$invoiceID 	    The primary key column name of the record to add.
 *  $lineItems      The line items they can pay for in an array
 *  $redirectURL    The php script to redirect to
 *  $redirectAction The action name for the redirect
 *  $redirectArgs   The args to send through the url to the redirectURL BESIDES the sid and actionID
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/quickApplyPayment.tpl"
 *            actionName="ProcessManualPayment"
 *            formName="quickpaymentform"
 *            lineItems=$lineItemsArray
 *            billingAccounts=$billingAccountOptions
 *            invoiceID=$invoiceID
 *            defaultAmount=$defaultAmount
 *            localeArray=$localeArray
 *            currencyID=$currencyID
 *            paymentTypes=$typesArray
 *            redirectURL="invoice.php"
 *            redirectAction="ShowInvoiceDetails"
 *            redirectArgs=""}
 *}

{include file="$tplDirectory/widgets/popup-panel-header.tpl" id="billing-id-process-manual-payment-popup-panel" heading="TRANS_QUICK_APPLY_PAYMENT" class="process-manual-payment" isScrollEnabled=true}
<form method="post" action="{getFormAction controller="invoices"}" name="{$formName}" id="{$formName}">
    <input type='hidden' name='act' value='{getActionID action="ProcessManualPayment"}'>
    <input type='hidden' name='subaction' value='applypayment'>
    <input type='hidden' name='invoiceID' value='{$invoiceID}'>
    <input type='hidden' name='redirectURL' value='{$redirectURL}'>
    <input type='hidden' name='redirectAction' value='{$redirectAction}'>
    <input type='hidden' name='redirectArgs' value='{$redirectArgs}'>
    <div class="popup-content-area">
        <div class="form-box">
            <div class="box-area">
                <div class="form-row"><div class="field-name">{"TRANS_CHOOSE_BILLING_ACCOUNT"|lmsg}</div>
                    <div class="field-value">
                        <select name='billingAccountID'>
                            {html_options options=$billingAccounts}
                            <option value="0" >{"TRANS_GENERAL_MANUAL_PAYMENT_ACCOUNT"|lmsg}</option>
                        </select>
                    </div>
                </div>
                <div class="form-row"><div class="field-name">{"TRANS_MANUAL_METHOD_OF_PAYMENT"|lmsg}</div>
                    <div class="field-value">
                        <select id="paymentMethod" name='paymentMethod' onchange="XKhandlePaymentMethod(this.options[this.selectedIndex].value);">
                            {html_options options=$paymentTypes selected=3}
                        </select>
                    </div>
                </div>
                <div id="paymentExtra" class="form-row">
                	<div id="paymentCheck" class="field-name">{"TRANS_CHECK_NUMBER"|lmsg}</div>
                	<div id="paymentCard" class="field-name">{"TRANS_THIS_TRANSACTION_CODE"|lmsg}</div>
                    <div class="field-value">
                        <input type="text" name="transactionCode" size="25" value="">
                    </div>
                </div>
                <div class="form-row"><div class="field-name">{"TRANS_APPLY_MANUAL_PAYMENT_TO"|lmsg}</div>
                    <div  class="field-value">
                        <label for="applyPaymentTo1" onmouseup="XKtoggleOff('{$formName}_lineitems');XKtoggleOn('{$formName}_amount');"><input type="radio" name="applyPaymentTo" id="applyPaymentTo1" checked="checked" value="invoice" onmouseup="XKtoggleOff('{$formName}_lineitems');XKtoggleOn('{$formName}_amount');"> {"TRANS_MANUAL_PAYMENT_ENTIRE_INVOICE"|lmsg}</label><br>
                        <label for="applyPaymentTo2" onmouseup="XKtoggleOn('{$formName}_lineitems');XKtoggleOff('{$formName}_amount');"><input type="radio" name="applyPaymentTo" id="applyPaymentTo2" value="lineitems" onmouseup="XKtoggleOn('{$formName}_lineitems');XKtoggleOff('{$formName}_amount');"> {"TRANS_MANUAL_PAYMENT_SELECTED_LINEITEMS"|lmsg}</label>
                    </div>
                </div>
                <div id='{$formName}_lineitems' class="list" style="height: 200px; display: none;">
                    <table width="100%" cellspacing="0">
                        <thead>
                            <tr>
                                <th>{"TRANS_PACKAGE_ID"|lmsg}</th>
                                <th>{"TRANS_DESCRIPTION"|lmsg}</th>
                                <th>{"TRANS_LINE_ITEM_BALANCE"|lmsg}</th>
                                <th>{"TRANS_AMOUNT_TO_PAY"|lmsg}</th>
                            </tr>
                        </thead>
                        <tbody>
                            {section name="j" loop=$lineItems}
                                <tr class="{cycle values="odd,even"}{if $didfirst==''}{assign var="didfirst" value="yes"} total{/if}">
                                    {if $lineItems[j].packageAddonID>0}
                                        <td>{"TRANS_ADDON_PREFIX"|lmsg}{$lineItems[j].packageAddonID}</td>
                                    {else}
                                        <td>{$lineItems[j].packageID}</td>
                                    {/if}
                                    <td>{$lineItems[j].lineItemDescription|escape:quotes|escape:htmlall}</td>
                                    <td class="text-right">{$lineItems[j].lineItemAmountDue|getAmount:$currencyID|escape:javascript}</td>
                                    <td><input type=text onkeyup="document.getElementById('{$formName}_totaldiv').innerHTML=XKformatNumber('{1000|getAmount:$currencyID:true:true}', XKgetFormFieldTotals(document.{$formName}, 'lineItemPayments'), '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');" onblur="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true}', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');" size="13" name="lineItemPayments[{$lineItems[j].lineItemID}]" value="0.00"></td>
                                </tr>
                            {/section}
                        </tbody>
                        <tfoot>
                            <tr>
                                <td colspan="4"><hr></td>
                            </tr>
                            <tr>
                                <td>&nbsp;</td>
                                <td>&nbsp;</td>
                                <td class="text-right">{"TRANS_LINEITEM_ADDUP_TOTAL"|lmsg}</td>
                                <td><div id="{$formName}_totaldiv">&nbsp;</div></td>
                            </tr>
                        </tfoot>
                    </table>
                </div>
                <div id='{$formName}_amount' class="form-row">
                    <div class="field-name">{"TRANS_QUICKPAYMENT_INVOICE_AMOUNT"|lmsg}</div>
                    <div class="field-value">
                        <input class="f-large-size" type="text" onblur="this.value=XKformatNumber('{1000|getAmount:$currencyID:true:true}', this.value, '{$localeArray.locale_separator_decimal}', '{$localeArray.locale_separator_grouping}');" name="paymentAmount" size="9" value="{$defaultAmount|escape:htmlall|getAmount:$currencyID}">
                    </div>
                </div>
                <div class="form-row">
                    <div class="field-name">{"TRANS_QUICKPAYMENT_COMMENTS"|lmsg}</div>
                    <div class="field-value">
                        <input type="text" name="paymentComments" size="25" value="">
                    </div>
                </div>
                {if $transactionType == "manual"}
                    <div class="form-row">
                        <div class="field-name">{"TRANS_DATE_PAYMENT_MADE"|lmsg}</div>
                        <div  class="field-value">
                            {include file="$tplDirectory/widgets/dateSelector.tpl" optional=0 param="transactionDateCreated" default="transactionDateCreated" real="transactionDateCreated"}
                        </div>
                    </div>
                {/if}
                <div class="form-row">
                    <div class="single-row">
                        <input type="checkbox" name="sendPaymentEmail" value="1" class="checkbox" id="billing-id-sendPaymentEmail" checked="checked">
                        <label for="billing-id-sendPaymentEmail"> {"TRANS_SEND_PAYMENT_RECEIPT_EMAIL"|lmsg}</label>
                    </div>
                </div>
            </div>
        </div>
        <div class="btns-box">
            <div class="box-area">
                <div class="form-row">
                    <div class="single-row">
                        <div class="field-value">
                            <span class="btn action"><button id="billing-id-apply-process-manual-payment" onclick="this.disabled=true; document.getElementById('{$formName}').submit(); return false;" value="{"TRANS_MANUAL_PAYMENT_APPLY"|lmsg}" name="process" type="submit">{"TRANS_MANUAL_PAYMENT_APPLY"|lmsg}</button></span>
                            <span class="btn"><button id="billing-id-cancel-process-manual-payment" value="{"TRANS_CANCEL"|lmsg}" name="cancel" type="button">{"TRANS_CANCEL"|lmsg}</button></span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</form>
{include file="$tplDirectory/widgets/popup-panel-footer.tpl"}
<script>
    {literal}
        function XKhandlePaymentMethod(x){
            if (x==3){
                // check
                jQuery('#paymentExtra').show();
                jQuery('#paymentCheck').show();
                jQuery('#paymentCard').hide();
            } else if (x==1 || x==2 || x==4 || x==5){
                // card (or echeck, bank draft)
                jQuery('#paymentExtra').show();
                jQuery('#paymentCheck').hide();
                jQuery('#paymentCard').show();
            } else {
                jQuery('#paymentExtra').hide();
            }
        }
        jQuery(document).ready(function() {
            XKhandlePaymentMethod(jQuery('#paymentMethod:selected'));
        });
    {/literal}
</script>
