{* $Id: quickEditLink.tpl 10845 2007-03-09 00:40:50Z kbailey $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for amount columns, that when you click on
 * the header name, will only search this column using amounts!
 *
 * Smarty Variables:
 *	$editActionName	The action name to get the action id for.
 *	$editID  		The id of the record to edit.
 *	$editKey		The primary key column name of the record to edit.
 *  $editColumn		The the column to edit.
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *  $useEditIcon    1 or 0
 *	$imageDirectory	The image directory for this theme.
 *  $extraparam		Extra parameter, if necessary
 *  $extravalue		Extra param value, if necessary
 *  $sid			The current sessionID
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/quickEditLink.tpl" useEditIcon=0 editActionName="EditAdminGroupResponse" editName="TRANS_FIRST_NAME" editColumn="clientCompany" editValue="$clients.i.clientCompany"}
 *}
{include file="$tplDirectory/widgets/tooltip-header.tpl" id="`$editColumn`-`$editID`" heading="TRANS_QUICK_EDIT"}
<form method="post" action="{getFormAction controller="`$fileName`"}">
    <input type="hidden" name="act" value="{getActionID action="$editActionName"}">
    <input type="hidden" name="{$editKey}" value="{$editID}">
    <input type="hidden" name="redirectURL" value="{$fileName}">
    <input type="hidden" name="redirectAction" value="{$actionName}">
    <input type="hidden" name="redirectArgs" value="{$bookmarkArgs}">
    <input type="hidden" name="token" value="{$token}">
    {if $extraparam}
        <input type="hidden" name="{$extraparam}" value="{$extravalue|escape|addslashes}">
    {/if}
    {$editName|lmsg}:&nbsp;
    <textarea  id="{$editColumn}Input"  {if $onlyNumbers==1}onkeyup="this.value=XKfilterStringNumbersOnly(this.value);"{/if} name="{$editColumn}">{$editValue|escape|addslashes}</textarea>
    <div class="btns-box">
        <div class="box-area text-center">
            <span class="btn action"><button name="edit" type="submit" value="{"TRANS_EDIT"|lmsg}">{"TRANS_EDIT"|lmsg}</button></span>
        </div>
    </div>
</form>
{include file="$tplDirectory/widgets/tooltip-footer.tpl"}
<a href="javascript:void(0);" class="button-tooltip i-link" id="billing-id-{$editColumn}-{$editID}">
    {if $useEditIcon}
        <img src="/theme/icons/16/billing/edit.png" width="16" height="16" alt="{"TRANS_QUICK_EDIT"|lmsg}" title="{"TRANS_QUICK_EDIT"|lmsg}">
    {/if}
</a>
{assign var="onlyNumbers" value=0}
