{* $Id: listHeaderSort.tpl 10611 2007-01-31 23:58:12Z kbailey $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a generic search box, that when you click on the header name,
 * will only search this column using text!
 *
 * Smarty Variables:
 *	$headerName  	The constant representation of that column name
 *	$fileName		The file name to submit to
 *	$actionID		The current actionID
 *  $sortColumn		The sort column to pass to the sortLinks widget
 *	$sortArgs		The sort arguments to pass to the sortLinks widget
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_X" sortColumn="someColumnName"}
 *}

{if $fileName==""}
	{assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}

{assign var="newSort" value="asc"}
{assign var="newSortTitle" value="TRANS_SORT_ASC"|lmsg}
{if $smarty.request.sortDir == "asc"}
    {assign var="newSort" value="desc"}
    {assign var="newSortTitle" value="TRANS_SORT_DESC"|lmsg}
{/if}
{if $headerAlign==""}
    {assign var="headerAlign" value="left"}
{/if}

{strip}
    {if $smarty.request.sortColumn == $sortColumn}
        <th {if $colWidth>0}width="{$colWidth}"{/if} class="text-{$headerAlign}">
    {else}
        <th {if $colWidth>0}width="{$colWidth}"{/if} class="text-{$headerAlign}">
    {/if}

    {include file="$tplDirectory/widgets/tooltip-header.tpl" id=`$sortColumn` heading="TRANS_SEARCH_BY"}
    <form method='get' action='{getFormAction}'>
        {if $smarty.request}
            {foreach from=$smarty.request key=keyID item=val}
                {if (!in_array($keyID, array('SSOSID', 'PHPSESSID')) && preg_match('/.+ID/', $keyID))}
                    <input type='hidden' name='{$keyID}' value='{$val}'>
                    {assign var=queryArgs value="$queryArgs&$keyID=$val"}
                {/if}
            {/foreach}
        {/if}
        <input type='hidden' name='ctr' value='{$fileName}'>
        <input type='hidden' name='act' value='{$actionID}'>
        <input type='hidden' name='queryColumn' value='{$sortColumn}'>
        {if $sortColumn}<input type='hidden' name='sortColumn' value='{$sortColumn}'>{/if}
        {if $sortDir}<input type='hidden' name='sortDir' value='{$sortDir}'>{/if}
        {if $queryArgCol}<input type='hidden' name='{$queryArgCol}' value='{$queryArgValue}'>{/if}
        <input type='text' name='query' id='query_{$sortColumn}' value='' class='input'>
        <div class="btns-box">
            <div class="box-area text-center">
                <span class="btn action"><button name="find" type="submit" value="{"TRANS_QUICK_FIND"|lmsg}">{"TRANS_QUICK_FIND"|lmsg}</button></span>
            </div>
        </div>
    </form>
    {include file="$tplDirectory/widgets/tooltip-footer.tpl"}
    <a href="javascript:void(0);" class="button-tooltip" id="billing-id-{$sortColumn}">
        <img  src="/theme/icons/16/billing/search.png" alt="{"TRANS_SEARCH"|lmsg}" title="{"TRANS_SEARCH"|lmsg}">
    </a>
    &nbsp;
    <a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=$newSort"}" title="{$newSortTitle}">
        {$headerName|lmsg}
    </a>
</th>
{if $addEmptyTD}
    <th>&nbsp;</th>
{/if}
{/strip}
