{* $Id: listHeaderSortAmount.tpl 10611 2007-01-31 23:58:12Z kbailey $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for amount columns, that when you click on
 * the header name, will only search this column using amounts!
 *
 * Smarty Variables:
 *	$headerName  	The constant representation of that column name.
 *	$fileName		The file name to submit to
 *	$actionID		The current actionID
 *  $sortColumn		The sort column to pass to the sortLinks widget.
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_X" sortColumn="someColumnName"}
 *}

{if $fileName==""}
    {assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}
{assign var="newSort" value="asc"}
{assign var="newSortTitle" value="TRANS_SORT_ASC"|lmsg}
{if $smarty.request.sortDir == "asc"}
    {assign var="newSort" value="desc"}
    {assign var="newSortTitle" value="TRANS_SORT_DESC"|lmsg}
{/if}
{if $smarty.const.$headerName == "" && $headerName != ""}
    {assign var="headerName" value=$headerName}
{else}
    {assign var="headerName" value=$smarty.const.$headerName}
{/if}
{strip}
{if $headerAlign==""}
    {assign var="headerAlign" value="left"}
{/if}

<th {if $colWidth>0}width="{$colWidth}"{/if} class="{$headerClass} text-{$headerAlign}">
    <a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=$newSort"}" title="{$newSortTitle}">
        {$headerName|lmsg}
    </a>
</th>
{if $addEmptyTD}
    <th>&nbsp;</th>
{/if}
{/strip}
