{* $Id: wizardQuestionInputSelect.tpl 12708 2008-02-28 17:01:59Z kbailey $
 * --------------------------------------------------------------
 * This widget template displays a question input select menu.
 *
 * Smarty Variables:
 *	$question		The question.
 *  $inputName		The name of the select menu.
 *  $selectOptions	An array of the select options.
 *  $selected		The selected options value.
 *  $appendText		The appended text messege.
 *
 * Example Usage:
 *  {include file="$tplDirectory/admin/widgets/wizard/questionInputSelect.tpl" question="Some Question" inputName="" selectOptions="" selected="" appendText=""}
 *}

{if $smarty.const.WIZARD_ADMIN_ADDON_DISPLAY==1}
    <select class="f-middle-size" name="addonValues[{literal}{ID}{/literal}][{$questionID}]" {if ($questionSize)}size="{$questionAnswers[i].size|safetyhtml}"{else}size="1"{/if}>
        {section name="i" loop=$questionAnswers}
            <option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value|safetyhtml}"{/if}
            {if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer|safetyhtml}</option>
        {/section}
    </select>
    {if $questionDescription}<span class="hint">{$questionDescription|safetyhtml}</span>{/if}
    {if $questionErrorMesgs}<span class="error-hint">{$questionErrorMesgs}</span>{/if}
{else}
    <div class="form-row {if $questionErrorMesgs}error{/if}"><div class="field-name"><label for="{$questionID}">{$question|safetyhtml}</label></div>
        <div class="field-value">
            <input type="hidden" name="{$questionID}" value="">
            <select class="f-middle-size" name="{$questionID}" {if ($questionSize)}size="{$questionAnswers[i].size|safetyhtml}"{else}size="1"{/if}>
                {section name="i" loop=$questionAnswers}
                    <option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value|safetyhtml}"{/if} {if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer|safetyhtml}</option>
                {/section}
            </select>
            {if $questionDescription}<span class="hint">{$questionDescription|safetyhtml}</span>{/if}
            {if $questionErrorMesgs}<span class="error-hint">{$questionErrorMesgs}</span>{/if}
        </div>
    </div>
{/if}
