{* $Id: wizardQuestionInputText.tpl 12708 2008-02-28 17:01:59Z kbailey $
 * --------------------------------------------------------------
 * This widget template displays a question input text field.
 *
 * Smarty Variables:
 *	$question		The question.
 *  $inputName		The name of the select menu.
 *  $inputValue		The value of the input.
 *  $inputSize		The size of the input field.
 *  $inputMaxlength	The maxlength of the input field.
 *  $appendText		The appended text messege.
 *
 * Example Usage:
 *  {include file="$tplDirectory/admin/widgets/wizard/questionInputText.tpl" question="Some Question" inputName="" inputValue="" inputSize="" inputMaxlength="" appendText=""}
 *}

{if $smarty.const.WIZARD_ADMIN_ADDON_DISPLAY==1}
    <input class="f-middle-size" type="text" name="addonValues[{literal}{ID}{/literal}][{$questionID}]" {if ($questionSize)}size="{$questionSize|safetyhtml}"{else}size="6"{/if} {if $questionMaxLength}maxlength="{$questionMaxLength|safetyhtml}"{/if} value="{$questionAnswers.0.answer|safetyhtml}">
    {if $questionDescription}<span class="hint">{$questionDescription|safetyhtml}</span>{/if}
    {if $questionErrorMesgs}<span class="error-hint">{$questionErrorMesgs}</span>{/if}
{else}
    <div class="form-row {if $questionErrorMesgs}error{/if}"><div class="field-name"><label for="{$questionID}">{$question|safetyhtml}{if ($requiredField)}<span class="required">*</span>{/if}</label></div>
        <div class="field-value">
            <input class="f-middle-size" type="text" name="{$questionID}" {if ($questionSize)}size="{$questionSize|safetyhtml}"{else}size="6"{/if} {if $questionMaxLength}maxlength="{$questionMaxLength|safetyhtml}"{/if} value="{$questionAnswers.0.answer|safetyhtml}">
            {if $questionDescription}<span class="hint">{$questionDescription|safetyhtml}</span>{/if}
            {if $questionErrorMesgs}<span class="error-hint">{$questionErrorMesgs}</span>{/if}
        </div>
    </div>
{/if}