{*
 * --------------------------------------------------------------
 * This template displays the client dashboard.
 *
 * Smarty Variables:
 *  $invoices (array of invoice data)
 *  $packages (array of package data)
 *  $overuses (array of overuse data)
 *  $helpdeskTicketsOpen (array of open tickets)
 *  $helpdeskTicketsOpenSubject (array of open ticket's subjects)
 *  $helpdeskEnabled (1 or 0 to show the helpdesk section)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Michael Fountain
 *}

{include file="$tplDirectory/header.tpl"}

{$messages}

{include file="$tplDirectory/widgets/dashboard/summary.tpl"}

{if $overuses}
    {include file="$commonTplDirectory/widgets/list-box-header.tpl" title="TRANS_TOTAL_OVERUSE"}
    <div class="list">
        <table width="100%" cellspacing="0">
            {foreach key=currency item=overuse from=$overuses}
                <tr class="{cycle values="odd,even"}">
                    <td>{$overuse|getAmount:$currency}</td>
                </tr>
            {/foreach}
            <tr class="{cycle values="odd,even"}">
                <td><a href="{getHREF page="overuses.php" actionName="ShowOveruseDetails"}">{"TRANS_SEE_DETAILS"|lmsg}</a></td>
            </tr>
        </table>
    </div>
    {include file="$commonTplDirectory/widgets/list-box-footer.tpl"}
{/if}

{include file="$commonTplDirectory/widgets/list-box-header.tpl" title="TRANS_INVOICES_DUE"}
<div class="list">
    <table width="100%" cellspacing="0">
        <thead>
            <tr>
                <th>{"TRANS_INVOICE_NUMBER"|lmsg}</th>
                <th class="text-right">{"TRANS_AMOUNT"|lmsg}</th>
                <th class="text-right">{"TRANS_AMOUNT_PAID"|lmsg}</th>
                <th>{"TRANS_DATE_GENERATED"|lmsg}</th>
                <th>{"TRANS_DATE_DUE"|lmsg}</th>
                <th>{"TRANS_STATUS"|lmsg}</th>
                <th>{"TRANS_ACTION"|lmsg}</th>
            </tr>
        </thead>
        <tbody>
            {section name=i loop=$invoices}
                {if $invoices[i].invoiceAmount!=$invoices[i].invoiceAmountPaid}
                    {assign var="invoiceEchod" value=1}
                    <tr class="{cycle values="odd,even"}">
                        <td>
                            <a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">
                                {$invoices[i].invoiceNumber}
                            </a>
                        </td>
                        <td class="text-right">{$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}</td>
                        <td class="text-right">{$invoices[i].invoiceAmountPaid|getAmount:$invoices[i].currencyID}</td>
                        <td>{$invoices[i].invoiceDateEntered|getDate}</td>
                        <td>{$invoices[i].invoiceDateDue|getDate}</td>
                        <td>{$invoices[i].invoiceStatus|getStatusName:"invoice"}</td>
                        <td>
                            {include file="$tplDirectory/widgets/actionLink.tpl"
                                page="invoices.php"
                                actionName="PayInvoices"
                                args="invoiceID=`$invoices[i].invoiceID`"
                                icoImage="pay-now.png"
                                altText="TRANS_PAY_NOW"
                                linkText="TRANS_PAY_NOW"}
                        </td>
                    </tr>
                {/if}
            {/section}
        </tbody>
    </table>
</div>
{include file="$commonTplDirectory/widgets/list-box-footer.tpl"}

{include file="$commonTplDirectory/widgets/list-box-header.tpl" title="TRANS_ACTIVE_BILLABLE_PACKAGES"}
<div class="list">
    <table width="100%" cellspacing="0">
        <thead>
            <tr>
                <th>{"TRANS_ID"|lmsg}</th>
                <th>{"TRANS_PACKAGE"|lmsg}</th>
                <th class="text-right">{"TRANS_PRICE"|lmsg}</th>
                <th>{"TRANS_BILLING_CYCLE"|lmsg}</th>
                <th>{"TRANS_NEXT_RENEWAL"|lmsg}</th>
                <th>{"TRANS_STATUS"|lmsg}</th>
            </tr>
        </thead>
        <tbody>
            {section name=i loop=$packages}
                <tr class="{cycle values="odd,even"}">
                    <td>{$packages[i].packageID}</td>
                    <td>
                        <a href="{getHREF page="packages.php" actionName="ShowPackageDetails"}&amp;packageID={$packages[i].packageID}">
                            {$packages[i].packageName|safetyhtml|stripslashes}
                        </a>
                        <div>
                            {if $packages[i].domains.0.domainID>0}
                                {foreach item="domain" key="dk" from=$packages[i].domains}
                                    <img src="/theme/icons/16/billing/domain.png" width="16" height="16" title="{$domain.domainSLD}.{$domain.domainTLD}" alt="{$domain.domainSLD}.{$domain.domainTLD}"> {$domain.domainSLD}.{$domain.domainTLD}<br>
                                {/foreach}
                            {/if}
                            {if $packages[i].additionalName}
                                <img src="/theme/icons/16/billing/go-to-subscriptions.png" width="16" height="16" title="{$packages[i].additionalName}" alt="{$packages[i].additionalName}">
                                {$packages[i].additionalName}
                            {/if}
                        </div>
                    </td>
                    <td class="text-right">{$packages[i].packagePrice|getAmount:$packages[i].currencyID}</td>
                    <td>{$packages[i].cycleID|getArrayValueByID:$cycles}</td>
                    <td>{$packages[i].packageDateNextRenewal|getDate}</td>
                    <td>{$packages[i].packageStatus|getStatusName:"package"}</td>
                </tr>
            {sectionelse}
                <tr class="odd">
                    <td colspan="7"><i>{"TRANS_NONE"|lmsg}</i></td>
                </tr>
            {/section}
        </tbody>
    </table>
</div>
{include file="$commonTplDirectory/widgets/list-box-footer.tpl"}