{* $Id: ShowInvoiceDetails.tpl 12256 2007-11-19 17:42:33Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of invoice records.
 *
 * Smarty Variables:
 *	$invoices (array of invoices that match input criteria)
 *		invoiceID			A unique invoice ID
 *		invoiceNumber		An invoice's number
 *		invoiceAmount		An invoice's amount
 *		invoiceDateEntered	An invoice's generation date
 *		invoiceDateDue		An invoice's due date
 *		invoiceStatus		The status of an invoice
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{assign var="filterArgs" value="invoiceStatus=$invoiceStatus"}

{php}$GLOBALS['__pagePath'] = array('TRANS_MENU_CLIENT_OPERATIONS_INVOICES', 'TRANS_INVOICES_INVOICE_DETAILS', '');{/php}
{include file="$tplDirectory/header.tpl"}

{assign var="lineItems" value=$invoice.lineItems}
<script type="text/javascript">
    {literal}
        function checkSure(url){
            if (confirm("{/literal}{"TRANS_ARE_YOU_SURE_FINALIZE"|lmsg|escape:javascript}{literal}")){
                document.location.href = url;
            }
        }
        function checkSure2(url){
            if (confirm("{/literal}{"TRANS_ARE_YOU_SURE_CANCEL"|lmsg|escape:javascript}{literal}")){
                document.location.href = url;
            }
        }
    {/literal}
</script>

<div class="actions-box">
    <div class="objects-toolbar clearfix">
        <a id="billing-id-pay-now" class="s-btn sb-pay-now" href="{getHREF page="invoices.php" actionName="PayInvoices"}&amp;invoiceID={$invoice.invoiceID}">
            <span>{"TRANS_PAY_NOW"|lmsg}</span>
        </a>
        <a id="billing-id-print-invoice" class="s-btn sb-print-invoice" target="_blank" href="{getHREF page="invoice_pdf.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoice.invoiceID`&redirectArgs=$bookmarkArgs"}">
            <span>{"TRANS_PRINT"|lmsg}</span>
        </a>
    </div>
</div>

{capture name="title" assign="title"}{"TRANS_INVOICE"|lmsg} {$invoice.invoiceNumber}{/capture}
{include file="$commonTplDirectory/widgets/list-box-header.tpl" title=$title}
{assign var="currencyID" value=$invoice.currencyID}
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_TO"|lmsg}: </div>
    <div class="field-value"><div class="text-value">
        {strip}
            {if $clientData.clientCompany && $invoice.clientContactID==0}
                {assign var="contactName" value=$clientData.clientCompany}
            {else}
                {assign var="contactName" value="`$contactData.contactFirstName` `$contactData.contactLastName`"}
            {/if}
            {$contactName|safetyhtml}
            , {$contactData.contactAddress1|safetyhtml}
            {if $contactData.contactAddress2!=""}
                , {$contactData.contactAddress2|safetyhtml}
            {/if}
            , {$contactData.contactCity|safetyhtml}, {$contactData.contactState|safetyhtml} {$contactData.contactZip|safetyhtml}
            , {$contactData.contactPhone1|safetyhtml} {if $contactData.contactPhone2!=''}- {$contactData.contactPhone2|safetyhtml}{/if}
            {if $clientData.taxIDNumber!=''}
                , {"TRANS_TAX_ID_NUMBER"|lmsg} {$clientData.taxIDNumber|safetyhtml}
            {/if}
        {/strip}
    </div></div>
</div>
<div class="form-row"><div class="field-name">{"TRANS_EMAIL_FROM"|lmsg}: </div>
    <div class="field-value"><div class="text-value">
        {strip}
            {$companyData.companyName}
            , {$companyData.companyAddress1}
            {if $companyData.companyAddress2!=""}
                , {$companyData.companyAddress2}
            {/if}
            , {$companyData.companyCity}, {$companyData.companyState} {$companyData.companyZip}
            , {$companyData.companyPhone1} {if $companyData.companyPhone2!=''}- {$companyData.companyPhone2}{/if}
            {if $companyData.companyTaxIDNumber!=''}
                , {"TRANS_TAX_ID_NUMBER"|lmsg} {$companyData.companyTaxIDNumber}
            {/if}
        {/strip}
    </div></div>
</div>
{if $invoice.invoiceComments}
    <div class="form-row"><div class="field-name">{"TRANS_INVOICE_COMMENTS"|lmsg}</div>
        <div class="field-value"><div class="text-value">
            {$invoice.invoiceComments}
        </div></div>
    </div>
{/if}
<div class="form-row">
    <div class="single-row list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>{"TRANS_INVOICE_NUMBER"|lmsg}</th>
                    <th>{"TRANS_ENTERED"|lmsg}</th>
                    <th>{"TRANS_DUE"|lmsg}</th>
                    <th>{"TRANS_PAYMENT_TERMS"|lmsg}</th>
                    <th class="text-right"><strong>{"TRANS_INVOICE_TOTAL"|lmsg}</strong></th>
                    <th class="text-right"><strong>{"TRANS_AMOUNT_PAID"|lmsg}</strong></th>
                </tr>
            </thead>
            <tbody>
                <tr class="odd">
                    <td>{$invoice.invoiceNumber}</td>
                    <td>{$invoice.invoiceDateEntered|getDate:"short"}</td>
                    <td>{$invoice.invoiceDateDue|getDate:"short"}</td>
                    <td>Due By Due Date</td>
                    <td class="text-right">{$invoice.invoiceAmount|getAmount:$currencyID}</td>
                    <td class="text-right">{$invoice.invoiceAmountPaid|getAmount:$currencyID}</td>
                </tr>
            </tbody>
        </table>
    </div>
</div>
<div class="form-row">
    <div class="single-row list">
        <table width="100%" cellspacing="0">
            <thead>
                <tr>
                    <th>#</th>
                    <th>{"TRANS_DESCRIPTION"|lmsg}</th>
                    <th>{"TRANS_BEGIN"|lmsg}</th>
                    <th>{"TRANS_CURRENT"|lmsg}</th>
                    <th>{"TRANS_NEXT_RENEWAL"|lmsg}</th>
                    <th>{"TRANS_QUANTITY_ABBR"|lmsg}</th>
                    <th class="text-right">{"TRANS_PRICE"|lmsg}</th>
                    <th class="text-right">{"TRANS_DISCOUNT"|lmsg}</th>
                    <th class="text-right">{"TRANS_SETUP"|lmsg}</th>
                    <th class="text-right">{"TRANS_SUB_TOTAL"|lmsg}</th>
                    <th class="text-right">{"TRANS_TAX"|lmsg}</th>
                    <th class="text-right">{"TRANS_TOTALS"|lmsg}</th>
                </tr>
            </thead>
            <tbody>
                {assign var="lastPackageId" value=0}
                {assign var="isOdd" value=true}
                {section name="j" loop=$lineItems}
                    {assign var="tpid" value=$lineItems[j].packageID}
                    {if $lineItems[j].packageAddonID>0}
                        {if $tpid != $lastPackageId}
                            {assign var="rowspan" value="2"}
                        {else}
                            {assign var="rowspan" value="1"}
                        {/if}
                        <tr class="{if $isOdd}odd{else}even{/if}">
                            <td rowspan="{$rowspan}">{$smarty.section.j.index+1}</td>
                            <td>
                                [{"TRANS_ADDON"|lmsg} <strong>{$lineItems[j].packageAddonID}</strong>]
                                {$lineItems[j].lineItemDescription|safetyhtml|highlightTerm}
                            </td>
                            {if $displayAddonDates}
                                <td>{$lineItems[j].lineItemDateBeginRenewal|getDate:"short"}</td>
                                <td>{$lineItems[j].lineItemDateCurrentRenewal|getDate:"short"}</td>
                                <td>{$lineItems[j].lineItemDateNextRenewal|getDate:"short"}</td>
                            {else}
                                <td colspan="3"></td>
                            {/if}
                            <td>{$lineItems[j].lineItemQuantity}</td>
                            <td class="text-right">{$lineItems[j].lineItemPriceAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td class="text-right">{$lineItems[j].lineItemDiscountAmount|getAmount:$currencyID|highlightTerm}
                                {if $lineItems[j].lineItemDiscountAmount>0}
                                    <br />
                                    {"TRANS_BASIS"|lmsg} {$lineItems[j].lineItemPriceAmount|getAmount:$currencyID}@
                                    {if $lineItems[j].lineItemDiscount>0 && $lineItems[j].prorationDiscount>0}
                                        {$lineItems[j].lineItemDiscount*100}% + {$lineItems[j].prorationDiscount*100}%
                                    {elseif $lineItems[j].lineItemDiscount>0}
                                        {$lineItems[j].lineItemDiscount*100}%
                                    {elseif $lineItems[j].prorationDiscount>0}
                                        {$lineItems[j].prorationDiscount*100}%
                                    {/if}
                                {/if}
                            </td>
                            <td class="text-right">{$lineItems[j].lineItemSetupAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td class="text-right">{$lineItems[j].lineItemTotalAmount-$lineItems[j].lineItemTaxAmount|getAmount:$currencyID}</td>
                            <td class="text-right">{$lineItems[j].lineItemTaxAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td class="text-right">{$lineItems[j].lineItemTotalAmount|getAmount:$currencyID|highlightTerm}</td>
                        </tr>
                        {if $tpid != $lastPackageId}
                            <tr class="{if $isOdd}odd{else}even{/if}">
                                <td colspan="11">
                                    {"TRANS_SUBSCRIPTION"|lmsg} <strong>{$tpid} {$lineItems[j].packageName|safetyhtml}</strong>
                                </td>
                            </tr>
                        {/if}
                        {assign var="isOdd" value=$isOdd-1|abs}
                    {else}
                        {if $lineItems[j].packageComments!=""}
                            {assign var="rowspan" value="2"}
                        {else}
                            {assign var="rowspan" value="1"}
                        {/if}
                        {assign var="lastPackageId" value=$tpid}
                        <tr class="{if $isOdd}odd{else}even{/if}">
                            <td rowspan="{$rowspan}">{$smarty.section.j.index+1}</td>
                            <td>
                                [<strong>{$tpid}</strong>]
                                {$lineItems[j].lineItemDescription|safetyhtml|highlightTerm}
                                {if $domains.$tpid.0.domainID}
                                    {foreach item="domain" key="dkey" from=$domains.$tpid}
                                        <br />{"TRANS_DOMAIN"|lmsg} <strong>{$domain.domainSLD|highlightTerm}.{$domain.domainTLD|highlightTerm}</strong>
                                    {/foreach}
                                {/if}
                            </td>
                            <td>{$lineItems[j].lineItemDateBeginRenewal|getDate:"short"}</td>
                            <td>{$lineItems[j].lineItemDateCurrentRenewal|getDate:"short"}</td>
                            <td>{$lineItems[j].lineItemDateNextRenewal|getDate:"short"}</td>
                            <td>{$lineItems[j].lineItemQuantity}</td>
                            <td class="text-right">{$lineItems[j].lineItemPriceAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td class="text-right">{$lineItems[j].lineItemDiscountAmount|getAmount:$currencyID|highlightTerm}
                                {if $lineItems[j].lineItemDiscountAmount>0}
                                <br />
                                {"TRANS_BASIS"|lmsg} {$lineItems[j].lineItemPriceAmount|getAmount:$currencyID}@
                                    {if $lineItems[j].lineItemDiscount>0 && $lineItems[j].prorationDiscount>0}
                                        {$lineItems[j].lineItemDiscount*100}% + {$lineItems[j].prorationDiscount*100}%
                                    {elseif $lineItems[j].lineItemDiscount>0}
                                        {$lineItems[j].lineItemDiscount*100}%
                                    {elseif $lineItems[j].prorationDiscount>0}
                                        {$lineItems[j].prorationDiscount*100}%
                                    {/if}
                                {/if}
                            </td>
                            <td class="text-right">{$lineItems[j].lineItemSetupAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td class="text-right">{$lineItems[j].lineItemTotalAmount-$lineItems[j].lineItemTaxAmount|getAmount:$currencyID}</td>
                            <td class="text-right">{$lineItems[j].lineItemTaxAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td class="text-right">{$lineItems[j].lineItemTotalAmount|getAmount:$currencyID|highlightTerm}</td>
                        </tr>
                        {if $lineItems[j].packageComments!=""}
                            <tr class="{if $isOdd}odd{else}even{/if}">
                                <td colspan="11">{$lineItems[j].packageComments|highlightTerm}</td>
                            </tr>
                        {/if}
                        {assign var="isOdd" value=$isOdd-1|abs}
                    {/if}
                {/section}
            </tbody>
        </table>
    </div>
</div>

{if $taxZones.0.taxZoneID}
    <div class="form-row">
        <div class="single-row list">
            <table width="100%" cellspacing="0">
                <thead>
                <tr>
                    <th colspan="6" class="text-center">{"TRANS_TAX_ZONES"|lmsg}</th>
                </tr>
                <tr>
                    <th>{"TRANS_TAX_ZONE_ID"|lmsg}</th>
                    <th>{"TRANS_TAX_ZONE_NAME"|lmsg}</th>
                    <th>{"TRANS_TAX_ZONE_DESCRIPTION"|lmsg}</th>
                    <th>{"TRANS_TAX_ZONE_TYPE"|lmsg}</th>
                    <th>{"TRANS_TAX_ZONE_RATE"|lmsg}</th>
                    <th>{"TRANS_TAX_ZONE_TOTAL"|lmsg}</th>
                </tr>
                </thead>
                <tbody>
                    {section name="j" loop=$taxZones}
                        {if $taxZones[j].taxZoneID>0}
                        <tr class="{cycle values="odd,even"}">
                            <td>{$taxZones[j].taxZoneID}</td>
                            <td>{$taxZones[j].taxZoneName}</td>
                            <td>{$taxZones[j].taxZoneDescription}</td>
                            <td>
                                {if $taxZones[j].lineItemTaxAmountType==0}
                                    {"TRANS_PERCENTAGE"|lmsg}
                                {else}
                                    {"TRANS_SET_AMOUNT"|lmsg}
                                {/if}
                                {if $taxZones[j].taxZoneStackable==1} -- {"TRANS_STACKABLE"|lmsg}{/if}
                            </td>
                            <td class="text-right">
                                {if $taxZones[j].lineItemTaxAmountType==0}
                                    {$taxZones[j].lineItemTaxAmount}%
                                    {else}
                                    {$taxZones[j].lineItemTaxAmount|getAmount:$currencyID}
                                {/if}
                            </td>
                            <td class="text-right">{$taxZones[j].taxTotal|getAmount:$currencyID}</td>
                        </tr>
                        {/if}
                    {/section}
                </tbody>
            </table>
        </div>
    </div>
{/if}

{if $transactions}
    <div class="form-row">
        <div class="single-row list">
            <table width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <th colspan="7" class="text-center">{"TRANS_TRANSACTIONS"|lmsg}</th>
                    </tr>
                    <tr>
                        <th>{"TRANS_ID"|lmsg}</th>
                        <th>{"TRANS_TRANSACTION_PAYMENT_METHOD"|lmsg}</th>
                        <th>{"TRANS_TRANSACTION_STATUS"|lmsg}</th>
                        <th>{"TRANS_TRANSACTION_CODE"|lmsg}</th>
                        <th>{"TRANS_TRANSACTION_NOTES"|lmsg}</th>
                        <th>{"TRANS_TRANSACTION_DATE"|lmsg}</th>
                        <th>{"TRANS_TRANSACTION_AMOUNT"|lmsg}</th>
                    </tr>
                </thead>
                <tbody>
                    {section name="j" loop=$transactions}
                        {if $className=="alt1"}
                            {assign var="className" value="alt2"}
                        {else}
                            {assign var="className" value="alt1"}
                        {/if}
                        <tr class="{cycle values="odd,even"}">
                            <td>{$transactions[j].transactionID}</td>
                            {assign var="tkey" value=$transactions[j].transactionPaymentMethod|getArrayValueByID:$paymentMethods}
                            <td>{$tkey|lmsg}</td>
                            {assign var="tkey" value=$transactions[j].authReturn|getArrayValueByID:$transactionStatuses}
                            <td>{$tkey|lmsg}</td>
                            <td>{$transactions[j].transactionCode}</td>
                            <td>{$transactions[j].transactionNotes}</td>
                            <td>{$transactions[j].transactionDateCreated|getDate:short}</td>
                            <td class="text-right">{$transactions[j].transactionAmount|getAmount:$transactions[j].currencyID}</td>
                        </tr>
                    {/section}
                </tbody>
            </table>
        </div>
    </div>
{/if}
{include file="$commonTplDirectory/widgets/list-box-footer.tpl"}