<?php

class CheckDomainAction extends sfAction {

	public function execute($request) {
		$this->setLayout(false);
		sfConfig::set('sf_web_debug', false);

		$store = sfContext::getInstance()->getUser()->getAttribute('store');
		$domainPlan = $store->getPlan($request->getParameter('domainPlanId'), true);

		$SLD = $request->getParameter('SLD');
		$tldIds = explode("-", $request->getParameter('TLDs'));
		$masterTLD = $request->getParameter('masterTLD');
		$targetDomains = array();
		foreach ($domainPlan->getDomains($store->getId()) as $domain) {
            $targetDomains[$domain->tldID] = $domain;
		}
        $cycles = $domainPlan->getCycles();
        $domainAvailable = ResourceLocator::getInstance()->billingDomainService->checkWhois($SLD, $tldIds);
        sfContext::getInstance()->getConfiguration()->loadHelpers('Partial');
        $result = array();
        foreach ($tldIds as $tldId) {
            if (!isset($domainAvailable[$tldId]) || !isset($targetDomains[$tldId])) {
                $result[$tldId] = "";
                continue;
            }
            $parameters = array(
                'currencyId' => $store->currencyID,
                'domain' => $targetDomains[$tldId],
                'cycles' => $cycles,
                'register' => $request->getParameter('operation') == 'register' ? true : false,
                'status' => $domainAvailable[$tldId],
                'SLD' => $SLD,
                'TLD' => $targetDomains[$tldId]->tldExtension,
                'masterTLD' => $masterTLD,
                'allowRegister' => in_array('dom_reg', $store->domainOptions),
                'allowTransfer' => in_array('dom_transfer', $store->domainOptions)
            );
            $result[$tldId] = get_partial('cart/checkDomain', $parameters);
        }
        $content = json_encode(array('content' => $result));
		$callback = $request->getParameter('callback');

		return $this->renderText($callback . '(' . $content . ');');
	}

}
