<?php

class LoginToPanelAction extends CartAction {

    const LOGIN_TO_PANEL = 'login-to-panel';

	public function execute($request) 
    {
        $this->_initSelectedPurchase();

        if ($request->isMethod('post')) {

			$operation = $request->getParameter('operation');
			switch ($operation) {
				case self::LOGIN_TO_PANEL:
                    $this->setLayout(false);
                    sfConfig::set('sf_web_debug', false);

                    $data = ResourceLocator::getInstance()->billingContactService->loginToPanel($this->selectedPurchase->getParameter('redirectToPanelSubscription'));
                    $this->_cart->removePurchase($this->selectedPurchase->getId());

                    // set no cache and localtion headers manually, because simple $this->redirect call entail clear
                    // of http headers, so some browsers may cache result of this action and prevent it execution
                    $response = $this->getResponse();
                    $response->addCacheControlHttpHeader('no-cache');
                    $response->setCookie('sid', $data['sid'], null, '/', null, (isset($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])), true);
                    $response->setHttpHeader('Location', $data['url']);

                    // send only headers to perform redirect
                    return sfView::HEADER_ONLY;
			}
            $this->_router->next(array(), false);
		}
	}

}