<?php
class PrepareSelectAddonAction extends CartAction
{
    public function execute($request)
    {
        $pages = array();

        if ($currentCartItem = $this->_cart->getCurrentItem()) {
            foreach ($currentCartItem->getPurchases(true) as $purchase) {
                if ($purchase->isAlreadyPurchased() ) {
                    continue;
                }
                $plan = $this->_store->getPlan($purchase->getPlanId());
                if ($plan->productAddonRequired != BillingPlan::ADDON_NOT_NEEDED) {
                    if ($purchase->getAvailableAddonsCount()) {
                        $pages[] = new RouterPage('select-addons', array('purchaseId' => $purchase->getId()));
                    }
                }
            }
        }

        if (!empty($pages)) {
            $router = new Router();
            $router->init($pages, reset($pages));
            ResourceLocator::getInstance()->routersStack->push($router);
            $router->next();
        } else {
            $this->_router->next(array(), false);
        }
    }
}