<?php

class SelectSubscriptionAction extends CartAction
{
    public function execute($request)
    {
        $customer = sfContext::getInstance()->getUser()->getAttribute('customer', null);
        $this->_initSelectedPurchase();
        $hasSubPurchase = false;
        foreach($this->cartItem->getPurchases() as $purchase) {
            $subPurchase = $purchase->getPurchases();
            if (!empty($subPurchase)) {
                $hasSubPurchase = true;
            }
        }

        if (!is_null($this->getUser()->getAttribute('subscriptionId')) || is_null($customer) || $hasSubPurchase) {
            $this->_router->next(array(), false);
        }

        if ($request->isMethod('post')) {
            if ('' == ($selectedExistingSubscriptionId = $request->getParameter('existingSubscriptionId'))) {
                if (BillingPlan::HOSTING_REQUIRED == $this->plan->productHostingRequired) {
                    $this->errorMessage = __('TRANS_STORE_SUPPLEMENTARY_HOSTING_PLAN_REQUIRED_MSG');
                } else {
                    $this->_router->next();
                }
            } else {
                $selectedExistingSubscription = ResourceLocator::getInstance()->billingSubscriptionService->getSubscription($selectedExistingSubscriptionId);
                $this->getUser()->setAttribute('subscriptionId',  $selectedExistingSubscriptionId);
                $selectedPlan = ResourceLocator::getInstance()->billingPlanService->getById($selectedExistingSubscription->getPlanId(), $this->_store->getId());
                $newPurchase = new Purchase($selectedExistingSubscription->getPlanId(), $selectedExistingSubscription->getCycleId(), null, $selectedExistingSubscription->getName(), $selectedPlan->getType());
                $newPurchase->setDescription($selectedExistingSubscription->additionalName);
                $newPurchase->setAlreadyPurchasedId($selectedExistingSubscriptionId);
                foreach ($this->cartItem->getPurchases() as $purchase) {
                    $purchase->setSubscriptionId($selectedExistingSubscriptionId);
                    $newPurchase->addPurchase($purchase);
                }
                foreach ($this->cartItem->getPurchases() as $purchase) {
                    $this->_cart->removePurchase($purchase->getId());
                }
                $newCartItem = new CartItem();
                $newCartItem->addPurchase($newPurchase);
                $this->_cart->setCurrentItem($newCartItem);
                $this->_cart->attachCurrentItem();

                $this->_router->next(array(), false);
            }
        }

        if (BillingPlan::TYPE_DOMAIN == $this->plan->productType) {
            if (BillingPlan::HOSTING_NOT_NEEDED != $this->plan->productHostingRequired && !is_null($customer)) {
                $this->existingSubscriptions = ResourceLocator::getInstance()->billingSubscriptionService->getExistingHostingSubscriptions($this->_store->getId(), $customer->clientID);
            }
        } else {
            if (!is_null($customer)) {
                $this->existingSubscriptions = ResourceLocator::getInstance()->billingSubscriptionService->getSubscriptionsToAttachAsParent($customer->clientID, $this->selectedPurchase->getPlanId(), $this->selectedPurchase->getCycleId());
            }
        }

        if (empty($this->existingSubscriptions)) {
            $this->_router->next(array(), false);
        }
    }
}