<?php

class SignInAction extends CartAction {

	const OPERATION_FORGOT_PASSWORD = 'forgot-password';

	public function execute($request) {
		
		$this->form = new BillingSignInForm(array(
			array(
				'inputs' => array(
					array(
						'id' => 'login',
						'type' => 'text',
						'title' => 'TRANS_USERNAME',
					    'description' => 'TRANS_ORDERFORM_USERNAME_HINT',
						'required' => true
					),
					array(
						'id' => 'password',
						'type' => 'password',
						'title' => 'TRANS_PASSWORD',
						'required' => true
					)
				)
			)
		));
		if (!is_null($infoMessage = sfContext::getInstance()->getUser()->getAttribute('infoMessage'))) {
			$this->info = $infoMessage;
			sfContext::getInstance()->getUser()->setAttribute('infoMessage', NULL);
		}
		
		if ($request->isMethod('post')) {
			try {
				$operation = $request->getParameter('operation');
				switch ($operation) {
					case self::OPERATION_FORGOT_PASSWORD:
						$router = new Router();
						$router->init(
							array(
								new RouterPage(self::OPERATION_FORGOT_PASSWORD),
								new RouterPage('sign-in')
							),
							new RouterPage('sign-in')
						);
						ResourceLocator::getInstance()->routersStack->push($router);
						$router->next();
						break;
					default:
						$this->form->bind($request->getParameter($this->form->getName()));
						if (!$this->form->isValid()) {
							throw new BillingFormException();
						}
						$store = $this->getUser()->getAttribute('store', null);
						$this->form->setStoreId($store->orderFormID);

						$this->form->save();

						$customer = $this->getUser()->getAttribute('customer', null);
						if($store && $customer) {
							if($customer->clientType != $store->orderFormType) {
								$this->getUser()->getAttributeHolder()->remove('customer');
								$message = ("reseller" == $customer->clientType) ? "TRANS_RESELLER_CANNOT_LOGIN_TO_CUSTOMERS_STORE_MSG" : "TRANS_CUSTOMER_CANNOT_LOGIN_TO_RESELLERS_STORE_MSG";
								throw new BillingFormException($message);
							} else if("customer" == $customer->clientType && $customer->vendorID != $store->vendorID) {
								$this->getUser()->getAttributeHolder()->remove('customer');
								throw new BillingFormException("TRANS_LOGIN_INCORRECT");
							}
						}

						$this->_router->next();
				}
			} catch (StoreException $exception) {
				$this->error = $exception->getMessage();
			}
		} else {
			
		}
		
	}
	
}
