<?php use_helper('BillingFormat'); ?>
<?php use_helper('BillingEscape'); ?>
<div id="main" class="">
	<div class="p-store-order">

		<?php include_partial('navigationBar', array('router' => $router)); ?>

		<div class="p-box">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">

                <?php include_partial('header', array('cartItem' => $cartItem, 'selectedPurchase' => $selectedPurchase)); ?>

                <div class="p-box-title p-box-title-1">
					<div class="p-box-title-area">
						<h1><span><?php echo __($operation == registerDomainAction::OPERATION_TRANSFER ? 'TRANS_TRANSFER_EXISTING_DOMAIN' : 'TRANS_REGISTER_NEW_DOMAIN'); ?></span></h1>
					</div>
				</div>
				<div class="p-box-content">

					<?php if (isset($errorMessage)): ?>
                        <?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
					<?php endif; ?>

					<div class="b-description"><p><?php echo __('TRANS_REGISTER_DOMAIN_DETAIL_DESCRIPTION'); ?></p></div>

					<form id="checkDomain" action="<?php echo url_for('@register-domain'); ?>" method="post" autocomplete="off">
						<input type="hidden" name="domainPlanId" value="<?php echo $domainPlan->getId(); ?>"/>
                        <?php if (!empty($selectedPurchase)) : ?>
                            <input type="hidden" name="purchaseId" value="<?php echo $selectedPurchase->getId(); ?>"/>
                        <?php endif; ?>
                        <input type="hidden" name="operation" value="<?php echo $operation; ?>"/>
						<input id="domainSLD" type="hidden" name="SLD" value=""/>
						<input id="domainTLD" type="hidden" name="masterTLD" value=""/>
						<input type="hidden" name="activity" value="<?php echo registerDomainAction::ACTIVITY_CHECK; ?>"/>
						<div class="b-domain-options">
							<label class="b-domain-options-label"><?php echo __('TRANS_SEARCH_ANOTHER_DOMAIN'); ?></label>
							<input id="domain" type="text" class="input-text domain-name" onblur="this.value=this.value.toLowerCase();" value="<?php echo $domainName; ?>"/>
							<a class="btn " href="#" id='checkDomainButton' onclick=""><span><i><?php echo __('TRANS_CHECK_DOMAIN'); ?></i></span></a>
							<script type="text/javascript">
								function checkDomain() {
									var domain = new String($("#domain").val());
									var dotIndex = domain.indexOf(".");
									if (dotIndex < 0) {
										SLD = domain;
										TLD = "";
									} else {
										SLD = domain.substring(0, dotIndex);
										TLD = domain.substring(dotIndex + 1);
									}
									$('#domainSLD').val(SLD);
									if (TLD > "") {
										$('#domainTLD').val(TLD);
									};
									return true;
								}
							</script>
						</div>
					</form>
					<script type="text/javascript">
						$('#checkDomain').bind('submit', function () {
							return checkDomain();
						});
					</script>

					<?php if (!isset($errorCode) || (isset($errorCode) && 1 != $errorCode)): ?>
					<div class="b-multidomain-whois">
						<div class="b-multidomain-whois-caption"><?php echo __('TRANS_DOMAINS_FOUND'); ?></div>

						<form id="purchaseDomains" action="<?php echo url_for('@register-domain'); ?>" method="post">
							<input type="hidden" name="planId" value="<?php echo $domainPlan->getId(); ?>"/>
                            <input type="hidden" name="domainPlanId" value="<?php echo $domainPlan->getId(); ?>"/>
                            <?php if (!empty($selectedPurchase)) : ?>
                                <input type="hidden" name="purchaseId" value="<?php echo $selectedPurchase->getId(); ?>"/>
                            <?php endif; ?>
                            <input type="hidden" name="SLD" value="<?php echo $SLD; ?>"/>
							<table class="t-multidomain-whois-results">
								<tbody>
									<script type="text/javascript" src="/store/js/jquery.ajaxmanager.js"></script>
									<script type="text/javascript">
										$.manageAjax.create('checkDomainQueue', {queue: false});
									</script>
									<?php foreach ($TLDs as $TLD => $tldId): ?>
									<tr>
										<td class="td-domain-name"><span><?php echo formatProductName($SLD.".".$TLD); ?></span></td>
										<td class="td-available">
											<span id="checking_<?php echo jQueryDomainPoint($tldId); ?>" class="wait"><?php echo __('TRANS_CHECKING_AVAILABILITY'); ?></span>
											<span id="available_<?php echo $TLD; ?>" style="display: none;" class="yes">
												<?php echo __('TRANS_AVAILABLE'); ?>
												<?php if($operation == registerDomainAction::OPERATION_TRANSFER) : ?>
													<em>[<a href="#" onclick="window.open('http://www.uwhois.com/cgi/whois.cgi?query=<?php echo $SLD ?>.<?php echo $TLD; ?>', '', 'top=0, left=0, width=1000, height=400, scrollbars=1'); return false;"><?php echo __('TRANS_WHOIS_INFO'); ?></a>]</em>
												<?php endif; ?>
											</span>
											<span id="unableWhois_<?php echo $TLD; ?>" style="display: none;" class="not-active">
												<?php echo __('TRANS_NOT_AVAILABLE_WHOIS_SERVER'); ?>
											</span>
											<span id="notAvailable_<?php echo $TLD; ?>" style="display: none;" class="no">
												<?php echo __('TRANS_NOT_AVAILABLE'); ?>
												<?php if($operation == registerDomainAction::OPERATION_REGISTER) : ?>
													<em>[<a href="#" onclick="window.open('http://www.uwhois.com/cgi/whois.cgi?query=<?php echo $SLD ?>.<?php echo $TLD; ?>', '', 'top=0, left=0, width=1000, height=400, scrollbars=1'); return false;"><?php echo __('TRANS_WHOIS_INFO'); ?></a>]</em>
												<?php endif; ?>
											</span>
                                            <span id="notAvailableForTransfer_<?php echo $TLD; ?>" style="display: none;" class="not-active">
                                                <?php echo __('TRANS_NOT_AVAILABLE_FOR_TRANSFER'); ?>
                                            </span>
										</td>
										<td class="td-register" id="domain_<?php echo jQueryDomainPoint($tldId); ?>">

										</td>
									</tr>
									<?php endforeach; ?>
                                    <?php include_partial('cart/jsCheckDomain', array('operation' => $operation, 'domainPlanId' => $domainPlan->getId(), 'TLDsCount' => $TLDsCount, 'SLD' => $SLD, 'TLDs' => $TLDsString, 'masterTLD' => $masterTLD)); ?>
								</tbody>
							</table>
						</form>

					</div>
					<?php else : ?>
					<script type="text/javascript">
						$('#checkDomainButton').click(function() { $('#checkDomain').submit(); });
					</script>
					<?php endif; ?>

				</div>

			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>

		<div class="p-store-actions">
			<div class="p-store-actions-area">
				<?php include_partial('backAction', array('router' => $router)); ?>
				<?php if (!isset($errorCode) || (isset($errorCode) && 1 != $errorCode)): ?>
				<a class="btn btn-action" href="#" onclick="$('#purchaseDomains').submit(); return false;"><span><i><?php echo __('TRANS_NEXT'); ?></i></span></a>
				<?php endif; ?>
			</div>
		</div>

		<?php if (isset($taxZone)): ?>
		<div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
		<?php endif; ?>

		</div> <!--/p-store-order-->

</div> <!--/#main-->
