<?php use_helper('BillingFormat') ?>
<div id="main" class="">

    <div class="p-store-order">

        <?php include_partial('navigationBar', array('router' => $router)); ?>

        <div class="p-box p-box-features">
            <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

            <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">

                <?php include_partial('header', array('cartItem' => $cartItem, 'selectedPurchase' => $selectedPurchase)); ?>

                <form id="purchaseAddons" action="<?php echo url_for('@select-addons'); ?>" method="post">
                    <input type="hidden" name="purchaseId" value="<?php echo $selectedPurchase->getId(); ?>"/>
                    <?php foreach ($purchaseAddonGroups as $purchaseId => $addonGroups): ?>

                    <div class="p-box-title p-box-title-1">
                        <div class="p-box-title-area">
                            <h1><span><?php echo __('TRANS_ADDITIONAL_FEATURES_FOR', array('%PURCHASE_NAME%' => $purchases[$purchaseId]->getName())); ?></span></h1>
                        </div>
                    </div>

                    <div class="p-box-content">

                        <?php if (isset($errorMessage)): ?>
                            <?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
                        <?php endif; ?>

                        <div class="b-description"><p><?php echo __('TRANS_ADDITIONAL_FEATURES_DESCR2'); ?></p></div>

                        <?php foreach ($addonGroups as $addonGroup): ?>
                        <input type="hidden" name="addonGroups_<?php echo $purchaseId; ?>[]" value="<?php echo $addonGroup->getId(); ?>"/>
                        <div class="b-features">
                            <h4><?php echo $addonGroup->productAddonGroupName; ?></h4>
                            <div class="b-features-area">
                                <table class="t-features">
                                    <tbody>
                                        <?php foreach ($addonGroup->getAddons() as $addon): ?>
                                        <tr>
                                            <?php $selectedAddon = isset($selectedAddons[$purchaseId][$addonGroup->getId()][$addon->getId()]); ?>
                                            <td class="">
                                                <label for="addon-<?php echo $addonGroup->getId(); ?>-<?php echo $addon->getId(); ?>">
                                                    <?php if ($addonGroup->multichoice()): ?>
                                                    <input type="checkbox" class="radio" name="addons_<?php echo $purchaseId; ?>_<?php echo $addonGroup->getId(); ?>_<?php echo $addon->getId(); ?>" value="<?php echo $addon->getId(); ?>" id="addon-<?php echo $addonGroup->getId(); ?>-<?php echo $addon->getId(); ?>" <?php if ($selectedAddon): ?> checked="checked"<?php endif; ?>/> - <?php echo $addon->productName; ?>
                                                    <?php else: ?>
                                                    <input type="radio" class="radio" name="addons_<?php echo $purchaseId; ?>_<?php echo $addonGroup->getId(); ?>" value="<?php echo $addon->getId(); ?>" id="addon-<?php echo $addonGroup->getId(); ?>-<?php echo $addon->getId(); ?>" <?php if ($selectedAddon): ?> checked="checked"<?php endif; ?>/> - <?php echo $addon->productName; ?>
                                                    <?php endif; ?>
                                                </label>
                                                <?php if (!empty($addon->productComments)) : ?>
                                                    <span class="addon-descripion">
                                                        <?php echo $addon->productComments; ?>
                                                    </span>
                                                <?php endif; ?>
                                            </td>
                                            <td class="t-feature-price">
                                                <div class="selection">
                                                    <?php $checked = false; ?>
                                                    <?php $severalPrices = ($addon->getPricesCount($currencyId) > 1); ?>
                                                    <?php foreach ($addon->getVariants() as $variant) : ?>
                                                        <?php foreach ($variant->getPrices() as $price) : ?>
                                                            <?php $selectedPrice = $selectedAddon && $selectedAddons[$purchaseId][$addonGroup->getId()][$addon->getId()] === $price->getId(); ?>
                                                            <?php $inputName = "price_".$addon->getId(); ?>
                                                            <?php $inputValue = $price->cycleID."_".$price->getId(); ?>
                                                            <?php $inputText = "<b>".formatPrice($price->getCycleFee(), $currencyId)."</b> ".__('TRANS_STORE_FOR_CYCLE')." ".__($addon->getCycle($price->cycleID)->cycleDisplayName);?>
                                                            <?php if ($severalPrices) : ?>
                                                                <div class="b-label">
                                                                    <label for="<?php echo $price->getId(); ?>">
                                                                        <input type="radio" class="radio" value="<?php echo $inputValue; ?>" name="<?php echo $inputName; ?>" <?php if ($selectedPrice || (!$checked && ($parentCycleId == $price->cycleID || !$addon->hasParentCycles))) { echo 'checked="checked"'; $checked = true;} ?>/>
                                                                        <?php echo $inputText; ?>
                                                                    </label>
                                                                    <?php include_partial('catalog/priceAdditionalData', array('price' => $price, 'currencyId' => $currencyId)); ?>
                                                                </div>
                                                            <?php else: ?>
                                                                <input type="hidden" value="<?php echo $inputValue; ?>" name="<?php echo $inputName; ?>"/>
                                                                <?php echo $inputText; ?>
                                                                <?php include_partial('catalog/priceAdditionalData', array('price' => $price, 'currencyId' => $currencyId)); ?>
                                                            <?php endif; ?>
                                                        <?php endforeach; ?>
                                                    <?php endforeach; ?>
                                                </div>
                                            </td>
                                        </tr>
                                        <?php endforeach; ?>
                                        <?php if (!$addonGroup->multichoice() && $addonGroup->productAddonGroupNoneChoice): ?>
                                        <tr>
                                            <td class=""><label for="addon-<?php echo $addonGroup->getId(); ?>-0"><input type="radio" class="radio" name="addons_<?php echo $purchaseId; ?>_<?php echo $addonGroup->getId(); ?>" value="" id="addon-<?php echo $addonGroup->getId(); ?>-0" name="addons-<?php echo $addonGroup->getId(); ?>"<?php if (sizeof($selectedAddons[$purchaseId][$addonGroup->getId()]) == 0): ?> checked="checked"<?php endif; ?>/> - <?php echo __('TRANS_NONE'); ?></label></td>
                                            <td class="t-feature-price">&nbsp;</td>
                                        </tr>
                                        <?php endif; ?>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <?php endforeach; ?>
                    </div>

                    <?php endforeach; ?>

                </form>

            </div></div></div>
            <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
        </div>

        <div class="p-store-actions">
            <div class="p-store-actions-area">
                <?php include_partial('backAction', array('router' => $router)); ?>
                <a class="btn btn-action" href="#" onclick="$('#purchaseAddons').submit(); return false;"><span><i><?php echo __('TRANS_NEXT'); ?></i></span></a>
            </div>
        </div>

        <?php if (isset($taxZone)): ?>
        <div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
        <?php endif; ?>

    </div> <!--/p-store-order-->

</div> <!--/#main-->