<?php use_helper('BillingFormat') ?>

<div id="main" class="">

    <div class="p-store-order">

        <?php include_partial('navigationBar', array('router' => $router)); ?>

        <div class="p-box p-box-features">
            <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

            <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">

                <?php include_partial('header', array('cartItem' => $cartItem, 'selectedPurchase' => $selectedPurchase)); ?>

                <form id="parentPlans" action="<?php echo url_for('@select-parent-service'); ?>" method="post">
                    <?php if (!empty($selectedPurchase)) : ?>
                        <input type="hidden" name="purchaseId" value="<?php echo $selectedPurchase->getId(); ?>"/>
                    <?php else: ?>
                        <input type="hidden" name="domainPlanId" value="<?php echo $domainPlanId; ?>"/>
                    <?php endif; ?>
                    <div class="p-box-title p-box-title-1">
                        <div class="p-box-title-area">
                            <h1><span><?php echo __('TRANS_STORE_PARENT_PLANS'); ?></span></h1>
                        </div>
                    </div>

                    <div class="p-box-content">

                        <?php if (isset($errorMessage)): ?>
                            <?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
                        <?php endif; ?>

                        <div class="b-description"><p><?php echo __('TRANS_STORE_PARENT_PLANS_DESC'); ?></p></div>

                        <div class="b-features">
                            <div class="b-features-area">
                                <table class="t-features">
                                    <tbody>
                                        <?php foreach ($parentPlans as $plan): ?>
                                            <tr>
                                                <td class="">
                                                    <label>
                                                        <?php echo $plan->productName; ?>
                                                    </label>
                                                    <?php if (!empty($plan->productComments)) : ?>
                                                        <span class="parent-plan-descripion">
                                                            <?php echo $plan->productComments; ?>
                                                        </span>
                                                    <?php endif; ?>
                                                </td>
                                                <td class="t-feature-price">
                                                    <?php foreach ($plan->getVariants() as $planVariant): ?>
                                                        <?php foreach ($planVariant->getPrices() as $planVariantPrice): ?>
                                                            <div class="b-label">
                                                            <label for="parentPlanVariantPrice-<?php echo $planVariantPrice->getId(); ?>">
                                                                <input type="radio" class="radio" name="parentPlanVariantPriceId" value="<?php echo $planVariantPrice->getId(); ?>" id="parentPlanVariantPrice-<?php echo $planVariantPrice->getId(); ?>" <?php echo ($planVariantPrice->getId() == $selectedPlan) ? 'checked="checked"' : ''; ?> />
                                                                <input type="hidden" name="plan_<?php echo $planVariantPrice->getId(); ?>" value="<?php echo $plan->getId(); ?>"/>
                                                                <input type="hidden" name="cycle_<?php echo $planVariantPrice->getId(); ?>" value="<?php echo $planVariantPrice->getCycleId(); ?>"/>
                                                                <b><?php echo formatPrice($planVariantPrice->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($plan->getCycle($planVariantPrice->getCycleId())->cycleDisplayName); ?>
                                                                <?php include_partial('catalog/priceAdditionalData', array('price' => $planVariantPrice, 'currencyId' => $currencyId)); ?>
                                                            </label>
                                                            </div>
                                                        <?php endforeach; ?>
                                                    <?php endforeach; ?>
                                                </td>
                                            </tr>
                                        <?php endforeach; ?>
                                        <?php foreach ($existingSubscriptions as $subscription): ?>
                                            <tr>
                                                <td class="">
                                                    <label>
                                                        <?php echo $subscription->packageName; ?>
                                                    </label>
                                                    <?php if (!empty($subscription->additionalName)) : ?>
                                                        <span class="parent-plan-descripion">
                                                            <?php echo $subscription->additionalName; ?>
                                                        </span>
                                                    <?php endif; ?>
                                                </td>
                                                <td class="t-feature-price">
                                                    <div class="b-label">
                                                        <label for="parentPlan-<?php echo $subscription->packageID; ?>-0">
                                                            <input type="radio" class="radio" name="parentPlanVariantPriceId" value="subscription-<?php echo $subscription->packageID; ?>" id="parentPlan-<?php echo $subscription->packageID; ?>-0" <?php echo ($subscription->packageID == $selectedSubscription) ? 'checked="checked"' : ''; ?> />
                                                            <?php echo __('TRANS_STORE_ATTACH_TO_EXISTING_SUBSCRIPTION'); ?>
                                                        </label>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php endforeach; ?>
                                        <?php if (!$isParentServiceRequired): ?>
                                            <tr>
                                                <td class="">&nbsp;</td>
                                                <td class="t-feature-price">
                                                    <div class="b-label">
                                                    <label for="parentPlan-0">
                                                        <input type="radio" class="radio" name="parentPlanVariantPriceId" value="" id="parentPlan-0" <?php if (is_null($selectedPlan) && is_null($selectedSubscription)) : ?>checked="checked" <?php endif; ?> /> <?php echo __('TRANS_NONE'); ?>
                                                    </label>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php endif; ?>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                </form>

            </div></div></div>
            <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
        </div>

        <div class="p-store-actions">
            <div class="p-store-actions-area">
                <?php include_partial('backAction', array('router' => $router)); ?>
                <a class="btn btn-action" href="#" onclick="$('#parentPlans').submit(); return false;"><span><i><?php echo __('TRANS_NEXT'); ?></i></span></a>
            </div>
        </div>

        <?php if (isset($taxZone)): ?>
            <div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
        <?php endif; ?>

    </div> <!--/p-store-order-->

</div> <!--/#main-->