<?php use_helper('BillingFormat') ?>
<div id="main" class="">

	<div class="p-store-order">

		<?php include_partial('navigationBar', array('router' => $router)); ?>

		<div class="p-box p-box-features">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">

                <?php include_partial('header', array('cartItem' => $cartItem, 'selectedPurchase' => $selectedPurchase)); ?>

				<form id="purchaseServices" action="<?php echo url_for('@select-services'); ?>" method="post">
                    <input type="hidden" name="purchaseId" value="<?php echo $selectedPurchase->getId(); ?>"/>
					<div class="p-box-title p-box-title-1">
						<div class="p-box-title-area">
							<h1><span><?php echo __('TRANS_STORE_ADDITIONAL_SERVICES'); ?></span></h1>
						</div>
					</div>

					<div class="p-box-content">

						<?php if (isset($errorMessage)): ?>
						<?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
						<?php endif; ?>

						<div class="b-description"><p><?php echo __('TRANS_STORE_ADDITIONAL_SERVICES_DESC'); ?></p></div>

						<div class="b-features">
                            <?php foreach ($groupsWithServices as $group): ?>
                                <h4><?php echo $group->name; ?></h4>
                                <div class="b-features-area">
                                    <table class="t-features">
                                        <tbody>
                                            <?php $enableDefaultButton = true;?>
                                            <?php foreach ($group->getPlans() as $id => $service): ?>
                                                <?php if (!empty($selectedServices[$purchaseId][$service->getId()])) : ?>
                                                    <?php $enableDefaultButton = false;?>
                                                <?php endif;?>
                                            <?php endforeach; ?>
                                            <?php foreach ($group->getPlans() as $id => $service): ?>
                                                <tr>
                                                    <?php $selectedService = ($enableDefaultButton && $service->isSelectedByDefault()) || !empty($selectedServices[$purchaseId][$service->getId()]); ?>
                                                    <td class="">
                                                        <label for="supplementary-<?php echo $purchaseId; ?>-<?php echo $service->getId(); ?>">
                                                            <?php if ($group->isMultipleChoice()) : ?>
                                                                <input type="checkbox" class="checkbox" name="supplementary_<?php echo $purchaseId; ?>_<?php echo $group->getId(); ?>[]" value="<?php echo $service->getId(); ?>" id="supplementary-<?php echo $purchaseId; ?>-<?php echo $service->getId(); ?>" <?php echo $selectedService ? 'checked="checked"' : ''; ?> /> - <?php echo $service->productName; ?>
                                                            <?php else: ?>
                                                                <input type="radio" class="radio" name="supplementary_<?php echo $purchaseId; ?>_<?php echo $group->getId(); ?>" value="<?php echo $service->getId(); ?>" id="supplementary-<?php echo $purchaseId; ?>-<?php echo $service->getId(); ?>" <?php echo $selectedService ? 'checked="checked"' : ''; ?> /> - <?php echo $service->productName; ?>
                                                            <?php endif; ?>
                                                        </label>
                                                        <?php if (!empty($service->productComments)) : ?>
                                                            <span class="addon-descripion">
                                                                <?php echo $service->productComments; ?>
                                                            </span>
                                                        <?php endif; ?>
                                                    </td>
                                                    <td class="t-feature-price">
                                                        <div class="selection">
                                                            <?php $checked = false; ?>
                                                            <?php $severalPrices = ($service->getPricesCount($currencyId) > 1); ?>
                                                            <?php foreach ($service->getVariants() as $variant) : ?>
                                                                <?php foreach ($variant->getPrices() as $price) : ?>
                                                                    <?php $selectedPrice = $selectedService && $selectedServices[$purchaseId][$service->getId()]["priceId"] === $price->getId(); ?>
                                                                    <?php $inputName = "supplementary_".$purchaseId."_".$service->getId()."_cycle_price"; ?>
                                                                    <?php $inputValue = $price->cycleID."_".$price->getId(); ?>
                                                                    <?php $inputText = (!empty($variant->productVariantDisplayName) ? '"'.$variant->productVariantDisplayName.'"': '')." <b>".formatPrice($price->getCycleFee(), $currencyId)."</b> ".__('TRANS_STORE_FOR_CYCLE')." ".__($service->getCycle($price->cycleID)->cycleDisplayName);?>
                                                                    <?php if ($severalPrices) : ?>
                                                                        <div class="b-label">
                                                                            <label for="<?php echo $price->getId(); ?>">
                                                                                <input type="radio" class="radio" value="<?php echo $inputValue; ?>" name="<?php echo $inputName; ?>" <?php if ($selectedPrice || (!$checked && ($parentCycleId == $price->cycleID || !$service->hasParentCycles))) { echo 'checked="checked"'; $checked = true;} ?>/>
                                                                                    <?php echo $inputText; ?>
                                                                            </label>
                                                                            <?php include_partial('catalog/priceAdditionalData', array('price' => $price, 'currencyId' => $currencyId)); ?>
                                                                        </div>
                                                                    <?php else: ?>
                                                                        <input type="hidden" value="<?php echo $inputValue; ?>" name="<?php echo $inputName; ?>"/>
                                                                        <?php echo $inputText; ?>
                                                                        <?php include_partial('catalog/priceAdditionalData', array('price' => $price, 'currencyId' => $currencyId)); ?>
                                                                    <?php endif; ?>
                                                                <?php endforeach; ?>
                                                            <?php endforeach; ?>
                                                        </div>
                                                    </td>
                                                </tr>
                                            <?php endforeach; ?>
                                            <?php if (!$group->isMultipleChoice() && $group->isPossiblyEmpty()): ?>
                                                <tr>
                                                    <td class="">
                                                        <label for="supplementary-<?php echo $group->group_id; ?>-0">
                                                            <input type="radio" class="radio" name="supplementary_<?php echo $purchaseId; ?>_<?php echo $group->getId(); ?>" value="" id="supplementary-<?php echo $group->group_id; ?>-0" <?php echo (!$group->hasDefaultSelect() && $enableDefaultButton) ? 'checked="checked"' : ''; ?> /> - <?php echo __('TRANS_NONE'); ?>
                                                        </label>
                                                    </td>
                                                    <td class="t-feature-price">&nbsp;</td>
                                                </tr>
                                            <?php endif; ?>
                                        </tbody>
                                    </table>
                                </div>
                            <?php endforeach; ?>
						</div>
					</div>

				</form>

			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>

		<div class="p-store-actions">
			<div class="p-store-actions-area">
                <?php if(!is_null($purchaseId)) :?>
				    <?php include_partial('backAction', array('router' => $router)); ?>
                <?php endif; ?>
				<a class="btn btn-action" href="#" onclick="$('#purchaseServices').submit(); return false;"><span><i><?php echo __('TRANS_NEXT'); ?></i></span></a>
			</div>
		</div>

		<?php if (isset($taxZone)): ?>
            <div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
		<?php endif; ?>

	</div> <!--/p-store-order-->

</div> <!--/#main-->