<?php use_helper('BillingFormat') ?>
<div id="main" class="">

    <div class="p-store-order">

        <?php include_partial('navigationBar', array('router' => $router)); ?>

        <div class="p-box p-box-features">
            <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

            <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
                <?php include_partial('header', array('cartItem' => $cartItem, 'selectedPurchase' => $selectedPurchase)); ?>

                <form id="parentPlan" action="<?php echo url_for('@select-subscription'); ?>" method="post">
                    <?php if (!empty($selectedPurchase)) : ?>
                        <input type="hidden" name="purchaseId" value="<?php echo $selectedPurchase->getId(); ?>"/>
                    <?php else: ?>
                        <input type="hidden" name="domainPlanId" value="<?php echo $domainPlanId; ?>"/>
                    <?php endif; ?>

                    <div class="p-box-title p-box-title-1">
                        <div class="p-box-title-area">
                            <h1><span>
                                <?php if (BillingPlan::TYPE_DOMAIN != $plan->productType) : ?>
                                    <?php echo __('TRANS_STORE_CHOOSE_EXISTING_SUBSCRIPTION'); ?>
                                <?php else: ?>
                                    <?php echo __('TRANS_STORE_CHOOSE_EXISTING_SUBSCRIPTION_TO_DOMAIN'); ?>
                                <?php endif; ?>
                            </span></h1>
                        </div>
                    </div>

                    <div class="p-box-content">

                        <?php if (isset($errorMessage)): ?>
                            <?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
                        <?php endif; ?>

                        <div class="b-description"><p>
                            <?php if (BillingPlan::TYPE_DOMAIN != $plan->productType) : ?>
                                <?php echo __('TRANS_STORE_CHOOSE_EXISTING_SUBSCRIPTION_DESC'); ?>
                            <?php else: ?>
                                <?php echo __('TRANS_STORE_CHOOSE_EXISTING_SUBSCRIPTION_TO_DOMAIN_DESC'); ?>
                            <?php endif; ?>
                        </p></div>
                        <div class="b-features">
                            <div class="b-features-area">
                                <table class="t-features">
                                    <tbody>
                                        <?php foreach ($existingSubscriptions as $subscription): ?>
                                            <tr>
                                                <td class="">
                                                    <label>
                                                        <?php echo $subscription->packageName; ?>
                                                    </label>
                                                    <?php if (!empty($subscription->additionalName)) : ?>
                                                        <span class="parent-plan-descripion">
                                                            <?php echo $subscription->additionalName; ?>
                                                        </span>
                                                    <?php endif; ?>
                                                </td>
                                                <td class="t-feature-price">
                                                    <div class="b-label">
                                                        <label for="existingSubscriptionId-<?php echo $subscription->packageID; ?>-0">
                                                            <input type="radio" class="radio" name="existingSubscriptionId" value="<?php echo $subscription->packageID; ?>" id="existingSubscriptionId-<?php echo $subscription->packageID; ?>" />
                                                            <?php echo __('TRANS_STORE_ATTACH_TO_EXISTING_SUBSCRIPTION'); ?>
                                                        </label>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php endforeach; ?>
                                        <?php if (BillingPlan::HOSTING_REQUIRED != $plan->productHostingRequired): ?>
                                            <tr>
                                                <td class="">&nbsp;</td>
                                                <td class="t-feature-price">
                                                    <div class="b-label">
                                                    <label for="existingSubscriptionId-0">
                                                        <input type="radio" class="radio" name="existingSubscriptionId" value="" id="existingSubscriptionId-0" checked="checked"/> <?php echo __('TRANS_NONE'); ?>
                                                    </label>
                                                    </div>
                                                </td>
                                            </tr>
                                        <?php endif; ?>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                </form>

            </div></div></div>
            <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
        </div>

        <div class="p-store-actions">
            <div class="p-store-actions-area">
                <?php include_partial('backAction', array('router' => $router)); ?>
                <a class="btn btn-action" href="#" onclick="$('#parentPlan').submit(); return false;"><span><i><?php echo __('TRANS_NEXT'); ?></i></span></a>
            </div>
        </div>

    </div> <!--/p-store-order-->

</div> <!--/#main-->