<?php use_helper('BillingFormat'); ?>
<div id="main" class="">

    <div class="p-store-order">

        <?php include_partial('navigationBar', array('router' => $router)); ?>

        <div class="p-box">
            <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

            <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
                <div class="p-box-title p-box-title-1">
                    <div class="p-box-title-area">
                        <h1><span><?php echo __('TRANS_SELECTED_PLANS_SUMMARY'); ?></span></h1>
                    </div>
                </div>
                <div class="p-box-content">
                    <div class="b-description"><p><?php echo __('TRANS_SELECTED_PLANS_SUMMARY_DESCR'); ?></p></div>

                    <?php if (isset($couponSuccessMessage)): ?>
                    <div class="p-box p-box-info-msg">
                        <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
                        <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
                            <div class="p-box-content">
                                <span class="msg-title"><?php echo __('TRANS_INFO'); ?>:</span> <?php echo __($couponSuccessMessage, array('%NAMES%' => $couponSuccessNames)); ?>
                            </div>
                        </div></div></div>
                        <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
                    </div>
                    <?php endif; ?>

                    <?php if (isset($errorMessage)): ?>
                    <?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
                    <?php endif; ?>

                    <form id="actionForm" action="<?php echo url_for('@summary'); ?>" method="post">
                        <input type="hidden" name="cartItemId" value=""/>
                        <input type="hidden" name="purchaseId" value=""/>
                        <input type="hidden" name="domainName" value=""/>
                        <input type="hidden" name="addonId" value=""/>
                        <input type="hidden" name="operation" value=""/>
                    </form>

                    <script type="text/javascript">

                        function addDomain(purchaseId, cartItemId) {
                            $('#actionForm > input[name="cartItemId"]').val(cartItemId);
                            $('#actionForm > input[name="purchaseId"]').val(purchaseId);
                            $('#actionForm > input[name="operation"]').val('add-domain');
                            $('#actionForm').submit();
                        }

                        function removePurchase(id) {
                            $('#actionForm > input[name="purchaseId"]').val(id);
                            $('#actionForm > input[name="operation"]').val('remove-purchase');
                            $('#actionForm').submit();
                        }

                        function editInformation(id) {
                            $('#actionForm > input[name="purchaseId"]').val(id);
                            $('#actionForm > input[name="operation"]').val('edit-information');
                            $('#actionForm').submit();
                        }

                        function removeOwnDomain(id, domainName) {
                            $('#actionForm > input[name="purchaseId"]').val(id);
                            $('#actionForm > input[name="domainName"]').val(domainName);
                            $('#actionForm > input[name="operation"]').val('remove-own-domain');
                            $('#actionForm').submit();
                        }

                        function removeAddon(purchaseId, addonId) {
                            $('#actionForm > input[name="purchaseId"]').val(purchaseId);
                            $('#actionForm > input[name="addonId"]').val(addonId);
                            $('#actionForm > input[name="operation"]').val('remove-addon');
                            $('#actionForm').submit();
                        }

                        function addAddons(purchaseId, cartItemId) {
                            $('#actionForm > input[name="purchaseId"]').val(purchaseId);
                            $('#actionForm > input[name="cartItemId"]').val(cartItemId);
                            $('#actionForm > input[name="operation"]').val('add-addons');
                            $('#actionForm').submit();
                        }

                        function removeService(purchaseId, serviceId) {
                            $('#actionForm > input[name="purchaseId"]').val(purchaseId);
                            $('#actionForm > input[name="serviceId"]').val(serviceId);
                            $('#actionForm > input[name="operation"]').val('remove-service');
                            $('#actionForm').submit();
                        }

                        function addServices(purchaseId, cartItemId) {
                            $('#actionForm > input[name="purchaseId"]').val(purchaseId);
                            $('#actionForm > input[name="cartItemId"]').val(cartItemId);
                            $('#actionForm > input[name="operation"]').val('add-services');
                            $('#actionForm').submit();
                        }

                        function continueOrder() {
                            $('#actionForm > input[name="operation"]').val('continue-order');
                            $('#actionForm').submit();
                        }

                        $(document).ready(function() {
                            $('.dropdown-box').each(function () {
                                $(this).mouseover(function () {
                                    $(this).addClass('dropdown-box-expanded');
                                });
                                $(this).mouseout(function () {
                                    $(this).removeClass('dropdown-box-expanded');
                                });
                            });
                        });

                    </script>

                    <?php if ($cartItemsData->getRawValue()): ?>

                    <?php foreach ($cartItemsData as $cartItemId => $purchasesData): ?>

                    <div class="b-summary">

                        <?php foreach ($purchasesData as $purchaseId => $purchaseData): ?>
                            <table class="t-summary">
                                <tbody>
                                    <tr>
                                        <td class="t-summary-item-name">
                                            <b><?php echo formatProductName($purchaseData['name']); ?></b>
                                            <?php if ($purchaseData['description']): ?>
                                                <table class="t-additional-data"><tr><td class="value"><?php echo formatProductName($purchaseData['description'], 40); ?></td></tr></table>
                                            <?php endif; ?>
                                            <?php if ($purchaseData['hasAdditionalInformation']): ?>
                                                <div><a class="i-btn" href="#" onclick="editInformation('<?php echo $purchaseData['id']; ?>'); return false;"><span><?php echo __('TRANS_INFORMATION_EDIT'); ?></span></a></div>
                                            <?php endif; ?>
                                        </td>
                                        <?php if (!$purchaseData['isAlreadyPurchased']) : ?>
                                            <td class="t-summary-item-price">
                                                <?php if ($purchaseData['useTransferFee']): ?>
                                                    <span><b><?php echo formatPrice($purchaseData['price']->getTransferFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($purchaseData['cycle']->cycleDisplayName); ?></span>
                                                    <?php include_partial('catalog/priceAdditionalData', array('price' => $purchaseData['price'], 'currencyId' => $currencyId, 'displayTaxes' => true, 'useTransferFee' => true)); ?>
                                                <?php else: ?>
                                                    <span><b><?php echo formatPrice($purchaseData['price']->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($purchaseData['cycle']->cycleDisplayName); ?></span>
                                                    <?php include_partial('catalog/priceAdditionalData', array('price' => $purchaseData['price'], 'currencyId' => $currencyId, 'displayTaxes' => true)); ?>
                                                <?php endif; ?>
                                            </td>
                                        <?php endif; ?>
                                        <?php include_partial('actions', array('purchaseData' => $purchaseData, 'cartItemId' => $cartItemId, 'isSubPurchase' => false)); ?>
                                    </tr>
                                </tbody>
                            </table>

                            <?php include_partial('showSubPurchase', array('purchaseData' => $purchaseData, 'currencyId' => $currencyId, 'cartItemId' => $cartItemId, 'showAction' => true)); ?>
                        <?php endforeach; ?>
                    </div>

                    <?php endforeach; ?>

                    <div class="b-summary">
                        <div class="b-summary-price-total">
                            <table class="t-price-total">
                                <tr>
                                    <td class="name"><?php echo __('TRANS_ORDERFORM_SUBTOTAL');?>:</td>
                                    <td class="t-summary-item-price"><b><?php echo formatPrice($amount, $currencyId); ?></b></td>
                                </tr>
                                <tr>
                                    <td class="name"><?php echo __('TRANS_TAX_ZONE_AMOUNT');?>:</td>
                                    <td class="t-summary-item-price"><b><?php echo formatPrice($totalAmount - $amount, $currencyId); ?></b></td>
                                </tr>
                                <tr class="t-summary-item-total">
                                    <td class="name"><b><?php echo __('TRANS_TOTAL');?>:</b></td>
                                    <td class="t-summary-item-price"><b><?php echo formatPrice($totalAmount, $currencyId); ?></b></td>
                                </tr>
                                <?php if ($minimalCycle): ?>
                                <tr>
                                    <td class="name"><?php echo __('TRANS_MINIMAL_CONTRACT_TERM');?>:</td>
                                    <td class="t-summary-item-price"><b><?php echo __($minimalCycle->cycleDisplayName); ?></b></td>
                                </tr>
                                <?php endif; ?>
                            </table>
                        </div>
                    </div>

                    <?php else: ?>

                    <div class="b-description"><p><?php echo __('TRANS_NO_PRODUCTS_IN_CART'); ?> <a href="<?php echo formatContinueShoppingUrl($container); ?>"><?php echo __('TRANS_BUY_SOMETHING_NOW'); ?></a></p></div>

                    <?php endif; ?>

                </div>

            </div></div></div>
            <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
        </div>

        <?php if ($cartItemsData->getRawValue()): ?>
        <div class="p-box">
            <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
            <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
                <div class="p-box-title p-box-title-1">
                    <div class="p-box-title-area">
                        <h1><span><?php echo __('TRANS_ORDERFORM_COUPON_APPLY'); ?></span></h1>
                    </div>
                </div>
                <div class="p-box-content">
                    <p><?php echo __('TRANS_COUPONS_DESCR'); ?></p>
                    <div class="b-form">
                        <form id="couponForm" action="<?php url_for('@summary'); ?>" method="post" autocomplete="off">
                            <input type="hidden" name="operation" value="apply-coupon"/>
                            <table class="t-form">
                                <tbody>
                                    <tr>
                                        <td class="field-name"><?php echo __('TRANS_ORDERFORM_ENTER_COUPON'); ?></td>
                                        <td class="field-value">
                                            <input type="text" class="input-text domain-name" name="coupon"/>
                                            <a class="btn" href="#" onclick="$('#couponForm').submit(); return false;"><span><i><?php echo __('TRANS_APPLY'); ?></i></span></a>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </form>
                    </div>
                </div>
            </div></div></div>
            <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
        </div>
        <?php endif; ?>

        <?php if(!$disableCatalogLinks) : ?>
        <div class="p-box p-box-note">
            <div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
            <div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
                <div class="p-box-content">
                    <a class="btn btn-note" href="<?php echo formatContinueShoppingUrl($container); ?>"><span><i><?php echo __('TRANS_CONTINUE_SHOPPING'); ?></i></span></a>
                    <div class="note note-buy"><i class="b-icon"><i></i></i><?php echo __('TRANS_CONTINUE_SHOPPING_DESCR'); ?></div>
                </div>
            </div></div></div>
            <div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
        </div>
        <?php endif; ?>

        <div class="p-store-actions">
            <div class="p-store-actions-area">
                <?php if(!$disableCatalogLinks) : ?>
                <a class="back-link" href="<?php echo formatContinueShoppingUrl($container); ?>"><span><?php echo __('TRANS_BACK_TO'); ?>&nbsp;<?php echo __('TRANS_PAGE_PLANS_OVERVIEW'); ?></span></a>
                <?php endif; ?>
                <?php if ($cartItemsData->getRawValue()): ?>
                <a id="checkout" class="btn btn-action" href="#" onclick="continueOrder(); return false;"><span><i><?php echo __('TRANS_CHECKOUT'); ?></i></span></a>
                <?php endif; ?>
            </div>
        </div>

        <?php if (isset($taxZone)): ?>
        <div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
        <?php endif; ?>

    </div> <!--/p-store-order-->

</div> <!--/#main-->