<?php

class AffiliateAction extends sfAction {
	
	public function execute($request) {
		$partnerId = $request->getParameter('partner');
		$programId = $request->getParameter('program');
		
		$program = ResourceLocator::getInstance()->billingAffiliateProgramService->getById($programId, $partnerId);
		
		// store partner and affiliate program indentifiers, if program is active and partner is valid
		if ($program->is_active && $program->is_partner_valid) {
			$this->getUser()->setAttribute('partner', $partnerId);
			$this->getUser()->setAttribute('program', $programId);
		}
		
		if ($program->url) {
			// redirect to specific url
			$redirectUrl = $program->url;
		} else {
			// redirect to catalog, associated with program
			$store = ResourceLocator::getInstance()->billingStoreService->getByAffiliateProgramId($programId);
			$redirectUrl = $this->generateUrl('catalog', array('container' => $store->orderFormCode));
		}
		
		// set no cache and localtion headers manually, because simple $this->redirect call entail clear
		// of http headers, so some browsers may cache result of this action and prevent it execution
		$response = $this->getResponse();
		$response->addCacheControlHttpHeader('no-cache');
		$response->setHttpHeader('Location', $redirectUrl);
		
		// send only headers to perform redirect
		return sfView::HEADER_ONLY;
	}
	
}