<?php

class BackToSummaryAction extends CatalogAction {
	
	public function execute($request) {
		
		$initialPage = new RouterPage('catalog', array('container' => $this->_container));
		
		$steps = array(
			new RouterPage('summary'),
			new RouterPage('contact-information'),
			new RouterPage('order-details'),
			new RouterPage('confirmation'),
			new RouterPage('thank-you')
		);
		
		$router = new Router();
		$router->init($steps, $initialPage);
		
		ResourceLocator::getInstance()->routersStack->push($router);
		// go to next page, but supress redirection via router method,
		// instead this below we apply workaround to avoid caching of this action
		$router->next(array(), true, true);
		
		// set no cache and localtion headers manually, because simple $this->redirect call entail clear
		// of http headers, so some browsers may cache result of this action and prevent it execution
		sfContext::getInstance()->getConfiguration()->loadHelpers('Url');
		$response = $this->getResponse();
		$response->addCacheControlHttpHeader('no-cache');
		$response->setHttpHeader('Location', url_for('@summary'));
		
		// send only headers to perform redirect
		return sfView::HEADER_ONLY;
		
	}
}