<?php

class BuyDomainAction extends CatalogAction {

	public function execute($request) {
		$plan = $this->_store->getPlan($request->getParameter('plan'));

		$cart = ResourceLocator::getInstance()->cart;
		$cart->setCurrentItem(new CartItem());
		if(!PurchaseManager::purchaseDomains($request, null, $cart, $plan, $duplicatedDomains)) {
			sfContext::getInstance()->getConfiguration()->loadHelpers('I18N');
            $errorMessage = $duplicatedDomains ? __('TRANS_DUPLICATE_DOMAINS', array('%DOMAINS%' => implode(', ', $duplicatedDomains))) : __('TRANS_YOU_MUST_SELECT_AT_LEAST_ONE_DOMAIN');
			sfContext::getInstance()->getUser()->setAttribute('errorMessage', $errorMessage);
		}

        $steps = array();
        foreach(array('prepare-select-addons', 'add-purchase', 'summary', 'contact-information', 'select-subscription', 'order-details', 'confirmation', 'thank-you') as $item) {
            $steps[] = new RouterPage($item);
        }

		$router = new Router();
		$router->init($steps, new RouterPage('catalog', array('container' => $this->_container)));

		ResourceLocator::getInstance()->routersStack->push($router);
		$router->next();

		return sfView::NONE;

	}
}