<?php

class CertificateAction extends PurchaseAction
{
    public function execute($request)
    {
        $this->getUser()->setAttribute('showOnlyCertificate', true);
        $parentSubscriptionId = $request->getParameter('subscription', false);
        $parentSubscription = ResourceLocator::getInstance()->billingSubscriptionService->getSubscription($parentSubscriptionId);
        $this->getUser()->setAttribute('subscriptionId', $parentSubscriptionId);
        $plan = ResourceLocator::getInstance()->billingPlanService->getById($parentSubscription->getPlanId(), $this->_store->getId());
        $purchase = new Purchase($parentSubscription->getPlanId(), $parentSubscription->getCycleId(), null, $parentSubscription->getName(), $plan->getType());
        $purchase->setDescription($parentSubscription->additionalName);
        $purchase->setAlreadyPurchasedId($parentSubscriptionId);
        $cartItem = new CartItem();
        $cartItem->addPurchase($purchase);
        ResourceLocator::getInstance()->cart->setCurrentItem($cartItem);

        $initialPage = new RouterPage('select-services', array('purchaseId' => $purchase->getId()));
        $steps = array(
            new RouterPage('select-services', array('purchaseId' => $purchase->getId())),
            new RouterPage('prepare-select-addons'),
            new RouterPage('add-purchase'),
            new RouterPage('summary'),
            new RouterPage('contact-information'),
            new RouterPage('order-details'),
            new RouterPage('confirmation'),
            new RouterPage('thank-you')
        );
        $router = new Router();
        $router->init($steps, $initialPage);

        ResourceLocator::getInstance()->routersStack->push($router);
        $router->next();
    }
}