<?php

class DomainAction extends PurchaseAction {

	public function execute($request) {
		// determine domain plan id, tld and sld
		$domainPlan = $this->_store->getDefaultDomainPlan();
		$domain = $request->getParameter('domain');

		$pos = strrpos($domain, '.');
		$sld = substr($domain, 0, $pos);
		$tld = substr($domain, $pos + 1);

		// prepare domain parameters and store it into session
		$selectDomainParameters = new sfParameterHolder();
		$selectDomainParameters->add(
			array(
				'domainPlanId' => $domainPlan->getId(),
				'masterTLD' => $tld,
				'SLD' => $sld,
				'operation' => 'register'
			)
		);
		sfContext::getInstance()->getUser()->setAttribute('selectDomainParameters', $selectDomainParameters);

		// place domain plan into cart
		$cart = ResourceLocator::getInstance()->cart;
		$cartItem = new CartItem();
		$cart->setCurrentItem($cartItem);

        // initialize router
		$initialPage = new RouterPage('register-domain');
		$steps = array(
            new RouterPage('register-domain', array('domainPlanId' => $domainPlan->getId())),
            new RouterPage('prepare-select-addons'),
			new RouterPage('add-purchase'),
			new RouterPage('summary'),
			new RouterPage('contact-information'),
			new RouterPage('order-details'),
			new RouterPage('confirmation'),
			new RouterPage('thank-you')
		);
		$router = new Router();
		$router->init($steps, $initialPage);

		ResourceLocator::getInstance()->routersStack->push($router);
		$router->next();
	}

}