<?php

class UpsellAction extends PurchaseAction {

	public function execute($request)
    {
        $parentSubscriptionId = $request->getParameter('subscription', false);
        $parentSubscription = ResourceLocator::getInstance()->billingSubscriptionService->getSubscription($parentSubscriptionId);
        $this->getUser()->setAttribute('subscriptionId', $parentSubscriptionId);
        $plan = ResourceLocator::getInstance()->billingPlanService->getById($parentSubscription->getPlanId(), $this->_store->getId());
        $purchase = new Purchase($parentSubscription->getPlanId(), $parentSubscription->getCycleId(), null, $parentSubscription->getName(), $plan->getType());
        $purchase->setDescription($parentSubscription->additionalName);
        $purchase->setAlreadyPurchasedId($parentSubscriptionId);
        $cartItem = new CartItem();
        $cartItem->addPurchase($purchase);
        ResourceLocator::getInstance()->cart->setCurrentItem($cartItem);

		$initialPage = new RouterPage('select-services', array('purchaseId' => $purchase->getId()));
		$steps = array(
            new RouterPage('select-services', array('purchaseId' => $purchase->getId())),
            new RouterPage('prepare-select-addons'),
            new RouterPage('add-purchase'),
			new RouterPage('summary'),
			new RouterPage('contact-information'),
			new RouterPage('order-details'),
			new RouterPage('confirmation'),
			new RouterPage('thank-you')
		);
		$router = new Router();
		$router->init($steps, $initialPage);

		ResourceLocator::getInstance()->routersStack->push($router);
		$router->next();

        // set no cache and localtion headers manually, because simple $this->redirect call entail clear
		// of http headers, so some browsers may cache result of this action and prevent it execution
		sfContext::getInstance()->getConfiguration()->loadHelpers('Url');
		$response = $this->getResponse();
		$response->addCacheControlHttpHeader('no-cache');
		$response->setHttpHeader('Location', $initialPage);

		// send only headers to perform redirect
		return sfView::HEADER_ONLY;
	}

}