<?php

class DomainsListAction extends sfAction {

	public function execute($request) {
		$this->setLayout(false);
		sfConfig::set('sf_web_debug', false);

		$container = $request->getParameter('container');
		$storeId = $request->getParameter('storeId');
		$store = ResourceLocator::getInstance()->billingStoreService->getById($storeId);

		sfContext::getInstance()->getUser()->setAttribute('store', $store);

		$domainPlanId = $request->getParameter('domainPlanId');
		$domainPlan = $store->getPlan($domainPlanId);

		$success = true;
		$TLDs = array();

		foreach ($domainPlan->getDomains($store->getId()) as $domain) {
            $TLDs[$domain->tldExtension] = $domain->tldID;
		}

        $parameters = array(
			'container' => $container,
			'domainPlan' => $domainPlan,
			'SLD' => $request->getParameter('SLD'),
			'TLDs' => $TLDs,
			'masterTLD' => $request->getParameter('masterTLD'),
			'allowRegister' => in_array('dom_reg', $store->domainOptions),
			'allowTransfer' => in_array('dom_transfer', $store->domainOptions),
            'TLDsCount' => count($TLDs),
            'TLDsString' => implode("-", $TLDs)
		);

		sfContext::getInstance()->getConfiguration()->loadHelpers('Partial');
		$content = json_encode(array('content' => get_partial('widget/domainsList', $parameters)));

		$this->callback = $request->getParameter('callback');
		$this->content = $content;
	}

}