<?php use_helper('BillingFormat'); ?>
<?php use_helper('BillingEscape'); ?>
<div class="b-multidomain-whois">

	<div class="b-multidomain-whois-caption"><?php echo __('TRANS_DOMAINS_FOUND'); ?></div>

	<form id="purchaseDomains" action="<?php echo url_for('@buy-domain?container=' . $container, array('absolute' => true)); ?>" method="post">
		<input type="hidden" name="plan" value="<?php echo $domainPlan->getId(); ?>"/>
		<input type="hidden" name="SLD" value="<?php echo $SLD; ?>"/>
        <script type="text/javascript">
            $.manageAjax.create('checkDomainQueue', {queue: false});
        </script>
        <table class="t-multidomain-whois-results">
			<tbody>
				<?php foreach ($TLDs as $TLD => $tldId): ?>
                    <tr>
                        <td class="td-domain-name"><span><?php echo formatProductName($SLD.".".$TLD); ?></span></td>
                        <td class="td-available">
                            <span id="checking_<?php echo jQueryDomainPoint($tldId); ?>" class="wait"><?php echo __('TRANS_CHECKING_AVAILABILITY'); ?></span>
                            <span id="available_<?php echo $TLD; ?>" style="display: none;" class="yes"><?php echo __('TRANS_AVAILABLE'); ?></span>
                            <span id="unableWhois_<?php echo $TLD; ?>" style="display: none;" class="not-active"><?php echo __('TRANS_NOT_AVAILABLE_WHOIS_SERVER'); ?></span>
                            <span id="notAvailable_<?php echo $TLD; ?>" style="display: none;" class="no"><?php echo __('TRANS_NOT_AVAILABLE'); ?></span>
                        </td>
                        <td class="td-register" id="domain_<?php echo jQueryDomainPoint($tldId); ?>">
                        </td>
                    </tr>
				<?php endforeach; ?>
                <?php include_partial('cart/jsCheckDomain', array('operation' => 'register', 'domainPlanId' => $domainPlan->getId(), 'TLDsCount' => $TLDsCount, 'SLD' => $SLD, 'TLDs' => $TLDsString, 'masterTLD' => $masterTLD)); ?>
            </tbody>
		</table>
	</form>

	<script type="text/javascript">
		function purchaseDomains() {
			if ($("input[name=\"registerTLDs\[\]\"]:checked").size() > 0 || $("input[name=\"transferTLDs\[\]\"]:checked").size() > 0) {
				$("#error").hide();
				$("#purchaseDomains").submit();
			} else {
				$("#errorMessage").html("<?php echo htmlspecialchars(__('TRANS_YOU_MUST_SELECT_AT_LEAST_ONE_DOMAIN')); ?>");
				$("#error").show();
			}
		}
		$("#next").show();
	</script>

</div>