<?php

class BillingSupplementaryGroup extends BillingObject
{
    public function getPlans() {
        if (!is_null($this->_plans)) {
            return $this->_plans;
        }
        if (!isset($this->plans)) {
            throw new BillingObjectException('Supplementary plans section does not exist in supplementary groups data');
        }

        $this->_plans = array();
        foreach ($this->plans as $data) {
            $plan = new BillingSupplementaryPlan($data);
            $this->_plans[$plan->getId()] = $plan;
        }

        return $this->_plans;
    }

    public function hasPlans()
    {
        $plans = $this->getPlans();
        return !empty($plans);
    }

    public function isMultipleChoice()
    {
        return $this->allow_multiple;
    }

    public function isPossiblyEmpty()
    {
        return $this->allow_empty;
    }

    public function removePlanById($planId)
    {
        if (isset($this->_plans[$planId])) {
            unset($this->_plans[$planId]);

            return true;
        }

        return false;
    }

    public function hasDefaultSelect()
    {
        foreach($this->getPlans() as $plan) {
            if ($plan->isSelectedByDefault()) {

                return true;
            }
        }

        return false;
    }

    protected function _extractId() {
        return $this->group_id;
    }

    private $_plans = null;
}