<?php

class BillingCompanyService extends BillingService {
	
	protected static $instance = null;
    protected $_isCacheEnabled = true;
	
	public function getProviderCompany() {
		$responce = $this->executeGetProviderCompany();
		if ($responce->hasErrors()) {
			throw new BillingObjectException('Provider company not found');
		} else {
			return new BillingCompany($responce->getData());
		}
	}
	
	public function getCompany($storeId) {
		$responce = $this->executeGetCompany($storeId);
		if ($responce->hasErrors()) {
			throw new BillingObjectException('Company for owner of store with id = ' . $storeId . ' not found');
		} else {
			return new BillingCompany($responce->getData());
		}
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('company'));
		}
		return self::$instance;
	}

}