<?php

class FormField {
	
	const TYPE_SELECT = 'select';
	const TYPE_RADIO = 'radio';
	const TYPE_CHECKBOX = 'checkbox';
	const TYPE_PASSWORD = 'password';
	const TYPE_HTML = 'html';
    const TYPE_TEXTAREA = 'textarea';
    const TYPE_HIDDEN = 'hidden';
	
	private $_name;
	
	private $_type;
	
	private $_value = false;
	
	private $_description;
	
	private $_violation = false;
	
	private $_required;
	
	private $_readOnly;
	
	private $_readOnlyLabel;

    private $_minLenght;

    private $_maxLenght;
	
	public function __construct($name, $type, $description = false, $required = false, $minLenght = false, $maxLenght = false) {
		$this->_name = $name;
		$this->_type = $type;
		$this->_description = $description;
		$this->_required = $required;
        $this->_minLenght = $minLenght;
        $this->_maxLenght = $maxLenght;
		$this->_readOnly = false;
		$this->_readOnlyLabel = false;
	}
	
	public function getName() {
		return $this->_name;
	}
	
	public function getType() {
		return $this->_type;
	}
	
	public function getDescription() {
		return $this->_description;
	}
	
	public function hasDescription() {
		return $this->_description ? true : false;
	}
	
	public function setViolation($violation) {
		$this->_violation = $violation;
	}
	
	public function getViolation() {
		return $this->_violation;
	}
	
	public function hasViolation() {
		return $this->_violation ? true : false;
	}
	
	public function required() {
		return $this->_required;
	}
	
	public function setValue($value) {
		$this->_value = $value;
	}
	
	public function getValue() {
		return $this->_value;
	}
	
	public function setReadOnly($label) {
		$this->_readOnly = true;
		$this->_readOnlyLabel = $label;
	}
	
	public function unsetReadOnly() {
		$this->_readOnly = false;
		$this->_readOnlyLabel = false;
	}
	
	public function readOnly() {
		return $this->_readOnly;
	}
	
	public function getReadOnlyLabel() {
		return $this->_readOnlyLabel;
	}
	
	public function hasReadOnlyLabel() {
		return $this->_readOnlyLabel ? true : false;
	}

    public function hasMinLenght() {
        return $this->_minLenght ? true : false;
    }

    public function hasMaxLenght() {
        return $this->_maxLenght ? true : false;
    }

    public function setMinLenght($value) {
        $this->_minLenght = $value;
    }

    public function setMaxLenght($value) {
        $this->_maxLenght = $value;
    }

    public function getMinLenght() {
        return $this->_minLenght;
    }

    public function getMaxLenght() {
        return $this->_maxLenght;
    }
}