<?php

class BillingCustomQuestionForm extends BillingForm {
	
	public function __construct($data, $defaults = array(), $options = array(), $CSRFSecret = null) {
		parent::__construct($data, $defaults, $options, $CSRFSecret);
	}
	
	public function save() {
		$purchase = $this->getAttribute('purchase');
        $parentPlanId = $purchase->hasParentPurchase() ? $purchase->getParentPurchase()->getPlanId() : null;
		$result = ResourceLocator::getInstance()->billingContactService->collectPlanCustomQuestions(
			$this->getValues(),
			array($purchase->getId() => array('planId' => $this->getAttribute('planId'), 'parentPlanId' => $parentPlanId))
		);
        if (false !== ($subscriptionId = $this->needRedirectToPanel($result))) {
            $purchase->addParameter('redirectToPanelSubscription', $subscriptionId);
		}
		if (!$this->validate($result)) {
			return false;
		}
		$purchase->addParameter('customQuestionData', $result->getData());
		return true;
	}
	
}